/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/base/common/path","vs/base/common/async","vs/platform/environment/common/environment","vs/platform/files/common/files","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/resources","vs/base/common/types","vs/base/common/network","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/arrays","vs/platform/storage/common/storage","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/buffer","vs/base/common/objects","fs","vs/platform/product/common/productService","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/cancellation","vs/base/common/uuid","vs/platform/registry/common/platform","vs/base/common/json","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/process","os","vs/base/parts/ipc/common/ipc","vs/platform/configuration/common/configurationRegistry","vs/base/common/map","vs/platform/request/common/request","vs/base/common/jsonEdit","vs/base/common/extpath","child_process","vs/base/common/errorMessage","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/jsonFormatter","vs/base/common/stream","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/userDataSync/common/content","vs/base/common/iterator","vs/base/common/codicons","vs/base/common/date","vs/platform/localizations/common/localizations","vs/base/common/semver/semver","vs/platform/native/electron-sandbox/native","vs/platform/telemetry/common/telemetryUtils","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/node/decoder","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/extensions/common/extensions","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/log/common/logIpc","vs/platform/files/common/io","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/extensionsStorageSync","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/userDataSync/common/userDataAutoSyncService","vs/base/common/assert","vs/base/common/stopwatch","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/macAddress","vs/base/node/id","vs/base/node/extpath","util","vs/base/node/powershell","vs/base/node/ps","vs/base/node/watcher","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","electron","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/processes","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/code/electron-browser/sharedProcess/contrib/deprecatedExtensionsCleaner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/code/electron-browser/sharedProcess/contrib/nodeCachedDataCleaner","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/storage/common/storageIpc","vs/platform/storage/electron-sandbox/storageService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncResourceEnablementService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/windows/node/windowTracker","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","string_decoder","path","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain","graceful-fs"],ee=function(G){for(var e=[],p=0,L=G.length;p<L;p++)e[p]=Z[G[p]];return e};define(Z[86],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,O){if(!L)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}e.ok=p}),define(Z[63],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const p=Object.prototype.hasOwnProperty;function L(n){const f=[];for(let v in n)p.call(n,v)&&f.push(n[v]);return f}e.values=L;function O(n,f){for(let v in n)if(p.call(n,v)&&f({key:v,value:n[v]},function(){delete n[v]})===!1)return}e.forEach=O;function R(n,f){const v=Object.create(null);for(const C of n){const d=f(C);let w=v[d];w||(w=v[d]=[]),w.push(C)}return v}e.groupBy=R;function U(n){const f=Object.create(null);return n&&n.forEach((v,C)=>{f[C]=v}),f}e.fromMap=U;function A(n,f){const v=[],C=[];for(let d of n)f.has(d)||v.push(d);for(let d of f)n.has(d)||C.push(d);return{removed:v,added:C}}e.diffSets=A;function S(n,f){const v=[],C=[];for(let[d,w]of n)f.has(d)||v.push(w);for(let[d,w]of f)n.has(d)||C.push(w);return{removed:v,added:C}}e.diffMaps=S;class y{constructor(){this.map=new Map}add(f,v){let C=this.map.get(f);C||(C=new Set,this.map.set(f,C)),C.add(v)}delete(f,v){const C=this.map.get(f);!C||(C.delete(v),C.size===0&&this.map.delete(f))}forEach(f,v){const C=this.map.get(f);!C||C.forEach(v)}}e.SetMap=y}),define(Z[64],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(U){return(A,S,y)=>{let n=null,f=null;if(typeof y.value=="function"?(n="value",f=y.value):typeof y.get=="function"&&(n="get",f=y.get),!f)throw new Error("not supported");y[n]=U(f,S)}}e.createDecorator=p;function L(U,A,S){let y=null,n=null;if(typeof S.value=="function"?(y="value",n=S.value,n.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof S.get=="function"&&(y="get",n=S.get),!n)throw new Error("not supported");const f=`$memoize$${A}`;S[y]=function(...v){return this.hasOwnProperty(f)||Object.defineProperty(this,f,{configurable:!1,enumerable:!1,writable:!1,value:n.apply(this,v)}),this[f]}}e.memoize=L;function O(U,A,S){return p((y,n)=>{const f=`$debounce$${n}`,v=`$debounce$result$${n}`;return function(...C){this[v]||(this[v]=S?S():void 0),clearTimeout(this[f]),A&&(this[v]=A(this[v],...C),C=[this[v]]),this[f]=setTimeout(()=>{y.apply(this,C),this[v]=S?S():void 0},U)}})}e.debounce=O;function R(U,A,S){return p((y,n)=>{const f=`$throttle$timer$${n}`,v=`$throttle$result$${n}`,C=`$throttle$lastRun$${n}`,d=`$throttle$pending$${n}`;return function(...w){if(this[v]||(this[v]=S?S():void 0),(this[C]===null||this[C]===void 0)&&(this[C]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...w)),!this[d]){const I=this[C]+U;I<=Date.now()?(this[C]=Date.now(),y.apply(this,[this[v]]),this[v]=S?S():void 0):(this[d]=!0,this[f]=setTimeout(()=>{this[d]=!1,this[C]=Date.now(),y.apply(this,[this[v]]),this[v]=S?S():void 0},I-Date.now()))}}})}e.throttle=R}),define(Z[11],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=p,e.errorHandler=new p;function L(s){e.errorHandler.setUnexpectedErrorHandler(s)}e.setUnexpectedErrorHandler=L;function O(s){S(s)||e.errorHandler.onUnexpectedError(s)}e.onUnexpectedError=O;function R(s){S(s)||e.errorHandler.onUnexpectedExternalError(s)}e.onUnexpectedExternalError=R;function U(s){if(s instanceof Error){let{name:t,message:i}=s;const r=s.stacktrace||s.stack;return{$isError:!0,name:t,message:i,stack:r}}return s}e.transformErrorForSerialization=U;const A="Canceled";function S(s){return s instanceof Error&&s.name===A&&s.message===A}e.isPromiseCanceledError=S;class y extends Error{constructor(){super(A);this.name=this.message}}e.CancellationError=y;function n(){const s=new Error(A);return s.name=s.message,s}e.canceled=n;function f(s){return s?new Error(`Illegal argument: ${s}`):new Error("Illegal argument")}e.illegalArgument=f;function v(s){return s?new Error(`Illegal state: ${s}`):new Error("Illegal state")}e.illegalState=v;function C(s){return s?new Error(`readonly property '${s} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=C;function d(s){const t=new Error(`${s} has been disposed`);return t.name="DISPOSED",t}e.disposed=d;function w(s){return s?s.message?s.message:s.stack?s.stack.split(`
`)[0]:String(s):"Error"}e.getErrorMessage=w;class I extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=I;class E extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=E;class D extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=D;function g(s){const t=s;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=g;function a(s,t=Object.create(null)){const i=new Error(s);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=a}),define(Z[19],ee([0,1,11]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(z,W=0){return z[z.length-(1+W)]}e.tail=L;function O(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=O;function R(z,W,H=(T,P)=>T===P){if(z===W)return!0;if(!z||!W||z.length!==W.length)return!1;for(let T=0,P=z.length;T<P;T++)if(!H(z[T],W[T]))return!1;return!0}e.equals=R;function U(z,W,H){let T=0,P=z.length-1;for(;T<=P;){const F=(T+P)/2|0,N=H(z[F],W);if(N<0)T=F+1;else if(N>0)P=F-1;else return F}return-(T+1)}e.binarySearch=U;function A(z,W){let H=0,T=z.length;if(T===0)return 0;for(;H<T;){const P=Math.floor((H+T)/2);W(z[P])?T=P:H=P+1}return H}e.findFirstInSorted=A;function S(z,W,H){if(z=z|0,z>=W.length)throw new TypeError("invalid index");let T=W[Math.floor(W.length*Math.random())],P=[],F=[],N=[];for(let x of W){const V=H(x,T);V<0?P.push(x):V>0?F.push(x):N.push(x)}return z<P.length?S(z,P,H):z<P.length+N.length?N[0]:S(z-(P.length+N.length),F,H)}e.quickSelect=S;function y(z,W){const H=[];let T;for(const P of z.slice(0).sort(W))!T||W(T[0],P)!==0?(T=[P],H.push(T)):T.push(P);return H}e.groupBy=y;function n(z,W,H){const T=[];function P(x,V,X){if(!(V===0&&X.length===0)){const Q=T[T.length-1];Q&&Q.start+Q.deleteCount===x?(Q.deleteCount+=V,Q.toInsert.push(...X)):T.push({start:x,deleteCount:V,toInsert:X})}}let F=0,N=0;for(;;){if(F===z.length){P(F,0,W.slice(N));break}if(N===W.length){P(F,z.length-F,[]);break}const x=z[F],V=W[N],X=H(x,V);X===0?(F+=1,N+=1):X<0?(P(F,1,[]),F+=1):X>0&&(P(F,0,[V]),N+=1)}return T}e.sortedDiff=n;function f(z,W,H){const T=n(z,W,H),P=[],F=[];for(const N of T)P.push(...z.slice(N.start,N.start+N.deleteCount)),F.push(...N.toInsert);return{removed:P,added:F}}e.delta=f;function v(z,W,H){if(H===0)return[];const T=z.slice(0,H).sort(W);return d(z,W,T,H,z.length),T}e.top=v;function C(z,W,H,T,P){return H===0?Promise.resolve([]):new Promise((F,N)=>{(async()=>{const x=z.length,V=z.slice(0,H).sort(W);for(let X=H,Q=Math.min(H+T,x);X<x;X=Q,Q=Math.min(Q+T,x)){if(X>H&&await new Promise(ie=>setTimeout(ie)),P&&P.isCancellationRequested)throw(0,p.canceled)();d(z,W,V,X,Q)}return V})().then(F,N)})}e.topAsync=C;function d(z,W,H,T,P){for(const F=H.length;T<P;T++){const N=z[T];if(W(N,H[F-1])<0){H.pop();const x=A(H,V=>W(N,V)<0);H.splice(x,0,N)}}}function w(z){return z.filter(W=>!!W)}e.coalesce=w;function I(z){let W=0;for(let H=0;H<z.length;H++)z[H]&&(z[W]=z[H],W+=1);z.length=W}e.coalesceInPlace=I;function E(z,W,H){z.splice(H,0,z.splice(W,1)[0])}e.move=E;function D(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=D;function g(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=g;function a(z,W){if(!W)return z.filter((T,P)=>z.indexOf(T)===P);const H=Object.create(null);return z.filter(T=>{const P=W(T);return H[P]?!1:(H[P]=!0,!0)})}e.distinct=a;function s(z){const W=new Set;return z.filter(H=>W.has(H)?!1:(W.add(H),!0))}e.distinctES6=s;function t(z){const W=Object.create(null);return H=>{const T=z(H);return W[T]?!1:(W[T]=!0,!0)}}e.uniqueFilter=t;function i(z,W){for(let H=z.length-1;H>=0;H--){const T=z[H];if(W(T))return H}return-1}e.lastIndex=i;function r(z,W){return z.length>0?z[0]:W}e.firstOrDefault=r;function o(z,W,H=(T,P)=>T===P){let T=0;for(let P=0,F=Math.min(z.length,W.length);P<F&&H(z[P],W[P]);P++)T++;return T}e.commonPrefixLength=o;function c(z){return[].concat(...z)}e.flatten=c;function l(z,W){let H=typeof W=="number"?z:0;typeof W=="number"?H=z:(H=0,W=z);const T=[];if(H<=W)for(let P=H;P<W;P++)T.push(P);else for(let P=H;P>W;P--)T.push(P);return T}e.range=l;function u(z,W,H){return z.reduce((T,P)=>(T[W(P)]=H?H(P):P,T),Object.create(null))}e.index=u;function m(z,W){return z.push(W),()=>b(z,W)}e.insert=m;function b(z,W){const H=z.indexOf(W);if(H>-1)return z.splice(H,1),W}e.remove=b;function h(z,W,H){const T=z.slice(0,W),P=z.slice(W);return T.concat(H,P)}e.arrayInsert=h;function k(z,W){let H;if(typeof W=="number"){let T=W;H=()=>{const P=Math.sin(T++)*179426549;return P-Math.floor(P)}}else H=Math.random;for(let T=z.length-1;T>0;T-=1){const P=Math.floor(H()*(T+1)),F=z[T];z[T]=z[P],z[P]=F}}e.shuffle=k;function _(z,W){const H=z.indexOf(W);H>-1&&(z.splice(H,1),z.unshift(W))}e.pushToStart=_;function j(z,W){const H=z.indexOf(W);H>-1&&(z.splice(H,1),z.push(W))}e.pushToEnd=j;function q(z,W){return Array.isArray(z)?z.map(W):W(z)}e.mapArrayOrNot=q;function K(z){return Array.isArray(z)?z:[z]}e.asArray=K;function M(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=M;function $(z,W){for(const H of z){const T=W(H);if(T!==void 0)return T}}e.mapFind=$}),define(Z[65],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const O=this;let R=!1,U;return function(){return R||(R=!0,U=L.apply(O,arguments)),U}}e.once=p}),define(Z[53],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function O(s){return s&&typeof s=="object"&&typeof s[Symbol.iterator]=="function"}L.is=O;const R=Object.freeze([]);function U(){return R}L.empty=U;function*A(s){yield s}L.single=A;function S(s){return s||R}L.from=S;function y(s){return!s||s[Symbol.iterator]().next().done===!0}L.isEmpty=y;function n(s){return s[Symbol.iterator]().next().value}L.first=n;function f(s,t){for(const i of s)if(t(i))return!0;return!1}L.some=f;function v(s,t){for(const i of s)if(t(i))return i}L.find=v;function*C(s,t){for(const i of s)t(i)&&(yield i)}L.filter=C;function*d(s,t){for(const i of s)yield t(i)}L.map=d;function*w(...s){for(const t of s)for(const i of t)yield i}L.concat=w;function*I(s){for(const t of s)for(const i of t)yield i}L.concatNested=I;function E(s,t,i){let r=i;for(const o of s)r=t(r,o);return r}L.reduce=E;function*D(s,t,i=s.length){for(t<0&&(t+=s.length),i<0?i+=s.length:i>s.length&&(i=s.length);t<i;t++)yield s[t]}L.slice=D;function g(s,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,s];const r=s[Symbol.iterator]();for(let o=0;o<t;o++){const c=r.next();if(c.done)return[i,L.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return r}}]}L.consume=g;function a(s,t,i=(r,o)=>r===o){const r=s[Symbol.iterator](),o=t[Symbol.iterator]();for(;;){const c=r.next(),l=o.next();if(c.done!==l.done)return!1;if(c.done)return!0;if(!i(c.value,l.value))return!1}}L.equals=a})(p=e.Iterable||(e.Iterable={}))}),define(Z[33],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var O;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(O=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function U(t,i=!1){let r=0,o=t.length,c="",l=0,u=16,m=0;function b(M){let $=0,z=0;for(;$<M;){const W=t.charCodeAt(r);if(W>=48&&W<=57)z=z*16+W-48;else if(W>=65&&W<=70)z=z*16+W-65+10;else if(W>=97&&W<=102)z=z*16+W-97+10;else break;r++,$++}return $<M&&(z=-1),z}function h(M){r=M,c="",l=0,u=16,m=0}function k(){const M=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&y(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&y(t.charCodeAt(r)))for(r++;r<t.length&&y(t.charCodeAt(r));)r++;else return m=3,t.substring(M,r);let $=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&y(t.charCodeAt(r))){for(r++;r<t.length&&y(t.charCodeAt(r));)r++;$=r}else m=3;return t.substring(M,$)}function _(){let M="",$=r;for(;;){if(r>=o){M+=t.substring($,r),m=2;break}const z=t.charCodeAt(r);if(z===34){M+=t.substring($,r),r++;break}if(z===92){if(M+=t.substring($,r),r++,r>=o){m=2;break}switch(t.charCodeAt(r++)){case 34:M+='"';break;case 92:M+="\\";break;case 47:M+="/";break;case 98:M+="\b";break;case 102:M+="\f";break;case 110:M+=`
`;break;case 114:M+="\r";break;case 116:M+="	";break;case 117:const H=b(4);H>=0?M+=String.fromCharCode(H):m=4;break;default:m=5}$=r;continue}if(z>=0&&z<=31)if(S(z)){M+=t.substring($,r),m=2;break}else m=6;r++}return M}function j(){if(c="",m=0,l=r,r>=o)return l=o,u=17;let M=t.charCodeAt(r);if(A(M)){do r++,c+=String.fromCharCode(M),M=t.charCodeAt(r);while(A(M));return u=15}if(S(M))return r++,c+=String.fromCharCode(M),M===13&&t.charCodeAt(r)===10&&(r++,c+=`
`),u=14;switch(M){case 123:return r++,u=1;case 125:return r++,u=2;case 91:return r++,u=3;case 93:return r++,u=4;case 58:return r++,u=6;case 44:return r++,u=5;case 34:return r++,c=_(),u=10;case 47:const $=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<o&&!S(t.charCodeAt(r));)r++;return c=t.substring($,r),u=12}if(t.charCodeAt(r+1)===42){r+=2;const z=o-1;let W=!1;for(;r<z;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,W=!0;break}r++}return W||(r++,m=1),c=t.substring($,r),u=13}return c+=String.fromCharCode(M),r++,u=16;case 45:if(c+=String.fromCharCode(M),r++,r===o||!y(t.charCodeAt(r)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=k(),u=11;default:for(;r<o&&q(M);)r++,M=t.charCodeAt(r);if(l!==r){switch(c=t.substring(l,r),c){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return c+=String.fromCharCode(M),r++,u=16}}function q(M){if(A(M)||S(M))return!1;switch(M){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let M;do M=j();while(M>=12&&M<=15);return M}return{setPosition:h,getPosition:()=>r,scan:i?K:j,getToken:()=>u,getTokenValue:()=>c,getTokenOffset:()=>l,getTokenLength:()=>r-l,getTokenError:()=>m}}e.createScanner=U;function A(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function S(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var n;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(n||(n={}));function f(t,i){const r=[],o=new Object;let c;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function m(b,h,k,_){l.value=b,l.offset=h,l.length=k,l.type=_,l.colonOffset=void 0,c=l}try{g(t,{onObjectBegin:(b,h)=>{if(i<=b)throw o;c=void 0,u=i>b,r.push("")},onObjectProperty:(b,h,k)=>{if(i<h||(m(b,h,k,"property"),r[r.length-1]=b,i<=h+k))throw o},onObjectEnd:(b,h)=>{if(i<=b)throw o;c=void 0,r.pop()},onArrayBegin:(b,h)=>{if(i<=b)throw o;c=void 0,r.push(0)},onArrayEnd:(b,h)=>{if(i<=b)throw o;c=void 0,r.pop()},onLiteralValue:(b,h,k)=>{if(i<h||(m(b,h,k,s(b)),i<=h+k))throw o},onSeparator:(b,h,k)=>{if(i<=h)throw o;if(b===":"&&c&&c.type==="property")c.colonOffset=h,u=!1,c=void 0;else if(b===","){const _=r[r.length-1];typeof _=="number"?r[r.length-1]=_+1:(u=!0,r[r.length-1]=""),c=void 0}}})}catch(b){if(b!==o)throw b}return{path:r,previousNode:c,isAtPropertyKey:u,matches:b=>{let h=0;for(let k=0;h<b.length&&k<r.length;k++)if(b[h]===r[k]||b[h]==="*")h++;else if(b[h]!=="**")return!1;return h===b.length}}}e.getLocation=f;function v(t,i=[],r=R.DEFAULT){let o=null,c=[];const l=[];function u(b){Array.isArray(c)?c.push(b):o!==null&&(c[o]=b)}return g(t,{onObjectBegin:()=>{const b={};u(b),l.push(c),c=b,o=null},onObjectProperty:b=>{o=b},onObjectEnd:()=>{c=l.pop()},onArrayBegin:()=>{const b=[];u(b),l.push(c),c=b,o=null},onArrayEnd:()=>{c=l.pop()},onLiteralValue:u,onError:(b,h,k)=>{i.push({error:b,offset:h,length:k})}},r),c[0]}e.parse=v;function C(t,i=[],r=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(b){o.type==="property"&&(o.length=b-o.offset,o=o.parent)}function l(b){return o.children.push(b),b}g(t,{onObjectBegin:b=>{o=l({type:"object",offset:b,length:-1,parent:o,children:[]})},onObjectProperty:(b,h,k)=>{o=l({type:"property",offset:h,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:b,offset:h,length:k,parent:o})},onObjectEnd:(b,h)=>{o.length=b+h-o.offset,o=o.parent,c(b+h)},onArrayBegin:(b,h)=>{o=l({type:"array",offset:b,length:-1,parent:o,children:[]})},onArrayEnd:(b,h)=>{o.length=b+h-o.offset,o=o.parent,c(b+h)},onLiteralValue:(b,h,k)=>{l({type:s(b),offset:h,length:k,parent:o,value:b}),c(h+k)},onSeparator:(b,h,k)=>{o.type==="property"&&(b===":"?o.colonOffset=h:b===","&&c(h))},onError:(b,h,k)=>{i.push({error:b,offset:h,length:k})}},r);const m=o.children[0];return m&&delete m.parent,m}e.parseTree=C;function d(t,i){if(!!t){let r=t;for(let o of i)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const l of r.children)if(Array.isArray(l.children)&&l.children[0].value===o){r=l.children[1],c=!0;break}if(!c)return}else{const c=o;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}}e.findNodeAtLocation=d;function w(t){if(!t.parent||!t.parent.children)return[];const i=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;i.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&i.push(r)}return i}e.getNodePath=w;function I(t){switch(t.type){case"array":return t.children.map(I);case"object":const i=Object.create(null);for(let r of t.children){const o=r.children[1];o&&(i[r.children[0].value]=I(o))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=I;function E(t,i,r=!1){return i>=t.offset&&i<t.offset+t.length||r&&i===t.offset+t.length}e.contains=E;function D(t,i,r=!1){if(E(t,i,r)){const o=t.children;if(Array.isArray(o))for(let c=0;c<o.length&&o[c].offset<=i;c++){const l=D(o[c],i,r);if(l)return l}return t}}e.findNodeAtOffset=D;function g(t,i,r=R.DEFAULT){const o=U(t,!1);function c(V){return V?()=>V(o.getTokenOffset(),o.getTokenLength()):()=>!0}function l(V){return V?X=>V(X,o.getTokenOffset(),o.getTokenLength()):()=>!0}const u=c(i.onObjectBegin),m=l(i.onObjectProperty),b=c(i.onObjectEnd),h=c(i.onArrayBegin),k=c(i.onArrayEnd),_=l(i.onLiteralValue),j=l(i.onSeparator),q=c(i.onComment),K=l(i.onError),M=r&&r.disallowComments,$=r&&r.allowTrailingComma;function z(){for(;;){const V=o.scan();switch(o.getTokenError()){case 4:W(14);break;case 5:W(15);break;case 3:W(13);break;case 1:M||W(11);break;case 2:W(12);break;case 6:W(16);break}switch(V){case 12:case 13:M?W(10):q();break;case 16:W(1);break;case 15:case 14:break;default:return V}}}function W(V,X=[],Q=[]){if(K(V),X.length+Q.length>0){let ie=o.getToken();for(;ie!==17;){if(X.indexOf(ie)!==-1){z();break}else if(Q.indexOf(ie)!==-1)break;ie=z()}}}function H(V){const X=o.getTokenValue();return V?_(X):m(X),z(),!0}function T(){switch(o.getToken()){case 11:let V=0;try{V=JSON.parse(o.getTokenValue()),typeof V!="number"&&(W(2),V=0)}catch(X){W(2)}_(V);break;case 7:_(null);break;case 8:_(!0);break;case 9:_(!1);break;default:return!1}return z(),!0}function P(){return o.getToken()!==10?(W(3,[],[2,5]),!1):(H(!1),o.getToken()===6?(j(":"),z(),x()||W(4,[],[2,5])):W(5,[],[2,5]),!0)}function F(){u(),z();let V=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(V||W(4,[],[]),j(","),z(),o.getToken()===2&&$)break}else V&&W(6,[],[]);P()||W(4,[],[2,5]),V=!0}return b(),o.getToken()!==2?W(7,[2],[]):z(),!0}function N(){h(),z();let V=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(V||W(4,[],[]),j(","),z(),o.getToken()===4&&$)break}else V&&W(6,[],[]);x()||W(4,[],[4,5]),V=!0}return k(),o.getToken()!==4?W(8,[4],[]):z(),!0}function x(){switch(o.getToken()){case 3:return N();case 1:return F();case 10:return H(!0);default:return T()}}return z(),o.getToken()===17?r.allowEmptyContent?!0:(W(4,[],[]),!1):x()?(o.getToken()!==17&&W(9,[],[]),!0):(W(4,[],[]),!1)}e.visit=g;function a(t,i){let r=U(t),o=[],c,l=0,u;do switch(u=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:l!==u&&o.push(t.substring(l,u)),i!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,i)),l=r.getPosition();break}while(c!==17);return o.join("")}e.stripComments=a;function s(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=s}),define(Z[47],ee([0,1,33]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(S,y,n){let f,v,C,d,w;if(y){for(d=y.offset,w=d+y.length,C=d;C>0&&!A(S,C-1);)C--;let l=w;for(;l<S.length&&!A(S,l);)l++;v=S.substring(C,l),f=R(v,n)}else v=S,f=0,C=0,d=0,w=S.length;const I=U(n,S);let E=!1,D=0,g;n.insertSpaces?g=O(" ",n.tabSize||4):g="	";const a=(0,p.createScanner)(v,!1);let s=!1;function t(){return I+O(g,f+D)}function i(){let l=a.scan();for(E=!1;l===15||l===14;)E=E||l===14,l=a.scan();return s=l===16||a.getTokenError()!==0,l}const r=[];function o(l,u,m){!s&&u<w&&m>d&&S.substring(u,m)!==l&&r.push({offset:u,length:m-u,content:l})}let c=i();if(c!==17){const l=a.getTokenOffset()+C,u=O(g,f);o(u,C,l)}for(;c!==17;){let l=a.getTokenOffset()+a.getTokenLength()+C,u=i(),m="";for(;!E&&(u===12||u===13);){const h=a.getTokenOffset()+C;o(" ",l,h),l=a.getTokenOffset()+a.getTokenLength()+C,m=u===12?t():"",u=i()}if(u===2)c!==1&&(D--,m=t());else if(u===4)c!==3&&(D--,m=t());else{switch(c){case 3:case 1:D++,m=t();break;case 5:case 12:m=t();break;case 13:E?m=t():m=" ";break;case 6:m=" ";break;case 10:if(u===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:u===12||u===13?m=" ":u!==5&&u!==17&&(s=!0);break;case 16:s=!0;break}E&&(u===12||u===13)&&(m=t())}const b=a.getTokenOffset()+C;o(m,l,b),c=u}return r}e.format=L;function O(S,y){let n="";for(let f=0;f<y;f++)n+=S;return n}function R(S,y){let n=0,f=0;const v=y.tabSize||4;for(;n<S.length;){const C=S.charAt(n);if(C===" ")f++;else if(C==="	")f+=v;else break;n++}return Math.floor(f/v)}function U(S,y){for(let n=0;n<y.length;n++){const f=y.charAt(n);if(f==="\r")return n+1<y.length&&y.charAt(n+1)===`
`?`\r
`:"\r";if(f===`
`)return`
`}return S&&S.eol||`
`}e.getEOL=U;function A(S,y){return`\r
`.indexOf(S.charAt(y))!==-1}e.isEOL=A}),define(Z[41],ee([0,1,33,47]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function O(y,n,f){return R(y,n,void 0,f)}e.removeProperty=O;function R(y,n,f,v,C){const d=n.slice(),w=[],I=(0,p.parseTree)(y,w);let E,D;for(;d.length>0&&(D=d.pop(),E=(0,p.findNodeAtLocation)(I,d),E===void 0&&f!==void 0);)typeof D=="string"?f={[D]:f}:f=[f];if(E)if(E.type==="object"&&typeof D=="string"&&Array.isArray(E.children)){const g=(0,p.findNodeAtLocation)(E,[D]);if(g!==void 0)if(f===void 0){if(!g.parent)throw new Error("Malformed AST");const a=E.children.indexOf(g.parent);let s,t=g.parent.offset+g.parent.length;if(a>0){const i=E.children[a-1];s=i.offset+i.length}else s=E.offset+1,E.children.length>1&&(t=E.children[1].offset);return U(y,{offset:s,length:t-s,content:""},v)}else return U(y,{offset:g.offset,length:g.length,content:JSON.stringify(f)},v);else{if(f===void 0)return[];const a=`${JSON.stringify(D)}: ${JSON.stringify(f)}`,s=C?C(E.children.map(i=>i.children[0].value)):E.children.length;let t;if(s>0){const i=E.children[s-1];t={offset:i.offset+i.length,length:0,content:","+a}}else E.children.length===0?t={offset:E.offset+1,length:0,content:a}:t={offset:E.offset+1,length:0,content:a+","};return U(y,t,v)}}else if(E.type==="array"&&typeof D=="number"&&Array.isArray(E.children))if(f!==void 0){const g=`${JSON.stringify(f)}`;let a;if(E.children.length===0||D===0)a={offset:E.offset+1,length:0,content:E.children.length===0?g:g+","};else{const s=D===-1||D>E.children.length?E.children.length:D,t=E.children[s-1];a={offset:t.offset+t.length,length:0,content:","+g}}return U(y,a,v)}else{const g=D,a=E.children[g];let s;if(E.children.length===1)s={offset:E.offset+1,length:E.length-2,content:""};else if(E.children.length-1===g){const t=E.children[g-1],i=t.offset+t.length,r=E.offset+E.length;s={offset:i,length:r-2-i,content:""}}else s={offset:a.offset,length:E.children[g+1].offset-a.offset,content:""};return U(y,s,v)}else throw new Error(`Can not add ${typeof D!="number"?"index":"property"} to parent of type ${E.type}`);else{if(f===void 0)throw new Error("Can not delete in empty document");return U(y,{offset:I?I.offset:0,length:I?I.length:0,content:JSON.stringify(f)},v)}}e.setProperty=R;function U(y,n,f){let v=A(y,n),C=n.offset,d=n.offset+n.content.length;if(n.length===0||n.content.length===0){for(;C>0&&!(0,L.isEOL)(v,C-1);)C--;for(;d<v.length&&!(0,L.isEOL)(v,d);)d++}const w=(0,L.format)(v,{offset:C,length:d-C},f);for(let E=w.length-1;E>=0;E--){const D=w[E];v=A(v,D),C=Math.min(C,D.offset),d=Math.max(d,D.offset+D.length),d+=D.content.length-D.length}const I=y.length-(v.length-d)-C;return[{offset:C,length:I,content:v.substring(C,d)}]}e.withFormatting=U;function A(y,n){return y.substring(0,n.offset)+n.content+y.substring(n.offset+n.length)}e.applyEdit=A;function S(y,n){let f=n.slice(0).sort((C,d)=>{const w=C.offset-d.offset;return w===0?C.length-d.length:w}),v=y.length;for(let C=f.length-1;C>=0;C--){let d=f[C];if(d.offset+d.length<=v)y=A(y,d);else throw new Error("Overlapping edit");v=d.offset}return y}e.applyEdits=S}),define(Z[2],ee([0,1,65,53]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const O=!1;let R=null;function U(g){R=g}if(e.setDisposableTracker=U,O){const g="__is_disposable_tracked__";R=new class{trackDisposable(a){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[g]||console.log(s)},3e3)}markTracked(a){if(a&&a!==w.None)try{a[g]=!0}catch(s){}}}}function A(g){!R||R.markTracked(g)}function S(g){return R&&R.trackDisposable(g),g}e.trackDisposable=S;class y extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=y;function n(g){return typeof g.dispose=="function"&&g.dispose.length===0}e.isDisposable=n;function f(g){if(L.Iterable.is(g)){let a=[];for(const s of g)if(s){A(s);try{s.dispose()}catch(t){a.push(t)}}if(a.length===1)throw a[0];if(a.length>1)throw new y(a);return Array.isArray(g)?[]:g}else if(g)return A(g),g.dispose(),g}e.dispose=f;function v(...g){return g.forEach(A),C(()=>f(g))}e.combinedDisposable=v;function C(g){const a=S({dispose:()=>{A(a),g()}});return a}e.toDisposable=C;class d{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(A(this),this._isDisposed=!0,this.clear())}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return A(a),this._isDisposed?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class w{constructor(){this._store=new d,S(this)}dispose(){A(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=w,w.None=Object.freeze({dispose(){}});class I{constructor(){this._isDisposed=!1,S(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){var s;this._isDisposed||a===this._value||((s=this._value)===null||s===void 0||s.dispose(),a&&A(a),this._value=a)}clear(){this.value=void 0}dispose(){var a;this._isDisposed=!0,A(this),(a=this._value)===null||a===void 0||a.dispose(),this._value=void 0}}e.MutableDisposable=I;class E{constructor(){this.references=new Map}acquire(a,...s){let t=this.references.get(a);t||(t={counter:0,object:this.createReferencedObject(a,...s)},this.references.set(a,t));const{object:i}=t,r=(0,p.once)(()=>{--t.counter==0&&(this.destroyReferencedObject(a,t.object),this.references.delete(a))});return t.counter++,{object:i,dispose:r}}}e.ReferenceCollection=E;class D{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=D}),define(Z[66],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(R){this.element=R,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let R=this._first;for(;R!==p.Undefined;){const U=R.next;R.prev=p.Undefined,R.next=p.Undefined,R=U}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,U){const A=new p(R);if(this._first===p.Undefined)this._first=A,this._last=A;else if(U){const y=this._last;this._last=A,A.prev=y,y.next=A}else{const y=this._first;this._first=A,A.next=y,y.prev=A}this._size+=1;let S=!1;return()=>{S||(S=!0,this._remove(A))}}shift(){if(this._first!==p.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==p.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==p.Undefined&&R.next!==p.Undefined){const U=R.prev;U.next=R.next,R.next.prev=U}else R.prev===p.Undefined&&R.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):R.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):R.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==p.Undefined;)yield R.element,R=R.next}}e.LinkedList=L});"use strict";(function(){function G(O){const R=[];typeof O=="number"&&R.push("code/timeOrigin",O);function U(S){R.push(S,Date.now())}function A(){const S=[];for(let y=0;y<R.length;y+=2)S.push({name:R[y],startTime:R[y+1]});return S}return{mark:U,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?G():{mark(O){performance.mark(O)},getMarks(){let O=performance.timeOrigin;typeof O!="number"&&(O=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(O)}];for(const U of performance.getEntriesByType("mark"))R.push({name:U.name,startTime:Math.round(O+U.startTime)});return R}};if(typeof process=="object"){const O=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return G(O)}else return console.trace("perf-util loaded in UNKNOWN environment"),G()}function p(O){return O.MonacoPerformanceMarks||(O.MonacoPerformanceMarks=e()),O.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))})(),define(Z[6],ee([0,1]),function(G,e){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const L="en";let O=!1,R=!1,U=!1,A=!1,S=!1,y=!1,n=!1,f,v=L,C,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let w;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?w=e.globals.vscode.process:typeof process!="undefined"&&(w=process);const I=typeof((p=w==null?void 0:w.versions)===null||p===void 0?void 0:p.electron)=="string"&&w.type==="renderer";if(e.isElectronSandboxed=I&&(w==null?void 0:w.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const o=w==null?void 0:w.env.VSCODE_BROWSER_CODE_LOADING;if(typeof o=="string")return o==="none"||o==="code"||o==="bypassHeatCheck"||o==="bypassHeatCheckAndEagerCompile"?o:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!I)d=navigator.userAgent,O=d.indexOf("Windows")>=0,R=d.indexOf("Macintosh")>=0,n=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,U=d.indexOf("Linux")>=0,y=!0,f=navigator.language,v=f;else if(typeof w=="object"){O=w.platform==="win32",R=w.platform==="darwin",U=w.platform==="linux",A=U&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,f=L,v=L;const o=w.env.VSCODE_NLS_CONFIG;if(o)try{const c=JSON.parse(o),l=c.availableLanguages["*"];f=c.locale,v=l||L,C=c._translationsConfigFile}catch(c){}S=!0}else console.error("Unable to resolve platform.");var E;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function D(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let g=0;R?g=1:O?g=3:U&&(g=2),e.isWindows=O,e.isMacintosh=R,e.isLinux=U,e.isLinuxSnap=A,e.isNative=S,e.isWeb=y,e.isIOS=n,e.platform=g,e.userAgent=d,e.language=v;var a;(function(o){function c(){return e.language}o.value=c;function l(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}o.isDefaultVariant=l;function u(){return e.language==="en"}o.isDefault=u})(a=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=C,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let l=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeSetImmediateId)for(let b=0,h=l.length;b<h;b++){const k=l[b];if(k.id===m.data.vscodeSetImmediateId){l.splice(b,1),k.callback();return}}});let u=0;return m=>{const b=++u;l.push({id:b,callback:m}),e.globals.postMessage({vscodeSetImmediateId:b},"*")}}if(typeof(w==null?void 0:w.nextTick)=="function")return w.nextTick.bind(w);const c=Promise.resolve();return l=>c.then(l)}();var s;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||n?2:O?1:3;let t=!0,i=!1;function r(){if(!i){i=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,t=new Uint16Array(o.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=r}),define(Z[35],ee([0,1,6]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const O=p.globals.vscode.process;L={get platform(){return O.platform},get env(){return O.env},cwd(){return O.cwd()},nextTick(R){return(0,p.setImmediate)(R)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(O){return process.nextTick(O)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},nextTick(O){return(0,p.setImmediate)(O)},get env(){return Object.create(null)},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick}),define(Z[7],ee([0,1,35]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,O=97,R=90,U=122,A=46,S=47,y=92,n=58,f=63;class v extends Error{constructor(a,s,t){let i;typeof s=="string"&&s.indexOf("not ")===0?(i="must not be",s=s.replace(/^not /,"")):i="must be";const r=a.indexOf(".")!==-1?"property":"argument";let o=`The "${a}" ${r} ${i} of type ${s}`;o+=`. Received type ${typeof t}`,super(o),this.code="ERR_INVALID_ARG_TYPE"}}function C(g,a){if(typeof g!="string")throw new v(a,"string",g)}function d(g){return g===S||g===y}function w(g){return g===S}function I(g){return g>=L&&g<=R||g>=O&&g<=U}function E(g,a,s,t){let i="",r=0,o=-1,c=0,l=0;for(let u=0;u<=g.length;++u){if(u<g.length)l=g.charCodeAt(u);else{if(t(l))break;l=S}if(t(l)){if(!(o===u-1||c===1))if(c===2){if(i.length<2||r!==2||i.charCodeAt(i.length-1)!==A||i.charCodeAt(i.length-2)!==A){if(i.length>2){const m=i.lastIndexOf(s);m===-1?(i="",r=0):(i=i.slice(0,m),r=i.length-1-i.lastIndexOf(s)),o=u,c=0;continue}else if(i.length!==0){i="",r=0,o=u,c=0;continue}}a&&(i+=i.length>0?`${s}..`:"..",r=2)}else i.length>0?i+=`${s}${g.slice(o+1,u)}`:i=g.slice(o+1,u),r=u-o-1;o=u,c=0}else l===A&&c!==-1?++c:c=-1}return i}function D(g,a){if(a===null||typeof a!="object")throw new v("pathObject","Object",a);const s=a.dir||a.root,t=a.base||`${a.name||""}${a.ext||""}`;return s?s===a.root?`${s}${t}`:`${s}${g}${t}`:t}e.win32={resolve(...g){let a="",s="",t=!1;for(let i=g.length-1;i>=-1;i--){let r;if(i>=0){if(r=g[i],C(r,"path"),r.length===0)continue}else a.length===0?r=p.cwd():(r=p.env[`=${a}`]||p.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==a.toLowerCase()&&r.charCodeAt(2)===y)&&(r=`${a}\\`));const o=r.length;let c=0,l="",u=!1;const m=r.charCodeAt(0);if(o===1)d(m)&&(c=1,u=!0);else if(d(m))if(u=!0,d(r.charCodeAt(1))){let b=2,h=b;for(;b<o&&!d(r.charCodeAt(b));)b++;if(b<o&&b!==h){const k=r.slice(h,b);for(h=b;b<o&&d(r.charCodeAt(b));)b++;if(b<o&&b!==h){for(h=b;b<o&&!d(r.charCodeAt(b));)b++;(b===o||b!==h)&&(l=`\\\\${k}\\${r.slice(h,b)}`,c=b)}}}else c=1;else I(m)&&r.charCodeAt(1)===n&&(l=r.slice(0,2),c=2,o>2&&d(r.charCodeAt(2))&&(u=!0,c=3));if(l.length>0)if(a.length>0){if(l.toLowerCase()!==a.toLowerCase())continue}else a=l;if(t){if(a.length>0)break}else if(s=`${r.slice(c)}\\${s}`,t=u,u&&a.length>0)break}return s=E(s,!t,"\\",d),t?`${a}\\${s}`:`${a}${s}`||"."},normalize(g){C(g,"path");const a=g.length;if(a===0)return".";let s=0,t,i=!1;const r=g.charCodeAt(0);if(a===1)return w(r)?"\\":g;if(d(r))if(i=!0,d(g.charCodeAt(1))){let c=2,l=c;for(;c<a&&!d(g.charCodeAt(c));)c++;if(c<a&&c!==l){const u=g.slice(l,c);for(l=c;c<a&&d(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&!d(g.charCodeAt(c));)c++;if(c===a)return`\\\\${u}\\${g.slice(l)}\\`;c!==l&&(t=`\\\\${u}\\${g.slice(l,c)}`,s=c)}}}else s=1;else I(r)&&g.charCodeAt(1)===n&&(t=g.slice(0,2),s=2,a>2&&d(g.charCodeAt(2))&&(i=!0,s=3));let o=s<a?E(g.slice(s),!i,"\\",d):"";return o.length===0&&!i&&(o="."),o.length>0&&d(g.charCodeAt(a-1))&&(o+="\\"),t===void 0?i?`\\${o}`:o:i?`${t}\\${o}`:`${t}${o}`},isAbsolute(g){C(g,"path");const a=g.length;if(a===0)return!1;const s=g.charCodeAt(0);return d(s)||a>2&&I(s)&&g.charCodeAt(1)===n&&d(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let a,s;for(let r=0;r<g.length;++r){const o=g[r];C(o,"path"),o.length>0&&(a===void 0?a=s=o:a+=`\\${o}`)}if(a===void 0)return".";let t=!0,i=0;if(typeof s=="string"&&d(s.charCodeAt(0))){++i;const r=s.length;r>1&&d(s.charCodeAt(1))&&(++i,r>2&&(d(s.charCodeAt(2))?++i:t=!1))}if(t){for(;i<a.length&&d(a.charCodeAt(i));)i++;i>=2&&(a=`\\${a.slice(i)}`)}return e.win32.normalize(a)},relative(g,a){if(C(g,"from"),C(a,"to"),g===a)return"";const s=e.win32.resolve(g),t=e.win32.resolve(a);if(s===t||(g=s.toLowerCase(),a=t.toLowerCase(),g===a))return"";let i=0;for(;i<g.length&&g.charCodeAt(i)===y;)i++;let r=g.length;for(;r-1>i&&g.charCodeAt(r-1)===y;)r--;const o=r-i;let c=0;for(;c<a.length&&a.charCodeAt(c)===y;)c++;let l=a.length;for(;l-1>c&&a.charCodeAt(l-1)===y;)l--;const u=l-c,m=o<u?o:u;let b=-1,h=0;for(;h<m;h++){const _=g.charCodeAt(i+h);if(_!==a.charCodeAt(c+h))break;_===y&&(b=h)}if(h!==m){if(b===-1)return t}else{if(u>m){if(a.charCodeAt(c+h)===y)return t.slice(c+h+1);if(h===2)return t.slice(c+h)}o>m&&(g.charCodeAt(i+h)===y?b=h:h===2&&(b=3)),b===-1&&(b=0)}let k="";for(h=i+b+1;h<=r;++h)(h===r||g.charCodeAt(h)===y)&&(k+=k.length===0?"..":"\\..");return c+=b,k.length>0?`${k}${t.slice(c,l)}`:(t.charCodeAt(c)===y&&++c,t.slice(c,l))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const a=e.win32.resolve(g);if(a.length<=2)return g;if(a.charCodeAt(0)===y){if(a.charCodeAt(1)===y){const s=a.charCodeAt(2);if(s!==f&&s!==A)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(I(a.charCodeAt(0))&&a.charCodeAt(1)===n&&a.charCodeAt(2)===y)return`\\\\?\\${a}`;return g},dirname(g){C(g,"path");const a=g.length;if(a===0)return".";let s=-1,t=0;const i=g.charCodeAt(0);if(a===1)return d(i)?g:".";if(d(i)){if(s=t=1,d(g.charCodeAt(1))){let c=2,l=c;for(;c<a&&!d(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&d(g.charCodeAt(c));)c++;if(c<a&&c!==l){for(l=c;c<a&&!d(g.charCodeAt(c));)c++;if(c===a)return g;c!==l&&(s=t=c+1)}}}}else I(i)&&g.charCodeAt(1)===n&&(s=a>2&&d(g.charCodeAt(2))?3:2,t=s);let r=-1,o=!0;for(let c=a-1;c>=t;--c)if(d(g.charCodeAt(c))){if(!o){r=c;break}}else o=!1;if(r===-1){if(s===-1)return".";r=s}return g.slice(0,r)},basename(g,a){a!==void 0&&C(a,"ext"),C(g,"path");let s=0,t=-1,i=!0,r;if(g.length>=2&&I(g.charCodeAt(0))&&g.charCodeAt(1)===n&&(s=2),a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let o=a.length-1,c=-1;for(r=g.length-1;r>=s;--r){const l=g.charCodeAt(r);if(d(l)){if(!i){s=r+1;break}}else c===-1&&(i=!1,c=r+1),o>=0&&(l===a.charCodeAt(o)?--o==-1&&(t=r):(o=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(r=g.length-1;r>=s;--r)if(d(g.charCodeAt(r))){if(!i){s=r+1;break}}else t===-1&&(i=!1,t=r+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let a=0,s=-1,t=0,i=-1,r=!0,o=0;g.length>=2&&g.charCodeAt(1)===n&&I(g.charCodeAt(0))&&(a=t=2);for(let c=g.length-1;c>=a;--c){const l=g.charCodeAt(c);if(d(l)){if(!r){t=c+1;break}continue}i===-1&&(r=!1,i=c+1),l===A?s===-1?s=c:o!==1&&(o=1):s!==-1&&(o=-1)}return s===-1||i===-1||o===0||o===1&&s===i-1&&s===t+1?"":g.slice(s,i)},format:D.bind(null,"\\"),parse(g){C(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const s=g.length;let t=0,i=g.charCodeAt(0);if(s===1)return d(i)?(a.root=a.dir=g,a):(a.base=a.name=g,a);if(d(i)){if(t=1,d(g.charCodeAt(1))){let b=2,h=b;for(;b<s&&!d(g.charCodeAt(b));)b++;if(b<s&&b!==h){for(h=b;b<s&&d(g.charCodeAt(b));)b++;if(b<s&&b!==h){for(h=b;b<s&&!d(g.charCodeAt(b));)b++;b===s?t=b:b!==h&&(t=b+1)}}}}else if(I(i)&&g.charCodeAt(1)===n){if(s<=2)return a.root=a.dir=g,a;if(t=2,d(g.charCodeAt(2))){if(s===3)return a.root=a.dir=g,a;t=3}}t>0&&(a.root=g.slice(0,t));let r=-1,o=t,c=-1,l=!0,u=g.length-1,m=0;for(;u>=t;--u){if(i=g.charCodeAt(u),d(i)){if(!l){o=u+1;break}continue}c===-1&&(l=!1,c=u+1),i===A?r===-1?r=u:m!==1&&(m=1):r!==-1&&(m=-1)}return c!==-1&&(r===-1||m===0||m===1&&r===c-1&&r===o+1?a.base=a.name=g.slice(o,c):(a.name=g.slice(o,r),a.base=g.slice(o,c),a.ext=g.slice(r,c))),o>0&&o!==t?a.dir=g.slice(0,o-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let a="",s=!1;for(let t=g.length-1;t>=-1&&!s;t--){const i=t>=0?g[t]:p.cwd();C(i,"path"),i.length!==0&&(a=`${i}/${a}`,s=i.charCodeAt(0)===S)}return a=E(a,!s,"/",w),s?`/${a}`:a.length>0?a:"."},normalize(g){if(C(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S,s=g.charCodeAt(g.length-1)===S;return g=E(g,!a,"/",w),g.length===0?a?"/":s?"./":".":(s&&(g+="/"),a?`/${g}`:g)},isAbsolute(g){return C(g,"path"),g.length>0&&g.charCodeAt(0)===S},join(...g){if(g.length===0)return".";let a;for(let s=0;s<g.length;++s){const t=g[s];C(t,"path"),t.length>0&&(a===void 0?a=t:a+=`/${t}`)}return a===void 0?".":e.posix.normalize(a)},relative(g,a){if(C(g,"from"),C(a,"to"),g===a||(g=e.posix.resolve(g),a=e.posix.resolve(a),g===a))return"";const s=1,t=g.length,i=t-s,r=1,o=a.length-r,c=i<o?i:o;let l=-1,u=0;for(;u<c;u++){const b=g.charCodeAt(s+u);if(b!==a.charCodeAt(r+u))break;b===S&&(l=u)}if(u===c)if(o>c){if(a.charCodeAt(r+u)===S)return a.slice(r+u+1);if(u===0)return a.slice(r+u)}else i>c&&(g.charCodeAt(s+u)===S?l=u:u===0&&(l=0));let m="";for(u=s+l+1;u<=t;++u)(u===t||g.charCodeAt(u)===S)&&(m+=m.length===0?"..":"/..");return`${m}${a.slice(r+l)}`},toNamespacedPath(g){return g},dirname(g){if(C(g,"path"),g.length===0)return".";const a=g.charCodeAt(0)===S;let s=-1,t=!0;for(let i=g.length-1;i>=1;--i)if(g.charCodeAt(i)===S){if(!t){s=i;break}}else t=!1;return s===-1?a?"/":".":a&&s===1?"//":g.slice(0,s)},basename(g,a){a!==void 0&&C(a,"ext"),C(g,"path");let s=0,t=-1,i=!0,r;if(a!==void 0&&a.length>0&&a.length<=g.length){if(a===g)return"";let o=a.length-1,c=-1;for(r=g.length-1;r>=0;--r){const l=g.charCodeAt(r);if(l===S){if(!i){s=r+1;break}}else c===-1&&(i=!1,c=r+1),o>=0&&(l===a.charCodeAt(o)?--o==-1&&(t=r):(o=-1,t=c))}return s===t?t=c:t===-1&&(t=g.length),g.slice(s,t)}for(r=g.length-1;r>=0;--r)if(g.charCodeAt(r)===S){if(!i){s=r+1;break}}else t===-1&&(i=!1,t=r+1);return t===-1?"":g.slice(s,t)},extname(g){C(g,"path");let a=-1,s=0,t=-1,i=!0,r=0;for(let o=g.length-1;o>=0;--o){const c=g.charCodeAt(o);if(c===S){if(!i){s=o+1;break}continue}t===-1&&(i=!1,t=o+1),c===A?a===-1?a=o:r!==1&&(r=1):a!==-1&&(r=-1)}return a===-1||t===-1||r===0||r===1&&a===t-1&&a===s+1?"":g.slice(a,t)},format:D.bind(null,"/"),parse(g){C(g,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return a;const s=g.charCodeAt(0)===S;let t;s?(a.root="/",t=1):t=0;let i=-1,r=0,o=-1,c=!0,l=g.length-1,u=0;for(;l>=t;--l){const m=g.charCodeAt(l);if(m===S){if(!c){r=l+1;break}continue}o===-1&&(c=!1,o=l+1),m===A?i===-1?i=l:u!==1&&(u=1):i!==-1&&(u=-1)}if(o!==-1){const m=r===0&&s?1:r;i===-1||u===0||u===1&&i===o-1&&i===r+1?a.base=a.name=g.slice(m,o):(a.name=g.slice(m,i),a.base=g.slice(m,o),a.ext=g.slice(i,o))}return r>0?a.dir=g.slice(0,r-1):s&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),function(G,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var p=e();for(var L in p)(typeof exports=="object"?exports:G)[L]=p[L]}}(typeof self!="undefined"?self:this,function(){return function(G){var e={};function p(L){if(e[L])return e[L].exports;var O=e[L]={i:L,l:!1,exports:{}};return G[L].call(O.exports,O,O.exports,p),O.l=!0,O.exports}return p.m=G,p.c=e,p.d=function(L,O,R){p.o(L,O)||Object.defineProperty(L,O,{enumerable:!0,get:R})},p.r=function(L){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},p.t=function(L,O){if(1&O&&(L=p(L)),8&O||4&O&&typeof L=="object"&&L&&L.__esModule)return L;var R=Object.create(null);if(p.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:L}),2&O&&typeof L!="string")for(var U in L)p.d(R,U,function(A){return L[A]}.bind(null,U));return R},p.n=function(L){var O=L&&L.__esModule?function(){return L.default}:function(){return L};return p.d(O,"a",O),O},p.o=function(L,O){return Object.prototype.hasOwnProperty.call(L,O)},p.p="",p(p.s=0)}([function(G,e,p){(function(L){var O;e=G.exports=Q,O=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var J=Array.prototype.slice.call(arguments,0);J.unshift("SEMVER"),console.log.apply(console,J)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,U=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],S=e.src=[],y=0,n=y++;S[n]="0|[1-9]\\d*";var f=y++;S[f]="[0-9]+";var v=y++;S[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var C=y++;S[C]="("+S[n]+")\\.("+S[n]+")\\.("+S[n]+")";var d=y++;S[d]="("+S[f]+")\\.("+S[f]+")\\.("+S[f]+")";var w=y++;S[w]="(?:"+S[n]+"|"+S[v]+")";var I=y++;S[I]="(?:"+S[f]+"|"+S[v]+")";var E=y++;S[E]="(?:-("+S[w]+"(?:\\."+S[w]+")*))";var D=y++;S[D]="(?:-?("+S[I]+"(?:\\."+S[I]+")*))";var g=y++;S[g]="[0-9A-Za-z-]+";var a=y++;S[a]="(?:\\+("+S[g]+"(?:\\."+S[g]+")*))";var s=y++,t="v?"+S[C]+S[E]+"?"+S[a]+"?";S[s]="^"+t+"$";var i="[v=\\s]*"+S[d]+S[D]+"?"+S[a]+"?",r=y++;S[r]="^"+i+"$";var o=y++;S[o]="((?:<|>)?=?)";var c=y++;S[c]=S[f]+"|x|X|\\*";var l=y++;S[l]=S[n]+"|x|X|\\*";var u=y++;S[u]="[v=\\s]*("+S[l]+")(?:\\.("+S[l]+")(?:\\.("+S[l]+")(?:"+S[E]+")?"+S[a]+"?)?)?";var m=y++;S[m]="[v=\\s]*("+S[c]+")(?:\\.("+S[c]+")(?:\\.("+S[c]+")(?:"+S[D]+")?"+S[a]+"?)?)?";var b=y++;S[b]="^"+S[o]+"\\s*"+S[u]+"$";var h=y++;S[h]="^"+S[o]+"\\s*"+S[m]+"$";var k=y++;S[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var _=y++;S[_]="(?:~>?)";var j=y++;S[j]="(\\s*)"+S[_]+"\\s+",A[j]=new RegExp(S[j],"g");var q=y++;S[q]="^"+S[_]+S[u]+"$";var K=y++;S[K]="^"+S[_]+S[m]+"$";var M=y++;S[M]="(?:\\^)";var $=y++;S[$]="(\\s*)"+S[M]+"\\s+",A[$]=new RegExp(S[$],"g");var z=y++;S[z]="^"+S[M]+S[u]+"$";var W=y++;S[W]="^"+S[M]+S[m]+"$";var H=y++;S[H]="^"+S[o]+"\\s*("+i+")$|^$";var T=y++;S[T]="^"+S[o]+"\\s*("+t+")$|^$";var P=y++;S[P]="(\\s*)"+S[o]+"\\s*("+i+"|"+S[u]+")",A[P]=new RegExp(S[P],"g");var F=y++;S[F]="^\\s*("+S[u]+")\\s+-\\s+("+S[u]+")\\s*$";var N=y++;S[N]="^\\s*("+S[m]+")\\s+-\\s+("+S[m]+")\\s*$";var x=y++;S[x]="(<|>)?=?\\s*\\*";for(var V=0;V<35;V++)O(V,S[V]),A[V]||(A[V]=new RegExp(S[V]));function X(J,re){if(J instanceof Q)return J;if(typeof J!="string"||J.length>R||!(re?A[r]:A[s]).test(J))return null;try{return new Q(J,re)}catch(se){return null}}function Q(J,re){if(J instanceof Q){if(J.loose===re)return J;J=J.version}else if(typeof J!="string")throw new TypeError("Invalid Version: "+J);if(J.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof Q))return new Q(J,re);O("SemVer",J,re),this.loose=re;var se=J.trim().match(re?A[r]:A[s]);if(!se)throw new TypeError("Invalid Version: "+J);if(this.raw=J,this.major=+se[1],this.minor=+se[2],this.patch=+se[3],this.major>U||this.major<0)throw new TypeError("Invalid major version");if(this.minor>U||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>U||this.patch<0)throw new TypeError("Invalid patch version");se[4]?this.prerelease=se[4].split(".").map(function(ve){if(/^[0-9]+$/.test(ve)){var Se=+ve;if(Se>=0&&Se<U)return Se}return ve}):this.prerelease=[],this.build=se[5]?se[5].split("."):[],this.format()}e.parse=X,e.valid=function(J,re){var se=X(J,re);return se?se.version:null},e.clean=function(J,re){var se=X(J.trim().replace(/^[=v]+/,""),re);return se?se.version:null},e.SemVer=Q,Q.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Q.prototype.toString=function(){return this.version},Q.prototype.compare=function(J){return O("SemVer.compare",this.version,this.loose,J),J instanceof Q||(J=new Q(J,this.loose)),this.compareMain(J)||this.comparePre(J)},Q.prototype.compareMain=function(J){return J instanceof Q||(J=new Q(J,this.loose)),ne(this.major,J.major)||ne(this.minor,J.minor)||ne(this.patch,J.patch)},Q.prototype.comparePre=function(J){if(J instanceof Q||(J=new Q(J,this.loose)),this.prerelease.length&&!J.prerelease.length)return-1;if(!this.prerelease.length&&J.prerelease.length)return 1;if(!this.prerelease.length&&!J.prerelease.length)return 0;var re=0;do{var se=this.prerelease[re],ve=J.prerelease[re];if(O("prerelease compare",re,se,ve),se===void 0&&ve===void 0)return 0;if(ve===void 0)return 1;if(se===void 0)return-1;if(se!==ve)return ne(se,ve)}while(++re)},Q.prototype.inc=function(J,re){switch(J){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",re);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",re);break;case"prepatch":this.prerelease.length=0,this.inc("patch",re),this.inc("pre",re);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",re),this.inc("pre",re);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var se=this.prerelease.length;--se>=0;)typeof this.prerelease[se]=="number"&&(this.prerelease[se]++,se=-2);se===-1&&this.prerelease.push(0)}re&&(this.prerelease[0]===re?isNaN(this.prerelease[1])&&(this.prerelease=[re,0]):this.prerelease=[re,0]);break;default:throw new Error("invalid increment argument: "+J)}return this.format(),this.raw=this.version,this},e.inc=function(J,re,se,ve){typeof se=="string"&&(ve=se,se=void 0);try{return new Q(J,se).inc(re,ve).version}catch(Se){return null}},e.diff=function(J,re){if(pe(J,re))return null;var se=X(J),ve=X(re);if(se.prerelease.length||ve.prerelease.length){for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==ve[Se])return"pre"+Se;return"prerelease"}for(var Se in se)if((Se==="major"||Se==="minor"||Se==="patch")&&se[Se]!==ve[Se])return Se},e.compareIdentifiers=ne;var ie=/^[0-9]+$/;function ne(J,re){var se=ie.test(J),ve=ie.test(re);return se&&ve&&(J=+J,re=+re),se&&!ve?-1:ve&&!se?1:J<re?-1:J>re?1:0}function ce(J,re,se){return new Q(J,se).compare(new Q(re,se))}function ue(J,re,se){return ce(J,re,se)>0}function ge(J,re,se){return ce(J,re,se)<0}function pe(J,re,se){return ce(J,re,se)===0}function Ce(J,re,se){return ce(J,re,se)!==0}function ke(J,re,se){return ce(J,re,se)>=0}function Fe(J,re,se){return ce(J,re,se)<=0}function Oe(J,re,se,ve){var Se;switch(re){case"===":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J===se;break;case"!==":typeof J=="object"&&(J=J.version),typeof se=="object"&&(se=se.version),Se=J!==se;break;case"":case"=":case"==":Se=pe(J,se,ve);break;case"!=":Se=Ce(J,se,ve);break;case">":Se=ue(J,se,ve);break;case">=":Se=ke(J,se,ve);break;case"<":Se=ge(J,se,ve);break;case"<=":Se=Fe(J,se,ve);break;default:throw new TypeError("Invalid operator: "+re)}return Se}function Ae(J,re){if(J instanceof Ae){if(J.loose===re)return J;J=J.value}if(!(this instanceof Ae))return new Ae(J,re);O("comparator",J,re),this.loose=re,this.parse(J),this.semver===je?this.value="":this.value=this.operator+this.semver.version,O("comp",this)}e.rcompareIdentifiers=function(J,re){return ne(re,J)},e.major=function(J,re){return new Q(J,re).major},e.minor=function(J,re){return new Q(J,re).minor},e.patch=function(J,re){return new Q(J,re).patch},e.compare=ce,e.compareLoose=function(J,re){return ce(J,re,!0)},e.rcompare=function(J,re,se){return ce(re,J,se)},e.sort=function(J,re){return J.sort(function(se,ve){return e.compare(se,ve,re)})},e.rsort=function(J,re){return J.sort(function(se,ve){return e.rcompare(se,ve,re)})},e.gt=ue,e.lt=ge,e.eq=pe,e.neq=Ce,e.gte=ke,e.lte=Fe,e.cmp=Oe,e.Comparator=Ae;var je={};function Ie(J,re){if(J instanceof Ie)return J.loose===re?J:new Ie(J.raw,re);if(J instanceof Ae)return new Ie(J.value,re);if(!(this instanceof Ie))return new Ie(J,re);if(this.loose=re,this.raw=J,this.set=J.split(/\s*\|\|\s*/).map(function(se){return this.parseRange(se.trim())},this).filter(function(se){return se.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+J);this.format()}function Te(J){return!J||J.toLowerCase()==="x"||J==="*"}function Ke(J,re,se,ve,Se,Pe,be,Ue,De,B,te,ae,oe){return((re=Te(se)?"":Te(ve)?">="+se+".0.0":Te(Se)?">="+se+"."+ve+".0":">="+re)+" "+(Ue=Te(De)?"":Te(B)?"<"+(+De+1)+".0.0":Te(te)?"<"+De+"."+(+B+1)+".0":ae?"<="+De+"."+B+"."+te+"-"+ae:"<="+Ue)).trim()}function Ye(J,re){for(var se=0;se<J.length;se++)if(!J[se].test(re))return!1;if(re.prerelease.length){for(se=0;se<J.length;se++)if(O(J[se].semver),J[se].semver!==je&&J[se].semver.prerelease.length>0){var ve=J[se].semver;if(ve.major===re.major&&ve.minor===re.minor&&ve.patch===re.patch)return!0}return!1}return!0}function $e(J,re,se){try{re=new Ie(re,se)}catch(ve){return!1}return re.test(J)}function qe(J,re,se,ve){var Se,Pe,be,Ue,De;switch(J=new Q(J,ve),re=new Ie(re,ve),se){case">":Se=ue,Pe=Fe,be=ge,Ue=">",De=">=";break;case"<":Se=ge,Pe=ke,be=ue,Ue="<",De="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if($e(J,re,ve))return!1;for(var B=0;B<re.set.length;++B){var te=re.set[B],ae=null,oe=null;if(te.forEach(function(he){he.semver===je&&(he=new Ae(">=0.0.0")),ae=ae||he,oe=oe||he,Se(he.semver,ae.semver,ve)?ae=he:be(he.semver,oe.semver,ve)&&(oe=he)}),ae.operator===Ue||ae.operator===De||(!oe.operator||oe.operator===Ue)&&Pe(J,oe.semver)||oe.operator===De&&be(J,oe.semver))return!1}return!0}Ae.prototype.parse=function(J){var re=this.loose?A[H]:A[T],se=J.match(re);if(!se)throw new TypeError("Invalid comparator: "+J);this.operator=se[1],this.operator==="="&&(this.operator=""),se[2]?this.semver=new Q(se[2],this.loose):this.semver=je},Ae.prototype.toString=function(){return this.value},Ae.prototype.test=function(J){return O("Comparator.test",J,this.loose),this.semver===je||(typeof J=="string"&&(J=new Q(J,this.loose)),Oe(J,this.operator,this.semver,this.loose))},Ae.prototype.intersects=function(J,re){if(!(J instanceof Ae))throw new TypeError("a Comparator is required");var se;if(this.operator==="")return se=new Ie(J.value,re),$e(this.value,se,re);if(J.operator==="")return se=new Ie(this.value,re),$e(J.semver,se,re);var ve=!(this.operator!==">="&&this.operator!==">"||J.operator!==">="&&J.operator!==">"),Se=!(this.operator!=="<="&&this.operator!=="<"||J.operator!=="<="&&J.operator!=="<"),Pe=this.semver.version===J.semver.version,be=!(this.operator!==">="&&this.operator!=="<="||J.operator!==">="&&J.operator!=="<="),Ue=Oe(this.semver,"<",J.semver,re)&&(this.operator===">="||this.operator===">")&&(J.operator==="<="||J.operator==="<"),De=Oe(this.semver,">",J.semver,re)&&(this.operator==="<="||this.operator==="<")&&(J.operator===">="||J.operator===">");return ve||Se||Pe&&be||Ue||De},e.Range=Ie,Ie.prototype.format=function(){return this.range=this.set.map(function(J){return J.join(" ").trim()}).join("||").trim(),this.range},Ie.prototype.toString=function(){return this.range},Ie.prototype.parseRange=function(J){var re=this.loose;J=J.trim(),O("range",J,re);var se=re?A[N]:A[F];J=J.replace(se,Ke),O("hyphen replace",J),J=J.replace(A[P],"$1$2$3"),O("comparator trim",J,A[P]),J=(J=(J=J.replace(A[j],"$1~")).replace(A[$],"$1^")).split(/\s+/).join(" ");var ve=re?A[H]:A[T],Se=J.split(" ").map(function(Pe){return function(be,Ue){return O("comp",be),be=function(De,B){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){O("caret",ae,oe);var he=oe?A[W]:A[z];return ae.replace(he,function(me,fe,ye,we,Ee){var le;return O("caret",ae,me,fe,ye,we,Ee),Te(fe)?le="":Te(ye)?le=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?le=fe==="0"?">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+".0 <"+(+fe+1)+".0.0":Ee?(O("replaceCaret pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+Ee+" <"+(+fe+1)+".0.0"):(O("no pr"),le=fe==="0"?ye==="0"?">="+fe+"."+ye+"."+we+" <"+fe+"."+ye+"."+(+we+1):">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0":">="+fe+"."+ye+"."+we+" <"+(+fe+1)+".0.0"),O("caret return",le),le})}(te,B)}).join(" ")}(be,Ue),O("caret",be),be=function(De,B){return De.trim().split(/\s+/).map(function(te){return function(ae,oe){var he=oe?A[K]:A[q];return ae.replace(he,function(me,fe,ye,we,Ee){var le;return O("tilde",ae,me,fe,ye,we,Ee),Te(fe)?le="":Te(ye)?le=">="+fe+".0.0 <"+(+fe+1)+".0.0":Te(we)?le=">="+fe+"."+ye+".0 <"+fe+"."+(+ye+1)+".0":Ee?(O("replaceTilde pr",Ee),Ee.charAt(0)!=="-"&&(Ee="-"+Ee),le=">="+fe+"."+ye+"."+we+Ee+" <"+fe+"."+(+ye+1)+".0"):le=">="+fe+"."+ye+"."+we+" <"+fe+"."+(+ye+1)+".0",O("tilde return",le),le})}(te,B)}).join(" ")}(be,Ue),O("tildes",be),be=function(De,B){return O("replaceXRanges",De,B),De.split(/\s+/).map(function(te){return function(ae,oe){ae=ae.trim();var he=oe?A[h]:A[b];return ae.replace(he,function(me,fe,ye,we,Ee,le){O("xRange",ae,me,fe,ye,we,Ee,le);var Re=Te(ye),_e=Re||Te(we),Me=_e||Te(Ee);return fe==="="&&Me&&(fe=""),Re?me=fe===">"||fe==="<"?"<0.0.0":"*":fe&&Me?(_e&&(we=0),Me&&(Ee=0),fe===">"?(fe=">=",_e?(ye=+ye+1,we=0,Ee=0):Me&&(we=+we+1,Ee=0)):fe==="<="&&(fe="<",_e?ye=+ye+1:we=+we+1),me=fe+ye+"."+we+"."+Ee):_e?me=">="+ye+".0.0 <"+(+ye+1)+".0.0":Me&&(me=">="+ye+"."+we+".0 <"+ye+"."+(+we+1)+".0"),O("xRange return",me),me})}(te,B)}).join(" ")}(be,Ue),O("xrange",be),be=function(De,B){return O("replaceStars",De,B),De.trim().replace(A[x],"")}(be,Ue),O("stars",be),be}(Pe,re)}).join(" ").split(/\s+/);return this.loose&&(Se=Se.filter(function(Pe){return!!Pe.match(ve)})),Se=Se.map(function(Pe){return new Ae(Pe,re)})},Ie.prototype.intersects=function(J,re){if(!(J instanceof Ie))throw new TypeError("a Range is required");return this.set.some(function(se){return se.every(function(ve){return J.set.some(function(Se){return Se.every(function(Pe){return ve.intersects(Pe,re)})})})})},e.toComparators=function(J,re){return new Ie(J,re).set.map(function(se){return se.map(function(ve){return ve.value}).join(" ").trim().split(" ")})},Ie.prototype.test=function(J){if(!J)return!1;typeof J=="string"&&(J=new Q(J,this.loose));for(var re=0;re<this.set.length;re++)if(Ye(this.set[re],J))return!0;return!1},e.satisfies=$e,e.maxSatisfying=function(J,re,se){var ve=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(ve&&Se.compare(be)!==-1||(Se=new Q(ve=be,se)))}),ve},e.minSatisfying=function(J,re,se){var ve=null,Se=null;try{var Pe=new Ie(re,se)}catch(be){return null}return J.forEach(function(be){Pe.test(be)&&(ve&&Se.compare(be)!==1||(Se=new Q(ve=be,se)))}),ve},e.validRange=function(J,re){try{return new Ie(J,re).range||"*"}catch(se){return null}},e.ltr=function(J,re,se){return qe(J,re,"<",se)},e.gtr=function(J,re,se){return qe(J,re,">",se)},e.outside=qe,e.prerelease=function(J,re){var se=X(J,re);return se&&se.prerelease.length?se.prerelease:null},e.intersects=function(J,re,se){return J=new Ie(J,se),re=new Ie(re,se),J.intersects(re)},e.coerce=function(J){if(J instanceof Q)return J;if(typeof J!="string")return null;var re=J.match(A[k]);return re==null?null:X((re[1]||"0")+"."+(re[2]||"0")+"."+(re[3]||"0"))}}).call(this,p(1))},function(G,e){var p,L,O=G.exports={};function R(){throw new Error("setTimeout has not been defined")}function U(){throw new Error("clearTimeout has not been defined")}function A(I){if(p===setTimeout)return setTimeout(I,0);if((p===R||!p)&&setTimeout)return p=setTimeout,setTimeout(I,0);try{return p(I,0)}catch(E){try{return p.call(null,I,0)}catch(D){return p.call(this,I,0)}}}(function(){try{p=typeof setTimeout=="function"?setTimeout:R}catch(I){p=R}try{L=typeof clearTimeout=="function"?clearTimeout:U}catch(I){L=U}})();var S,y=[],n=!1,f=-1;function v(){n&&S&&(n=!1,S.length?y=S.concat(y):f=-1,y.length&&C())}function C(){if(!n){var I=A(v);n=!0;for(var E=y.length;E;){for(S=y,y=[];++f<E;)S&&S[f].run();f=-1,E=y.length}S=null,n=!1,function(D){if(L===clearTimeout)return clearTimeout(D);if((L===U||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(D);try{L(D)}catch(g){try{return L.call(null,D)}catch(a){return L.call(this,D)}}}(I)}}function d(I,E){this.fun=I,this.array=E}function w(){}O.nextTick=function(I){var E=new Array(arguments.length-1);if(arguments.length>1)for(var D=1;D<arguments.length;D++)E[D-1]=arguments[D];y.push(new d(I,E)),y.length!==1||n||A(C)},d.prototype.run=function(){this.fun.apply(null,this.array)},O.title="browser",O.browser=!0,O.env={},O.argv=[],O.version="",O.versions={},O.on=w,O.addListener=w,O.once=w,O.off=w,O.removeListener=w,O.removeAllListeners=w,O.emit=w,O.prependListener=w,O.prependOnceListener=w,O.listeners=function(I){return[]},O.binding=function(I){throw new Error("process.binding is not supported")},O.cwd=function(){return"/"},O.chdir=function(I){throw new Error("process.chdir is not supported")},O.umask=function(){return 0}}])}),define(Z[87],ee([0,1,6]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class O{constructor(U){this._highResolution=L&&U,this._startTime=this._now(),this._stopTime=-1}static create(U=!0){return new O(U)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=O}),define(Z[3],ee([0,1,11,65,2,66,87]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var A;(function(E){E.None=()=>O.Disposable.None;function D(M){return($,z=null,W)=>{let H=!1,T;return T=M(P=>{if(!H)return T?T.dispose():H=!0,$.call(z,P)},null,W),H&&T.dispose(),T}}E.once=D;function g(M,$){return o((z,W=null,H)=>M(T=>z.call(W,$(T)),null,H))}E.map=g;function a(M,$){return o((z,W=null,H)=>M(T=>{$(T),z.call(W,T)},null,H))}E.forEach=a;function s(M,$){return o((z,W=null,H)=>M(T=>$(T)&&z.call(W,T),null,H))}E.filter=s;function t(M){return M}E.signal=t;function i(...M){return($,z=null,W)=>(0,O.combinedDisposable)(...M.map(H=>H(T=>$.call(z,T),null,W)))}E.any=i;function r(M,$,z){let W=z;return g(M,H=>(W=$(W,H),W))}E.reduce=r;function o(M){let $;const z=new v({onFirstListenerAdd(){$=M(z.fire,z)},onLastListenerRemove(){$.dispose()}});return z.event}E.snapshot=o;function c(M,$,z=100,W=!1,H){let T,P,F,N=0;const x=new v({leakWarningThreshold:H,onFirstListenerAdd(){T=M(V=>{N++,P=$(P,V),W&&!F&&(x.fire(P),P=void 0),clearTimeout(F),F=setTimeout(()=>{const X=P;P=void 0,F=void 0,(!W||N>1)&&x.fire(X),N=0},z)})},onLastListenerRemove(){T.dispose()}});return x.event}E.debounce=c;function l(M){const $=new Date().getTime();return g(D(M),z=>new Date().getTime()-$)}E.stopwatch=l;function u(M,$=(z,W)=>z===W){let z=!0,W;return s(M,H=>{const T=z||!$(H,W);return z=!1,W=H,T})}E.latch=u;function m(M,$){return[E.filter(M,$),E.filter(M,z=>!$(z))]}E.split=m;function b(M,$=!1,z=[]){let W=z.slice(),H=M(F=>{W?W.push(F):P.fire(F)});const T=()=>{W&&W.forEach(F=>P.fire(F)),W=null},P=new v({onFirstListenerAdd(){H||(H=M(F=>P.fire(F)))},onFirstListenerDidAdd(){W&&($?setTimeout(T):T())},onLastListenerRemove(){H&&H.dispose(),H=null}});return P.event}E.buffer=b;class h{constructor($){this.event=$}map($){return new h(g(this.event,$))}forEach($){return new h(a(this.event,$))}filter($){return new h(s(this.event,$))}reduce($,z){return new h(r(this.event,$,z))}latch(){return new h(u(this.event))}debounce($,z=100,W=!1,H){return new h(c(this.event,$,z,W,H))}on($,z,W){return this.event($,z,W)}once($,z,W){return D(this.event)($,z,W)}}function k(M){return new h(M)}E.chain=k;function _(M,$,z=W=>W){const W=(...F)=>P.fire(z(...F)),H=()=>M.on($,W),T=()=>M.removeListener($,W),P=new v({onFirstListenerAdd:H,onLastListenerRemove:T});return P.event}E.fromNodeEventEmitter=_;function j(M,$,z=W=>W){const W=(...F)=>P.fire(z(...F)),H=()=>M.addEventListener($,W),T=()=>M.removeEventListener($,W),P=new v({onFirstListenerAdd:H,onLastListenerRemove:T});return P.event}E.fromDOMEventEmitter=j;function q(M){const $=new v;let z=!1;return M.then(void 0,()=>null).then(()=>{z?$.fire(void 0):setTimeout(()=>$.fire(void 0),0)}),z=!0,$.event}E.fromPromise=q;function K(M){return new Promise($=>D(M)($))}E.toPromise=K})(A=e.Event||(e.Event={}));class S{constructor(D){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${D}_${S._idPool++}`}start(D){this._stopWatch=new U.StopWatch(!0),this._listenerCount=D}stop(){if(this._stopWatch){const D=this._stopWatch.elapsed();this._elapsedOverall+=D,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${D.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}S._idPool=0;let y=-1;function n(E){const D=y;return y=E,{dispose(){y=D}}}e.setGlobalLeakWarningThreshold=n;class f{constructor(D,g=Math.random().toString(18).slice(2,5)){this.customThreshold=D,this.name=g,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(D){let g=y;if(typeof this.customThreshold=="number"&&(g=this.customThreshold),!(g<=0||D<g)){this._stacks||(this._stacks=new Map);const a=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(a)||0;if(this._stacks.set(a,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=g*.5;let t,i=0;for(const[r,o]of this._stacks)(!t||i<o)&&(t=r,i=o);console.warn(`[${this.name}] potential listener LEAK detected, having ${D} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(a)||0;this._stacks.set(a,t-1)}}}}class v{constructor(D){var g;this._disposed=!1,this._options=D,this._leakageMon=y>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((g=this._options)===null||g===void 0?void 0:g._profName)?new S(this._options._profName):void 0}get event(){return this._event||(this._event=(D,g,a)=>{var s;this._listeners||(this._listeners=new R.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(g?[D,g]:D);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,D,g);const r=(s=this._leakageMon)===null||s===void 0?void 0:s.check(this._listeners.size);let o;return o={dispose:()=>{r&&r(),o.dispose=v._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},a instanceof O.DisposableStore?a.add(o):Array.isArray(a)&&a.push(o),o}),this._event}fire(D){var g,a;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new R.LinkedList);for(let s of this._listeners)this._deliveryQueue.push([s,D]);for((g=this._perfMon)===null||g===void 0||g.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[s,t]=this._deliveryQueue.shift();try{typeof s=="function"?s.call(void 0,t):s[0].call(s[1],t)}catch(i){(0,p.onUnexpectedError)(i)}}(a=this._perfMon)===null||a===void 0||a.stop()}}dispose(){var D,g,a,s,t;this._disposed||(this._disposed=!0,(D=this._listeners)===null||D===void 0||D.clear(),(g=this._deliveryQueue)===null||g===void 0||g.clear(),(s=(a=this._options)===null||a===void 0?void 0:a.onLastListenerRemove)===null||s===void 0||s.call(a),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=v,v._noop=function(){};class C extends v{constructor(D){super(D);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=D==null?void 0:D.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const D=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(D))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(D){this._listeners&&(this._isPaused!==0?this._eventQueue.push(D):super.fire(D))}}e.PauseableEmitter=C;class d{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(D){const g={event:D,listener:null};this.events.push(g),this.hasListeners&&this.hook(g);const a=()=>{this.hasListeners&&this.unhook(g);const s=this.events.indexOf(g);this.events.splice(s,1)};return(0,O.toDisposable)((0,L.once)(a))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(D=>this.hook(D))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(D=>this.unhook(D))}hook(D){D.listener=D.event(g=>this.emitter.fire(g))}unhook(D){D.listener&&D.listener.dispose(),D.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=d;class w{constructor(){this.buffers=[]}wrapEvent(D){return(g,a,s)=>D(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>g.call(a,t)):g.call(a,t)},void 0,s)}bufferEvents(D){const g=[];this.buffers.push(g);const a=D();return this.buffers.pop(),g.forEach(s=>s()),a}}e.EventBufferer=w;class I{constructor(){this.listening=!1,this.inputEvent=A.None,this.inputEventListener=O.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(D){this.inputEvent=D,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=D(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=I}),define(Z[30],ee([0,1,3]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(A,S){const y=setTimeout(A.bind(S),0);return{dispose(){clearTimeout(y)}}});var O;(function(A){function S(y){return y===A.None||y===A.Cancelled||y instanceof R?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}A.isCancellationToken=S,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(O=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class U{constructor(S){this._token=void 0,this._parentListener=void 0,this._parentListener=S&&S.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=O.Cancelled}dispose(S=!1){S&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=O.None}}e.CancellationTokenSource=U}),define(Z[54],ee([0,1,3]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(f){const v=this._icons.get(f.id);v?f.description?v.description=f.description:console.error(`Duplicate registration of codicon ${f.id}`):(this._icons.set(f.id,f),this._onDidRegister.fire(f))}get(f){return this._icons.get(f)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const O=new L;e.iconRegistry=O;function R(n,f){return new A(n,f)}e.registerCodicon=R;function U(n){return n?n.replace(/\$\((.*?)\)/g,(f,v)=>` ${v} `).trim():""}e.getCodiconAriaLabel=U;class A{constructor(f,v,C){this.id=f,this.definition=v,this.description=C,O.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=A;function S(n,f){const v=["codicon","codicon-"+n];return f&&v.push("codicon-modifier-"+f),v}e.getClassNamesArray=S;var y;(function(n){n.iconNameSegment="[A-Za-z0-9]+",n.iconNameExpression="[A-Za-z0-9\\-]+",n.iconModifierExpression="~[A-Za-z]+";const f=new RegExp(`^(${n.iconNameExpression})(${n.iconModifierExpression})?$`);function v(w){if(w instanceof A)return["codicon","codicon-"+w.id];const I=f.exec(w.id);if(!I)return v(A.error);let[,E,D]=I;const g=["codicon","codicon-"+E];return D&&g.push("codicon-modifier-"+D.substr(1)),g}n.asClassNameArray=v;function C(w){return v(w).join(" ")}n.asClassName=C;function d(w){return"."+v(w).join(".")}n.asCSSSelector=d})(y=e.CSSIcon||(e.CSSIcon={})),function(n){n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",{fontCharacter:"\\ea60"}),n.gistNew=new n("gist-new",{fontCharacter:"\\ea60"}),n.repoCreate=new n("repo-create",{fontCharacter:"\\ea60"}),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eb0a"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.debugStackframeDot=new n("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition)}(A=e.Codicon||(e.Codicon={}))}),define(Z[48],ee([0,1,11,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function O(g){const a=g;return a?[a.on,a.pause,a.resume,a.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=O;function R(g){const a=g;return a?O(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.isReadableBufferedStream=R;function U(g,a){return new A(g,a)}e.newWriteableStream=U;class A{constructor(a,s){this.reducer=a,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(a){var s;if(!this.state.destroyed){if(this.state.flowing)this.emitData(a);else if(this.buffer.data.push(a),typeof((s=this.options)===null||s===void 0?void 0:s.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(a){this.state.destroyed||(this.state.flowing?this.emitError(a):this.buffer.error.push(a))}end(a){this.state.destroyed||(typeof a!="undefined"&&this.write(a),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(a){this.listeners.data.slice(0).forEach(s=>s(a))}emitError(a){this.listeners.error.length===0?(0,p.onUnexpectedError)(a):this.listeners.error.slice(0).forEach(s=>s(a))}emitEnd(){this.listeners.end.slice(0).forEach(a=>a())}on(a,s){if(!this.state.destroyed)switch(a){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(a,s){if(!this.state.destroyed){let t;switch(a){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(s);i>=0&&t.splice(i,1)}}}flowData(){if(this.buffer.data.length>0){const a=this.reducer(this.buffer.data);this.emitData(a),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const a of this.buffer.error)this.emitError(a);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function S(g,a){const s=[];let t;for(;(t=g.read())!==null;)s.push(t);return a(s)}e.consumeReadable=S;function y(g,a,s){const t=[];let i;for(;(i=g.read())!==null&&t.length<s;)t.push(i);return i===null&&t.length>0?a(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const r=i;return i=void 0,r}return g.read()}}}e.peekReadable=y;function n(g,a){return new Promise((s,t)=>{const i=[];f(g,{onData:r=>{a&&i.push(r)},onError:r=>{a?t(r):s(void 0)},onEnd:()=>{s(a?a(i):void 0)}})})}e.consumeStream=n;function f(g,a){g.on("error",s=>a.onError(s)),g.on("end",()=>a.onEnd()),g.on("data",s=>a.onData(s))}e.listenStream=f;function v(g,a){return new Promise((s,t)=>{const i=new L.DisposableStore,r=[],o=u=>{if(r.push(u),r.length>a)return i.dispose(),g.pause(),s({stream:g,buffer:r,ended:!1})},c=u=>t(u),l=()=>s({stream:g,buffer:r,ended:!0});i.add((0,L.toDisposable)(()=>g.removeListener("error",c))),g.on("error",c),i.add((0,L.toDisposable)(()=>g.removeListener("end",l))),g.on("end",l),i.add((0,L.toDisposable)(()=>g.removeListener("data",o))),g.on("data",o)})}e.peekStream=v;function C(g,a){const s=U(a);return s.end(g),s}e.toStream=C;function d(){const g=U(()=>{throw new Error("not supported")});return g.end(),g}e.emptyStream=d;function w(g){let a=!1;return{read:()=>a?null:(a=!0,g)}}e.toReadable=w;function I(g,a,s){const t=U(s);return f(g,{onData:i=>t.write(a.data(i)),onError:i=>t.error(a.error?a.error(i):i),onEnd:()=>t.end()}),t}e.transform=I;function E(g,a,s){let t=!1;return{read:()=>{const i=a.read();return t?i:(t=!0,i!==null?s([g,i]):g)}}}e.prefixedReadable=E;function D(g,a,s){let t=!1;const i=U(s);return f(a,{onData:r=>t?i.write(r):(t=!0,i.write(s([g,r]))),onError:r=>i.error(r),onEnd:()=>{t||(t=!0,i.write(g)),i.end()}}),i}e.prefixedStream=D}),define(Z[22],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function p(B){return!B||typeof B!="string"?!0:B.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function O(B,...te){return te.length===0?B:B.replace(L,function(ae,oe){const he=parseInt(oe,10);return isNaN(he)||he<0||he>=te.length?ae:te[he]})}e.format=O;function R(B){return B.replace(/[<>&]/g,function(te){switch(te){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return te}})}e.escape=R;function U(B){return B.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=U;function A(B,te){let ae=0;const oe=te.charCodeAt(0);for(let he=B.length-1;he>=0;he--)B.charCodeAt(he)===oe&&ae++;return ae}e.count=A;function S(B,te,ae="\u2026"){return B.length<=te?B:`${B.substr(0,te)}${ae}`}e.truncate=S;function y(B,te=" "){const ae=n(B,te);return f(ae,te)}e.trim=y;function n(B,te){if(!B||!te)return B;const ae=te.length;if(ae===0||B.length===0)return B;let oe=0;for(;B.indexOf(te,oe)===oe;)oe=oe+ae;return B.substring(oe)}e.ltrim=n;function f(B,te){if(!B||!te)return B;const ae=te.length,oe=B.length;if(ae===0||oe===0)return B;let he=oe,me=-1;for(;me=B.lastIndexOf(te,he-1),!(me===-1||me+ae!==he);){if(me===0)return"";he=me}return B.substring(0,he)}e.rtrim=f;function v(B){return B.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=v;function C(B){return B.replace(/\*/g,"")}e.stripWildcards=C;function d(B,te,ae={}){if(!B)throw new Error("Cannot create regex from empty string");te||(B=U(B)),ae.wholeWord&&(/\B/.test(B.charAt(0))||(B="\\b"+B),/\B/.test(B.charAt(B.length-1))||(B=B+"\\b"));let oe="";return ae.global&&(oe+="g"),ae.matchCase||(oe+="i"),ae.multiline&&(oe+="m"),ae.unicode&&(oe+="u"),new RegExp(B,oe)}e.createRegExp=d;function w(B){return B.source==="^"||B.source==="^$"||B.source==="$"||B.source==="^\\s*$"?!1:!!(B.exec("")&&B.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function I(B){return!!B.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=I;function E(B){return(B.global?"g":"")+(B.ignoreCase?"i":"")+(B.multiline?"m":"")+(B.unicode?"u":"")}e.regExpFlags=E;function D(B){return B.split(/\r\n|\r|\n/)}e.splitLines=D;function g(B){for(let te=0,ae=B.length;te<ae;te++){const oe=B.charCodeAt(te);if(oe!==32&&oe!==9)return te}return-1}e.firstNonWhitespaceIndex=g;function a(B,te=0,ae=B.length){for(let oe=te;oe<ae;oe++){const he=B.charCodeAt(oe);if(he!==32&&he!==9)return B.substring(te,oe)}return B.substring(te,ae)}e.getLeadingWhitespace=a;function s(B,te=B.length-1){for(let ae=te;ae>=0;ae--){const oe=B.charCodeAt(ae);if(oe!==32&&oe!==9)return ae}return-1}e.lastNonWhitespaceIndex=s;function t(B,te){return B<te?-1:B>te?1:0}e.compare=t;function i(B,te,ae=0,oe=B.length,he=0,me=te.length){for(;ae<oe&&he<me;ae++,he++){let we=B.charCodeAt(ae),Ee=te.charCodeAt(he);if(we<Ee)return-1;if(we>Ee)return 1}const fe=oe-ae,ye=me-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstring=i;function r(B,te){return o(B,te,0,B.length,0,te.length)}e.compareIgnoreCase=r;function o(B,te,ae=0,oe=B.length,he=0,me=te.length){for(;ae<oe&&he<me;ae++,he++){let we=B.charCodeAt(ae),Ee=te.charCodeAt(he);if(we!==Ee){const le=we-Ee;if(!(le===32&&l(Ee))&&!(le===-32&&l(we)))return c(we)&&c(Ee)?le:i(B.toLowerCase(),te.toLowerCase(),ae,oe,he,me)}}const fe=oe-ae,ye=me-he;return fe<ye?-1:fe>ye?1:0}e.compareSubstringIgnoreCase=o;function c(B){return B>=97&&B<=122}e.isLowerAsciiLetter=c;function l(B){return B>=65&&B<=90}e.isUpperAsciiLetter=l;function u(B){return c(B)||l(B)}function m(B,te){return B.length===te.length&&b(B,te)}e.equalsIgnoreCase=m;function b(B,te,ae=B.length){for(let oe=0;oe<ae;oe++){const he=B.charCodeAt(oe),me=te.charCodeAt(oe);if(he!==me){if(u(he)&&u(me)){const fe=Math.abs(he-me);if(fe!==0&&fe!==32)return!1}else if(String.fromCharCode(he).toLowerCase()!==String.fromCharCode(me).toLowerCase())return!1}}return!0}function h(B,te){const ae=te.length;return te.length>B.length?!1:b(B,te,ae)}e.startsWithIgnoreCase=h;function k(B,te){let ae,oe=Math.min(B.length,te.length);for(ae=0;ae<oe;ae++)if(B.charCodeAt(ae)!==te.charCodeAt(ae))return ae;return oe}e.commonPrefixLength=k;function _(B,te){let ae,oe=Math.min(B.length,te.length);const he=B.length-1,me=te.length-1;for(ae=0;ae<oe;ae++)if(B.charCodeAt(he-ae)!==te.charCodeAt(me-ae))return ae;return oe}e.commonSuffixLength=_;function j(B){return 55296<=B&&B<=56319}e.isHighSurrogate=j;function q(B){return 56320<=B&&B<=57343}e.isLowSurrogate=q;function K(B,te){return(B-55296<<10)+(te-56320)+65536}e.computeCodePoint=K;function M(B,te,ae){const oe=B.charCodeAt(ae);if(j(oe)&&ae+1<te){const he=B.charCodeAt(ae+1);if(q(he))return K(oe,he)}return oe}e.getNextCodePoint=M;function $(B,te){const ae=B.charCodeAt(te-1);if(q(ae)&&te>1){const oe=B.charCodeAt(te-2);if(j(oe))return K(oe,ae)}return ae}function z(B,te){const ae=se.getInstance(),oe=te,he=B.length,me=M(B,he,te);te+=me>=65536?2:1;let fe=ae.getGraphemeBreakType(me);for(;te<he;){const ye=M(B,he,te),we=ae.getGraphemeBreakType(ye);if(J(fe,we))break;te+=ye>=65536?2:1,fe=we}return te-oe}e.nextCharLength=z;function W(B,te){const ae=se.getInstance(),oe=te,he=$(B,te);te-=he>=65536?2:1;let me=ae.getGraphemeBreakType(he);for(;te>0;){const fe=$(B,te),ye=ae.getGraphemeBreakType(fe);if(J(ye,me))break;te-=fe>=65536?2:1,me=ye}return oe-te}e.prevCharLength=W;function H(B,te){const ae=se.getInstance(),oe=B.length,he=te,me=M(B,oe,te),fe=ae.getGraphemeBreakType(me);te+=me>=65536?2:1;let ye=fe;for(;te<oe;){const Ee=M(B,oe,te),le=ae.getGraphemeBreakType(Ee);if(J(ye,le))break;te+=Ee>=65536?2:1,ye=le}const we=te;for(te=he,ye=fe;te>0;){const Ee=$(B,te),le=ae.getGraphemeBreakType(Ee);if(J(le,ye))break;te-=Ee>=65536?2:1,ye=le}return[te,we]}function T(B,te){return te>0&&q(B.charCodeAt(te))?H(B,te-1):H(B,te)}e.getCharContainingOffset=T;function P(B){const te=B.length;let ae=0,oe=0;for(;oe<te;){const fe=M(B,te,oe);oe+=fe>=65536?2:1,fe<128?ae+=1:fe<2048?ae+=2:fe<65536?ae+=3:ae+=4}const he=new Uint8Array(ae);oe=0;let me=0;for(;oe<te;){const fe=M(B,te,oe);oe+=fe>=65536?2:1,fe<128?he[me++]=fe:fe<2048?(he[me++]=192|(fe&1984)>>>6,he[me++]=128|(fe&63)>>>0):fe<65536?(he[me++]=224|(fe&61440)>>>12,he[me++]=128|(fe&4032)>>>6,he[me++]=128|(fe&63)>>>0):(he[me++]=240|(fe&1835008)>>>18,he[me++]=128|(fe&258048)>>>12,he[me++]=128|(fe&4032)>>>6,he[me++]=128|(fe&63)>>>0)}return he}e.encodeUTF8=P;function F(B){const te=B.byteLength,ae=[];let oe=0;for(;oe<te;){const he=B[oe];let me;if(he>=240&&oe+3<te?me=(B[oe++]&7)<<18>>>0|(B[oe++]&63)<<12>>>0|(B[oe++]&63)<<6>>>0|(B[oe++]&63)<<0>>>0:he>=224&&oe+2<te?me=(B[oe++]&15)<<12>>>0|(B[oe++]&63)<<6>>>0|(B[oe++]&63)<<0>>>0:he>=192&&oe+1<te?me=(B[oe++]&31)<<6>>>0|(B[oe++]&63)<<0>>>0:me=B[oe++],me>=0&&me<=55295||me>=57344&&me<=65535)ae.push(String.fromCharCode(me));else if(me>=65536&&me<=1114111){const fe=me-65536,ye=55296+((fe&1047552)>>>10),we=56320+((fe&1023)>>>0);ae.push(String.fromCharCode(ye)),ae.push(String.fromCharCode(we))}else ae.push(String.fromCharCode(65533))}return ae.join("")}e.decodeUTF8=F;const N=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function x(B){return N.test(B)}e.containsRTL=x;const V=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function X(B){return V.test(B)}e.containsEmoji=X;const Q=/^[\t\n\r\x20-\x7E]*$/;function ie(B){return Q.test(B)}e.isBasicASCII=ie,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ne(B){return e.UNUSUAL_LINE_TERMINATORS.test(B)}e.containsUnusualLineTerminators=ne;function ce(B){for(let te=0,ae=B.length;te<ae;te++)if(ue(B.charCodeAt(te)))return!0;return!1}e.containsFullWidthCharacter=ce;function ue(B){return B=+B,B>=11904&&B<=55215||B>=63744&&B<=64255||B>=65281&&B<=65374}e.isFullWidthCharacter=ue;function ge(B){return B>=127462&&B<=127487||B===8986||B===8987||B===9200||B===9203||B>=9728&&B<=10175||B===11088||B===11093||B>=127744&&B<=128591||B>=128640&&B<=128764||B>=128992&&B<=129003||B>=129280&&B<=129535||B>=129648&&B<=129750}e.isEmojiImprecise=ge;function pe(B,te){if(B.length<te)return B;const ae=/\b/g;let oe=0;for(;ae.test(B)&&!(B.length-ae.lastIndex<te);)oe=ae.lastIndex,ae.lastIndex+=1;return B.substring(oe).replace(/^\s/,"")}e.lcut=pe;const Ce=/\x1B\x5B[12]?K/g,ke=/\x1b\[\d+m/g,Fe=/\x1b\[0?m/g;function Oe(B){return B&&(B=B.replace(Ce,""),B=B.replace(ke,""),B=B.replace(Fe,"")),B}e.removeAnsiEscapeCodes=Oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(B){return!!(B&&B.length>0&&B.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function je(B){return Ae(B)?B.substr(1):B}e.stripUTF8BOM=je;function Ie(B,te){if(!B||!te||B.length<te.length)return!1;const ae=te.length,oe=B.toLowerCase();let he=0,me=-1;for(;he<ae;){const fe=oe.indexOf(te[he],me+1);if(fe<0)return!1;me=fe,he++}return!0}e.fuzzyContains=Ie;function Te(B,te=!1){return B?(te&&(B=B.replace(/\\./g,"")),B.toLowerCase()!==B):!1}e.containsUppercaseCharacter=Te;function Ke(B){return B.charAt(0).toUpperCase()+B.slice(1)}e.uppercaseFirstLetter=Ke;function Ye(B,te=1){if(te===0)return"";let ae=-1;do ae=B.indexOf(`
`,ae+1),te--;while(te>0&&ae>=0);return ae===-1?B:(B[ae-1]==="\r"&&ae--,B.substr(0,ae))}e.getNLines=Ye;function $e(B){const te=90-65+1;return B=B%(2*te),B<te?String.fromCharCode(97+B):String.fromCharCode(65+B-te)}e.singleLetterHash=$e;function qe(B){return se.getInstance().getGraphemeBreakType(B)}e.getGraphemeBreakType=qe;function J(B,te){return B===0?te!==5&&te!==7:B===2&&te===3?!1:B===4||B===2||B===3||te===4||te===2||te===3?!0:!(B===8&&(te===8||te===9||te===11||te===12)||(B===11||B===9)&&(te===9||te===10)||(B===12||B===10)&&te===10||te===5||te===13||te===7||B===1||B===13&&te===14||B===6&&te===6)}e.breakBetweenGraphemeBreakType=J;var re;(function(B){B[B.Other=0]="Other",B[B.Prepend=1]="Prepend",B[B.CR=2]="CR",B[B.LF=3]="LF",B[B.Control=4]="Control",B[B.Extend=5]="Extend",B[B.Regional_Indicator=6]="Regional_Indicator",B[B.SpacingMark=7]="SpacingMark",B[B.L=8]="L",B[B.V=9]="V",B[B.T=10]="T",B[B.LV=11]="LV",B[B.LVT=12]="LVT",B[B.ZWJ=13]="ZWJ",B[B.Extended_Pictographic=14]="Extended_Pictographic"})(re=e.GraphemeBreakType||(e.GraphemeBreakType={}));class se{constructor(){this._data=ve()}static getInstance(){return se._INSTANCE||(se._INSTANCE=new se),se._INSTANCE}getGraphemeBreakType(te){if(te<32)return te===10?3:te===13?2:4;if(te<127)return 0;const ae=this._data,oe=ae.length/3;let he=1;for(;he<=oe;)if(te<ae[3*he])he=2*he;else if(te>ae[3*he+1])he=2*he+1;else return ae[3*he+2];return 0}}se._INSTANCE=null;function ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function Se(B,te){if(B===0)return 0;const ae=Pe(B,te);if(ae!==void 0)return ae;const oe=$(te,B);return B-=be(oe),B}e.getLeftDeleteOffset=Se;function Pe(B,te){let ae=$(te,B);for(B-=be(ae);Ue(ae)||ae===65039||ae===8419;){if(B===0)return;ae=$(te,B),B-=be(ae)}if(!!ge(ae)){if(B>=0){const oe=$(te,B);oe===8205&&(B-=be(oe))}return B}}function be(B){return B>=65536?2:1}function Ue(B){return 127995<=B&&B<=127999}var De;(function(B){B[B.zwj=8205]="zwj",B[B.emojiVariantSelector=65039]="emojiVariantSelector",B[B.enclosingKeyCap=8419]="enclosingKeyCap"})(De||(De={}))}),define(Z[25],ee([0,1,22,48]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const O=typeof Buffer!="undefined",R=typeof TextEncoder!="undefined",U=typeof TextDecoder!="undefined";let A,S;class y{constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}static alloc(u){return O?new y(Buffer.allocUnsafe(u)):new y(new Uint8Array(u))}static wrap(u){return O&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new y(u)}static fromString(u,m){return!((m==null?void 0:m.dontUseNodeBuffer)||!1)&&O?new y(Buffer.from(u)):R?(A||(A=new TextEncoder),new y(A.encode(u))):new y(p.encodeUTF8(u))}static concat(u,m){if(typeof m=="undefined"){m=0;for(let k=0,_=u.length;k<_;k++)m+=u[k].byteLength}const b=y.alloc(m);let h=0;for(let k=0,_=u.length;k<_;k++){const j=u[k];b.set(j,h),h+=j.byteLength}return b}toString(){return O?this.buffer.toString():U?(S||(S=new TextDecoder),S.decode(this.buffer)):p.decodeUTF8(this.buffer)}slice(u,m){return new y(this.buffer.subarray(u,m))}set(u,m){u instanceof y?this.buffer.set(u.buffer,m):this.buffer.set(u,m)}readUInt32BE(u){return v(this.buffer,u)}writeUInt32BE(u,m){C(this.buffer,u,m)}readUInt32LE(u){return d(this.buffer,u)}writeUInt32LE(u,m){w(this.buffer,u,m)}readUInt8(u){return I(this.buffer,u)}writeUInt8(u,m){E(this.buffer,u,m)}}e.VSBuffer=y;function n(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0}e.readUInt16LE=n;function f(l,u,m){l[m+0]=u&255,u=u>>>8,l[m+1]=u&255}e.writeUInt16LE=f;function v(l,u){return l[u]*2**24+l[u+1]*2**16+l[u+2]*2**8+l[u+3]}e.readUInt32BE=v;function C(l,u,m){l[m+3]=u,u=u>>>8,l[m+2]=u,u=u>>>8,l[m+1]=u,u=u>>>8,l[m]=u}e.writeUInt32BE=C;function d(l,u){return l[u+0]<<0>>>0|l[u+1]<<8>>>0|l[u+2]<<16>>>0|l[u+3]<<24>>>0}e.readUInt32LE=d;function w(l,u,m){l[m+0]=u&255,u=u>>>8,l[m+1]=u&255,u=u>>>8,l[m+2]=u&255,u=u>>>8,l[m+3]=u&255}e.writeUInt32LE=w;function I(l,u){return l[u]}e.readUInt8=I;function E(l,u,m){l[m]=u}e.writeUInt8=E;function D(l){return L.consumeReadable(l,u=>y.concat(u))}e.readableToBuffer=D;function g(l){return L.toReadable(l)}e.bufferToReadable=g;function a(l){return L.consumeStream(l,u=>y.concat(u))}e.streamToBuffer=a;async function s(l){return l.ended?y.concat(l.buffer):y.concat([...l.buffer,await a(l.stream)])}e.bufferedStreamToBuffer=s;function t(l){return L.toStream(l,u=>y.concat(u))}e.bufferToStream=t;function i(l){return L.transform(l,{data:u=>typeof u=="string"?y.fromString(u):y.wrap(u)},u=>y.concat(u))}e.streamToBufferReadableStream=i;function r(l){return L.newWriteableStream(u=>y.concat(u),l)}e.newWriteableBufferStream=r;function o(l,u){return L.prefixedReadable(l,u,m=>y.concat(m))}e.prefixedBufferReadable=o;function c(l,u){return L.prefixedStream(l,u,m=>y.concat(m))}e.prefixedBufferStream=c}),define(Z[15],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(u){return Array.isArray(u)}e.isArray=p;function L(u){return typeof u=="string"}e.isString=L;function O(u){return Array.isArray(u)&&u.every(m=>L(m))}e.isStringArray=O;function R(u){return typeof u=="object"&&u!==null&&!Array.isArray(u)&&!(u instanceof RegExp)&&!(u instanceof Date)}e.isObject=R;function U(u){return typeof u=="number"&&!isNaN(u)}e.isNumber=U;function A(u){return!!u&&typeof u[Symbol.iterator]=="function"}e.isIterable=A;function S(u){return u===!0||u===!1}e.isBoolean=S;function y(u){return typeof u=="undefined"}e.isUndefined=y;function n(u){return!f(u)}e.isDefined=n;function f(u){return y(u)||u===null}e.isUndefinedOrNull=f;function v(u,m){if(!u)throw new Error(m?`Unexpected type, expected '${m}'`:"Unexpected type")}e.assertType=v;function C(u){if(f(u))throw new Error("Assertion Failed: argument is undefined or null");return u}e.assertIsDefined=C;function d(...u){const m=[];for(let b=0;b<u.length;b++){const h=u[b];if(f(h))throw new Error(`Assertion Failed: argument at index ${b} is undefined or null`);m.push(h)}return m}e.assertAllDefined=d;const w=Object.prototype.hasOwnProperty;function I(u){if(!R(u))return!1;for(let m in u)if(w.call(u,m))return!1;return!0}e.isEmptyObject=I;function E(u){return typeof u=="function"}e.isFunction=E;function D(...u){return u.length>0&&u.every(E)}e.areFunctions=D;function g(u,m){const b=Math.min(u.length,m.length);for(let h=0;h<b;h++)a(u[h],m[h])}e.validateConstraints=g;function a(u,m){if(L(m)){if(typeof u!==m)throw new Error(`argument does not match constraint: typeof ${m}`)}else if(E(m)){try{if(u instanceof m)return}catch(b){}if(!f(u)&&u.constructor===m||m.length===1&&m.call(void 0,u)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=a;function s(u){let m=[],b=Object.getPrototypeOf(u);for(;Object.prototype!==b;)m=m.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return m}e.getAllPropertyNames=s;function t(u){const m=[];for(const b of s(u))typeof u[b]=="function"&&m.push(b);return m}e.getAllMethodNames=t;function i(u,m){const b=k=>function(){const _=Array.prototype.slice.call(arguments,0);return m(k,_)};let h={};for(const k of u)h[k]=b(k);return h}e.createProxyObject=i;function r(u){return u===null?void 0:u}e.withNullAsUndefined=r;function o(u){return typeof u=="undefined"?null:u}e.withUndefinedAsNull=o;function c(u){return class{constructor(){return new Proxy({},{get(m,b){if(m[b])return m[b];throw new Error(`Not Implemented: ${u}->${String(b)}`)}})}}}e.NotImplementedProxy=c;function l(u){throw new Error("Unreachable")}e.assertNever=l}),define(Z[42],ee([0,1,6,22,7,15]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function U(r){return r===47||r===92}e.isPathSeparator=U;function A(r){return r.replace(/[\\/]/g,O.posix.sep)}e.toSlashes=A;function S(r){return r.indexOf("/")===-1&&(r=A(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=S;function y(r,o=O.posix.sep){if(!r)return"";const c=r.length,l=r.charCodeAt(0);if(U(l)){if(U(r.charCodeAt(1))&&!U(r.charCodeAt(2))){let m=3;const b=m;for(;m<c&&!U(r.charCodeAt(m));m++);if(b!==m&&!U(r.charCodeAt(m+1))){for(m+=1;m<c;m++)if(U(r.charCodeAt(m)))return r.slice(0,m+1).replace(/[\\/]/g,o)}}return o}else if(E(l)&&r.charCodeAt(1)===58)return U(r.charCodeAt(2))?r.slice(0,2)+o:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<c;u++)if(U(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.getRoot=y;function n(r){if(!p.isWindows||!r||r.length<5)return!1;let o=r.charCodeAt(0);if(o!==92||(o=r.charCodeAt(1),o!==92))return!1;let c=2;const l=c;for(;c<r.length&&(o=r.charCodeAt(c),o!==92);c++);return!(l===c||(o=r.charCodeAt(c+1),isNaN(o)||o===92))}e.isUNC=n;const f=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,C=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(r,o=p.isWindows){const c=o?f:v;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||o&&C.test(r)||r==="."||r===".."||o&&r[r.length-1]==="."||o&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=d;function w(r,o,c){const l=r===o;return!c||l?l:!r||!o?!1:(0,L.equalsIgnoreCase)(r,o)}e.isEqual=w;function I(r,o,c,l=O.sep){if(r===o)return!0;if(!r||!o||o.length>r.length)return!1;if(c){if(!(0,L.startsWithIgnoreCase)(r,o))return!1;if(o.length===r.length)return!0;let m=o.length;return o.charAt(o.length-1)===l&&m--,r.charAt(m)===l}return o.charAt(o.length-1)!==l&&(o+=l),r.indexOf(o)===0}e.isEqualOrParent=I;function E(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=E;function D(r,o){return p.isWindows&&r.endsWith(":")&&(r+=O.sep),(0,O.isAbsolute)(r)||(r=(0,O.join)(o,r)),r=(0,O.normalize)(r),p.isWindows?(r=(0,L.rtrim)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,L.rtrim)(r,O.sep),r||(r=O.sep)),r}e.sanitizeFilePath=D;function g(r){const o=(0,O.normalize)(r);return p.isWindows?r.length>3?!1:a(o)&&(r.length===2||o.charCodeAt(2)===92):o===O.posix.sep}e.isRootOrDriveLetter=g;function a(r){return p.isWindows?E(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=a;function s(r){return a(r)?r[0]:void 0}e.getDriveLetter=s;function t(r,o,c){return o.length>r.length?-1:r===o?0:(c&&(r=r.toLowerCase(),o=o.toLowerCase()),r.indexOf(o))}e.indexOfPath=t;function i(r){const o=r.split(":");let c,l,u;if(o.forEach(m=>{const b=Number(m);(0,R.isNumber)(b)?l===void 0?l=b:u===void 0&&(u=b):c=c?[c,m].join(":"):m}),!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:l!==void 0?l:void 0,column:u!==void 0?u:l!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(Z[26],ee([0,1,15]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const I=Array.isArray(w)?[]:{};return Object.keys(w).forEach(E=>{w[E]&&typeof w[E]=="object"?I[E]=L(w[E]):I[E]=w[E]}),I}e.deepClone=L;function O(w){if(!w||typeof w!="object")return w;const I=[w];for(;I.length>0;){const E=I.shift();Object.freeze(E);for(const D in E)if(R.call(E,D)){const g=E[D];typeof g=="object"&&!Object.isFrozen(g)&&I.push(g)}}return w}e.deepFreeze=O;const R=Object.prototype.hasOwnProperty;function U(w,I){return A(w,I,new Set)}e.cloneAndChange=U;function A(w,I,E){if((0,p.isUndefinedOrNull)(w))return w;const D=I(w);if(typeof D!="undefined")return D;if((0,p.isArray)(w)){const g=[];for(const a of w)g.push(A(a,I,E));return g}if((0,p.isObject)(w)){if(E.has(w))throw new Error("Cannot clone recursive data-structure");E.add(w);const g={};for(let a in w)R.call(w,a)&&(g[a]=A(w[a],I,E));return E.delete(w),g}return w}function S(w,I,E=!0){return(0,p.isObject)(w)?((0,p.isObject)(I)&&Object.keys(I).forEach(D=>{D in w?E&&((0,p.isObject)(w[D])&&(0,p.isObject)(I[D])?S(w[D],I[D],E):w[D]=I[D]):w[D]=I[D]}),w):I}e.mixin=S;function y(w,I){if(w===I)return!0;if(w==null||I===null||I===void 0||typeof w!=typeof I||typeof w!="object"||Array.isArray(w)!==Array.isArray(I))return!1;let E,D;if(Array.isArray(w)){if(w.length!==I.length)return!1;for(E=0;E<w.length;E++)if(!y(w[E],I[E]))return!1}else{const g=[];for(D in w)g.push(D);g.sort();const a=[];for(D in I)a.push(D);if(a.sort(),!y(g,a))return!1;for(E=0;E<g.length;E++)if(!y(w[g[E]],I[g[E]]))return!1}return!0}e.equals=y;function n(w){const I=new Set;return JSON.stringify(w,(E,D)=>{if((0,p.isObject)(D)||Array.isArray(D)){if(I.has(D))return"[Circular]";I.add(D)}return D})}e.safeStringify=n;function f(w,I,E){const D=I(w);return typeof D=="undefined"?E:D}e.getOrDefault=f;function v(w,I){const E=Object.create(null);return!w||!I||Object.keys(I).forEach(g=>{const a=w[g],s=I[g];y(a,s)||(E[g]=s)}),E}e.distinct=v;function C(w,I){const E=I.toLowerCase(),D=Object.keys(w).find(g=>g.toLowerCase()===E);return D?w[D]:w[I]}e.getCaseInsensitive=C;function d(w,I){const E=Object.create(null);for(const D of Object.keys(w))I(D,w[D])&&(E[D]=w[D]);return E}e.filter=d}),define(Z[5],ee([0,1,6,7]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const O=/^\w[\w\d+.-]*$/,R=/^\//,U=/^\/\//;function A(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!O.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(U.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function S(r,o){return!r&&!o?"file":r}function y(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==f&&(o=f+o):o=f;break}return o}const n="",f="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class C{constructor(o,c,l,u,m,b=!1){typeof o=="object"?(this.scheme=o.scheme||n,this.authority=o.authority||n,this.path=o.path||n,this.query=o.query||n,this.fragment=o.fragment||n):(this.scheme=S(o,b),this.authority=c||n,this.path=y(this.scheme,l||n),this.query=u||n,this.fragment=m||n,A(this,b))}static isUri(o){return o instanceof C?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}get fsPath(){return g(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:l,path:u,query:m,fragment:b}=o;return c===void 0?c=this.scheme:c===null&&(c=n),l===void 0?l=this.authority:l===null&&(l=n),u===void 0?u=this.path:u===null&&(u=n),m===void 0?m=this.query:m===null&&(m=n),b===void 0?b=this.fragment:b===null&&(b=n),c===this.scheme&&l===this.authority&&u===this.path&&m===this.query&&b===this.fragment?this:new w(c,l,u,m,b)}static parse(o,c=!1){const l=v.exec(o);return l?new w(l[2]||n,i(l[4]||n),i(l[5]||n),i(l[7]||n),i(l[9]||n),c):new w(n,n,n,n,n)}static file(o){let c=n;if(p.isWindows&&(o=o.replace(/\\/g,f)),o[0]===f&&o[1]===f){const l=o.indexOf(f,2);l===-1?(c=o.substring(2),o=f):(c=o.substring(2,l),o=o.substring(l)||f)}return new w("file",c,o,n,n)}static from(o){const c=new w(o.scheme,o.authority,o.path,o.query,o.fragment);return A(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return p.isWindows&&o.scheme==="file"?l=C.file(L.win32.join(g(o,!0),...c)).path:l=L.posix.join(o.path,...c),o.with({path:l})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof C)return o;{const c=new w(o);return c._formatted=o.external,c._fsPath=o._sep===d?o.fsPath:null,c}}else return o}}e.URI=C;const d=p.isWindows?1:void 0;class w extends C{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=d),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const I={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(r,o){let c,l=-1;for(let u=0;u<r.length;u++){const m=r.charCodeAt(u);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||o&&m===47)l!==-1&&(c+=encodeURIComponent(r.substring(l,u)),l=-1),c!==void 0&&(c+=r.charAt(u));else{c===void 0&&(c=r.substr(0,u));const b=I[m];b!==void 0?(l!==-1&&(c+=encodeURIComponent(r.substring(l,u)),l=-1),c+=b):l===-1&&(l=u)}}return l!==-1&&(c+=encodeURIComponent(r.substring(l))),c!==void 0?c:r}function D(r){let o;for(let c=0;c<r.length;c++){const l=r.charCodeAt(c);l===35||l===63?(o===void 0&&(o=r.substr(0,c)),o+=I[l]):o!==void 0&&(o+=r[c])}return o!==void 0?o:r}function g(r,o){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,p.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=g;function a(r,o){const c=o?D:E;let l="",{scheme:u,authority:m,path:b,query:h,fragment:k}=r;if(u&&(l+=u,l+=":"),(m||u==="file")&&(l+=f,l+=f),m){let _=m.indexOf("@");if(_!==-1){const j=m.substr(0,_);m=m.substr(_+1),_=j.indexOf(":"),_===-1?l+=c(j,!1):(l+=c(j.substr(0,_),!1),l+=":",l+=c(j.substr(_+1),!1)),l+="@"}m=m.toLowerCase(),_=m.indexOf(":"),_===-1?l+=c(m,!1):(l+=c(m.substr(0,_),!1),l+=m.substr(_))}if(b){if(b.length>=3&&b.charCodeAt(0)===47&&b.charCodeAt(2)===58){const _=b.charCodeAt(1);_>=65&&_<=90&&(b=`/${String.fromCharCode(_+32)}:${b.substr(3)}`)}else if(b.length>=2&&b.charCodeAt(1)===58){const _=b.charCodeAt(0);_>=65&&_<=90&&(b=`${String.fromCharCode(_+32)}:${b.substr(2)}`)}l+=c(b,!0)}return h&&(l+="?",l+=c(h,!1)),k&&(l+="#",l+=o?k:E(k,!1)),l}function s(r){try{return decodeURIComponent(r)}catch(o){return r.length>3?r.substr(0,3)+s(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(r){return r.match(t)?r.replace(t,o=>s(o)):r}}),define(Z[88],ee([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(y){const n=y;return n&&typeof n.type=="string"&&typeof n.severity=="string"}e.isRemoteConsoleLog=L;function O(y){const n=[];let f;try{const v=JSON.parse(y.arguments),C=v[v.length-1];C&&C.__$stack&&(v.pop(),f=C.__$stack),n.push(...v)}catch(v){n.push("Unable to log remote console arguments",y.arguments)}return{args:n,stack:f}}e.parse=O;function R(y){if(typeof y!="string")return R(O(y).stack);const n=y;if(n){const f=U(n),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(f||"");if(v&&v.length===4)return{uri:p.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=R;function U(y){if(!y)return y;const n=y.indexOf(`
`);return n===-1?y:y.substring(0,n)}function A(y,n){const{args:f,stack:v}=O(y),C=typeof f[0]=="string"&&f.length===1;let d=U(v);d&&(d=`(${d.trim()})`);let w=[];if(typeof f[0]=="string"?d&&C?w=[`%c[${n}] %c${f[0]} %c${d}`,S("blue"),S(""),S("grey")]:w=[`%c[${n}] %c${f[0]}`,S("blue"),S(""),...f.slice(1)]:w=[`%c[${n}]%`,S("blue"),...f],d&&!C&&w.push(d),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,w)}e.log=A;function S(y){return`color: ${y}`}});var ft=this&&this.__classPrivateFieldSet||function(G,e,p,L,O){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!O)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?G!==e||!O:!e.has(G))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?O.call(G,p):O?O.value=p:e.set(G,p),p},ze=this&&this.__classPrivateFieldGet||function(G,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?G!==e||!L:!e.has(G))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(G):L?L.value:e.get(G)};define(Z[39],ee([0,1,5,22]),function(G,e,p,L){"use strict";var O,R,U;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function A(t,i,r){let o=t.get(i);return o===void 0&&(o=r,t.set(i,o)),o}e.getOrSet=A;function S(t){const i=[];return t.forEach((r,o)=>{i.push(`${o} => ${r}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=S;function y(t){const i=[];return t.forEach(r=>{i.push(r)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=y;class n{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),o=this._value.charCodeAt(this._pos);return r-o}value(){return this._value[this._pos]}}e.StringIterator=n;class f{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=f;class v{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,L.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var C;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(C||(C={}));class d{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,L.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class w{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class I{constructor(i){this._iter=i}static forUris(i=()=>!1){return new I(new d(i))}static forPaths(){return new I(new v)}static forStrings(){return new I(new n)}static forConfigKeys(){return new I(new f)}clear(){this._root=void 0}set(i,r){const o=this._iter.reset(i);let c;for(this._root||(this._root=new w,this._root.segment=o.value()),c=this._root;;){const u=o.cmp(c.segment);if(u>0)c.left||(c.left=new w,c.left.segment=o.value()),c=c.left;else if(u<0)c.right||(c.right=new w,c.right.segment=o.value()),c=c.right;else if(o.hasNext())o.next(),c.mid||(c.mid=new w,c.mid.segment=o.value()),c=c.mid;else break}const l=c.value;return c.value=r,c.key=i,l}get(i){var r;return(r=this._getNode(i))===null||r===void 0?void 0:r.value}_getNode(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const c=r.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else break}return o}has(i){const r=this._getNode(i);return!((r==null?void 0:r.value)===void 0&&(r==null?void 0:r.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const o=this._iter.reset(i),c=[];let l=this._root;for(;l;){const u=o.cmp(l.segment);if(u>0)c.push([1,l]),l=l.left;else if(u<0)c.push([-1,l]),l=l.right;else if(o.hasNext())o.next(),c.push([0,l]),l=l.mid;else{for(r?(l.left=void 0,l.mid=void 0,l.right=void 0):l.value=void 0;c.length>0&&l.isEmpty();){let[m,b]=c.pop();switch(m){case 1:b.left=void 0;break;case 0:b.mid=void 0;break;case-1:b.right=void 0;break}l=b}break}}}findSubstr(i){const r=this._iter.reset(i);let o=this._root,c;for(;o;){const l=r.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(r.hasNext())r.next(),c=o.value||c,o=o.mid;else break}return o&&o.value||c}findSuperstr(i){const r=this._iter.reset(i);let o=this._root;for(;o;){const c=r.cmp(o.segment);if(c>0)o=o.left;else if(c<0)o=o.right;else if(r.hasNext())r.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(i){for(const[r,o]of this)i(o,r)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i){i&&(yield*this._entries(i.left),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid),yield*this._entries(i.right))}}e.TernarySearchTree=I;class E{constructor(i,r){this[O]="ResourceMap",i instanceof E?(this.map=new Map(i.map),this.toKey=r!=null?r:E.defaultToKey):(this.map=new Map,this.toKey=i!=null?i:E.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),r),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(let[o,c]of this.map)i(c,p.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield p.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[p.URI.parse(i[0]),i[1]]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[p.URI.parse(i[0]),i[1]]}}e.ResourceMap=E,E.defaultToKey=t=>t.toString();var D;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(D=e.Touch||(e.Touch={}));class g{constructor(){this[R]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,r=0){const o=this._map.get(i);if(!!o)return r!==0&&this.touch(o,r),o.value}set(i,r,o=0){let c=this._map.get(i);if(c)c.value=r,o!==0&&this.touch(c,o);else{switch(c={key:i,value:r,next:void 0,previous:void 0},o){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!(!this._head&&!this._tail)){if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}}forEach(i,r){const o=this._state;let c=this._head;for(;c;){if(r?i.bind(r)(c.value,c.key,this):i(c.value,c.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,r=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.key,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}values(){const i=this,r=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:o.value,done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}entries(){const i=this,r=this._state;let o=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(o){const l={value:[o.key,o.value],done:!1};return o=o.next,l}else return{value:void 0,done:!0}}};return c}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(!(i>=this.size)){if(i===0){this.clear();return}let r=this._head,o=this.size;for(;r&&o>i;)this._map.delete(r.key),r=r.next,o--;this._head=r,this._size=o,r&&(r.previous=void 0),this._state++}}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,o=i.previous;if(!r||!o)throw new Error("Invalid list");r.previous=o,o.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const o=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(o.previous=c,c.next=o),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const o=i.next,c=i.previous;i===this._head?(o.previous=void 0,this._head=o):(o.previous=c,c.next=o),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,o)=>{i.push([o,r])}),i}fromJSON(i){this.clear();for(const[r,o]of i)this.set(r,o)}}e.LinkedMap=g;class a extends g{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=a;class s{constructor(i){U.set(this,void 0),ft(this,U,i,"f")}get size(){return ze(this,U,"f").size}forEach(i,r){ze(this,U,"f").forEach(i,r)}get(i){return ze(this,U,"f").get(i)}has(i){return ze(this,U,"f").has(i)}entries(){return ze(this,U,"f").entries()}keys(){return ze(this,U,"f").keys()}values(){return ze(this,U,"f").values()}[(U=new WeakMap,Symbol.iterator)](){return ze(this,U,"f").entries()}}e.ReadonlyMapView=s}),define(Z[89],ee([0,1,25,22,5]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(y){return JSON.stringify(y,A)}e.stringify=R;function U(y){let n=JSON.parse(y);return n=S(n),n}e.parse=U;function A(y,n){return n instanceof RegExp?{$mid:2,source:n.source,flags:(0,L.regExpFlags)(n)}:n}function S(y,n=0){if(!y||n>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return O.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof p.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let f=0;f<y.length;++f)y[f]=S(y[f],n+1);else for(const f in y)Object.hasOwnProperty.call(y,f)&&(y[f]=S(y[f],n+1))}return y}e.revive=S}),define(Z[16],ee([0,1,5,6]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var O;(function(A){A.inMemory="inmemory",A.vscode="vscode",A.internal="private",A.walkThrough="walkThrough",A.walkThroughSnippet="walkThroughSnippet",A.http="http",A.https="https",A.file="file",A.mailto="mailto",A.untitled="untitled",A.data="data",A.command="command",A.vscodeRemote="vscode-remote",A.vscodeRemoteResource="vscode-remote-resource",A.userData="vscode-userdata",A.vscodeCustomEditor="vscode-custom-editor",A.vscodeNotebook="vscode-notebook",A.vscodeNotebookCell="vscode-notebook-cell",A.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",A.vscodeNotebookCellOutput="vscode-notebook-cell-output",A.vscodeSettings="vscode-settings",A.vscodeWorkspaceTrust="vscode-workspace-trust",A.vscodeTerminal="vscode-terminal",A.webviewPanel="webview-panel",A.vscodeWebview="vscode-webview",A.extension="extension",A.vscodeFileResource="vscode-file",A.tmp="tmp"})(O=e.Schemas||(e.Schemas={}));class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(S){this._preferredWebSchema=S}setDelegate(S){this._delegate=S}set(S,y,n){this._hosts[S]=y,this._ports[S]=n}setConnectionToken(S,y){this._connectionTokens[S]=y}rewrite(S){if(this._delegate)return this._delegate(S);const y=S.authority;let n=this._hosts[y];n&&n.indexOf(":")!==-1&&(n=`[${n}]`);const f=this._ports[y],v=this._connectionTokens[y];let C=`path=${encodeURIComponent(S.path)}`;return typeof v=="string"&&(C+=`&tkn=${encodeURIComponent(v)}`),p.URI.from({scheme:L.isWeb?this._preferredWebSchema:O.vscodeRemoteResource,authority:`${n}:${f}`,path:"/vscode-remote-resource",query:C})}}e.RemoteAuthorities=new R;class U{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(S,y,n){const f=this.toUri(S,y);return f.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(f):L.isNative&&(n||L.isPreferringBrowserCodeLoad)&&f.scheme===O.file?f.with({scheme:O.vscodeFileResource,authority:f.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(S,y){const n=this.toUri(S,y);return n.scheme===O.vscodeFileResource?n.with({scheme:O.file,authority:n.authority!==this.FALLBACK_AUTHORITY?n.authority:null,query:null,fragment:null}):n}toUri(S,y){return p.URI.isUri(S)?S:p.URI.parse(y.toUrl(S))}}e.FileAccess=new U}),define(Z[67],ee([0,1,39]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const L=new p.LRUCache(1e4);function O(y){return S(y,"NFC",L)}e.normalizeNFC=O;const R=new p.LRUCache(1e4);function U(y){return S(y,"NFD",R)}e.normalizeNFD=U;const A=/[^\u0000-\u0080]/;function S(y,n,f){if(!e.canNormalize||!y)return y;const v=f.get(y);if(v)return v;let C;return A.test(y)?C=y.normalize(n):C=y,f.set(y,C),C}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(n){return U(n).replace(y,"")}}else return function(y){return y}}()}),define(Z[14],ee([0,1,42,7,5,22,16,6]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function S(C){return(0,O.uriToFsPath)(C,!0)}e.originalFSPath=S;class y{constructor(d){this._ignorePathCasing=d}compare(d,w,I=!1){return d===w?0:(0,R.compare)(this.getComparisonKey(d,I),this.getComparisonKey(w,I))}isEqual(d,w,I=!1){return d===w?!0:!d||!w?!1:this.getComparisonKey(d,I)===this.getComparisonKey(w,I)}getComparisonKey(d,w=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,w,I=!1){if(d.scheme===w.scheme){if(d.scheme===U.Schemas.file)return p.isEqualOrParent(S(d),S(w),this._ignorePathCasing(d))&&d.query===w.query&&(I||d.fragment===w.fragment);if((0,e.isEqualAuthority)(d.authority,w.authority))return p.isEqualOrParent(d.path,w.path,this._ignorePathCasing(d),"/")&&d.query===w.query&&(I||d.fragment===w.fragment)}return!1}joinPath(d,...w){return O.URI.joinPath(d,...w)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return L.posix.basename(d.path)}extname(d){return L.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let w;return d.scheme===U.Schemas.file?w=O.URI.file(L.dirname(S(d))).path:(w=L.posix.dirname(d.path),d.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),w="/")),d.with({path:w})}normalizePath(d){if(!d.path.length)return d;let w;return d.scheme===U.Schemas.file?w=O.URI.file(L.normalize(S(d))).path:w=L.posix.normalize(d.path),d.with({path:w})}relativePath(d,w){if(!(d.scheme!==w.scheme||!(0,e.isEqualAuthority)(d.authority,w.authority))){if(d.scheme===U.Schemas.file){const D=L.relative(S(d),S(w));return A.isWindows?p.toSlashes(D):D}let I=d.path||"/",E=w.path||"/";if(this._ignorePathCasing(d)){let D=0;for(const g=Math.min(I.length,E.length);D<g&&!(I.charCodeAt(D)!==E.charCodeAt(D)&&I.charAt(D).toLowerCase()!==E.charAt(D).toLowerCase());D++);I=E.substr(0,D)+I.substr(D)}return L.posix.relative(I,E)}}resolvePath(d,w){if(d.scheme===U.Schemas.file){const I=O.URI.file(L.resolve(S(d),w));return d.with({authority:I.authority,path:I.path})}return w=p.toPosixPath(w),d.with({path:L.posix.resolve(d.path,w)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,w){return d===w||(0,R.equalsIgnoreCase)(d,w)}hasTrailingPathSeparator(d,w=L.sep){if(d.scheme===U.Schemas.file){const I=S(d);return I.length>p.getRoot(I).length&&I[I.length-1]===w}else{const I=d.path;return I.length>1&&I.charCodeAt(I.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,w=L.sep){return(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,w=L.sep){let I=!1;if(d.scheme===U.Schemas.file){const E=S(d);I=E!==void 0&&E.length===p.getRoot(E).length&&E[E.length-1]===w}else{w="/";const E=d.path;I=E.length===1&&E.charCodeAt(E.length-1)===47}return!I&&!(0,e.hasTrailingPathSeparator)(d,w)?d.with({path:d.path+"/"}):d}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(C=>C.scheme===U.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new y(C=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function n(C,d){const w=[];for(let I=0;I<C.length;I++){const E=d(C[I]);C.some((D,g)=>g===I?!1:(0,e.isEqualOrParent)(E,d(D)))||w.push(C[I])}return w}e.distinctParents=n;var f;(function(C){C.META_DATA_LABEL="label",C.META_DATA_DESCRIPTION="description",C.META_DATA_SIZE="size",C.META_DATA_MIME="mime";function d(w){const I=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(g=>{const[a,s]=g.split(":");a&&s&&I.set(a,s)});const D=w.path.substring(0,w.path.indexOf(";"));return D&&I.set(C.META_DATA_MIME,D),I}C.parseMetaData=d})(f=e.DataUri||(e.DataUri={}));function v(C,d,w){if(d){let I=C.path;return I&&I[0]!==L.posix.sep&&(I=L.posix.sep+I),C.with({scheme:w,authority:d,path:I})}return C.with({scheme:w})}e.toLocalResource=v}),define(Z[8],ee([0,1,30,11,3,2,66,14]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function S(H){return!!H&&typeof H.then=="function"}e.isThenable=S;function y(H){const T=new p.CancellationTokenSource,P=H(T.token),F=new Promise((N,x)=>{T.token.onCancellationRequested(()=>{x((0,L.canceled)())}),Promise.resolve(P).then(V=>{T.dispose(),N(V)},V=>{T.dispose(),x(V)})});return new class{cancel(){T.cancel()}then(N,x){return F.then(N,x)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=y;function n(H,T,P){return Promise.race([H,new Promise(F=>T.onCancellationRequested(()=>F(P)))])}e.raceCancellation=n;async function f(H){let T=-1;const P=H.map((N,x)=>N.then(V=>(T=x,V))),F=await Promise.race(P);return H.forEach((N,x)=>{x!==T&&N.cancel()}),F}e.raceCancellablePromises=f;function v(H,T,P){let F;const N=setTimeout(()=>{F==null||F(void 0),P==null||P()},T);return Promise.race([H.finally(()=>clearTimeout(N)),new Promise(x=>F=x)])}e.raceTimeout=v;function C(H){return new Promise((T,P)=>{const F=H();S(F)?F.then(T,P):T(F)})}e.asPromise=C;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(T){if(this.activePromise){if(this.queuedPromiseFactory=T,!this.queuedPromise){const P=()=>{this.queuedPromise=null;const F=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,F};this.queuedPromise=new Promise(F=>{this.activePromise.then(P,P).then(F)})}return new Promise((P,F)=>{this.queuedPromise.then(P,F)})}return this.activePromise=T(),new Promise((P,F)=>{this.activePromise.then(N=>{this.activePromise=null,P(N)},N=>{this.activePromise=null,F(N)})})}}e.Throttler=d;class w{constructor(){this.current=Promise.resolve(null)}queue(T){return this.current=this.current.then(()=>T(),()=>T())}}e.Sequencer=w;class I{constructor(){this.promiseMap=new Map}queue(T,P){var F;const x=((F=this.promiseMap.get(T))!==null&&F!==void 0?F:Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.promiseMap.get(T)===x&&this.promiseMap.delete(T)});return this.promiseMap.set(T,x),x}}e.SequencerByKey=I;class E{constructor(T){this.defaultDelay=T,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(T,P=this.defaultDelay){return this.task=T,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((F,N)=>{this.doResolve=F,this.doReject=N}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const F=this.task;return this.task=null,F()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},P),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=E;class D{constructor(T){this.delayer=new E(T),this.throttler=new d}trigger(T,P){return this.delayer.trigger(()=>this.throttler.queue(T),P)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=D;class g{constructor(){this._isOpen=!1,this._promise=new Promise((T,P)=>{this._completePromise=T})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=g;class a extends g{constructor(T){super();this._timeout=setTimeout(()=>this.open(),T)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=a;function s(H,T){return T?new Promise((P,F)=>{const N=setTimeout(P,H);T.onCancellationRequested(()=>{clearTimeout(N),F((0,L.canceled)())})}):y(P=>s(H,P))}e.timeout=s;function t(H,T=0){const P=setTimeout(H,T);return(0,R.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=t;function i(H){return H.then(void 0,T=>{})}e.ignoreErrors=i;function r(H){const T=[];let P=0;const F=H.length;function N(){return P<F?H[P++]():null}function x(V){V!=null&&T.push(V);const X=N();return X?X.then(x):Promise.resolve(T)}return Promise.resolve(null).then(x)}e.sequence=r;function o(H,T=F=>!!F,P=null){let F=0;const N=H.length,x=()=>{if(F>=N)return Promise.resolve(P);const V=H[F++];return Promise.resolve(V()).then(Q=>T(Q)?Promise.resolve(Q):x())};return x()}e.first=o;function c(H,T=F=>!!F,P=null){if(H.length===0)return Promise.resolve(P);let F=H.length;const N=()=>{var x,V;F=-1;for(const X of H)(V=(x=X).cancel)===null||V===void 0||V.call(x)};return new Promise((x,V)=>{for(const X of H)X.then(Q=>{--F>=0&&T(Q)?(N(),x(Q)):F===0&&x(P)}).catch(Q=>{--F>=0&&(N(),V(Q))})})}e.firstParallel=c;class l{constructor(T){this._size=0,this.maxDegreeOfParalellism=T,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new O.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(T){return this._size++,new Promise((P,F)=>{this.outstandingPromises.push({factory:T,c:P,e:F}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const T=this.outstandingPromises.shift();this.runningPromises++;const P=T.factory();P.then(T.c,T.e),P.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=l;class u extends l{constructor(){super(1)}}e.Queue=u;class m{constructor(){this.queues=new Map}queueFor(T,P=A.extUri){const F=P.getComparisonKey(T);let N=this.queues.get(F);return N||(N=new u,O.Event.once(N.onFinished)(()=>{N==null||N.dispose(),this.queues.delete(F)}),this.queues.set(F,N)),N}dispose(){this.queues.forEach(T=>T.dispose()),this.queues.clear()}}e.ResourceQueue=m;class b{constructor(T,P){this._token=-1,typeof T=="function"&&typeof P=="number"&&this.setIfNotSet(T,P)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(T,P){this.cancel(),this._token=setTimeout(()=>{this._token=-1,T()},P)}setIfNotSet(T,P){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,T()},P))}}e.TimeoutTimer=b;class h{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(T,P){this.cancel(),this._token=setInterval(()=>{T()},P)}}e.IntervalTimer=h;class k{constructor(T,P){this.timeoutToken=-1,this.runner=T,this.timeout=P,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(T=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,T)}get delay(){return this.timeout}set delay(T){this.timeout=T}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=k;class _ extends k{constructor(T,P){super(T,P);this.units=[]}work(T){this.units.push(T),this.isScheduled()||this.schedule()}doRun(){const T=this.units;this.units=[],this.runner&&this.runner(T)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=_,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const H=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=T=>{const P=setTimeout(()=>T(H));let F=!1;return{dispose(){F||(F=!0,clearTimeout(P))}}}}else e.runWhenIdle=(H,T)=>{const P=requestIdleCallback(H,typeof T=="number"?{timeout:T}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(P))}}}}();class j{constructor(T){this._didRun=!1,this._executor=()=>{try{this._value=T()}catch(P){this._error=P}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=j;async function q(H,T,P){let F;for(let N=0;N<P;N++)try{return await H()}catch(x){F=x,await s(T)}throw F}e.retry=q;class K{hasPending(T){return this._pending?typeof T=="number"?this._pending.taskId===T:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var T;(T=this._pending)===null||T===void 0||T.cancel()}setPending(T,P,F){return this._pending={taskId:T,cancel:()=>F==null?void 0:F(),promise:P},P.then(()=>this.donePending(T),()=>this.donePending(T)),P}donePending(T){this._pending&&T===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const T=this._next;this._next=void 0,T.run().then(T.promiseResolve,T.promiseReject)}}setNext(T){if(this._next)this._next.run=T;else{let P,F;const N=new Promise((x,V)=>{P=x,F=V});this._next={run:T,promise:N,promiseResolve:P,promiseReject:F}}return this._next.promise}}e.TaskSequentializer=K;class M{constructor(T){this.interval=T,this.lastIncrementTime=0,this.value=0}increment(){const T=Date.now();return T-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=T,this.value=0),this.value++,this.value}}e.IntervalCounter=M;class ${constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((T,P)=>{this.completeCallback=T,this.errorCallback=P})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(T){return new Promise(P=>{this.completeCallback(T),this.resolved=!0,P()})}error(T){return new Promise(P=>{this.errorCallback(T),this.rejected=!0,P()})}cancel(){new Promise(T=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,T()})}}e.DeferredPromise=$;class z extends O.Emitter{async fireAsync(T,P,F){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new U.LinkedList);for(const N of this._listeners)this._asyncDeliveryQueue.push([N,T]);for(;this._asyncDeliveryQueue.size>0&&!P.isCancellationRequested;){const[N,x]=this._asyncDeliveryQueue.shift(),V=[],X=Object.assign(Object.assign({},x),{waitUntil:Q=>{if(Object.isFrozen(V))throw new Error("waitUntil can NOT be called asynchronous");F&&(Q=F(Q,typeof N=="function"?N:N[0])),V.push(Q)}});try{typeof N=="function"?N.call(void 0,X):N[0].call(N[1],X)}catch(Q){(0,L.onUnexpectedError)(Q);continue}Object.freeze(V),await W.settled(V).catch(Q=>(0,L.onUnexpectedError)(Q))}}}}e.AsyncEmitter=z;var W;(function(H){async function T(x){return typeof Promise.allSettled=="function"?P(x):F(x)}H.allSettled=T;async function P(x){return Promise.allSettled(x)}async function F(x){return Promise.all(x.map(V=>V.then(X=>({status:"fulfilled",value:X}),X=>({status:"rejected",reason:X}))))}async function N(x){let V;const X=await Promise.all(x.map(Q=>Q.then(ie=>ie,ie=>{V||(V=ie)})));if(typeof V!="undefined")throw V;return X}H.settled=N})(W=e.Promises||(e.Promises={}))}),define(Z[90],ee([0,1,22,42,7,39,8]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function A(){return Object.create(null)}e.getEmptyExpression=A;const S="**",y="/",n="[/\\\\]",f="[^/\\\\]",v=/\//g;function C(P){switch(P){case 0:return"";case 1:return`${f}*?`;default:return`(?:${n}|${f}+${n}|${n}${f}+)*?`}}function d(P,F){if(!P)return[];const N=[];let x=!1,V=!1,X="";for(const Q of P){switch(Q){case F:if(!x&&!V){N.push(X),X="";continue}break;case"{":x=!0;break;case"}":x=!1;break;case"[":V=!0;break;case"]":V=!1;break}X+=Q}return X&&N.push(X),N}e.splitGlobAware=d;function w(P){if(!P)return"";let F="";const N=d(P,y);if(N.every(x=>x===S))F=".*";else{let x=!1;N.forEach((V,X)=>{if(V===S){x||(F+=C(2),x=!0);return}let Q=!1,ie="",ne=!1,ce="";for(const ue of V){if(ue!=="}"&&Q){ie+=ue;continue}if(ne&&(ue!=="]"||!ce)){let ge;ue==="-"?ge=ue:(ue==="^"||ue==="!")&&!ce?ge="^":ue===y?ge="":ge=p.escapeRegExpCharacters(ue),ce+=ge;continue}switch(ue){case"{":Q=!0;continue;case"[":ne=!0;continue;case"}":F+=`(?:${d(ie,",").map(Ce=>w(Ce)).join("|")})`,Q=!1,ie="";break;case"]":F+="["+ce+"]",ne=!1,ce="";break;case"?":F+=f;continue;case"*":F+=C(1);continue;default:F+=p.escapeRegExpCharacters(ue)}}X<N.length-1&&(N[X+1]!==S||X+2<N.length)&&(F+=n),x=!1})}return F}const I=/^\*\*\/\*\.[\w\.-]+$/,E=/^\*\*\/([\w\.-]+)\/?$/,D=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,g=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,a=/^\*\*((\/[\w\.-]+)+)\/?$/,s=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.LRUCache(1e4),i=function(){return!1},r=function(){return null};function o(P,F){if(!P)return r;let N;typeof P!="string"?N=P.pattern:N=P,N=N.trim();const x=`${N}_${!!F.trimForExclusions}`;let V=t.get(x);if(V)return c(V,P);let X;if(I.test(N)){const Q=N.substr(4);V=function(ie,ne){return typeof ie=="string"&&ie.endsWith(Q)?N:null}}else(X=E.exec(l(N,F)))?V=u(X[1],N):(F.trimForExclusions?g:D).test(N)?V=m(N,F):(X=a.exec(l(N,F)))?V=b(X[1].substr(1),N,!0):(X=s.exec(l(N,F)))?V=b(X[1],N,!1):V=h(N);return t.set(x,V),c(V,P)}function c(P,F){return typeof F=="string"?P:function(N,x){return L.isEqualOrParent(N,F.base)?P(O.relative(F.base,N),x):null}}function l(P,F){return F.trimForExclusions&&P.endsWith("/**")?P.substr(0,P.length-2):P}function u(P,F){const N=`/${P}`,x=`\\${P}`,V=function(Q,ie){return typeof Q!="string"?null:ie?ie===P?F:null:Q===P||Q.endsWith(N)||Q.endsWith(x)?F:null},X=[P];return V.basenames=X,V.patterns=[F],V.allBasenames=X,V}function m(P,F){const N=T(P.slice(1,-1).split(",").map(ie=>o(ie,F)).filter(ie=>ie!==r),P),x=N.length;if(!x)return r;if(x===1)return N[0];const V=function(ie,ne){for(let ce=0,ue=N.length;ce<ue;ce++)if(N[ce](ie,ne))return P;return null},X=N.find(ie=>!!ie.allBasenames);X&&(V.allBasenames=X.allBasenames);const Q=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(V.allPaths=Q),V}function b(P,F,N){const x=O.sep===O.posix.sep,V=x?P:P.replace(v,O.sep),X=O.sep+V,Q=O.posix.sep+P,ie=N?function(ne,ce){return typeof ne=="string"&&(ne===V||ne.endsWith(X)||!x&&(ne===P||ne.endsWith(Q)))?F:null}:function(ne,ce){return typeof ne=="string"&&(ne===V||!x&&ne===P)?F:null};return ie.allPaths=[(N?"*/":"./")+P],ie}function h(P){try{const F=new RegExp(`^${w(P)}$`);return function(N){return F.lastIndex=0,typeof N=="string"&&F.test(N)?P:null}}catch(F){return r}}function k(P,F,N){return!P||typeof F!="string"?!1:_(P)(F,void 0,N)}e.match=k;function _(P,F={}){if(!P)return i;if(typeof P=="string"||M(P)){const N=o(P,F);if(N===r)return i;const x=function(V,X){return!!N(V,X)};return N.allBasenames&&(x.allBasenames=N.allBasenames),N.allPaths&&(x.allPaths=N.allPaths),x}return W(P,F)}e.parse=_;function j(P){if(!!P){let F;return N=>(F||(F=(P()||Promise.resolve([])).then(x=>x?K(x):{})),F.then(x=>!!x[N]))}}e.hasSiblingPromiseFn=j;function q(P){if(!!P){let F;return N=>{if(!F){const x=P();F=x?K(x):{}}return!!F[N]}}}e.hasSiblingFn=q;function K(P){const F={};for(const N of P)F[N]=!0;return F}function M(P){const F=P;return F&&typeof F.base=="string"&&typeof F.pattern=="string"}e.isRelativePattern=M;function $(P){return P.allBasenames||[]}e.getBasenameTerms=$;function z(P){return P.allPaths||[]}e.getPathTerms=z;function W(P,F){const N=T(Object.getOwnPropertyNames(P).map(ie=>H(ie,P[ie],F)).filter(ie=>ie!==r)),x=N.length;if(!x)return r;if(!N.some(ie=>!!ie.requiresSiblings)){if(x===1)return N[0];const ie=function(ue,ge){for(let pe=0,Ce=N.length;pe<Ce;pe++){const ke=N[pe](ue,ge);if(ke)return ke}return null},ne=N.find(ue=>!!ue.allBasenames);ne&&(ie.allBasenames=ne.allBasenames);const ce=N.reduce((ue,ge)=>ge.allPaths?ue.concat(ge.allPaths):ue,[]);return ce.length&&(ie.allPaths=ce),ie}const V=function(ie,ne,ce){let ue;for(let ge=0,pe=N.length;ge<pe;ge++){const Ce=N[ge];Ce.requiresSiblings&&ce&&(ne||(ne=O.basename(ie)),ue||(ue=ne.substr(0,ne.length-O.extname(ie).length)));const ke=Ce(ie,ne,ue,ce);if(ke)return ke}return null},X=N.find(ie=>!!ie.allBasenames);X&&(V.allBasenames=X.allBasenames);const Q=N.reduce((ie,ne)=>ne.allPaths?ie.concat(ne.allPaths):ie,[]);return Q.length&&(V.allPaths=Q),V}function H(P,F,N){if(F===!1)return r;const x=o(P,N);if(x===r)return r;if(typeof F=="boolean")return x;if(F){const V=F.when;if(typeof V=="string"){const X=(Q,ie,ne,ce)=>{if(!ce||!x(Q,ie))return null;const ue=V.replace("$(basename)",ne),ge=ce(ue);return(0,U.isThenable)(ge)?ge.then(pe=>pe?P:null):ge?P:null};return X.requiresSiblings=!0,X}}return x}function T(P,F){const N=P.filter(ie=>!!ie.basenames);if(N.length<2)return P;const x=N.reduce((ie,ne)=>{const ce=ne.basenames;return ce?ie.concat(ce):ie},[]);let V;if(F){V=[];for(let ie=0,ne=x.length;ie<ne;ie++)V.push(F)}else V=N.reduce((ie,ne)=>{const ce=ne.patterns;return ce?ie.concat(ce):ie},[]);const X=function(ie,ne){if(typeof ie!="string")return null;if(!ne){let ue;for(ue=ie.length;ue>0;ue--){const ge=ie.charCodeAt(ue-1);if(ge===47||ge===92)break}ne=ie.substr(ue)}const ce=x.indexOf(ne);return ce!==-1?V[ce]:null};X.basenames=x,X.patterns=V,X.allBasenames=x;const Q=P.filter(ie=>!ie.basenames);return Q.push(X),Q}}),define(Z[91],ee([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function L(n){return n.toJSON()}class O{constructor(f){this._uriTransformer=f}transformIncoming(f){const v=this._uriTransformer.transformIncoming(f);return v===f?f:L(p.URI.from(v))}transformOutgoing(f){const v=this._uriTransformer.transformOutgoing(f);return v===f?f:L(p.URI.from(v))}transformOutgoingURI(f){const v=this._uriTransformer.transformOutgoing(f);return v===f?f:p.URI.from(v)}transformOutgoingScheme(f){return this._uriTransformer.transformOutgoingScheme(f)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(n){return n}transformOutgoing(n){return n}transformOutgoingURI(n){return n}transformOutgoingScheme(n){return n}};function R(n,f,v){if(!n||v>200)return null;if(typeof n=="object"){if(n instanceof p.URI)return f.transformOutgoing(n);for(let C in n)if(Object.hasOwnProperty.call(n,C)){const d=R(n[C],f,v+1);d!==null&&(n[C]=d)}}return null}function U(n,f){const v=R(n,f,0);return v===null?n:v}e.transformOutgoingURIs=U;function A(n,f,v,C){if(!n||C>200)return null;if(typeof n=="object"){if(n.$mid===1)return v?p.URI.revive(f.transformIncoming(n)):f.transformIncoming(n);for(let d in n)if(Object.hasOwnProperty.call(n,d)){const w=A(n[d],f,v,C+1);w!==null&&(n[d]=w)}}return null}function S(n,f){const v=A(n,f,!1,0);return v===null?n:v}e.transformIncomingURIs=S;function y(n,f){const v=A(n,f,!0,0);return v===null?n:v}e.transformAndReviveIncomingURIs=y}),define(Z[31],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(S){return p.test(S)}e.isUUID=L;const O=new Uint8Array(16),R=[];for(let S=0;S<256;S++)R.push(S.toString(16).padStart(2,"0"));let U;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?U=crypto.getRandomValues.bind(crypto):U=function(S){for(let y=0;y<S.length;y++)S[y]=Math.floor(Math.random()*256);return S};function A(){U(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let S=0,y="";return y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y+="-",y+=R[O[S++]],y+=R[O[S++]],y+="-",y+=R[O[S++]],y+=R[O[S++]],y+="-",y+=R[O[S++]],y+=R[O[S++]],y+="-",y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y+=R[O[S++]],y}e.generateUuid=A}),define(Z[68],ee([0,1,207]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(R="utf8"){this.stringDecoder=new p.StringDecoder(R),this.remaining=null}write(R){const U=[],A=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(A.length<1)return U;let S=0,y,n=S;for(;n<A.length;)if(y=A.charCodeAt(n),y===13||y===10){if(U.push(A.substring(S,n)),n++,n<A.length){const f=y;y=A.charCodeAt(n),(f===13&&y===10||f===10&&y===13)&&n++}S=n}else n++;return this.remaining=S<A.length?A.substr(S):null,U}end(){return this.remaining}}e.LineDecoder=L}),define(Z[92],ee([0,1,36]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function O(A){const S=A.replace(/\-/g,":").toLowerCase();return!L.has(S)}function R(){return new Promise(async(A,S)=>{const y=setTimeout(()=>S("Unable to retrieve mac address (timeout after 10s)"),1e4);try{A(await U())}catch(n){S(n)}finally{clearTimeout(y)}})}e.getMac=R;function U(){return new Promise((A,S)=>{try{const y=(0,p.networkInterfaces)();for(let n in y){const f=y[n];if(f){for(const{mac:v}of f)if(O(v))return A(v)}}S("Unable to retrieve mac address (unexpected format)")}catch(y){S(y)}})}}),define(Z[93],ee([0,1,11,31,36,39,92]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(n){return this._virtualMachineOUIs||(this._virtualMachineOUIs=R.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(n)}value(){if(this._value===void 0){let n=0,f=0;const v=(0,O.networkInterfaces)();for(let C in v){const d=v[C];if(d)for(const{mac:w,internal:I}of d)I||(f+=1,this._isVirtualMachineMacAdress(w.toUpperCase())&&(n+=1))}this._value=f>0?n/f:0}return this._value}};let A;async function S(){return A||(A=(async()=>await y()||L.generateUuid())()),A}e.getMachineId=S;async function y(){try{const n=await new Promise((v,C)=>{G(["crypto"],v,C)}),f=await(0,U.getMac)();return n.createHash("sha256").update(f,"utf8").digest("hex")}catch(n){p.onUnexpectedError(n);return}}}),define(Z[17],ee([0,1,27,36,7,8,6,42,31,67,14,5]),function(G,e,p,L,O,R,U,A,S,y,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var v;(function($){$[$.UNLINK=0]="UNLINK",$[$.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function C($,z=v.UNLINK){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");return z===v.UNLINK?w($):d($)}e.rimraf=C;async function d($){try{const z=(0,O.join)((0,L.tmpdir)(),(0,S.generateUuid)());try{await p.promises.rename($,z)}catch(W){return w($)}w(z).catch(W=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function w($){return p.promises.rmdir($,{recursive:!0,maxRetries:3})}function I($){if((0,A.isRootOrDriveLetter)($))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync($,{recursive:!0})}e.rimrafSync=I;async function E($,z){return a(await(z?D($):p.promises.readdir($)))}e.readdir=E;async function D($){try{return await p.promises.readdir($,{withFileTypes:!0})}catch(H){console.warn("[node.js fs] readdir with filetypes failed with error: ",H)}const z=[],W=await E($);for(const H of W){let T=!1,P=!1,F=!1;try{const N=await p.promises.lstat((0,O.join)($,H));T=N.isFile(),P=N.isDirectory(),F=N.isSymbolicLink()}catch(N){console.warn("[node.js fs] unexpected error from lstat after readdir: ",N)}z.push({name:H,isFile:()=>T,isDirectory:()=>P,isSymbolicLink:()=>F})}return z}function g($){return a(p.readdirSync($))}e.readdirSync=g;function a($){return $.map(z=>typeof z=="string"?U.isMacintosh?(0,y.normalizeNFC)(z):z:(z.name=U.isMacintosh?(0,y.normalizeNFC)(z.name):z.name,z))}async function s($){const z=await E($),W=[];for(const H of z)await i.existsDirectory((0,O.join)($,H))&&W.push(H);return W}e.readDirsInDir=s;function t($,z=1e3){return new Promise(W=>{let H=!1;const T=setInterval(()=>{H||(H=!0,p.access($,P=>{H=!1,P&&(clearInterval(T),W(void 0))}))},z)})}e.whenDeleted=t;var i;(function($){async function z(T){let P;try{if(P=await p.promises.lstat(T),!P.isSymbolicLink())return{stat:P}}catch(F){}try{return{stat:await p.promises.stat(T),symbolicLink:(P==null?void 0:P.isSymbolicLink())?{dangling:!1}:void 0}}catch(F){if(F.code==="ENOENT"&&P)return{stat:P,symbolicLink:{dangling:!0}};if(U.isWindows&&F.code==="EACCES")try{return{stat:await p.promises.stat(await p.promises.readlink(T)),symbolicLink:{dangling:!1}}}catch(N){if(N.code==="ENOENT"&&P)return{stat:P,symbolicLink:{dangling:!0}};throw N}throw F}}$.stat=z;async function W(T){try{const{stat:P,symbolicLink:F}=await $.stat(T);return P.isFile()&&(F==null?void 0:F.dangling)!==!0}catch(P){}return!1}$.existsFile=W;async function H(T){try{const{stat:P,symbolicLink:F}=await $.stat(T);return P.isDirectory()&&(F==null?void 0:F.dangling)!==!0}catch(P){}return!1}$.existsDirectory=H})(i=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function o($,z,W){return r.queueFor(f.URI.file($),n.extUriBiasedIgnorePathCase).queue(()=>{const H=m(W);return new Promise((T,P)=>l($,z,H,F=>F?P(F):T()))})}e.writeFile=o;let c=!0;function l($,z,W,H){if(!c)return p.writeFile($,z,{mode:W.mode,flag:W.flag},H);p.open($,W.flag,W.mode,(T,P)=>{if(T)return H(T);p.writeFile(P,z,F=>{if(F)return p.close(P,()=>H(F));p.fdatasync(P,N=>(N&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",N),c=!1),p.close(P,x=>H(x))))})})}function u($,z,W){const H=m(W);if(!c)return p.writeFileSync($,z,{mode:H.mode,flag:H.flag});const T=p.openSync($,H.flag,H.mode);try{p.writeFileSync(T,z);try{p.fdatasyncSync(T)}catch(P){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",P),c=!1}}finally{p.closeSync(T)}}e.writeFileSync=u;function m($){return $?{mode:typeof $.mode=="number"?$.mode:438,flag:typeof $.flag=="string"?$.flag:"w"}:{mode:438,flag:"w"}}async function b($,z){if($!==z){async function W(H){try{const T=await p.promises.lstat(H);if(T.isDirectory()||T.isSymbolicLink())return;const P=await p.promises.open(H,"a");try{await P.utimes(T.atime,new Date)}finally{await P.close()}}catch(T){}}try{await p.promises.rename($,z),await W(z)}catch(H){if($.toLowerCase()!==z.toLowerCase()&&H.code==="EXDEV"||$.endsWith("."))await h($,z,{preserveSymlinks:!1}),await C($,v.MOVE),await W(z);else throw H}}}e.move=b;async function h($,z,W){return _($,z,{root:{source:$,target:z},options:W,handledSourcePaths:new Set})}e.copy=h;const k=511;async function _($,z,W){if(!W.handledSourcePaths.has($)){W.handledSourcePaths.add($);const{stat:H,symbolicLink:T}=await i.stat($);if(T){if(W.options.preserveSymlinks)try{return await K($,z,W)}catch(P){console.warn("[node.js fs] copy of symlink failed: ",P)}if(T.dangling)return}return H.isDirectory()?j($,z,H.mode&k,W):q($,z,H.mode&k)}}async function j($,z,W,H){await p.promises.mkdir(z,{recursive:!0,mode:W});const T=await E($);for(const P of T)await _((0,O.join)($,P),(0,O.join)(z,P),H)}async function q($,z,W){await p.promises.copyFile($,z),await p.promises.chmod(z,W)}async function K($,z,W){let H=await p.promises.readlink($);(0,A.isEqualOrParent)(H,W.root.source,!U.isLinux)&&(H=(0,O.join)(W.root.target,H.substr(W.root.source.length+1))),await p.promises.symlink(H,z)}async function M($){try{return await p.promises.access($),!0}catch(z){return!1}}e.exists=M}),define(Z[94],ee([0,1,27,95,22,7,17]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function A(f){const v=(0,R.dirname)(f);if(f===v)return f;const C=((0,R.basename)(f)||f).toLowerCase();try{const w=(0,U.readdirSync)(v).filter(I=>I.toLowerCase()===C);if(w.length===1){const I=A(v);if(I)return(0,R.join)(I,w[0])}else if(w.length>1){const I=w.indexOf(C);if(I>=0){const E=A(v);if(E)return(0,R.join)(E,w[I])}}}catch(d){}return null}e.realcaseSync=A;async function S(f){try{return await(0,L.promisify)(p.realpath)(f)}catch(v){const C=n(f);return await p.promises.access(C,p.constants.R_OK),C}}e.realpath=S;function y(f){try{return p.realpathSync(f)}catch(v){const C=n(f);return p.accessSync(C,p.constants.R_OK),C}}e.realpathSync=y;function n(f){return(0,O.rtrim)((0,R.normalize)(f),R.sep)}});var Le=this&&this.__await||function(G){return this instanceof Le?(this.v=G,this):new Le(G)},lt=this&&this.__asyncGenerator||function(G,e,p){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var L=p.apply(G,e||[]),O,R=[];return O={},U("next"),U("throw"),U("return"),O[Symbol.asyncIterator]=function(){return this},O;function U(v){L[v]&&(O[v]=function(C){return new Promise(function(d,w){R.push([v,C,d,w])>1||A(v,C)})})}function A(v,C){try{S(L[v](C))}catch(d){f(R[0][3],d)}}function S(v){v.value instanceof Le?Promise.resolve(v.value.v).then(y,n):f(R[0][2],v)}function y(v){A("next",v)}function n(v){A("throw",v)}function f(v,C){v(C),R.shift(),R.length&&A(R[0][0],R[0][1])}},et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],p;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),p={},L("next"),L("throw"),L("return"),p[Symbol.asyncIterator]=function(){return this},p);function L(R){p[R]=G[R]&&function(U){return new Promise(function(A,S){U=G[R](U),O(A,S,U.done,U.value)})}}function O(R,U,A,S){Promise.resolve(S).then(function(y){R({value:y,done:A})},U)}};define(Z[96],ee([0,1,17,36,7]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,U=/^Microsoft.PowerShell_.*/,A=/^Microsoft.PowerShellPreview_.*/;var S;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(S||(S={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let n;process.env.PROCESSOR_ARCHITEW6432?n=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?n=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?n=1:n=0;class f{constructor(s,t,i){this.exePath=s,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await p.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:a=!1}={}){return a?y===0?process.env["ProgramFiles(x86)"]||null:n===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function C({useAlternateBitness:a=!1,findPreview:s=!1}={}){const t=v({useAlternateBitness:a});if(!t)return null;const i=O.join(t,"PowerShell");if(!await p.SymlinkSupport.existsDirectory(i))return null;let r=-1,o=null;for(const u of await p.readdir(i)){let m=-1;if(s){const h=u.indexOf("-");if(h<0)continue;const k=u.substring(0,h);if(!R.test(k)||u.substring(h+1)!=="preview")continue;m=parseInt(k,10)}else{if(!R.test(u))continue;m=parseInt(u,10)}if(!(m<=r)){const b=O.join(i,u,"pwsh.exe");!await p.SymlinkSupport.existsFile(b)||(o=b,r=m)}}if(!o)return null;const c=t.includes("x86")?" (x86)":"",l=s?" Preview":"";return new f(o,`PowerShell${l}${c}`,!0)}async function d({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=O.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await p.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=a?{pwshMsixDirRegex:A,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:U,pwshMsixName:"PowerShell (Store)"};for(const r of await p.readdir(s))if(t.test(r)){const o=O.join(s,r,"pwsh.exe");return new f(o,i)}return null}function w(){const a=O.join(L.homedir(),".dotnet","tools","pwsh.exe");return new f(a,".NET Core PowerShell Global Tool")}function I(){const a=O.join(process.env.windir,y===1&&n!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new f(a,"Windows PowerShell",!0)}function E(){return lt(this,arguments,function*(){let s=yield Le(C());s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0})),s&&(yield yield Le(s)),s=yield Le(d()),s&&(yield yield Le(s)),s=w(),s&&(yield yield Le(s)),s=yield Le(C({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(d({findPreview:!0})),s&&(yield yield Le(s)),s=yield Le(C({useAlternateBitness:!0,findPreview:!0})),s&&(yield yield Le(s)),s=I(),s&&(yield yield Le(s))})}function D(){return lt(this,arguments,function*(){var s,t;try{for(var i=et(E()),r;r=yield Le(i.next()),!r.done;){const o=r.value;(yield Le(o.exists()))&&(yield yield Le(o))}}catch(o){s={error:o}}finally{try{r&&!r.done&&(t=i.return)&&(yield Le(t.call(i)))}finally{if(s)throw s.error}}})}e.enumeratePowerShellInstallations=D;async function g(){var a,s;try{for(var t=et(D()),i;i=await t.next(),!i.done;)return i.value}catch(r){a={error:r}}finally{try{i&&!i.done&&(s=t.return)&&await s.call(t)}finally{if(a)throw a.error}}return null}e.getFirstAvailablePowerShellInstallation=g}),define(Z[97],ee([0,1,43,16]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function O(U){return new Promise((A,S)=>{let y;const n=new Map;function f(d,w,I,E,D){const g=n.get(w);if(d===U||g){const a={name:v(I),cmd:I,pid:d,ppid:w,load:E,mem:D};n.set(d,a),d===U&&(y=a),g&&(g.children||(g.children=[]),g.children.push(a),g.children.length>1&&(g.children=g.children.sort((s,t)=>s.pid-t.pid)))}}function v(d){const w=/--disable-blink-features=Auxclick/,I=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,D=/\\pipe\\winpty-control/,g=/conhost\.exe/,a=/--type=([a-zA-Z-]+)/;if(I.exec(d))return"watcherService ";if(E.exec(d))return"electron-crash-reporter";if(D.exec(d))return"winpty-process";if(g.exec(d))return"console-window-host (Windows internal process)";let s=a.exec(d);if(s&&s.length===2)return s[1]==="renderer"?w.exec(d)?"shared-process":"window":s[1];const t=/[a-zA-Z-]+\.js/g;let i="";do s=t.exec(d),s&&(i+=s+" ");while(s);return i&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron_node ${i}`:d}if(process.platform==="win32"){const d=w=>w.indexOf("\\\\?\\")===0||w.indexOf("\\??\\")===0?w.substr(4):w.indexOf('"\\\\?\\')===0||w.indexOf('"\\??\\')===0?'"'+w.substr(5):w;new Promise((w,I)=>{G(["windows-process-tree"],w,I)}).then(w=>{w.getProcessList(U,I=>{w.getProcessCpuUsage(I,E=>{const D=new Map;E.forEach(g=>{const a=d(g.commandLine||"");D.set(g.pid,{name:v(a),cmd:a,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),y=D.get(U),y?(D.forEach(g=>{const a=D.get(g.ppid);a&&(a.children||(a.children=[]),a.children.push(g))}),D.forEach(g=>{g.children&&(g.children=g.children.sort((a,s)=>a.pid-s.pid))}),A(y)):S(new Error(`Root process ${U} not found`))})},w.ProcessDataFlag.CommandLine|w.ProcessDataFlag.Memory)})}else{function C(){let d=[y];const w=[];for(;d.length;){const E=d.shift();E&&(w.push(E.pid),E.children&&(d=d.concat(E.children)))}let I=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",G).fsPath);I+=" "+w.join(" "),(0,p.exec)(I,{},(E,D,g)=>{if(E||g)S(E||new Error(g.toString()));else{const a=D.toString().split(`
`);for(let s=0;s<w.length;s++){const t=n.get(w[s]);t.load=parseFloat(a[s])}if(!y){S(new Error(`Root process ${U} not found`));return}A(y)}})}(0,p.exec)("which ps",{},(d,w,I)=>{if(d||I)if(process.platform!=="linux")S(d||new Error(I.toString()));else{const E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",G).fsPath);(0,p.exec)(E,{},(D,g,a)=>{D||a?S(D||new Error(a.toString())):(R(g,f),C())})}else{const E=w.toString().trim(),D="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${E} ${D}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,a,s)=>{g||s&&!s.includes("screen size is bogus")?S(g||new Error(s.toString())):(R(a,f),process.platform==="linux"?C():y?A(y):S(new Error(`Root process ${U} not found`)))})}})}})}e.listProcesses=O;function R(U,A){const S=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=U.toString().split(`
`);for(const n of y){const f=S.exec(n.trim());f&&f.length===6&&A(parseInt(f[1]),parseInt(f[2]),f[5],parseFloat(f[3]),parseFloat(f[4]))}}}),define(Z[98],ee([0,1,7,27,6,67,2,17]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function S(f,v,C){return n({path:f,isDirectory:!1},v,C)}e.watchFile=S;function y(f,v,C){return n({path:f,isDirectory:!0},v,C)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function n(f,v,C){const d=(0,p.basename)(f.path),w=new Map;let I=!1,E=[(0,U.toDisposable)(()=>{w.forEach(D=>(0,U.dispose)(D)),w.clear()})];try{const D=(0,L.watch)(f.path);E.push((0,U.toDisposable)(()=>{D.removeAllListeners(),D.close()}));const g=new Set;f.isDirectory&&(0,A.readdir)(f.path).then(a=>a.forEach(s=>g.add(s))),D.on("error",(a,s)=>{I||C(`Failed to watch ${f.path} for changes using fs.watch() (${a}, ${s})`)}),D.on("change",(a,s)=>{if(!I){let t="";if(s&&(t=s.toString(),O.isMacintosh&&(t=(0,R.normalizeNFC)(t))),!(!t||a!=="change"&&a!=="rename")){const i=f.isDirectory?(0,p.join)(f.path,t):f.path;if(f.isDirectory)if(a==="rename"){const r=w.get(i);r&&(0,U.dispose)(r);const o=setTimeout(async()=>{w.delete(i);const c=await(0,A.exists)(i);if(!I){let l;c?g.has(t)?l="changed":(l="added",g.add(t)):(g.delete(t),l="deleted"),v(l,i)}},e.CHANGE_BUFFER_DELAY);w.set(i,(0,U.toDisposable)(()=>clearTimeout(o)))}else{let r;g.has(t)?r="changed":(r="added",g.add(t)),v(r,i)}else if(a==="rename"||t!==d){const r=setTimeout(async()=>{const o=await(0,A.exists)(i);I||(o?(v("changed",i),E=[n(f,v,C)]):v("deleted",i))},e.CHANGE_BUFFER_DELAY);(0,U.dispose)(E),E=[(0,U.toDisposable)(()=>clearTimeout(r))]}else v("changed",i)}}})}catch(D){(0,A.exists)(f.path).then(g=>{g&&!I&&C(`Failed to watch ${f.path} for changes using fs.watch() (${D.toString()})`)})}return(0,U.toDisposable)(()=>{I=!0,E=(0,U.dispose)(E)})}});var de=this&&this.__decorate||function(G,e,p,L){var O=arguments.length,R=O<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,U;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(G,e,p,L);else for(var A=G.length-1;A>=0;A--)(U=G[A])&&(R=(O<3?U(R):O>3?U(e,p,R):U(e,p))||R);return O>3&&R&&Object.defineProperty(e,p,R),R};define(Z[37],ee([0,1,3,2,8,30,11,25,19,15,89,22,64]),function(G,e,p,L,O,R,U,A,S,y,n,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var C;(function(T){T[T.Promise=100]="Promise",T[T.PromiseCancel=101]="PromiseCancel",T[T.EventListen=102]="EventListen",T[T.EventDispose=103]="EventDispose"})(C=e.RequestType||(e.RequestType={}));function d(T){switch(T){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(T){T[T.Initialize=200]="Initialize",T[T.PromiseSuccess=201]="PromiseSuccess",T[T.PromiseError=202]="PromiseError",T[T.PromiseErrorObj=203]="PromiseErrorObj",T[T.EventFire=204]="EventFire"})(w=e.ResponseType||(e.ResponseType={}));function I(T){switch(T){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(T){T[T.Uninitialized=0]="Uninitialized",T[T.Idle=1]="Idle"})(E||(E={}));class D{constructor(P){this.buffer=P,this.pos=0}read(P){const F=this.buffer.slice(this.pos,this.pos+P);return this.pos+=F.byteLength,F}}class g{constructor(){this.buffers=[]}get buffer(){return A.VSBuffer.concat(this.buffers)}write(P){this.buffers.push(P)}}var a;(function(T){T[T.Undefined=0]="Undefined",T[T.String=1]="String",T[T.Buffer=2]="Buffer",T[T.VSBuffer=3]="VSBuffer",T[T.Array=4]="Array",T[T.Object=5]="Object"})(a||(a={}));function s(T){const P=A.VSBuffer.alloc(4);return P.writeUInt32BE(T,0),P}function t(T){return T.read(4).readUInt32BE(0)}function i(T){const P=A.VSBuffer.alloc(1);return P.writeUInt8(T,0),P}const r={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object)},o=typeof Buffer!="undefined";function c(T,P){if(typeof P=="undefined")T.write(r.Undefined);else if(typeof P=="string"){const F=A.VSBuffer.fromString(P);T.write(r.String),T.write(s(F.byteLength)),T.write(F)}else if(o&&Buffer.isBuffer(P)){const F=A.VSBuffer.wrap(P);T.write(r.Buffer),T.write(s(F.byteLength)),T.write(F)}else if(P instanceof A.VSBuffer)T.write(r.VSBuffer),T.write(s(P.byteLength)),T.write(P);else if(Array.isArray(P)){T.write(r.Array),T.write(s(P.length));for(const F of P)c(T,F)}else{const F=A.VSBuffer.fromString(JSON.stringify(P));T.write(r.Object),T.write(s(F.byteLength)),T.write(F)}}function l(T){switch(T.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return T.read(t(T)).toString();case a.Buffer:return T.read(t(T)).buffer;case a.VSBuffer:return T.read(t(T));case a.Array:{const F=t(T),N=[];for(let x=0;x<F;x++)N.push(l(T));return N}case a.Object:return JSON.parse(T.read(t(T)).toString())}}class u{constructor(P,F,N=null,x=1e3){this.protocol=P,this.ctx=F,this.logger=N,this.timeoutDelay=x,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(V=>this.onRawMessage(V)),this.sendResponse({type:200})}registerChannel(P,F){this.channels.set(P,F),setTimeout(()=>this.flushPendingRequests(P),0)}sendResponse(P){switch(P.type){case 200:{const F=this.send([P.type]);this.logger&&this.logger.logOutgoing(F,0,1,I(P.type));return}case 201:case 202:case 204:case 203:{const F=this.send([P.type,P.id],P.data);this.logger&&this.logger.logOutgoing(F,P.id,1,I(P.type),P.data);return}}}send(P,F=void 0){const N=new g;return c(N,P),c(N,F),this.sendBuffer(N.buffer)}sendBuffer(P){try{return this.protocol.send(P),P.byteLength}catch(F){return 0}}onRawMessage(P){const F=new D(P),N=l(F),x=l(F),V=N[0];switch(V){case 100:return this.logger&&this.logger.logIncoming(P.byteLength,N[1],1,`${d(V)}: ${N[2]}.${N[3]}`,x),this.onPromise({type:V,id:N[1],channelName:N[2],name:N[3],arg:x});case 102:return this.logger&&this.logger.logIncoming(P.byteLength,N[1],1,`${d(V)}: ${N[2]}.${N[3]}`,x),this.onEventListen({type:V,id:N[1],channelName:N[2],name:N[3],arg:x});case 101:return this.logger&&this.logger.logIncoming(P.byteLength,N[1],1,`${d(V)}`),this.disposeActiveRequest({type:V,id:N[1]});case 103:return this.logger&&this.logger.logIncoming(P.byteLength,N[1],1,`${d(V)}`),this.disposeActiveRequest({type:V,id:N[1]})}}onPromise(P){const F=this.channels.get(P.channelName);if(!F){this.collectPendingRequest(P);return}const N=new R.CancellationTokenSource;let x;try{x=F.call(this.ctx,P.name,P.arg,N.token)}catch(Q){x=Promise.reject(Q)}const V=P.id;x.then(Q=>{this.sendResponse({id:V,data:Q,type:201}),this.activeRequests.delete(P.id)},Q=>{Q instanceof Error?this.sendResponse({id:V,data:{message:Q.message,name:Q.name,stack:Q.stack?Q.stack.split?Q.stack.split(`
`):Q.stack:void 0},type:202}):this.sendResponse({id:V,data:Q,type:203}),this.activeRequests.delete(P.id)});const X=(0,L.toDisposable)(()=>N.cancel());this.activeRequests.set(P.id,X)}onEventListen(P){const F=this.channels.get(P.channelName);if(!F){this.collectPendingRequest(P);return}const N=P.id,V=F.listen(this.ctx,P.name,P.arg)(X=>this.sendResponse({id:N,data:X,type:204}));this.activeRequests.set(P.id,V)}disposeActiveRequest(P){const F=this.activeRequests.get(P.id);F&&(F.dispose(),this.activeRequests.delete(P.id))}collectPendingRequest(P){let F=this.pendingRequests.get(P.channelName);F||(F=[],this.pendingRequests.set(P.channelName,F));const N=setTimeout(()=>{console.error(`Unknown channel: ${P.channelName}`),P.type===100&&this.sendResponse({id:P.id,data:{name:"Unknown channel",message:`Channel name '${P.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);F.push({request:P,timeoutTimer:N})}flushPendingRequests(P){const F=this.pendingRequests.get(P);if(F){for(const N of F)switch(clearTimeout(N.timeoutTimer),N.request.type){case 100:this.onPromise(N.request);break;case 102:this.onEventListen(N.request);break}this.pendingRequests.delete(P)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(P=>P.dispose()),this.activeRequests.clear()}}e.ChannelServer=u;var m;(function(T){T[T.LocalSide=0]="LocalSide",T[T.OtherSide=1]="OtherSide"})(m=e.RequestInitiator||(e.RequestInitiator={}));class b{constructor(P,F=null){this.protocol=P,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new p.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(N=>this.onBuffer(N)),this.logger=F}getChannel(P){const F=this;return{call(N,x,V){return F.isDisposed?Promise.reject(U.canceled()):F.requestPromise(P,N,x,V)},listen(N,x){return F.isDisposed?Promise.reject(U.canceled()):F.requestEvent(P,N,x)}}}requestPromise(P,F,N,x=R.CancellationToken.None){const V=this.lastRequestId++,Q={id:V,type:100,channelName:P,name:F,arg:N};if(x.isCancellationRequested)return Promise.reject(U.canceled());let ie;return new Promise((ce,ue)=>{if(x.isCancellationRequested)return ue(U.canceled());const ge=()=>{const Fe=Oe=>{switch(Oe.type){case 201:this.handlers.delete(V),ce(Oe.data);break;case 202:this.handlers.delete(V);const Ae=new Error(Oe.data.message);Ae.stack=Oe.data.stack,Ae.name=Oe.data.name,ue(Ae);break;case 203:this.handlers.delete(V),ue(Oe.data);break}};this.handlers.set(V,Fe),this.sendRequest(Q)};let pe=null;this.state===E.Idle?ge():(pe=(0,O.createCancelablePromise)(Fe=>this.whenInitialized()),pe.then(()=>{pe=null,ge()}));const Ce=()=>{pe?(pe.cancel(),pe=null):this.sendRequest({id:V,type:101}),ue(U.canceled())},ke=x.onCancellationRequested(Ce);ie=(0,L.combinedDisposable)((0,L.toDisposable)(Ce),ke),this.activeRequests.add(ie)}).finally(()=>{this.activeRequests.delete(ie)})}requestEvent(P,F,N){const x=this.lastRequestId++,X={id:x,type:102,channelName:P,name:F,arg:N};let Q=null;const ie=new p.Emitter({onFirstListenerAdd:()=>{Q=(0,O.createCancelablePromise)(ce=>this.whenInitialized()),Q.then(()=>{Q=null,this.activeRequests.add(ie),this.sendRequest(X)})},onLastListenerRemove:()=>{Q?(Q.cancel(),Q=null):(this.activeRequests.delete(ie),this.sendRequest({id:x,type:103}))}}),ne=ce=>ie.fire(ce.data);return this.handlers.set(x,ne),ie.event}sendRequest(P){switch(P.type){case 100:case 102:{const F=this.send([P.type,P.id,P.channelName,P.name],P.arg);this.logger&&this.logger.logOutgoing(F,P.id,0,`${d(P.type)}: ${P.channelName}.${P.name}`,P.arg);return}case 101:case 103:{const F=this.send([P.type,P.id]);this.logger&&this.logger.logOutgoing(F,P.id,0,d(P.type));return}}}send(P,F=void 0){const N=new g;return c(N,P),c(N,F),this.sendBuffer(N.buffer)}sendBuffer(P){try{return this.protocol.send(P),P.byteLength}catch(F){return 0}}onBuffer(P){const F=new D(P),N=l(F),x=l(F),V=N[0];switch(V){case 200:return this.logger&&this.logger.logIncoming(P.byteLength,0,0,I(V)),this.onResponse({type:N[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(P.byteLength,N[1],0,I(V),x),this.onResponse({type:N[0],id:N[1],data:x})}}onResponse(P){if(P.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}const F=this.handlers.get(P.id);F&&F(P)}get onDidInitializePromise(){return p.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(P=>P.dispose()),this.activeRequests.clear()}}de([v.memoize],b.prototype,"onDidInitializePromise",null),e.ChannelClient=b;class h{constructor(P){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new p.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new p.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,P(({protocol:F,onDidClientDisconnect:N})=>{p.Event.once(F.onMessage)(V=>{const X=new D(V),Q=l(X),ie=new u(F,Q),ne=new b(F);this.channels.forEach((ue,ge)=>ie.registerChannel(ge,ue));const ce={channelServer:ie,channelClient:ne,ctx:Q};this._connections.add(ce),this._onDidAddConnection.fire(ce),N(()=>{ie.dispose(),ne.dispose(),this._connections.delete(ce),this._onDidRemoveConnection.fire(ce)})})})}get connections(){const P=[];return this._connections.forEach(F=>P.push(F)),P}getChannel(P,F){const N=this;return{call(x,V,X){let Q;if((0,y.isFunction)(F)){let ne=(0,S.getRandomElement)(N.connections.filter(F));Q=ne?Promise.resolve(ne):p.Event.toPromise(p.Event.filter(N.onDidAddConnection,F))}else Q=F.routeCall(N,x,V);const ie=Q.then(ne=>ne.channelClient.getChannel(P));return _(ie).call(x,V,X)},listen(x,V){if((0,y.isFunction)(F))return N.getMulticastEvent(P,F,x,V);const X=F.routeEvent(N,x,V).then(Q=>Q.channelClient.getChannel(P));return _(X).listen(x,V)}}}getMulticastEvent(P,F,N,x){const V=this;let X=new L.DisposableStore;const Q=new p.Emitter({onFirstListenerAdd:()=>{X=new L.DisposableStore;const ie=new p.EventMultiplexer,ne=new Map,ce=ge=>{const Ce=ge.channelClient.getChannel(P).listen(N,x),ke=ie.add(Ce);ne.set(ge,ke)},ue=ge=>{const pe=ne.get(ge);!pe||(pe.dispose(),ne.delete(ge))};V.connections.filter(F).forEach(ce),p.Event.filter(V.onDidAddConnection,F)(ce,void 0,X),V.onDidRemoveConnection(ue,void 0,X),ie.event(Q.fire,Q,X),X.add(ie)},onLastListenerRemove:()=>{X.dispose()}});return Q.event}registerChannel(P,F){this.channels.set(P,F),this._connections.forEach(N=>{N.channelServer.registerChannel(P,F)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=h;class k{constructor(P,F,N=null){const x=new g;c(x,F),P.send(x.buffer),this.channelClient=new b(P,N),this.channelServer=new u(P,F,N)}getChannel(P){return this.channelClient.getChannel(P)}registerChannel(P,F){this.channelServer.registerChannel(P,F)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=k;function _(T){return{call(P,F,N){return T.then(x=>x.call(P,F,N))},listen(P,F){const N=new p.Relay;return T.then(x=>N.input=x.listen(P,F)),N.event}}}e.getDelayedChannel=_;function j(T){let P=!1;return{call(F,N,x){return P?T.call(F,N,x):(0,O.timeout)(0).then(()=>P=!0).then(()=>T.call(F,N,x))},listen(F,N){if(P)return T.listen(F,N);const x=new p.Relay;return(0,O.timeout)(0).then(()=>P=!0).then(()=>x.input=T.listen(F,N)),x.event}}}e.getNextTickChannel=j;class q{constructor(P){this.fn=P}routeCall(P){return this.route(P)}routeEvent(P){return this.route(P)}async route(P){for(const F of P.connections)if(await Promise.resolve(this.fn(F.ctx)))return Promise.resolve(F);return await p.Event.toPromise(P.onDidAddConnection),await this.route(P)}}e.StaticRouter=q;var K;(function(T){function P(x,V){const X=x,Q=V&&V.disableMarshalling,ie=new Map;for(const ne in X)N(ne)&&ie.set(ne,p.Event.buffer(X[ne],!0));return new class{listen(ne,ce){const ue=ie.get(ce);if(ue)return ue;throw new Error(`Event not found: ${ce}`)}call(ne,ce,ue){const ge=X[ce];if(typeof ge=="function"){if(!Q&&Array.isArray(ue))for(let pe=0;pe<ue.length;pe++)ue[pe]=(0,n.revive)(ue[pe]);return ge.apply(X,ue)}throw new Error(`Method not found: ${ce}`)}}}T.fromService=P;function F(x,V){const X=V&&V.disableMarshalling;return new Proxy({},{get(Q,ie){var ne;if(typeof ie=="string")return((ne=V==null?void 0:V.properties)===null||ne===void 0?void 0:ne.has(ie))?V.properties.get(ie):N(ie)?x.listen(ie):async function(...ce){let ue;V&&!(0,y.isUndefinedOrNull)(V.context)?ue=[V.context,...ce]:ue=ce;const ge=await x.call(ie,ue);return X?ge:(0,n.revive)(ge)};throw new Error(`Property not found: ${String(ie)}`)}})}T.toService=F;function N(x){return x[0]==="o"&&x[1]==="n"&&f.isUpperAsciiLetter(x.charCodeAt(2))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function $(T){if(Array.isArray(T))return T;if(T&&typeof T=="object"&&typeof T.toString=="function"){let P=T.toString();if(P!=="[object Object]")return P}return T}function z(T){return Array.isArray(T)?T.map($):$(T)}function W(T,P,F,N,x,V,X){X=z(X);const Q=M[x],ie=Q[N%Q.length];let ne=[`%c[${T}]%c[${String(P).padStart(7," ")}]%c[len: ${String(F).padStart(5," ")}]%c${String(N).padStart(5," ")} - ${V}`,"color: darkgreen","color: grey","color: grey",`color: ${ie}`];/\($/.test(V)?(ne=ne.concat(X),ne.push(")")):ne.push(X),console.log.apply(console,ne)}e.logWithColors=W;class H{constructor(P,F){this._outgoingPrefix=P,this._incomingPrefix=F,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(P,F,N,x,V){this._totalOutgoing+=P,W(this._outgoingPrefix,this._totalOutgoing,P,F,N,x,V)}logIncoming(P,F,N,x,V){this._totalIncoming+=P,W(this._incomingPrefix,this._totalIncoming,P,F,N,x,V)}}e.IPCLogger=H}),define(Z[99],ee([0,1,3,37,25]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(S){this.port=S,this.onMessage=p.Event.fromDOMEventEmitter(this.port,"message",y=>O.VSBuffer.wrap(y.data)),S.start()}send(S){this.port.postMessage(S.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class U extends L.IPCClient{constructor(S,y){const n=new R(S);super(n,y);this.protocol=n}dispose(){this.protocol.disconnect()}}e.Client=U}),define(Z[100],ee([0,1,101,3,37,99]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class U extends O.IPCServer{static getOnDidClientConnect(){const S=L.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:createMessageChannel",(y,n)=>n);return L.Event.map(S,y=>{const{port1:n,port2:f}=new MessageChannel,C={protocol:new R.Protocol(n),onDidClientDisconnect:L.Event.fromDOMEventEmitter(n,"close")};return p.ipcRenderer.postMessage("vscode:createMessageChannelResult",y,[f]),C})}constructor(){super(U.getOnDidClientConnect())}}e.Server=U}),define(Z[102],ee([0,1,11,25]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function O(A,S){A.proxyAuthorization&&(A.headers=Object.assign(Object.assign({},A.headers||{}),{"Proxy-Authorization":A.proxyAuthorization}));const y=new XMLHttpRequest;return new Promise((n,f)=>{y.open(A.type||"GET",A.url||"",!0,A.user,A.password),R(y,A),y.responseType="arraybuffer",y.onerror=v=>f(new Error(y.statusText&&"XHR failed: "+y.statusText||"XHR failed")),y.onload=v=>{n({res:{statusCode:y.status,headers:U(y)},stream:(0,L.bufferToStream)(L.VSBuffer.wrap(new Uint8Array(y.response)))})},y.ontimeout=v=>f(new Error(`XHR timeout: ${A.timeout}ms`)),A.timeout&&(y.timeout=A.timeout),y.send(A.data),S.onCancellationRequested(()=>{y.abort(),f((0,p.canceled)())})})}e.request=O;function R(A,S){if(S.headers){e:for(let y in S.headers){switch(y){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}A.setRequestHeader(y,S.headers[y])}}}function U(A){const S=Object.create(null);for(const y of A.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(y){const n=y.indexOf(":");S[y.substr(0,n).trim().toLowerCase()]=y.substr(n+1).trim()}return S}}),define(Z[69],ee([0,1,2,3,8,15]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var U;(function(n){n[n.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(U=e.StorageHint||(e.StorageHint={}));var A;(function(n){n[n.None=0]="None",n[n.Initialized=1]="Initialized",n[n.Closed=2]="Closed"})(A||(A={}));class S extends p.Disposable{constructor(f,v=Object.create(null)){super();this.database=f,this.options=v,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=A.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(S.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(f=>this.onDidChangeItemsExternal(f)))}onDidChangeItemsExternal(f){var v,C;(v=f.changed)===null||v===void 0||v.forEach((d,w)=>this.accept(w,d)),(C=f.deleted)===null||C===void 0||C.forEach(d=>this.accept(d,void 0))}accept(f,v){if(this.state!==A.Closed){let C=!1;(0,R.isUndefinedOrNull)(v)?C=this.cache.delete(f):this.cache.get(f)!==v&&(this.cache.set(f,v),C=!0),C&&this._onDidChangeStorage.fire(f)}}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===A.None&&(this.state=A.Initialized,this.options.hint!==U.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(f,v){const C=this.cache.get(f);return(0,R.isUndefinedOrNull)(C)?v:C}getBoolean(f,v){const C=this.get(f);return(0,R.isUndefinedOrNull)(C)?v:C==="true"}getNumber(f,v){const C=this.get(f);return(0,R.isUndefinedOrNull)(C)?v:parseInt(C,10)}async set(f,v){if(this.state!==A.Closed){if((0,R.isUndefinedOrNull)(v))return this.delete(f);const C=String(v);if(this.cache.get(f)!==C)return this.cache.set(f,C),this.pendingInserts.set(f,C),this.pendingDeletes.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}}async delete(f){if(this.state!==A.Closed&&!!this.cache.delete(f))return this.pendingDeletes.has(f)||this.pendingDeletes.add(f),this.pendingInserts.delete(f),this._onDidChangeStorage.fire(f),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=A.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(f){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!!this.hasPending){const f={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(f).finally(()=>{var v;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(v=this.whenFlushedCallbacks.pop())===null||v===void 0||v()})}}async whenFlushed(){if(!!this.hasPending)return new Promise(f=>this.whenFlushedCallbacks.push(f))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=S,S.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(f){f.insert&&f.insert.forEach((v,C)=>this.items.set(C,v)),f.delete&&f.delete.forEach(v=>this.items.delete(v))}async close(){}}e.InMemoryStorageDatabase=y}),define(Z[103],ee([12,13]),function(G,e){return G.create("vs/base/common/date",e)}),define(Z[55],ee([0,1,103]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,O=L*60,R=O*24,U=R*7,A=R*30,S=R*365;function y(f,v){typeof f!="number"&&(f=f.getTime());const C=Math.round((new Date().getTime()-f)/1e3);if(C<-30)return(0,p.localize)(0,null,y(new Date().getTime()+C*1e3,!1));if(C<30)return(0,p.localize)(1,null);let d;return C<L?(d=C,v?d===1?(0,p.localize)(2,null,d):(0,p.localize)(3,null,d):d===1?(0,p.localize)(4,null,d):(0,p.localize)(5,null,d)):C<O?(d=Math.floor(C/L),v?d===1?(0,p.localize)(6,null,d):(0,p.localize)(7,null,d):d===1?(0,p.localize)(8,null,d):(0,p.localize)(9,null,d)):C<R?(d=Math.floor(C/O),v?d===1?(0,p.localize)(10,null,d):(0,p.localize)(11,null,d):d===1?(0,p.localize)(12,null,d):(0,p.localize)(13,null,d)):C<U?(d=Math.floor(C/R),v?d===1?(0,p.localize)(14,null,d):(0,p.localize)(15,null,d):d===1?(0,p.localize)(16,null,d):(0,p.localize)(17,null,d)):C<A?(d=Math.floor(C/U),v?d===1?(0,p.localize)(18,null,d):(0,p.localize)(19,null,d):d===1?(0,p.localize)(20,null,d):(0,p.localize)(21,null,d)):C<S?(d=Math.floor(C/A),v?d===1?(0,p.localize)(22,null,d):(0,p.localize)(23,null,d):d===1?(0,p.localize)(24,null,d):(0,p.localize)(25,null,d)):(d=Math.floor(C/S),v?d===1?(0,p.localize)(26,null,d):(0,p.localize)(27,null,d):d===1?(0,p.localize)(28,null,d):(0,p.localize)(29,null,d))}e.fromNow=y;function n(f){return f.getFullYear()+"-"+String(f.getMonth()+1).padStart(2,"0")+"-"+String(f.getDate()).padStart(2,"0")+"T"+String(f.getHours()).padStart(2,"0")+":"+String(f.getMinutes()).padStart(2,"0")+":"+String(f.getSeconds()).padStart(2,"0")+"."+(f.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=n}),define(Z[104],ee([12,13]),function(G,e){return G.create("vs/base/common/errorMessage",e)}),define(Z[44],ee([0,1,104,15,19]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function R(y,n){return n&&(y.stack||y.stacktrace)?p.localize(0,null,A(y),U(y.stack)||U(y.stacktrace)):A(y)}function U(y){return Array.isArray(y)?y.join(`
`):y}function A(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?p.localize(1,null,y.message):y.message||p.localize(2,null)}function S(y=null,n=!1){if(!y)return p.localize(3,null);if(Array.isArray(y)){const f=O.coalesce(y),v=S(f[0],n);return f.length>1?p.localize(4,null,v,f.length):v}if(L.isString(y))return y;if(y.detail){const f=y.detail;if(f.error)return R(f.error,n);if(f.exception)return R(f.exception,n)}return y.stack?R(y,n):y.message?y.message:p.localize(5,null)}e.toErrorMessage=S}),define(Z[105],ee([12,13]),function(G,e){return G.create("vs/base/node/processes",e)}),define(Z[106],ee([0,1,7,27,17,43,105,35,15,26,42,6,68,16]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function d(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function w(s,t){if(f.isWindows)try{const i={stdio:["pipe","pipe","ignore"]};t&&(i.cwd=t);const r=R.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],i);return new Promise(o=>{r.once("error",c=>{o({success:!1,error:c})}),r.once("exit",(c,l)=>{o(c===0?{success:!0}:{success:!1,code:c!==null?c:1})})})}catch(i){return Promise.resolve({success:!1,error:i,code:i.status?d(i.status):1})}else if(f.isLinux||f.isMacintosh)try{const i=C.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",G).fsPath;return new Promise(r=>{R.execFile(i,[s.pid.toString()],{encoding:"utf8",shell:!0},(o,c,l)=>{r(o?{success:!1,error:o}:{success:!0})})})}catch(i){return Promise.resolve({success:!1,error:i})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function I(s=A.env){return s.comspec||"cmd.exe"}e.getWindowsShell=I;class E{constructor(t,i,r,o){if(i!==void 0&&r!==void 0&&o!==void 0)this.cmd=t,this.args=i,this.shell=r,this.options=o;else{const c=t;this.cmd=c.command,this.shell=c.isShellCommand,this.args=c.args.slice(0),this.options=c.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const c=Object.create(null);Object.keys(A.env).forEach(l=>{c[l]=A.env[l]}),Object.keys(this.options.env).forEach(l=>{c[l]=this.options.env[l]}),this.options.env=c}}getSanitizedCommand(){let t=this.cmd.toLowerCase();const i=t.lastIndexOf(p.sep);return i!==-1&&(t=t.substring(i+1)),E.WellKnowCommands[t]?t:"other"}start(t){return f.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(A.cwd()))?Promise.reject(new Error(U.localize(0,null))):this.useExec().then(i=>{let r,o;const c=new Promise((l,u)=>{r=l,o=u});if(i){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=R.exec(l,this.options,(u,m,b)=>{this.childProcess=null;const h=u;h&&h.killed?o({killed:this.terminateRequested,stdout:m.toString(),stderr:b.toString()}):this.handleExec(r,t,u,m,b)})}else{let l=null;const u=m=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(m,r,t,o);const b={terminated:this.terminateRequested};S.isNumber(m)&&(b.cmdCode=m),r(b)};if(this.shell&&f.isWindows){const m=y.deepClone(this.options);m.windowsVerbatimArguments=!0,m.detached=!1;let b=!1,h=!1;const k=[];let _=this.ensureQuotes(this.cmd);k.push(_.value),b=_.quoted,this.args&&this.args.forEach(q=>{_=this.ensureQuotes(q),k.push(_.value),h=h&&_.quoted});const j=["/s","/c"];b?h?j.push('"'+k.join(" ")+'"'):k.length>1?j.push('"'+k[0]+'" '+k.slice(1).join(" ")):j.push('"'+k[0]+'"'):j.push(k.join(" ")),l=R.spawn(I(),j,m)}else this.cmd&&(l=R.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(S.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",m=>{this.childProcess=null,o({terminated:this.terminateRequested,error:m})}),l.pid&&(this.childProcess.on("close",u),this.handleSpawn(l,r,t,o,!0)))}return c})}handleClose(t,i,r,o){}ensureQuotes(t){return E.regexp.test(t)?{value:'"'+t+'"',quoted:!0}:{value:t,quoted:t.length>0&&t[0]==='"'&&t[t.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(t=>t.pid,t=>-1):new Promise(t=>{this.pidResolve=t})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,w(t,this.options.cwd).then(i=>(i.success&&(this.childProcess=null),i))),t=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(t=>{if(!this.shell||!f.isWindows)return t(!1);const i=R.spawn(I(),["/s","/c"]);i.on("error",r=>t(!0)),i.on("exit",r=>t(!1))})}}e.AbstractProcess=E,E.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},E.regexp=/^[^"].* .*[^"]/;class D extends E{constructor(t,i,r,o){super(t,i,r,o);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(t,i,r,o,c){[o,c].forEach((l,u)=>{const m=new v.LineDecoder;m.write(l).forEach(k=>{i({line:k,source:u===0?0:1})});const h=m.end();h&&i({line:h,source:u===0?0:1})}),t({terminated:this.terminateRequested,error:r})}handleSpawn(t,i,r,o,c){const l=new v.LineDecoder,u=new v.LineDecoder;t.stdout.on("data",m=>{l.write(m).forEach(h=>r({line:h,source:0}))}),t.stderr.on("data",m=>{u.write(m).forEach(h=>r({line:h,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=u}handleClose(t,i,r,o){const c=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;c&&r({line:c,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&r({line:l,source:1})}}e.LineProcess=D;function g(s){let t=[],i=!1;const r=function(o){if(i){t.push(o);return}(!s.send(o,l=>{if(l&&console.error(l),i=!1,t.length>0){const u=t.slice(0);t=[],u.forEach(m=>r(m))}})||f.isWindows)&&(i=!0)};return{send:r}}e.createQueuedSender=g;var a;(function(s){async function t(i,r,o){if(p.isAbsolute(i))return i;if(r===void 0&&(r=A.cwd()),p.dirname(i)!=="."||(o===void 0&&S.isString(A.env.PATH)&&(o=A.env.PATH.split(p.delimiter)),o===void 0||o.length===0))return p.join(r,i);async function l(u){return await O.exists(u)?!(await L.promises.stat(u)).isDirectory():!1}for(let u of o){let m;if(p.isAbsolute(u)?m=p.join(u,i):m=p.join(r,u,i),await l(m))return m;let b=m+".com";if(await l(b)||(b=m+".exe",await l(b)))return b}return p.join(r,i)}s.findExecutable=t})(a=e.win32||(e.win32={}))}),define(Z[49],ee([0,1,43,2,8,26,3,106,37,88,30,11,25,6]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends S.ChannelServer{constructor(E){super({send:D=>{try{process.send&&process.send(D.buffer.toString("base64"))}catch(g){}},onMessage:U.Event.fromNodeEventEmitter(process,"message",D=>v.VSBuffer.wrap(Buffer.from(D,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=d;class w{constructor(E,D){this.modulePath=E,this.options=D,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new U.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=D&&D.timeout?D.timeout:6e4;this.disposeDelayer=new O.Delayer(g),this.child=null,this._client=null}getChannel(E){const D=this;return{call(g,a,s){return D.requestPromise(E,g,a,s)},listen(g,a){return D.requestEvent(E,g,a)}}}requestPromise(E,D,g,a=n.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(f.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(E),t=(0,O.createCancelablePromise)(o=>s.call(D,g,o)),i=a.onCancellationRequested(()=>t.cancel()),r=(0,L.toDisposable)(()=>t.cancel());return this.activeRequests.add(r),t.finally(()=>{i.dispose(),this.activeRequests.delete(r),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(E,D,g){if(!this.disposeDelayer)return U.Event.None;this.disposeDelayer.cancel();let a;const s=new U.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(E).listen(D,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],D=Object.create(null);D.env=Object.assign(Object.assign({},(0,R.deepClone)(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(D.env=Object.assign(Object.assign({},D.env),this.options.env)),this.options&&this.options.freshExecArgv&&(D.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(D.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(D.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),D.execArgv===void 0&&(D.execArgv=process.execArgv.filter(c=>!/^--inspect(-brk)?=/.test(c))),C.isMacintosh&&D.env&&delete D.env.DYLD_LIBRARY_PATH,this.child=(0,p.fork)(this.modulePath,E,D);const g=new U.Emitter;U.Event.fromNodeEventEmitter(this.child,"message",c=>c)(c=>{if((0,y.isRemoteConsoleLog)(c)){(0,y.log)(c,`IPC Library: ${this.options.serverName}`);return}g.fire(v.VSBuffer.wrap(Buffer.from(c,"base64")))});const s=this.options.useQueue?(0,A.createQueuedSender)(this.child):this.child,t=c=>this.child&&this.child.connected&&s.send(c.buffer.toString("base64")),i=g.event,r={send:t,onMessage:i};this._client=new S.ChannelClient(r);const o=()=>this.disposeClient();process.once("exit",o),this.child.on("error",c=>console.warn('IPC "'+this.options.serverName+'" errored with '+c)),this.child.on("exit",(c,l)=>{process.removeListener("exit",o),this.activeRequests.forEach(u=>(0,L.dispose)(u)),this.activeRequests.clear(),c!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+c+" and signal "+l),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:c,signal:l})})}return this._client}getCachedChannel(E){let D=this.channels.get(E);return D||(D=this.client.getChannel(E),this.channels.set(E,D)),D}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=w}),define(Z[107],ee([12,13]),function(G,e){return G.create("vs/base/node/zip",e)}),define(Z[108],ee([12,13]),function(G,e){return G.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Z[109],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Z[110],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(Z[111],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(Z[112],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(Z[113],ee([12,13]),function(G,e){return G.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(Z[114],ee([12,13]),function(G,e){return G.create("vs/platform/extensions/common/extensionValidator",e)}),define(Z[115],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/fileService",e)}),define(Z[116],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/files",e)}),define(Z[117],ee([12,13]),function(G,e){return G.create("vs/platform/files/common/io",e)}),define(Z[118],ee([12,13]),function(G,e){return G.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Z[119],ee([12,13]),function(G,e){return G.create("vs/platform/request/common/request",e)}),define(Z[120],ee([12,13]),function(G,e){return G.create("vs/platform/telemetry/common/telemetryService",e)}),define(Z[121],ee([12,13]),function(G,e){return G.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(Z[122],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(Z[123],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(Z[124],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/settingsSync",e)}),define(Z[125],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(Z[126],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSync",e)}),define(Z[127],ee([12,13]),function(G,e){return G.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(Z[128],ee([0,1,7,14,64,55,16,5,35]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(d,w,I){this._args=d,this.paths=w,this.productService=I}get appRoot(){return(0,p.dirname)(U.FileAccess.asFileUri("",G).fsPath)}get userHome(){return A.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return A.URI.file((0,p.join)(this.userDataPath,"User"))}get tmpDir(){return A.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,p.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return A.URI.file((0,p.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(A.URI.file((0,p.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return A.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return A.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=S.env.VSCODE_PORTABLE;return d?A.URI.file((0,p.join)(d,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return A.URI.file((0,p.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,p.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,p.resolve)(d):(0,p.normalize)((0,p.join)(U.FileAccess.asFileUri("",G).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,p.resolve)(d):(0,p.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,p.resolve)(d);const w=S.env.VSCODE_EXTENSIONS;if(w)return w;const I=S.env.VSCODE_PORTABLE;return I?(0,p.join)(I,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(w=>/^[^:/?#]+?:\/\//.test(w)?A.URI.parse(w):A.URI.file((0,p.normalize)(w)))}get extensionDevelopmentKind(){var d;return(d=this.args.extensionDevelopmentKind)===null||d===void 0?void 0:d.map(w=>w==="ui"||w==="workspace"||w==="web"?w:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?A.URI.parse(d):A.URI.file((0,p.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return n(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(A.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return A.URI.file((0,p.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get args(){return this._args}}de([O.memoize],y.prototype,"appRoot",null),de([O.memoize],y.prototype,"userHome",null),de([O.memoize],y.prototype,"userDataPath",null),de([O.memoize],y.prototype,"appSettingsHome",null),de([O.memoize],y.prototype,"tmpDir",null),de([O.memoize],y.prototype,"userRoamingDataHome",null),de([O.memoize],y.prototype,"settingsResource",null),de([O.memoize],y.prototype,"userDataSyncHome",null),de([O.memoize],y.prototype,"userDataSyncLogResource",null),de([O.memoize],y.prototype,"sync",null),de([O.memoize],y.prototype,"machineSettingsResource",null),de([O.memoize],y.prototype,"globalStorageHome",null),de([O.memoize],y.prototype,"workspaceStorageHome",null),de([O.memoize],y.prototype,"keybindingsResource",null),de([O.memoize],y.prototype,"keyboardLayoutResource",null),de([O.memoize],y.prototype,"argvResource",null),de([O.memoize],y.prototype,"snippetsHome",null),de([O.memoize],y.prototype,"isExtensionDevelopment",null),de([O.memoize],y.prototype,"untitledWorkspacesHome",null),de([O.memoize],y.prototype,"installSourcePath",null),de([O.memoize],y.prototype,"builtinExtensionsPath",null),de([O.memoize],y.prototype,"extensionsPath",null),de([O.memoize],y.prototype,"extensionDevelopmentLocationURI",null),de([O.memoize],y.prototype,"extensionDevelopmentKind",null),de([O.memoize],y.prototype,"extensionTestsLocationURI",null),de([O.memoize],y.prototype,"debugExtensionHost",null),de([O.memoize],y.prototype,"serviceMachineIdResource",null),de([O.memoize],y.prototype,"telemetryLogResource",null),e.AbstractNativeEnvironmentService=y;function n(C,d){return v(C["inspect-extensions"],C["inspect-brk-extensions"],5870,d,C.debugId)}e.parseExtensionHostPort=n;function f(C,d){return v(C["inspect-search"],C["inspect-brk-search"],5876,d)}e.parseSearchPort=f;function v(C,d,w,I,E){const g=Number(d||C)||(I?null:w),a=g?Boolean(!!d):!1;return{port:g,break:a,debugId:E}}}),function(){"use strict";function G(e,p,L,O){function R(A){const S=U(A),y=[S];return e.isAbsolute(S)||y.unshift(O),e.resolve(...y)}function U(A){const S=process.env.VSCODE_PORTABLE;if(S)return e.join(S,"user-data");const y=A["user-data-dir"];if(y)return y;let n=process.env.VSCODE_APPDATA;if(!n)switch(process.platform){case"win32":if(n=process.env.APPDATA,!n){const f=process.env.USERPROFILE;if(typeof f!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");n=e.join(f,"AppData","Roaming")}break;case"darwin":n=e.join(p.homedir(),"Library","Application Support");break;case"linux":n=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(n,L)}return{getUserDataPath:R}}if(typeof define=="function")define(Z[129],ee([0,208,36,16,14,35]),function(e,p,L,O,R,U){const A=R.dirname(O.FileAccess.asFileUri("",e)),S=e.__$__nodeRequire(R.joinPath(A,"package.json").fsPath);return G(p,L,S.name,U.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=G(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[130],ee([0,1,36,129,128]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends O.AbstractNativeEnvironmentService{constructor(A,S){super(A,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,L.getUserDataPath)(A)},S)}}e.NativeEnvironmentService=R}),define(Z[131],ee([0,1,5]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const L=/^([^@:]+@)?([^:]+):/,O=/^([^@:]+@)?([^:]+):(.+)$/,R=/^([^@]+@)?([^:]+)(:\d+)?$/,U=/([^@:.]+\.[^@:.]+)(:\d+)?$/,A=/^\s*url\s*=\s*(.+\S)\s*$/mg,S=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function y(I){const E=I.match(U);return E?E[1]:null}function n(I){if(I.indexOf("://")===-1){const E=I.match(L);return E?y(E[2]):null}try{const E=p.URI.parse(I);if(E.authority)return y(E.authority)}catch(E){}return null}function f(I,E){const D=new Set;let g;for(;g=A.exec(I);){const s=n(g[1]);s&&D.add(s)}const a=new Set(E);return Array.from(D).map(s=>a.has(s)?s:s.replace(S,"a"))}e.getDomainsOfRemotes=f;function v(I){const E=I.match(R);return E?E[2]:null}function C(I,E,D){return I&&E?(D&&E.endsWith(".git")&&(E=E.substr(0,E.length-4)),E.indexOf("/")===0?`${I}${E}`:`${I}/${E}`):null}function d(I,E){if(I.indexOf("://")===-1){const D=I.match(O);if(D)return C(D[2],D[3],E)}try{const D=p.URI.parse(I);if(D.authority)return C(v(D.authority),D.path,E)}catch(D){}return null}function w(I,E=!1){const D=[];let g;for(;g=A.exec(I);){const a=d(g[1],E);a&&D.push(a)}return D}e.getRemotes=w}),define(Z[132],ee([0,1,3,5,91,26,2]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function A(d,w){return L.URI.revive(w?w.transformIncoming(d):d)}function S(d,w){return w?w.transformOutgoingURI(d):d}function y(d,w){w=w||O.DefaultURITransformer;const I=d.manifest,E=(0,O.transformAndReviveIncomingURIs)(Object.assign(Object.assign({},d),{manifest:void 0}),w);return Object.assign(Object.assign({},E),{manifest:I})}function n(d,w){return w?(0,R.cloneAndChange)(d,I=>I instanceof L.URI?w.transformOutgoingURI(I):void 0):d}class f{constructor(w,I){this.service=w,this.getUriTransformer=I,this.onInstallExtension=p.Event.buffer(w.onInstallExtension,!0),this.onDidInstallExtension=p.Event.buffer(w.onDidInstallExtension,!0),this.onUninstallExtension=p.Event.buffer(w.onUninstallExtension,!0),this.onDidUninstallExtension=p.Event.buffer(w.onDidUninstallExtension,!0)}listen(w,I){const E=this.getUriTransformer(w);switch(I){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return p.Event.map(this.onDidInstallExtension,D=>Object.assign(Object.assign({},D),{local:D.local?n(D.local,E):D.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(w,I,E){const D=this.getUriTransformer(w);switch(I){case"zip":return this.service.zip(y(E[0],D)).then(g=>S(g,D));case"unzip":return this.service.unzip(A(E[0],D));case"install":return this.service.install(A(E[0],D));case"getManifest":return this.service.getManifest(A(E[0],D));case"canInstall":return this.service.canInstall(E[0]);case"installFromGallery":return this.service.installFromGallery(E[0],E[1]);case"uninstall":return this.service.uninstall(y(E[0],D),E[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(y(E[0],D));case"getInstalled":return this.service.getInstalled(E[0]).then(g=>g.map(a=>n(a,D)));case"updateMetadata":return this.service.updateMetadata(y(E[0],D),E[1]).then(g=>n(g,D));case"updateExtensionScope":return this.service.updateExtensionScope(y(E[0],D),E[1]).then(g=>n(g,D));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=f;class v extends U.Disposable{constructor(w){super();this.channel=w,this._onInstallExtension=this._register(new p.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new p.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new p.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new p.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(I=>this._onInstallExtension.fire(I))),this._register(this.channel.listen("onDidInstallExtension")(I=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},I),{local:I.local?y(I.local,null):I.local})))),this._register(this.channel.listen("onUninstallExtension")(I=>this._onUninstallExtension.fire(I))),this._register(this.channel.listen("onDidUninstallExtension")(I=>this._onDidUninstallExtension.fire(I)))}zip(w){return Promise.resolve(this.channel.call("zip",[w]).then(I=>L.URI.revive(I)))}unzip(w){return Promise.resolve(this.channel.call("unzip",[w]))}install(w){return Promise.resolve(this.channel.call("install",[w])).then(I=>y(I,null))}getManifest(w){return Promise.resolve(this.channel.call("getManifest",[w]))}async canInstall(w){return!0}installFromGallery(w,I){return Promise.resolve(this.channel.call("installFromGallery",[w,I])).then(E=>y(E,null))}uninstall(w,I){return Promise.resolve(this.channel.call("uninstall",[w,I]))}reinstallFromGallery(w){return Promise.resolve(this.channel.call("reinstallFromGallery",[w]))}getInstalled(w=null){return Promise.resolve(this.channel.call("getInstalled",[w])).then(I=>I.map(E=>y(E,null)))}updateMetadata(w,I){return Promise.resolve(this.channel.call("updateMetadata",[w,I])).then(E=>y(E,null))}updateExtensionScope(w,I){return Promise.resolve(this.channel.call("updateExtensionScope",[w,I])).then(E=>y(E,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=v;class C{constructor(w){this.service=w}listen(w,I){throw new Error("Invalid listen")}call(w,I,E){switch(I){case"getConfigBasedTips":return this.service.getConfigBasedTips(L.URI.revive(E[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=C}),define(Z[133],ee([0,1,26]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const L=/^%([\w\d.-]+)%$/i;function O(R,U){const A=S=>{if(typeof S=="string"){const y=L.exec(S);if(!!y)return U[y[1]]||S}};return(0,p.cloneAndChange)(R,A)}e.localizeManifest=O}),define(Z[134],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class p{constructor(R){this.channel=R}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(R,U,A,S){return this.channel.call("promptImportantExtensionsInstallNotification",[R,U,A,S])}promptWorkspaceRecommendations(R){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=p;class L{constructor(R){this.service=R}listen(R,U){throw new Error(`Event not found: ${U}`)}call(R,U,A){switch(U){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(A[0],A[1],A[2],A[3])}throw new Error(`Call not found: ${U}`)}}e.ExtensionRecommendationNotificationServiceChannel=L}),define(Z[70],ee([0,1,114]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,O=/^-(\d{4})(\d{2})(\d{2})$/;function R(v){return v=v.trim(),v==="*"||L.test(v)}e.isValidVersionStr=R;function U(v){if(!R(v))return null;if(v=v.trim(),v==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let C=v.match(L);return C?{hasCaret:C[1]==="^",hasGreaterEquals:C[1]===">=",majorBase:C[2]==="x"?0:parseInt(C[2],10),majorMustEqual:C[2]!=="x",minorBase:C[4]==="x"?0:parseInt(C[4],10),minorMustEqual:C[4]!=="x",patchBase:C[6]==="x"?0:parseInt(C[6],10),patchMustEqual:C[6]!=="x",preRelease:C[8]||null}:null}e.parseVersion=U;function A(v){if(!v)return null;let C=v.majorBase,d=v.majorMustEqual,w=v.minorBase,I=v.minorMustEqual,E=v.patchBase,D=v.patchMustEqual;v.hasCaret&&(C===0||(I=!1),D=!1);let g=0;if(v.preRelease){const a=O.exec(v.preRelease);if(a){const[,s,t,i]=a;g=Date.UTC(Number(s),Number(t)-1,Number(i))}}return{majorBase:C,majorMustEqual:d,minorBase:w,minorMustEqual:I,patchBase:E,patchMustEqual:D,isMinimum:v.hasGreaterEquals,notBefore:g}}e.normalizeVersion=A;function S(v,C,d){let w;typeof v=="string"?w=A(U(v)):w=v;let I;C instanceof Date?I=C.getTime():typeof C=="string"&&(I=new Date(C).getTime());let E;if(typeof d=="string"?E=A(U(d)):E=d,!w||!E)return!1;let D=w.majorBase,g=w.minorBase,a=w.patchBase,s=E.majorBase,t=E.minorBase,i=E.patchBase,r=E.notBefore,o=E.majorMustEqual,c=E.minorMustEqual,l=E.patchMustEqual;return E.isMinimum?D>s?!0:D<s?!1:g>t?!0:g<t||I&&I<r?!1:a>=i:(D===1&&s===0&&(!o||!c||!l)&&(s=1,t=0,i=0,o=!0,c=!1,l=!1),D<s?!1:D>s?!o:g<t?!1:g>t?!c:a<i?!1:a>i?!l:!(I&&I<r))}e.isValidVersion=S;function y(v,C,d,w){return d.isBuiltin||typeof d.main=="undefined"?!0:f(v,C,d.engines.vscode,w)}e.isValidExtensionVersion=y;function n(v,C,d){return v==="*"||f(C,d,v)}e.isEngineValid=n;function f(v,C,d,w=[]){let I=A(U(d));if(!I)return w.push(p.localize(0,null,d)),!1;if(I.majorBase===0){if(!I.majorMustEqual||!I.minorMustEqual)return w.push(p.localize(1,null,d)),!1}else if(!I.majorMustEqual)return w.push(p.localize(2,null,d)),!1;return S(v,C,I)?!0:(w.push(p.localize(3,null,v,d)),!1)}}),define(Z[135],ee([0,1,37,49,2,16]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends O.Disposable{constructor(S,y,n,f){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=f,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(S){this.verboseLogging=S,!this.isDisposed&&this.service&&this.service.setVerboseLogging(S)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${S}`})}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[136],ee([0,1,37,49,2,16]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class U extends O.Disposable{constructor(S,y,n,f,v={}){super();this.folders=S,this.onDidFilesChange=y,this.onLogMessage=n,this.verboseLogging=f,this.watcherOptions=v,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const S=this._register(new L.Client(R.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(S.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=U.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=p.ProxyChannel.toService((0,p.getNextTickChannel)(S.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(S){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${S}`})}setVerboseLogging(S){this.verboseLogging=S,this.service&&this.service.setVerboseLogging(S)}setFolders(S){this.folders=S,this.service&&this.service.setRoots(S)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=U,U.MAX_RESTARTS=5}),define(Z[137],ee([0,1,43,68,90,16]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class U{constructor(S,y,n,f,v){this.watchedFolder=S,this.eventCallback=n,this.logCallback=f,this.verboseLogging=v,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(C=>O.parse(C)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${S}`),this.startWatcher()}startWatcher(){const S=[this.watchedFolder];this.verboseLogging&&S.push("-verbose"),this.handle=p.spawn(R.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",G).fsPath,S);const y=new L.LineDecoder;this.handle.stdout.on("data",n=>{const f=[];y.write(n).forEach(v=>{const C=v.split("|");if(C.length===2){const d=Number(C[0]),w=C[1];if(d>=0&&d<3){if(this.ignored&&this.ignored.some(I=>I(w))){this.verboseLogging&&this.log(w);return}f.push({type:U.changeTypeMap[d],path:w})}else this.log(C[1])}}),f.length>0&&this.eventCallback(f)}),this.handle.on("error",n=>this.onError(n)),this.handle.stderr.on("data",n=>this.onError(n)),this.handle.on("exit",(n,f)=>this.onExit(n,f))}onError(S){this.error("process error: "+S.toString())}onExit(S,y){this.handle&&(this.error(`terminated unexpectedly (code: ${S}, signal: ${y})`),this.restartCounter<=U.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(S){this.logCallback({type:"error",message:`[File Watcher (C#)] ${S}`})}log(S){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${S}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=U,U.MAX_RESTARTS=5,U.changeTypeMap=[0,1,2]}),define(Z[138],ee([0,1,137,7,22]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class R{constructor(A,S,y,n){this.onDidFilesChange=S,this.onLogMessage=y,this.verboseLogging=n,this.service=void 0,this.folder=A[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(L.posix.sep)&&(this.folder.path=(0,O.rtrim)(this.folder.path,L.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new p.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,A=>this.onFileEvents(A),A=>this.onLogMessage(A),this.verboseLogging)}setVerboseLogging(A){this.verboseLogging=A,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(A){this.isDisposed||A.length>0&&this.onDidFilesChange(A)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=R}),define(Z[50],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class p{constructor(R,U=[],A=!1){this.ctor=R,this.staticArguments=U,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=p;const L=(O,...R)=>new p(O,R);e.createSyncDescriptor=L}),define(Z[139],ee([0,1,50]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const L=[];function O(U,A,S){A instanceof p.SyncDescriptor||(A=new p.SyncDescriptor(A,[],S)),L.push([U,A])}e.registerSingleton=O;function R(){return L}e.getSingletonServiceDescriptors=R}),define(Z[140],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=p;class L{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(let U of this._nodes.values())U.outgoing.size===0&&R.push(U);return R}insertEdge(R,U){const A=this.lookupOrInsertNode(R),S=this.lookupOrInsertNode(U);A.outgoing.set(this._hashFn(U),S),S.incoming.set(this._hashFn(R),A)}removeNode(R){const U=this._hashFn(R);this._nodes.delete(U);for(let A of this._nodes.values())A.outgoing.delete(U),A.incoming.delete(U)}lookupOrInsertNode(R){const U=this._hashFn(R);let A=this._nodes.get(U);return A||(A=new p(R),this._nodes.set(U,A)),A}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){let R=[];for(let[U,A]of this._nodes)R.push(`${U}, (incoming)[${[...A.incoming.keys()].join(", ")}], (outgoing)[${[...A.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(let[R,U]of this._nodes){const A=new Set([R]),S=this._findCycle(U,A);if(S)return S}}_findCycle(R,U){for(let[A,S]of R.outgoing){if(U.has(A))return[...U,A].join(" -> ");U.add(A);const y=this._findCycle(S,U);if(y)return y;U.delete(A)}}}e.Graph=L}),define(Z[4],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function S(y){return y[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=S})(p=e._util||(e._util={})),e.IInstantiationService=O("instantiationService");function L(A,S,y,n){S[p.DI_TARGET]===S?S[p.DI_DEPENDENCIES].push({id:A,index:y,optional:n}):(S[p.DI_DEPENDENCIES]=[{id:A,index:y,optional:n}],S[p.DI_TARGET]=S)}function O(A){if(p.serviceIds.has(A))return p.serviceIds.get(A);const S=function(y,n,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(S,y,f,!1)};return S.toString=()=>A,p.serviceIds.set(A,S),S}e.createDecorator=O;function R(A){return A}e.refineServiceDecorator=R;function U(A){return function(S,y,n){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(A,S,n,!0)}}e.optional=U}),define(Z[141],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,p.createDecorator)("checksumService")}),define(Z[142],ee([0,1,22,4,6]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let R=O.userAgent||"";const U=new Map;U.set("false",!1),U.set("true",!0),U.set("isMac",O.isMacintosh),U.set("isLinux",O.isLinux),U.set("isWindows",O.isWindows),U.set("isWeb",O.isWeb),U.set("isMacNative",O.isMacintosh&&!O.isWeb),U.set("isEdge",R.indexOf("Edg/")>=0),U.set("isFirefox",R.indexOf("Firefox")>=0),U.set("isChrome",R.indexOf("Chrome")>=0),U.set("isSafari",R.indexOf("Safari")>=0);const A=Object.prototype.hasOwnProperty;var S;(function(b){b[b.False=0]="False",b[b.True=1]="True",b[b.Defined=2]="Defined",b[b.Not=3]="Not",b[b.Equals=4]="Equals",b[b.NotEquals=5]="NotEquals",b[b.And=6]="And",b[b.Regex=7]="Regex",b[b.NotRegex=8]="NotRegex",b[b.Or=9]="Or",b[b.In=10]="In",b[b.NotIn=11]="NotIn",b[b.Greater=12]="Greater",b[b.GreaterEquals=13]="GreaterEquals",b[b.Smaller=14]="Smaller",b[b.SmallerEquals=15]="SmallerEquals"})(S=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return f.INSTANCE}static true(){return v.INSTANCE}static has(h){return C.create(h)}static equals(h,k){return d.create(h,k)}static notEquals(h,k){return E.create(h,k)}static regex(h,k){return i.create(h,k)}static in(h,k){return w.create(h,k)}static not(h){return D.create(h)}static and(...h){return o.create(h)}static or(...h){return c.create(h)}static greater(h,k){return g.create(h,k)}static less(h,k){return s.create(h,k)}static deserialize(h,k=!1){if(!!h)return this._deserializeOrExpression(h,k)}static _deserializeOrExpression(h,k){let _=h.split("||");return c.create(_.map(j=>this._deserializeAndExpression(j,k)))}static _deserializeAndExpression(h,k){let _=h.split("&&");return o.create(_.map(j=>this._deserializeOne(j,k)))}static _deserializeOne(h,k){if(h=h.trim(),h.indexOf("!=")>=0){let _=h.split("!=");return E.create(_[0].trim(),this._deserializeValue(_[1],k))}if(h.indexOf("==")>=0){let _=h.split("==");return d.create(_[0].trim(),this._deserializeValue(_[1],k))}if(h.indexOf("=~")>=0){let _=h.split("=~");return i.create(_[0].trim(),this._deserializeRegexValue(_[1],k))}if(h.indexOf(" in ")>=0){let _=h.split(" in ");return w.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(h)){const _=h.split(">=");return a.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(h)){const _=h.split(">");return g.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(h)){const _=h.split("<=");return t.create(_[0].trim(),_[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(h)){const _=h.split("<");return s.create(_[0].trim(),_[1].trim())}return/^\!\s*/.test(h)?D.create(h.substr(1).trim()):C.create(h)}static _deserializeValue(h,k){if(h=h.trim(),h==="true")return!0;if(h==="false")return!1;let _=/^'([^']*)'$/.exec(h);return _?_[1].trim():h}static _deserializeRegexValue(h,k){if((0,p.isFalsyOrWhitespace)(h)){if(k)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let _=h.indexOf("/"),j=h.lastIndexOf("/");if(_===j||_<0){if(k)throw new Error(`bad regexp-value '${h}', missing /-enclosure`);return console.warn(`bad regexp-value '${h}', missing /-enclosure`),null}let q=h.slice(_+1,j),K=h[j+1]==="i"?"i":"";try{return new RegExp(q,K)}catch(M){if(k)throw new Error(`bad regexp-value '${h}', parse error: ${M}`);return console.warn(`bad regexp-value '${h}', parse error: ${M}`),null}}}e.ContextKeyExpr=y;function n(b,h){return b.cmp(h)}class f{constructor(){this.type=0}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!1}serialize(){return"false"}keys(){return[]}map(h){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=f,f.INSTANCE=new f;class v{constructor(){this.type=1}cmp(h){return this.type-h.type}equals(h){return h.type===this.type}evaluate(h){return!0}serialize(){return"true"}keys(){return[]}map(h){return this}negate(){return f.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class C{constructor(h){this.key=h,this.type=2}static create(h){const k=U.get(h);return typeof k=="boolean"?k?v.INSTANCE:f.INSTANCE:new C(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!!h.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(h){return h.mapDefined(this.key)}negate(){return D.create(this.key)}}e.ContextKeyDefinedExpr=C;class d{constructor(h,k){this.key=h,this.value=k,this.type=4}static create(h,k){if(typeof k=="boolean")return k?C.create(h):D.create(h);const _=U.get(h);return typeof _=="boolean"?k===(_?"true":"false")?v.INSTANCE:f.INSTANCE:new d(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(h){return h.mapEquals(this.key,this.value)}negate(){return E.create(this.key,this.value)}}e.ContextKeyEqualsExpr=d;class w{constructor(h,k){this.key=h,this.valueKey=k,this.type=10}static create(h,k){return new w(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.valueKey,h.key,h.valueKey)}equals(h){return h.type===this.type?this.key===h.key&&this.valueKey===h.valueKey:!1}evaluate(h){const k=h.getValue(this.valueKey),_=h.getValue(this.key);return Array.isArray(k)?k.indexOf(_)>=0:typeof _=="string"&&typeof k=="object"&&k!==null?A.call(k,_):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(h){return h.mapIn(this.key,this.valueKey)}negate(){return I.create(this)}}e.ContextKeyInExpr=w;class I{constructor(h){this._actual=h,this.type=11}static create(h){return new I(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new I(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotInExpr=I;class E{constructor(h,k){this.key=h,this.value=k,this.type=5}static create(h,k){if(typeof k=="boolean")return k?D.create(h):C.create(h);const _=U.get(h);return typeof _=="boolean"?k===(_?"true":"false")?f.INSTANCE:v.INSTANCE:new E(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return h.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(h){return h.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=E;class D{constructor(h){this.key=h,this.type=3}static create(h){const k=U.get(h);return typeof k=="boolean"?k?f.INSTANCE:v.INSTANCE:new D(h)}cmp(h){return h.type!==this.type?this.type-h.type:u(this.key,h.key)}equals(h){return h.type===this.type?this.key===h.key:!1}evaluate(h){return!h.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(h){return h.mapNot(this.key)}negate(){return C.create(this.key)}}e.ContextKeyNotExpr=D;class g{constructor(h,k){this.key=h,this.value=k,this.type=12}static create(h,k){return new g(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=g;class a{constructor(h,k){this.key=h,this.value=k,this.type=13}static create(h,k){return new a(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(h){return h.mapGreaterEquals(this.key,this.value)}negate(){return s.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=a;class s{constructor(h,k){this.key=h,this.value=k,this.type=14}static create(h,k){return new s(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmaller(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeySmallerExpr=s;class t{constructor(h,k){this.key=h,this.value=k,this.type=15}static create(h,k){return new t(h,k)}cmp(h){return h.type!==this.type?this.type-h.type:m(this.key,this.value,h.key,h.value)}equals(h){return h.type===this.type?this.key===h.key&&this.value===h.value:!1}evaluate(h){return parseFloat(h.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(h){return h.mapSmallerEquals(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(h,k){this.key=h,this.regexp=k,this.type=7}static create(h,k){return new i(h,k)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.key<h.key)return-1;if(this.key>h.key)return 1;const k=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return k<_?-1:k>_?1:0}equals(h){if(h.type===this.type){const k=this.regexp?this.regexp.source:"",_=h.regexp?h.regexp.source:"";return this.key===h.key&&k===_}return!1}evaluate(h){let k=h.getValue(this.key);return this.regexp?this.regexp.test(k):!1}serialize(){const h=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${h}`}keys(){return[this.key]}map(h){return h.mapRegex(this.key,this.regexp)}negate(){return r.create(this)}}e.ContextKeyRegexExpr=i;class r{constructor(h){this._actual=h,this.type=8}static create(h){return new r(h)}cmp(h){return h.type!==this.type?this.type-h.type:this._actual.cmp(h._actual)}equals(h){return h.type===this.type?this._actual.equals(h._actual):!1}evaluate(h){return!this._actual.evaluate(h)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(h){return new r(this._actual.map(h))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=r;class o{constructor(h){this.expr=h,this.type=6}static create(h){return o._normalizeArr(h)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let k=0,_=this.expr.length;k<_;k++){const j=n(this.expr[k],h.expr[k]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let k=0,_=this.expr.length;k<_;k++)if(!this.expr[k].equals(h.expr[k]))return!1;return!0}return!1}evaluate(h){for(let k=0,_=this.expr.length;k<_;k++)if(!this.expr[k].evaluate(h))return!1;return!0}static _normalizeArr(h){const k=[];let _=!1;for(const j of h)if(!!j){if(j.type===1){_=!0;continue}if(j.type===0)return f.INSTANCE;if(j.type===6){k.push(...j.expr);continue}k.push(j)}if(k.length===0&&_)return v.INSTANCE;if(k.length!==0){if(k.length===1)return k[0];for(k.sort(n);k.length>1;){const j=k[k.length-1];if(j.type!==9)break;k.pop();const q=k.pop(),K=c.create(j.expr.map(M=>o.create([M,q])));K&&(k.push(K),k.sort(n))}return k.length===1?k[0]:new o(k)}}serialize(){return this.expr.map(h=>h.serialize()).join(" && ")}keys(){const h=[];for(let k of this.expr)h.push(...k.keys());return h}map(h){return new o(this.expr.map(k=>k.map(h)))}negate(){let h=[];for(let k of this.expr)h.push(k.negate());return c.create(h)}}e.ContextKeyAndExpr=o;class c{constructor(h){this.expr=h,this.type=9}static create(h){const k=c._normalizeArr(h);if(k.length!==0)return k.length===1?k[0]:new c(k)}cmp(h){if(h.type!==this.type)return this.type-h.type;if(this.expr.length<h.expr.length)return-1;if(this.expr.length>h.expr.length)return 1;for(let k=0,_=this.expr.length;k<_;k++){const j=n(this.expr[k],h.expr[k]);if(j!==0)return j}return 0}equals(h){if(h.type===this.type){if(this.expr.length!==h.expr.length)return!1;for(let k=0,_=this.expr.length;k<_;k++)if(!this.expr[k].equals(h.expr[k]))return!1;return!0}return!1}evaluate(h){for(let k=0,_=this.expr.length;k<_;k++)if(this.expr[k].evaluate(h))return!0;return!1}static _normalizeArr(h){let k=[],_=!1;if(h){for(let j=0,q=h.length;j<q;j++){const K=h[j];if(!!K){if(K.type===0){_=!0;continue}if(K.type===1)return[v.INSTANCE];if(K.type===9){k=k.concat(K.expr);continue}k.push(K)}}if(k.length===0&&_)return[f.INSTANCE];k.sort(n)}return k}serialize(){return this.expr.map(h=>h.serialize()).join(" || ")}keys(){const h=[];for(let k of this.expr)h.push(...k.keys());return h}map(h){return new c(this.expr.map(k=>k.map(h)))}negate(){let h=[];for(let _ of this.expr)h.push(_.negate());const k=_=>_.type===9?_.expr:[_];for(;h.length>1;){const _=h.shift(),j=h.shift(),q=[];for(const K of k(_))for(const M of k(j))q.push(y.and(K,M));h.unshift(y.or(...q))}return h[0]}}e.ContextKeyOrExpr=c;class l extends C{constructor(h,k,_){super(h);this._defaultValue=k,typeof _=="object"?l._info.push(Object.assign(Object.assign({},_),{key:h})):_!==!0&&l._info.push({key:h,description:_,type:k!=null?typeof k:void 0})}static all(){return l._info.values()}bindTo(h){return h.createKey(this.key,this._defaultValue)}getValue(h){return h.getContextKeyValue(this.key)}toNegated(){return y.not(this.key)}isEqualTo(h){return y.equals(this.key,h)}notEqualsTo(h){return y.notEquals(this.key,h)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function u(b,h){return b<h?-1:b>h?1:0}function m(b,h,k,_){return b<k?-1:b>k?1:h<_?-1:h>_?1:0}}),define(Z[71],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=L}),define(Z[72],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,p.createDecorator)("downloadService")}),define(Z[9],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)});var Y=this&&this.__param||function(G,e){return function(p,L){e(p,L,G)}};define(Z[143],ee([0,1,9,7,17,11,2,8]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let S=class extends U.Disposable{constructor(n){super();this.environmentService=n,this.cleanUpOldLogsSoon()}cleanUpOldLogsSoon(){let n=setTimeout(()=>{n=void 0;const f=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath);(0,O.readdir)(v).then(C=>{const w=C.filter(E=>/^\d{8}T\d{6}$/.test(E)).sort().filter((E,D)=>E!==f),I=w.slice(0,Math.max(0,w.length-9));return A.Promises.settled(I.map(E=>(0,O.rimraf)((0,L.join)(v,E))))}).then(null,R.onUnexpectedError)},10*1e3);this._register((0,U.toDisposable)(()=>{n&&(clearTimeout(n),n=void 0)}))}};S=de([Y(0,p.IEnvironmentService)],S),e.LogsDataCleaner=S}),define(Z[144],ee([0,1,27,9,7,17,11,2]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let S=class ht extends A.Disposable{constructor(n,f){super();this.backupWorkspacesPath=n,this.environmentService=f,this.cleanUpStorageSoon()}cleanUpStorageSoon(){let n=setTimeout(()=>{n=void 0,(async()=>{try{const f=await p.promises.readFile(this.backupWorkspacesPath,"utf8"),C=JSON.parse(f).emptyWorkspaceInfos.map(I=>I.backupFolder),d=await(0,R.readdir)(this.environmentService.workspaceStorageHome.fsPath),w=[];d.forEach(I=>{I.length!==ht.NON_EMPTY_WORKSPACE_ID_LENGTH&&C.indexOf(I)===-1&&w.push((0,R.rimraf)((0,O.join)(this.environmentService.workspaceStorageHome.fsPath,I)))}),await Promise.all(w)}catch(f){(0,U.onUnexpectedError)(f)}})()},30*1e3);this._register((0,A.toDisposable)(()=>{n&&(clearTimeout(n),n=void 0)}))}};S.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,S=de([Y(1,L.INativeEnvironmentService)],S),e.StorageDataCleaner=S}),define(Z[29],ee([0,1,109,4,16]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function R(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=R;var U;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=5]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(U=e.SortBy||(e.SortBy={}));var A;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(A=e.SortOrder||(e.SortOrder={}));var S;(function(f){f.Uninstall="uninstall"})(S=e.StatisticType||(e.StatisticType={}));var y;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class n extends Error{constructor(v,C){super(v);this.code=C}}e.ExtensionManagementError=n,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",G).toString(!0),e.ExtensionsLabel=(0,p.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,p.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,L.createDecorator)("IExtensionManagementCLIService")}),define(Z[145],ee([0,1,2,29]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DeprecatedExtensionsCleaner=void 0;let O=class extends p.Disposable{constructor(U){super();this.extensionManagementService=U,this._register(U),this.cleanUpDeprecatedExtensions()}cleanUpDeprecatedExtensions(){this.extensionManagementService.removeDeprecatedExtensions()}};O=de([Y(0,L.IExtensionManagementService)],O),e.DeprecatedExtensionsCleaner=O}),define(Z[73],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var L;(function(U){U[U.FILE=1]="FILE",U[U.WORKSPACE=2]="WORKSPACE",U[U.EXE=3]="EXE"})(L=e.RecommendationSource||(e.RecommendationSource={}));function O(U){switch(U){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=O;var R;(function(U){U.Ignored="ignored",U.Cancelled="cancelled",U.TooMany="toomany",U.IncompatibleWindow="incompatibleWindow",U.Accepted="reacted"})(R=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,p.createDecorator)("IExtensionRecommendationNotificationService")}),define(Z[74],ee([0,1,22,4]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function O(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class U{constructor(n){this.value=n,this._lower=n.toLowerCase()}static equals(n,f){if(typeof n=="undefined"||n===null)return typeof f=="undefined"||f===null;if(typeof f=="undefined"||f===null)return!1;if(typeof n=="string"||typeof f=="string"){let v=typeof n=="string"?n:n.value,C=typeof f=="string"?f:f.value;return p.equalsIgnoreCase(v,C)}return n._lower===f._lower}static toKey(n){return typeof n=="string"?n.toLowerCase():n._lower}}e.ExtensionIdentifier=U;function A(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}e.isLanguagePackExtension=A;function S(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=S,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[34],ee([0,1,22,74]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function O(C,d){return C.uuid&&d.uuid?C.uuid===d.uuid:C.id===d.id?!0:(0,p.compareIgnoreCase)(C.id,d.id)===0}e.areSameExtensions=O;class R{constructor(d,w){this.version=w,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof R?O(this,d)&&this.version===d.version:!1}}e.ExtensionIdentifierWithVersion=R;function U(C,d){return`${C}.${d}`}e.getExtensionId=U;function A(C){return C.toLocaleLowerCase()}e.adoptToGalleryExtensionId=A;function S(C,d){return A(U(C,d))}e.getGalleryExtensionId=S;function y(C,d){const w=[],I=E=>{for(const D of w)if(D.some(g=>O(d(g),d(E))))return D;return null};for(const E of C){const D=I(E);D?D.push(E):w.push([E])}return w}e.groupByExtension=y;function n(C){return{id:C.identifier.id,name:C.manifest.name,galleryId:null,publisherId:C.publisherId,publisherName:C.manifest.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:C.manifest.extensionDependencies&&C.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=n;function f(C){return Object.assign({id:C.identifier.id,name:C.name,galleryId:C.identifier.uuid,publisherId:C.publisherId,publisherName:C.publisher,publisherDisplayName:C.publisherDisplayName,dependencies:!!(C.properties.dependencies&&C.properties.dependencies.length>0)},C.telemetryData)}e.getGalleryExtensionTelemetryData=f,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function v(C){const d=new Set;for(const w of C)w.malicious&&d.add(w.id.id);return d}e.getMaliciousExtensionsSet=v}),define(Z[146],ee([0,1,2,7,74,17]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class U extends p.Disposable{constructor(S,y){super();this.environmentService=S,this.extensionsManifestCache=(0,L.join)(this.environmentService.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this._register(y.onDidInstallExtension(n=>this.onDidInstallExtension(n))),this._register(y.onDidUninstallExtension(n=>this.onDidUnInstallExtension(n)))}onDidInstallExtension(S){S.error||this.invalidate()}onDidUnInstallExtension(S){S.error||this.invalidate()}invalidate(){R.rimraf(this.extensionsManifestCache,R.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=U}),define(Z[10],ee([0,1,116,7,5,4,22,15,39]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,R.createDecorator)("fileService");function y(M){return M.create===!0}e.isFileOpenForWriteOptions=y;var n;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(n=e.FileType||(e.FileType={}));var f;(function(M){M[M.Readonly=1]="Readonly"})(f=e.FilePermission||(e.FilePermission={}));var v;(function(M){M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function C(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=C;function d(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=d;function w(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function I(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=I;var E;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(E=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class D extends Error{constructor($,z){super($);this.code=z}}e.FileSystemProviderError=D;function g(M,$){const z=new D(M.toString(),$);return s(z,$),z}e.createFileSystemProviderError=g;function a(M){return M||g((0,p.localize)(0,null),E.Unknown)}e.ensureFileSystemProviderError=a;function s(M,$){return M.name=$?`${$} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=s;function t(M){if(!M)return E.Unknown;if(M instanceof D)return M.code;const $=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!$)return E.Unknown;switch($[1]){case E.FileExists:return E.FileExists;case E.FileIsADirectory:return E.FileIsADirectory;case E.FileNotADirectory:return E.FileNotADirectory;case E.FileNotFound:return E.FileNotFound;case E.FileExceedsMemoryLimit:return E.FileExceedsMemoryLimit;case E.FileTooLarge:return E.FileTooLarge;case E.FileWriteLocked:return E.FileWriteLocked;case E.NoPermissions:return E.NoPermissions;case E.Unavailable:return E.Unavailable}return E.Unknown}e.toFileSystemProviderErrorCode=t;function i(M){if(M instanceof m)return M.fileOperationResult;switch(t(M)){case E.FileNotFound:return 1;case E.FileIsADirectory:return 0;case E.FileNotADirectory:return 10;case E.FileWriteLocked:return 5;case E.NoPermissions:return 6;case E.FileExists:return 4;case E.FileExceedsMemoryLimit:return 9;case E.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY"})(r=e.FileOperation||(e.FileOperation={}));class o{constructor($,z,W){this.resource=$,this.operation=z,this.target=W}isOperation($){return this.operation===$}}e.FileOperationEvent=o;var c;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class l{constructor($,z){this.ignorePathCasing=z,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=$;for(const W of $)switch(W.type){case 1:this.added||(this.added=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(W.resource,W);break;case 0:this.updated||(this.updated=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(W.resource,W);break;case 2:this.deleted||(this.deleted=S.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(W.resource,W);break}}contains($,...z){return this.doContains($,{includeChildren:!1},...z)}affects($,...z){return this.doContains($,{includeChildren:!0},...z)}doContains($,z,...W){var H,T,P,F,N,x;if(!$)return!1;const V=W.length>0;return!!((!V||W.includes(1))&&(((H=this.added)===null||H===void 0?void 0:H.get($))||z.includeChildren&&((T=this.added)===null||T===void 0?void 0:T.findSuperstr($)))||(!V||W.includes(0))&&(((P=this.updated)===null||P===void 0?void 0:P.get($))||z.includeChildren&&((F=this.updated)===null||F===void 0?void 0:F.findSuperstr($)))||(!V||W.includes(2))&&(((N=this.deleted)===null||N===void 0?void 0:N.findSubstr($))||z.includeChildren&&((x=this.deleted)===null||x===void 0?void 0:x.findSuperstr($))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType($){const z=[],W=$===1?this.added:$===0?this.updated:this.deleted;if(W)for(const[,H]of W)z.push(H);return z}filter($){return new l(this.changes.filter(z=>$(z)),this.ignorePathCasing)}}e.FileChangesEvent=l;function u(M,$,z){return!M||!$||M===$||$.length>M.length?!1:($.charAt($.length-1)!==L.sep&&($+=L.sep),z?(0,U.startsWithIgnoreCase)(M,$):M.indexOf($)===0)}e.isParent=u;class m extends Error{constructor($,z,W){super($);this.fileOperationResult=z,this.options=W}static isFileOperationError($){return $ instanceof Error&&!(0,A.isUndefinedOrNull)($.fileOperationResult)}}e.FileOperationError=m;var b;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(b=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var h;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(h=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function k(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=k;async function _(M,$){if(!$.canHandleResource(O.URI.from({scheme:M.scheme})))return new Promise(z=>{const W=$.onDidChangeFileSystemProviderRegistrations(H=>{H.scheme===M.scheme&&H.added&&(W.dispose(),z())})})}e.whenProviderRegistered=_,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class j{static formatSize($){return(0,A.isNumber)($)||($=0),$<j.KB?(0,p.localize)(1,null,$.toFixed(0)):$<j.MB?(0,p.localize)(2,null,($/j.KB).toFixed(2)):$<j.GB?(0,p.localize)(3,null,($/j.MB).toFixed(2)):$<j.TB?(0,p.localize)(4,null,($/j.GB).toFixed(2)):(0,p.localize)(5,null,($/j.TB).toFixed(2))}}e.ByteSize=j,j.KB=1024,j.MB=j.KB*j.KB,j.GB=j.MB*j.KB,j.TB=j.GB*j.KB;var q;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(q=e.Arch||(e.Arch={}));function K(M){return{maxFileSize:M===0?300*j.MB:16*j.GB,maxHeapSize:M===0?700*j.MB:2*700*j.MB}}e.getPlatformLimits=K}),define(Z[147],ee([0,1,148,48,10]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let R=class{constructor(A){this.fileService=A}checksum(A){return new Promise(async(S,y)=>{const n=(0,p.createHash)("md5"),f=(await this.fileService.readFileStream(A)).value;(0,L.listenStream)(f,{onData:v=>n.update(v.buffer),onError:v=>y(v),onEnd:()=>S(n.digest("base64").replace(/=+$/,""))})})}};R=de([Y(0,O.IFileService)],R),e.ChecksumService=R}),define(Z[75],ee([0,1,5,10,6]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function R(S){return S.map(y=>({type:y.type,resource:p.URI.file(y.path)}))}e.toFileChanges=R;function U(S){const y=new A;for(const n of S)y.processEvent(n);return y.normalize()}e.normalizeFileChanges=U;class A{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const n=this.mapPathToChange.get(y.path);if(n){const f=n.type,v=y.type;f===1&&v===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(n),1)):f===2&&v===1?n.type=0:f===1&&v===0||(n.type=v)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],n=[];return this.normalized.filter(f=>f.type!==2?(y.push(f),!1):!0).sort((f,v)=>f.path.length-v.path.length).filter(f=>n.some(v=>(0,L.isParent)(f.path,v,!O.isLinux))?!1:(n.push(f.path),!0)).concat(y)}}}),define(Z[149],ee([0,1,75,2,17,94,98,8,7]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends L.Disposable{constructor(f,v,C,d){super();this.path=f,this.onDidFilesChange=v,this.onLogMessage=C,this.verboseLogging=d,this.fileChangesDelayer=this._register(new A.ThrottledDelayer(U.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(f){this.verboseLogging=f}async startWatching(){try{const{stat:f,symbolicLink:v}=await O.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let C=this.path;if(v)try{C=await(0,R.realpath)(C)}catch(d){if(this.onError(d),v.dangling)return}f.isDirectory()?this._register((0,U.watchFolder)(C,(d,w)=>{this.onFileChange({type:d==="changed"?0:d==="added"?1:2,path:(0,S.join)(this.path,(0,S.basename)(w))})},d=>this.onError(d))):this._register((0,U.watchFile)(C,d=>{this.onFileChange({type:d==="changed"?0:2,path:this.path})},d=>this.onError(d)))}catch(f){f.code!=="ENOENT"&&this.onError(f)}}onFileChange(f){this.fileChangesBuffer.push(f),this.verboseLogging&&this.onVerbose(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`),this.fileChangesDelayer.trigger(async()=>{const v=this.fileChangesBuffer;this.fileChangesBuffer=[];const C=(0,p.normalizeFileChanges)(v);this.verboseLogging&&C.forEach(d=>{this.onVerbose(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`)}),C.length>0&&this.onDidFilesChange(C)})}onError(f){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${f}`})}onVerbose(f){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(Z[76],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...O){this._entries=new Map;for(let[R,U]of O)this.set(R,U)}set(O,R){const U=this._entries.get(O);return this._entries.set(O,R),U}has(O){return this._entries.has(O)}get(O){return this._entries.get(O)}}e.ServiceCollection=p}),define(Z[150],ee([0,1,11,140,50,4,76,8]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const S=!1;class y extends Error{constructor(d){var w;super("cyclic dependency between services");this.message=(w=d.findCycleSlow())!==null&&w!==void 0?w:`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class n{constructor(d=new U.ServiceCollection,w=!1,I){this._activeInstantiations=new Set,this._services=d,this._strict=w,this._parent=I,this._services.set(R.IInstantiationService,this)}createChild(d){return new n(d,this._strict,this)}invokeFunction(d,...w){let I=v.traceInvocation(d),E=!1;try{return d({get:(g,a)=>{if(E)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(g,I);if(!s&&a!==R.optional)throw new Error(`[invokeFunction] unknown service '${g}'`);return s}},...w)}finally{E=!0,I.stop()}}createInstance(d,...w){let I,E;return d instanceof O.SyncDescriptor?(I=v.traceCreation(d.ctor),E=this._createInstance(d.ctor,d.staticArguments.concat(w),I)):(I=v.traceCreation(d),E=this._createInstance(d,w,I)),I.stop(),E}_createInstance(d,w=[],I){let E=R._util.getServiceDependencies(d).sort((a,s)=>a.index-s.index),D=[];for(const a of E){let s=this._getOrCreateServiceInstance(a.id,I);if(!s&&this._strict&&!a.optional)throw new Error(`[createInstance] ${d.name} depends on UNKNOWN service ${a.id}.`);D.push(s)}let g=E.length>0?E[0].index:w.length;if(w.length!==g){console.warn(`[createInstance] First service dependency of ${d.name} at position ${g+1} conflicts with ${w.length} static arguments`);let a=g-w.length;a>0?w=w.concat(new Array(a)):w=w.slice(0,g)}return new d(...[...w,...D])}_setServiceInstance(d,w){if(this._services.get(d)instanceof O.SyncDescriptor)this._services.set(d,w);else if(this._parent)this._parent._setServiceInstance(d,w);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){let w=this._services.get(d);return!w&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):w}_getOrCreateServiceInstance(d,w){let I=this._getServiceInstanceOrDescriptor(d);return I instanceof O.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,I,w.branch(d,!0)):(w.branch(d,!1),I)}_safeCreateAndCacheServiceInstance(d,w,I){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,w,I)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,w,I){const E=new L.Graph(a=>a.id.toString());let D=0;const g=[{id:d,desc:w,_trace:I}];for(;g.length;){const a=g.pop();if(E.lookupOrInsertNode(a),D++>1e3)throw new y(E);for(let s of R._util.getServiceDependencies(a.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(s.id);if(!t&&!s.optional&&console.warn(`[createInstance] ${d} depends on ${s.id} which is NOT registered.`),t instanceof O.SyncDescriptor){const i={id:s.id,desc:t,_trace:a._trace.branch(s.id,!0)};E.insertEdge(a,i),g.push(i)}}}for(;;){const a=E.roots();if(a.length===0){if(!E.isEmpty())throw new y(E);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof O.SyncDescriptor){const i=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,i)}E.removeNode(s)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,w,I=[],E,D){if(this._services.get(d)instanceof O.SyncDescriptor)return this._createServiceInstance(w,I,E,D);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,w,I,E,D);throw new Error(`illegalState - creating UNKNOWN service instance ${w.name}`)}_createServiceInstance(d,w=[],I,E){if(I){const D=new A.IdleValue(()=>this._createInstance(d,w,E));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];let s=D.value,t=s[a];return typeof t!="function"||(t=t.bind(s),g[a]=t),t},set(g,a,s){return D.value[a]=s,!0}})}else return this._createInstance(d,w,E)}}e.InstantiationService=n;var f;(function(C){C[C.Creation=0]="Creation",C[C.Invocation=1]="Invocation",C[C.Branch=2]="Branch"})(f||(f={}));class v{constructor(d,w){this.type=d,this.name=w,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return S?new v(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(d){return S?new v(0,d.name):v._None}branch(d,w){let I=new v(2,d.toString());return this._dep.push([d,w,I]),I}stop(){let d=Date.now()-this._start;v._totals+=d;let w=!1;function I(D,g){let a=[],s=new Array(D+1).join("	");for(const[t,i,r]of g._dep)if(i&&r){w=!0,a.push(`${s}CREATES -> ${t}`);let o=I(D+1,r);o&&a.push(o)}else a.push(`${s}uses -> ${t}`);return a.join(`
`)}let E=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${I(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(d>2||w)&&console.log(E.join(`
`))}}v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(Z[151],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class p{constructor(O,R){this.server=O,this.router=R}getChannel(O){return this.server.getChannel(O,this.router)}registerChannel(O,R){this.server.registerChannel(O,R)}}e.MessagePortMainProcessService=p}),define(Z[152],ee([0,1,37,50,139,4]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class U{constructor(C,d,w){const I=w.getChannel(C);return A(d)?new d.channelClientCtor(I):p.ProxyChannel.toService(I,d==null?void 0:d.proxyOptions)}}function A(v){const C=v;return!!(C==null?void 0:C.channelClientCtor)}e.IMainProcessService=(0,R.createDecorator)("mainProcessService");let S=class extends U{constructor(C,d,w){super(C,d,w)}};S=de([Y(2,e.IMainProcessService)],S);function y(v,C,d){(0,O.registerSingleton)(v,new L.SyncDescriptor(S,[C,d],d==null?void 0:d.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=y,e.ISharedProcessService=(0,R.createDecorator)("sharedProcessService");let n=class extends U{constructor(C,d,w){super(C,d,w)}};n=de([Y(2,e.ISharedProcessService)],n);function f(v,C,d){(0,O.registerSingleton)(v,new L.SyncDescriptor(n,[C,d],d==null?void 0:d.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=f}),define(Z[56],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=(0,p.createDecorator)("localizationsService");function L(O){if(typeof O.languageId!="string"||!Array.isArray(O.translations)||O.translations.length===0)return!1;for(const R of O.translations)if(typeof R.id!="string"||typeof R.path!="string")return!1;return!(O.languageName&&typeof O.languageName!="string"||O.localizedLanguageName&&typeof O.localizedLanguageName!="string")}e.isValidLocalization=L}),define(Z[153],ee([0,1,2,56]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let O=class extends p.Disposable{constructor(U){super();this.localizationsService=U,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};O=de([Y(0,L.ILocalizationsService)],O),e.LocalizationsUpdater=O}),define(Z[18],ee([0,1,4,2,6,3,44]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,p.createDecorator)("logService"),e.ILoggerService=(0,p.createDecorator)("loggerService");function A(){return new Date().toISOString()}var S;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(S=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=S.Info;class y extends L.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new R.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class n extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(S.Trace)&&this.log(S.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(S.Debug)&&this.log(S.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(S.Info)&&this.log(S.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(S.Warning)&&this.log(S.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(S.Error))if(t instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=t.stack,this.log(S.Error,this.format(r))}else this.log(S.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(S.Critical)&&this.log(S.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let r=0;r<t.length;r++){let o=t[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch(c){}i+=(r>0?" ":"")+o}return i}}e.AbstractMessageLogger=n;class f extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!O.isWindows}trace(t,...i){this.getLevel()<=S.Trace&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...i):console.log(`[main ${A()}]`,t,...i))}debug(t,...i){this.getLevel()<=S.Debug&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...i):console.log(`[main ${A()}]`,t,...i))}info(t,...i){this.getLevel()<=S.Info&&(this.useColors?console.log(`[90m[main ${A()}][0m`,t,...i):console.log(`[main ${A()}]`,t,...i))}warn(t,...i){this.getLevel()<=S.Warning&&(this.useColors?console.warn(`[93m[main ${A()}][0m`,t,...i):console.warn(`[main ${A()}]`,t,...i))}error(t,...i){this.getLevel()<=S.Error&&(this.useColors?console.error(`[91m[main ${A()}][0m`,t,...i):console.error(`[main ${A()}]`,t,...i))}critical(t,...i){this.getLevel()<=S.Critical&&(this.useColors?console.error(`[90m[main ${A()}][0m`,t,...i):console.error(`[main ${A()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class v extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=S.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=S.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=S.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=S.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=S.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=S.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=v;class C extends y{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=S.Trace&&this.adapter.log(S.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=S.Debug&&this.adapter.log(S.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=S.Info&&this.adapter.log(S.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=S.Warning&&this.adapter.log(S.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=S.Error&&this.adapter.log(S.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=S.Critical&&this.adapter.log(S.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,U.toErrorMessage)(t,this.getLevel()<=S.Trace)}dispose(){}flush(){}}e.AdapterLogger=C;class d extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const r of this.logServices)r.trace(t,...i)}debug(t,...i){for(const r of this.logServices)r.debug(t,...i)}info(t,...i){for(const r of this.logServices)r.info(t,...i)}warn(t,...i){for(const r of this.logServices)r.warn(t,...i)}error(t,...i){for(const r of this.logServices)r.error(t,...i)}critical(t,...i){for(const r of this.logServices)r.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=d;class w extends L.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=w;class I extends L.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(r))}))}createLogger(t,i){let r=this.loggers.get(t.toString());return r||(r=this.doCreateLogger(t,(i==null?void 0:i.always)?S.Trace:this.logLevel,i),this.loggers.set(t.toString(),r),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class E{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(t){}getLevel(){return S.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=E;function D(s){if(s.verbose)return S.Trace;if(typeof s.logLevel=="string"){const t=g(s.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=D;function g(s){switch(s){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Critical;case"off":return S.Off}}e.parseLogLevel=g;function a(s){switch(s){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Critical:return"critical";case S.Off:return"off"}}e.LogLevelToString=a}),define(Z[154],ee([0,1,27,2,10,29,9,5,14,34,18,31,57,6,8,11]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let E=class extends L.Disposable{constructor(g,a,s,t){super();this.fileService=a,this.extensionGalleryService=s,this.logService=t,this.extensionsDownloadDir=A.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,a){await this.cleanUpPromise;const s=this.getName(g),t=(0,S.joinPath)(this.extensionsDownloadDir,s);if(!await this.fileService.exists(t)){const i=(0,S.joinPath)(this.extensionsDownloadDir,`.${(0,f.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(g,i,a);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(i)}catch(o){}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,i.path),r}}return t}async delete(g){}async rename(g,a,s){try{await p.promises.rename(g.fsPath,a.fsPath)}catch(t){if(C.isWindows&&t&&t.code==="EPERM"&&Date.now()<s)return this.logService.info(`Failed renaming ${g} to ${a} with 'EPERM' error. Trying again...`),this.rename(g,a,s);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const a=[],s=[];for(const r of g.children){const o=this.parse(r.name);o&&s.push([o,r])}const t=(0,y.groupByExtension)(s,([r])=>r),i=[];for(const r of t)r.sort((o,c)=>v.rcompare(o[0].version,c[0].version)),a.push(...r.slice(1).map(o=>o[1].resource)),i.push(r[0][1]);i.sort((r,o)=>r.mtime-o.mtime),a.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(r=>r.resource)),await d.Promises.settled(a.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?new y.ExtensionIdentifierWithVersion(g.identifier,g.version).key().toLowerCase():(0,f.generateUuid)()}parse(g){const a=I.exec(g);return a&&a[1]&&a[2]?new y.ExtensionIdentifierWithVersion({id:a[1]},a[2]):null}};E=de([Y(0,U.INativeEnvironmentService),Y(1,O.IFileService),Y(2,R.IExtensionGalleryService),Y(3,n.ILogService)],E),e.ExtensionsDownloader=E}),define(Z[155],ee([0,1,2,18,43,44,7,8,3,16,17,9]),function(G,e,p,L,O,R,U,A,S,y,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends p.Disposable{constructor(d,w){super();this.environmentService=d,this.logService=w,this.processesLimiter=new A.Limiter(5)}async postUninstall(d){const w=this.parseScript(d,"uninstall");return w&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(w.script,"uninstall",w.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),I=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${I}`)))),(0,n.rimraf)(this.getExtensionStoragePath(d)).then(void 0,I=>this.logService.error("Error while removing extension storage path",I))}parseScript(d,w){const I=`vscode:${w}`;if(d.location.scheme===y.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[I]=="string"){const E=d.manifest.scripts[I].split(" ");return E.length<2||E[0]!=="node"||!E[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${I} should be a node script`),null):{script:(0,U.join)(d.location.fsPath,E[1]),args:E.slice(2)||[]}}return null}runLifecycleHook(d,w,I,E,D){return new Promise((g,a)=>{const s=this.start(d,w,I,D);let t;const i=r=>{t&&(clearTimeout(t),t=null),r?a(r):g(void 0)};s.on("error",r=>{i((0,R.toErrorMessage)(r)||"Unknown")}),s.on("exit",(r,o)=>{i(r?`post-${w} process exited with code ${r}`:void 0)}),E&&(t=setTimeout(()=>{t=null,s.kill(),a("timed out")},5e3))})}start(d,w,I,E){const D={silent:!0,execArgv:void 0},g=(0,O.fork)(d,[`--type=extension-post-${w}`,...I],D);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=S.Event.fromNodeEventEmitter(g.stdout,"data"),s=S.Event.fromNodeEventEmitter(g.stderr,"data");a(r=>this.logService.info(E.identifier.id,E.manifest.version,`post-${w}`,r)),s(r=>this.logService.error(E.identifier.id,E.manifest.version,`post-${w}`,r));const t=S.Event.any(S.Event.map(a,r=>({data:`%c${r}`,format:[""]})),S.Event.map(s,r=>({data:`%c${r}`,format:["color: red"]})));return S.Event.debounce(t,(r,o)=>r?{data:r.data+o.data,format:[...r.format,...o.format]}:{data:o.data,format:o.format},100)(r=>{console.group(E.identifier.id),console.log(r.data,...r.format),console.groupEnd()}),g}getExtensionStoragePath(d){return(0,U.join)(this.environmentService.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};v=de([Y(0,f.IEnvironmentService),Y(1,L.ILogService)],v),e.ExtensionsLifecycle=v}),define(Z[156],ee([0,1,2,9,3,10,5,34,14,18]),function(G,e,p,L,O,R,U,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let n=class extends p.Disposable{constructor(v,C,d,w){super();this.extensionsManagementService=v,this.logService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(D=>{this.installedExtensions=D.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(D=>this.onInstallExtension(D))),this._register(v.onDidInstallExtension(D=>this.onDidInstallExtension(D))),this._register(v.onDidUninstallExtension(D=>this.onDidUninstallExtension(D)));const I=U.URI.file(d.extensionsPath),E=new S.ExtUri(D=>!C.hasCapability(D,1024));this._register(C.watch(I)),this._register(O.Event.filter(C.onDidFilesChange,D=>D.changes.some(g=>this.doesChangeAffects(g,I,E)))(()=>this.onDidChange()))}doesChangeAffects(v,C,d){return d.isEqual(d.dirname(v.resource),C)?d.isEqual(v.resource,d.joinPath(C,".obsolete"))?!0:!(v.type!==1&&v.type!==2||d.basename(v.resource).startsWith(".")):!1}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtension(v){this.removeInstallingExtension(v.identifier),v.error||this.addInstalledExtension(v.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(C=>!(0,A.areSameExtensions)(C,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(C=>!(0,A.areSameExtensions)(C,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(1),C=v.filter(w=>[...this.installingExtensions,...this.installedExtensions].some(I=>(0,A.areSameExtensions)(I,w.identifier))?!1:w.installedTimestamp&&w.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",w.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",w.identifier.id),!1)),d=this.installedExtensions.filter(w=>this.installingExtensions.some(I=>(0,A.areSameExtensions)(I,w))?!1:v.every(I=>!(0,A.areSameExtensions)(I.identifier,w))?(this.logService.info("Detected extension removed from another source",w.id),!0):!1);this.installedExtensions=v.map(w=>w.identifier),(C.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:C,removed:d})}}};n=de([Y(1,R.IFileService),Y(2,L.INativeEnvironmentService),Y(3,y.ILogService)],n),e.ExtensionsWatcher=n}),define(Z[157],ee([0,1,17,27,148,29,2,9,8,34,18,56,19,3,16,7]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let I=class extends U.Disposable{constructor(g,a,s){super();this.extensionManagementService=g,this.logService=s,this._onDidLanguagesChange=this._register(new C.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new E(a,s)),this._register(g.onDidInstallExtension(({local:t})=>this.onDidInstallExtension(t))),this._register(g.onDidUninstallExtension(({identifier:t})=>this.onDidUninstallExtension(t)))}getLanguageIds(){return this.cache.getLanguagePacks().then(g=>{const a=["en",...Object.keys(g)];return(0,v.distinct)(a)})}onDidInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",g.identifier.id),this.update().then(a=>{a&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(g){this.cache.getLanguagePacks().then(a=>{Object.keys(a).some(s=>a[s]&&a[s].extensions.some(t=>(0,y.areSameExtensions)(t.extensionIdentifier,g)))&&(this.logService.debug("Removing language packs from the extension",g.id),this.update().then(s=>{s&&this._onDidLanguagesChange.fire()}))})}async update(){const[g,a]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),s=await this.cache.update(a);return!(0,v.equals)(Object.keys(g),Object.keys(s))}};I=de([Y(0,R.IExtensionManagementService),Y(1,A.INativeEnvironmentService),Y(2,n.ILogService)],I),e.LocalizationsService=I;let E=class extends U.Disposable{constructor(g,a){super();this.logService=a,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new S.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(a=>{Object.keys(a).forEach(s=>delete a[s]),this.createLanguagePacksFromExtensions(a,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...a){for(const s of a)s&&s.manifest&&s.manifest.contributes&&s.manifest.contributes.localizations&&s.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,s);Object.keys(g).forEach(s=>this.updateHash(g[s]))}createLanguagePacksFromExtension(g,a){const s=a.identifier,t=a.manifest.contributes&&a.manifest.contributes.localizations?a.manifest.contributes.localizations:[];for(const i of t)if(a.location.scheme===d.Schemas.file&&(0,f.isValidLocalization)(i)){let r=g[i.languageId];r||(r={hash:"",extensions:[],translations:{}},g[i.languageId]=r);let o=r.extensions.filter(c=>(0,y.areSameExtensions)(c.extensionIdentifier,s))[0];o?o.version=a.manifest.version:r.extensions.push({extensionIdentifier:s,version:a.manifest.version});for(const c of i.translations)r.translations[c.id]=(0,w.join)(a.location.fsPath,c.path)}}updateHash(g){if(g){const a=(0,O.createHash)("md5");for(const s of g.extensions)a.update(s.extensionIdentifier.uuid||s.extensionIdentifier.id).update(s.version);g.hash=a.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let a=null;return L.promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,s=>s.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(s)).then(s=>{try{return JSON.parse(s)}catch(t){return{}}}).then(s=>(a=g(s),s)).then(s=>{for(const i of Object.keys(s))s[i]||delete s[i];this.languagePacks=s,this.initializedCache=!0;const t=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",t),(0,p.writeFile)(this.languagePacksFilePath,t)}).then(()=>a,s=>this.logService.error(s))})}};E=de([Y(0,A.INativeEnvironmentService),Y(1,n.ILogService)],E)}),define(Z[77],ee([0,1,18,3,5]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(v){this.service=v,this.onDidChangeLogLevel=L.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,C){switch(C){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${C}`)}async call(v,C,d){switch(C){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${C}`)}}e.LogLevelChannel=R;class U{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){U.setLevel(this.channel,v)}static setLevel(v,C){return v.call("setLevel",C)}}e.LogLevelChannelClient=U;class A{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,C){throw new Error(`Event not found: ${C}`)}async call(v,C,d){switch(C){case"createLogger":this.createLogger(O.URI.revive(d[0]),d[1]);return;case"log":return this.log(O.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${C}`)}createLogger(v,C){this.loggers.set(v.toString(),this.loggerService.createLogger(v,C))}consoleLog(v,C){let d=console.log;switch(v){case p.LogLevel.Error:d=console.error;break;case p.LogLevel.Warning:d=console.warn;break;case p.LogLevel.Info:d=console.info;break}d.call(console,...C)}log(v,C){const d=this.loggers.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[w,I]of C)switch(w){case p.LogLevel.Trace:d.trace(I);break;case p.LogLevel.Debug:d.debug(I);break;case p.LogLevel.Info:d.info(I);break;case p.LogLevel.Warning:d.warn(I);break;case p.LogLevel.Error:d.error(I);break;case p.LogLevel.Critical:d.critical(I);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=A;class S extends p.AbstractLoggerService{constructor(v,C,d){super(v,C);this.channel=d}createConsoleMainLogger(){return new p.AdapterLogger({log:(v,C)=>{this.channel.call("consoleLog",[v,C])}})}doCreateLogger(v,C,d){return new y(this.channel,v,C,d)}}e.LoggerChannelClient=S;class y extends p.AbstractMessageLogger{constructor(v,C,d,w){super(w==null?void 0:w.always);this.channel=v,this.file=C,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[C,w]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,C){const d=[[v,C]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(v){this.channel.call("log",[this.file,v])}}class n extends p.LogService{constructor(v,C){super(C);this.parent=v,this._register(v.onDidChangeLogLevel(d=>C.setLevel(d)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=n}),define(Z[58],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,p.createDecorator)("nativeHostService")}),define(Z[51],ee([0,1,16,6,35,14]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let U;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const A=L.globals.vscode.context.configuration();if(A)U=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(G==null?void 0:G.__$__nodeRequire)=="function"){const A=(0,R.dirname)(p.FileAccess.asFileUri("",G));U=G.__$__nodeRequire((0,R.joinPath)(A,"product.json").fsPath);const S=G.__$__nodeRequire((0,R.joinPath)(A,"package.json").fsPath);O.env.VSCODE_DEV&&Object.assign(U,{nameShort:`${U.nameShort} Dev`,nameLong:`${U.nameLong} Dev`,dataFolderName:`${U.dataFolderName}-dev`}),Object.assign(U,{version:S.version})}else U={},Object.keys(U).length===0&&Object.assign(U,{version:"1.57.0-dev",nameShort:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:L.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-webview.net/{{quality}}/{{commit}}/out/vs/workbench/contrib/webview/browser/pre/",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.github-browser","ms-vscode.github-richnav","ms-vscode.remotehub","ms-vscode.remotehub-insiders"]});e.default=U}),define(Z[78],ee([0,1,117,25,10,11,51]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(f,v,C,d,w,I){let E;try{await S(f,v,C,d,w,I)}catch(D){E=D}finally{E&&w.errorTransformer&&(E=w.errorTransformer(E)),typeof E!="undefined"&&C.error(E),C.end()}}e.readFileIntoStream=A;async function S(f,v,C,d,w,I){y(I);const E=await f.open(v,{create:!1});try{y(I);let D=0,g=0,a=w&&typeof w.length=="number"?w.length:void 0,s=L.VSBuffer.alloc(Math.min(w.bufferSize,typeof a=="number"?a:w.bufferSize)),t=w&&typeof w.position=="number"?w.position:0,i=0;do g=await f.read(E,t,s.buffer,i,s.byteLength-i),t+=g,i+=g,D+=g,typeof a=="number"&&(a-=g),i===s.byteLength&&(await C.write(d(s)),s=L.VSBuffer.alloc(Math.min(w.bufferSize,typeof a=="number"?a:w.bufferSize)),i=0);while(g>0&&(typeof a!="number"||a>0)&&y(I)&&n(D,w));if(i>0){let r=i;typeof a=="number"&&(r=Math.min(i,a)),C.write(d(s.slice(0,r)))}}catch(D){throw(0,O.ensureFileSystemProviderError)(D)}finally{await f.close(E)}}function y(f){if(f.isCancellationRequested)throw(0,R.canceled)();return!0}function n(f,v){if(v==null?void 0:v.limits){if(typeof v.limits.memory=="number"&&f>v.limits.memory)throw(0,O.createFileSystemProviderError)((0,p.localize)(0,null,U.default.nameShort),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof v.limits.size=="number"&&f>v.limits.size)throw(0,O.createFileSystemProviderError)((0,p.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[158],ee([0,1,115,159,2,10,3,14,39,19,18,25,48,8,30,16,78,53]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class extends O.Disposable{constructor(a){super();this.logService=a,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new U.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new U.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new U.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new U.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new U.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new U.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new C.ResourceQueue)}registerProvider(a,s){if(this.provider.has(a))throw new Error(`A filesystem provider for the scheme '${a}' is already registered.`);(0,L.mark)(`code/registerFilesystem/${a}`),this.provider.set(a,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:a,provider:s});const t=new O.DisposableStore;return t.add(s.onDidChangeFile(i=>this._onDidFilesChange.fire(new R.FileChangesEvent(i,!this.isPathCaseSensitive(s))))),t.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:a}))),typeof s.onDidErrorOccur=="function"&&t.add(s.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,O.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:a,provider:s}),this.provider.delete(a),(0,O.dispose)(t)})}getProvider(a){return this.provider.get(a)}async activateProvider(a){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:a,join(t){s.push(t)}}),!this.provider.has(a)&&await C.Promises.settled(s)}canHandleResource(a){return this.provider.has(a.scheme)}hasCapability(a,s){const t=this.provider.get(a.scheme);return!!(t&&t.capabilities&s)}listCapabilities(){return E.Iterable.map(this.provider,([a,s])=>({scheme:a,capabilities:s.capabilities}))}async withProvider(a){if(!(0,A.isAbsolutePath)(a))throw new R.FileOperationError((0,p.localize)(0,null,this.resourceForError(a)),8);await this.activateProvider(a.scheme);const s=this.provider.get(a.scheme);if(!s){const t=new Error;throw t.name="ENOPRO",t.message=(0,p.localize)(1,null,a.toString()),t}return s}async withReadProvider(a){const s=await this.withProvider(a);if((0,R.hasOpenReadWriteCloseCapability)(s)||(0,R.hasReadWriteCapability)(s)||(0,R.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(a){const s=await this.withProvider(a);if((0,R.hasOpenReadWriteCloseCapability)(s)||(0,R.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${a.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(a,s){try{return await this.doResolveFile(a,s)}catch(t){throw(0,R.toFileSystemProviderErrorCode)(t)===R.FileSystemProviderErrorCode.FileNotFound?new R.FileOperationError((0,p.localize)(2,null,this.resourceForError(a)),1):(0,R.ensureFileSystemProviderError)(t)}}async doResolveFile(a,s){const t=await this.withProvider(a),i=this.isPathCaseSensitive(t),r=s==null?void 0:s.resolveTo,o=s==null?void 0:s.resolveSingleChildDescendants,c=s==null?void 0:s.resolveMetadata,l=await t.stat(a);let u;return this.toFileStat(t,a,l,void 0,!!c,(m,b)=>(u||(u=S.TernarySearchTree.forUris(()=>!i),u.set(a,!0),(0,y.isNonEmptyArray)(r)&&r.forEach(h=>u.set(h,!0))),Boolean(u.findSuperstr(m.resource)||u.get(m.resource))?!0:m.isDirectory&&o?b===1:!1))}async toFileStat(a,s,t,i,r,o){var c;const{providerExtUri:l}=this.getExtUri(a),u={resource:s,name:l.basename(s),isFile:(t.type&R.FileType.File)!=0,isDirectory:(t.type&R.FileType.Directory)!=0,isSymbolicLink:(t.type&R.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((c=t.permissions)!==null&&c!==void 0?c:0)&R.FilePermission.Readonly)||Boolean(a.capabilities&2048),etag:(0,R.etag)({mtime:t.mtime,size:t.size})};if(u.isDirectory&&o(u,i)){try{const m=await a.readdir(s),b=await C.Promises.settled(m.map(async([h,k])=>{try{const _=l.joinPath(s,h),j=r?await a.stat(_):{type:k};return await this.toFileStat(a,_,j,m.length,r,o)}catch(_){return this.logService.trace(_),null}}));u.children=(0,y.coalesce)(b)}catch(m){this.logService.trace(m),u.children=[]}return u}return u}async resolveAll(a){return C.Promises.settled(a.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(a){const s=await this.withProvider(a);try{return!!await s.stat(a)}catch(t){return!1}}async canCreateFile(a,s){try{await this.doValidateCreateFile(a,s)}catch(t){return t}return!0}async doValidateCreateFile(a,s){if(!(s==null?void 0:s.overwrite)&&await this.exists(a))throw new R.FileOperationError((0,p.localize)(3,null,this.resourceForError(a)),3,s)}async createFile(a,s=f.VSBuffer.fromString(""),t){await this.doValidateCreateFile(a,t);const i=await this.writeFile(a,s);return this._onDidRunOperation.fire(new R.FileOperationEvent(a,0,i)),i}async writeFile(a,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),{providerExtUri:r}=this.getExtUri(i);try{await this.validateWriteFile(i,a,t)||await this.mkdirp(i,r.dirname(a));let c;if((0,R.hasReadWriteCapability)(i)&&!(s instanceof f.VSBuffer))if((0,v.isReadableStream)(s)){const l=await(0,v.peekStream)(s,3);l.ended?c=f.VSBuffer.concat(l.buffer):c=l}else c=(0,v.peekReadable)(s,l=>f.VSBuffer.concat(l),3);else c=s;!(0,R.hasOpenReadWriteCloseCapability)(i)||(0,R.hasReadWriteCapability)(i)&&c instanceof f.VSBuffer?await this.doWriteUnbuffered(i,a,t,c):await this.doWriteBuffered(i,a,t,c instanceof f.VSBuffer?(0,f.bufferToReadable)(c):c)}catch(o){throw new R.FileOperationError((0,p.localize)(4,null,this.resourceForError(a),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),t)}return this.resolve(a,{resolveMetadata:!0})}async validateWriteFile(a,s,t){if(!!(t==null?void 0:t.unlock)&&!(a.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(s)));let r;try{r=await a.stat(s)}catch(o){return}if((r.type&R.FileType.Directory)!=0)throw new R.FileOperationError((0,p.localize)(6,null,this.resourceForError(s)),0,t);if(this.throwIfFileIsReadonly(s,r),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&t.mtime<r.mtime&&t.etag!==(0,R.etag)({mtime:t.mtime,size:r.size}))throw new R.FileOperationError((0,p.localize)(7,null),3,t);return r}async readFile(a,s){const t=await this.withReadProvider(a);return(s==null?void 0:s.atomic)?this.doReadFileAtomic(t,a,s):this.doReadFile(t,a,s)}async doReadFileAtomic(a,s,t){return new Promise((i,r)=>{this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(async()=>{try{const o=await this.doReadFile(a,s,t);i(o)}catch(o){r(o)}})})}async doReadFile(a,s,t){const i=await this.doReadFileStream(a,s,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await(0,f.streamToBuffer)(i.value)})}async readFileStream(a,s){const t=await this.withReadProvider(a);return this.doReadFileStream(t,a,s)}async doReadFileStream(a,s,t){const i=new d.CancellationTokenSource,r=this.validateReadFile(s,t).then(c=>c,c=>{throw i.cancel(),c});let o;try{t&&typeof t.etag=="string"&&t.etag!==R.ETAG_DISABLED&&await r,!((0,R.hasOpenReadWriteCloseCapability)(a)||(0,R.hasFileReadStreamCapability)(a))||(0,R.hasReadWriteCapability)(a)&&(t==null?void 0:t.preferUnbuffered)?o=this.readFileUnbuffered(a,s,t):(0,R.hasFileReadStreamCapability)(a)?o=this.readFileStreamed(a,s,i.token,t):o=this.readFileBuffered(a,s,i.token,t);const c=await r;return Object.assign(Object.assign({},c),{value:o})}catch(c){throw o&&await(0,v.consumeStream)(o),new R.FileOperationError((0,p.localize)(8,null,this.resourceForError(s),(0,R.ensureFileSystemProviderError)(c).toString()),(0,R.toFileOperationResult)(c),t)}}readFileStreamed(a,s,t,i=Object.create(null)){const r=a.readFileStream(s,i,t);return(0,v.transform)(r,{data:o=>o instanceof f.VSBuffer?o:f.VSBuffer.wrap(o),error:o=>new R.FileOperationError((0,p.localize)(9,null,this.resourceForError(s),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),i)},o=>f.VSBuffer.concat(o))}readFileBuffered(a,s,t,i=Object.create(null)){const r=(0,f.newWriteableBufferStream)();return(0,I.readFileIntoStream)(a,s,r,o=>o,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new R.FileOperationError((0,p.localize)(10,null,this.resourceForError(s),(0,R.ensureFileSystemProviderError)(o).toString()),(0,R.toFileOperationResult)(o),i)}),t),r}readFileUnbuffered(a,s,t){const i=(0,v.newWriteableStream)(r=>f.VSBuffer.concat(r));return(async()=>{try{let r=await a.readFile(s);t&&typeof t.position=="number"&&(r=r.slice(t.position)),t&&typeof t.length=="number"&&(r=r.slice(0,t.length)),this.validateReadFileLimits(s,r.byteLength,t),i.end(f.VSBuffer.wrap(r))}catch(r){i.error(r),i.end()}})(),i}async validateReadFile(a,s){const t=await this.resolve(a,{resolveMetadata:!0});if(t.isDirectory)throw new R.FileOperationError((0,p.localize)(11,null,this.resourceForError(a)),0,s);if(s&&typeof s.etag=="string"&&s.etag!==R.ETAG_DISABLED&&s.etag===t.etag)throw new R.FileOperationError((0,p.localize)(12,null),2,s);return this.validateReadFileLimits(a,t.size,s),t}validateReadFileLimits(a,s,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&s>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&s>t.limits.size&&(i=7),typeof i=="number")throw new R.FileOperationError((0,p.localize)(13,null,this.resourceForError(a)),i)}}async canMove(a,s,t){return this.doCanMoveCopy(a,s,"move",t)}async canCopy(a,s,t){return this.doCanMoveCopy(a,s,"copy",t)}async doCanMoveCopy(a,s,t,i){if(a.toString()!==s.toString())try{const r=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a):await this.withReadProvider(a),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(r,a,o,s,t,i)}catch(r){return r}return!0}async move(a,s,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,a,r,s,"move",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(a,o==="move"?2:3,c)),c}async copy(a,s,t){const i=await this.withReadProvider(a),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(i,a,r,s,"copy",!!t),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(a,o==="copy"?3:2,c)),c}async doMoveCopy(a,s,t,i,r,o){if(s.toString()===i.toString())return r;const{exists:c,isSameResourceWithDifferentPathCase:l}=await this.doValidateMoveCopy(a,s,t,i,r,o);if(c&&!l&&o&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),r==="copy"){if(a===t&&(0,R.hasFileFolderCopyCapability)(a))await a.copy(s,i,{overwrite:o});else{const u=await this.resolve(s);u.isDirectory?await this.doCopyFolder(a,u,t,i):await this.doCopyFile(a,s,t,i)}return r}else return a===t?(await a.rename(s,i,{overwrite:o}),r):(await this.doMoveCopy(a,s,t,i,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(a,s,t,i){if((0,R.hasOpenReadWriteCloseCapability)(a)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(a,s,t,i);if((0,R.hasOpenReadWriteCloseCapability)(a)&&(0,R.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(a,s,t,i);if((0,R.hasReadWriteCapability)(a)&&(0,R.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(a,s,t,i);if((0,R.hasReadWriteCapability)(a)&&(0,R.hasReadWriteCapability)(t))return this.doPipeUnbuffered(a,s,t,i)}async doCopyFolder(a,s,t,i){await t.mkdir(i),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async r=>{const o=this.getExtUri(t).providerExtUri.joinPath(i,r.name);return r.isDirectory?this.doCopyFolder(a,await this.resolve(r.resource),t,o):this.doCopyFile(a,r.resource,t,o)}))}async doValidateMoveCopy(a,s,t,i,r,o){let c=!1;if(a===t){const{providerExtUri:u,isPathCaseSensitive:m}=this.getExtUri(a);if(m||(c=u.isEqual(s,i)),c&&r==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(s),this.resourceForError(i)));if(!c&&u.isEqualOrParent(i,s))throw new Error((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(i)))}const l=await this.exists(i);if(l&&!c){if(!o)throw new R.FileOperationError((0,p.localize)(16,null,this.resourceForError(s),this.resourceForError(i)),4);if(a===t){const{providerExtUri:u}=this.getExtUri(a);if(u.isEqualOrParent(s,i))throw new Error((0,p.localize)(17,null,this.resourceForError(s),this.resourceForError(i)))}}return{exists:l,isSameResourceWithDifferentPathCase:c}}getExtUri(a){const s=this.isPathCaseSensitive(a);return{providerExtUri:s?A.extUri:A.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(a){return!!(a.capabilities&1024)}async createFolder(a){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);await this.mkdirp(s,a);const t=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new R.FileOperationEvent(a,0,t)),t}async mkdirp(a,s){const t=[],{providerExtUri:i}=this.getExtUri(a);for(;!i.isEqual(s,i.dirname(s));)try{if(((await a.stat(s)).type&R.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(s)));break}catch(r){if((0,R.toFileSystemProviderErrorCode)(r)!==R.FileSystemProviderErrorCode.FileNotFound)throw r;t.push(i.basename(s)),s=i.dirname(s)}for(let r=t.length-1;r>=0;r--){s=i.joinPath(s,t[r]);try{await a.mkdir(s)}catch(o){if((0,R.toFileSystemProviderErrorCode)(o)!==R.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(a,s){try{await this.doValidateDelete(a,s)}catch(t){return t}return!0}async doValidateDelete(a,s){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(a),a);if(!!(s==null?void 0:s.useTrash)&&!(t.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(a)));let r;try{r=await t.stat(a)}catch(c){}if(r)this.throwIfFileIsReadonly(a,r);else throw new R.FileOperationError((0,p.localize)(20,null,this.resourceForError(a)),1);if(!!!(s==null?void 0:s.recursive)){const c=await this.resolve(a);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(a)))}return t}async del(a,s){const t=await this.doValidateDelete(a,s),i=!!(s==null?void 0:s.useTrash),r=!!(s==null?void 0:s.recursive);await t.delete(a,{recursive:r,useTrash:i}),this._onDidRunOperation.fire(new R.FileOperationEvent(a,1))}watch(a,s={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(a,s).then(r=>{t?(0,O.dispose)(r):i=()=>(0,O.dispose)(r)},r=>this.logService.error(r)),(0,O.toDisposable)(()=>i())}async doWatch(a,s){const t=await this.withProvider(a),i=this.toWatchKey(t,a,s),r=this.activeWatchers.get(i)||{count:0,disposable:t.watch(a,s)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,r),r.count+=1,(0,O.toDisposable)(()=>{r.count--,r.count===0&&((0,O.dispose)(r.disposable),this.activeWatchers.delete(i))})}toWatchKey(a,s,t){const{providerExtUri:i}=this.getExtUri(a);return[i.getComparisonKey(s),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(a=>(0,O.dispose)(a.disposable)),this.activeWatchers.clear()}async doWriteBuffered(a,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(async()=>{var r;const o=await a.open(s,{create:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1});try{(0,v.isReadableStream)(i)||(0,v.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(a,o,i):await this.doWriteReadableBufferedQueued(a,o,i)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await a.close(o)}})}async doWriteStreamBufferedQueued(a,s,t){let i=0,r;if((0,v.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=f.VSBuffer.concat(t.buffer);await this.doWriteBuffer(a,s,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;r=t.stream}else r=t;return new Promise(async(o,c)=>{(0,v.listenStream)(r,{onData:async l=>{r.pause();try{await this.doWriteBuffer(a,s,l,l.byteLength,i,0)}catch(u){return c(u)}i+=l.byteLength,setTimeout(()=>r.resume())},onError:l=>c(l),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(a,s,t){let i=0,r;for(;(r=t.read())!==null;)await this.doWriteBuffer(a,s,r,r.byteLength,i,0),i+=r.byteLength}async doWriteBuffer(a,s,t,i,r,o){let c=0;for(;c<i;)c+=await a.write(s,r+c,t.buffer,o+c,i-c)}async doWriteUnbuffered(a,s,t,i){return this.writeQueue.queueFor(s,this.getExtUri(a).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(a,s,t,i))}async doWriteUnbufferedQueued(a,s,t,i){var r;let o;i instanceof f.VSBuffer?o=i:(0,v.isReadableStream)(i)?o=await(0,f.streamToBuffer)(i):(0,v.isReadableBufferedStream)(i)?o=await(0,f.bufferedStreamToBuffer)(i):o=(0,f.readableToBuffer)(i),await a.writeFile(s,o.buffer,{create:!0,overwrite:!0,unlock:(r=t==null?void 0:t.unlock)!==null&&r!==void 0?r:!1})}async doPipeBuffered(a,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(a,s,t,i))}async doPipeBufferedQueued(a,s,t,i){let r,o;try{r=await a.open(s,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const c=f.VSBuffer.alloc(this.BUFFER_SIZE);let l=0,u=0,m=0;do m=await a.read(r,l,c.buffer,u,c.byteLength-u),await this.doWriteBuffer(t,o,c,m,l,u),l+=m,u+=m,u===c.byteLength&&(u=0);while(m>0)}catch(c){throw(0,R.ensureFileSystemProviderError)(c)}finally{await C.Promises.settled([typeof r=="number"?a.close(r):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async doPipeUnbuffered(a,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(a,s,t,i))}async doPipeUnbufferedQueued(a,s,t,i){return t.writeFile(i,await a.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(a,s,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(a,s,t,i))}async doPipeUnbufferedToBufferedQueued(a,s,t,i){const r=await t.open(i,{create:!0,unlock:!1});try{const o=await a.readFile(s);await this.doWriteBuffer(t,r,f.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,R.ensureFileSystemProviderError)(o)}finally{await t.close(r)}}async doPipeBufferedToUnbuffered(a,s,t,i){const r=await(0,f.streamToBuffer)(this.readFileBuffered(a,s,d.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,r)}throwIfFileSystemIsReadonly(a,s){if(a.capabilities&2048)throw new R.FileOperationError((0,p.localize)(22,null,this.resourceForError(s)),6);return a}throwIfFileIsReadonly(a,s){var t;if(((t=s.permissions)!==null&&t!==void 0?t:0)&R.FilePermission.Readonly)throw new R.FileOperationError((0,p.localize)(23,null,this.resourceForError(a)),6)}resourceForError(a){return a.scheme===w.Schemas.file?a.fsPath:a.toString(!0)}};D=de([Y(0,n.ILogService)],D),e.FileService=D}),define(Z[160],ee([0,1,27,95,2,10,3,6,17,7,14,42,8,18,118,75,136,138,135,149,48,78,19,25]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class r extends O.Disposable{constructor(c,l){var u;super();this.logService=c,this.options=l,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=U.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new U.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new U.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new v.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,A.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(c){try{const{stat:l,symbolicLink:u}=await S.SymlinkSupport.stat(this.toFilePath(c));return{type:this.toType(l,u),ctime:l.birthtime.getTime(),mtime:l.mtime.getTime(),size:l.size}}catch(l){throw this.toFileSystemProviderError(l)}}async readdir(c){try{const l=await(0,S.readdir)(this.toFilePath(c),{withFileTypes:!0}),u=[];return await Promise.all(l.map(async m=>{try{let b;m.isSymbolicLink()?b=(await this.stat((0,n.joinPath)(c,m.name))).type:b=this.toType(m),u.push([m.name,b])}catch(b){this.logService.trace(b)}})),u}catch(l){throw this.toFileSystemProviderError(l)}}toType(c,l){let u;return(l==null?void 0:l.dangling)?u=R.FileType.Unknown:c.isFile()?u=R.FileType.File:c.isDirectory()?u=R.FileType.Directory:u=R.FileType.Unknown,l&&(u|=R.FileType.SymbolicLink),u}async readFile(c){try{const l=this.toFilePath(c);return await p.promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}}readFileStream(c,l,u){const m=(0,a.newWriteableStream)(b=>i.VSBuffer.concat(b.map(h=>i.VSBuffer.wrap(h))).buffer);return(0,s.readFileIntoStream)(this,c,m,b=>b.buffer,Object.assign(Object.assign({},l),{bufferSize:this.BUFFER_SIZE}),u),m}async writeFile(c,l,u){let m;try{const b=this.toFilePath(c);if(!u.create||!u.overwrite){if(await(0,S.exists)(b)){if(!u.overwrite)throw(0,R.createFileSystemProviderError)((0,d.localize)(0,null),R.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,R.createFileSystemProviderError)((0,d.localize)(1,null),R.FileSystemProviderErrorCode.FileNotFound)}m=await this.open(c,{create:!0,unlock:u.unlock}),await this.write(m,0,l,0,l.byteLength)}catch(b){throw await this.toFileSystemProviderWriteError(c,b)}finally{typeof m=="number"&&await this.close(m)}}async open(c,l){try{const u=this.toFilePath(c);if((0,R.isFileOpenForWriteOptions)(l)&&l.unlock)try{const{stat:h}=await S.SymlinkSupport.stat(u);h.mode&128||await p.promises.chmod(u,h.mode|128)}catch(h){this.logService.trace(h)}let m;if((0,R.isFileOpenForWriteOptions)(l)){if(A.isWindows)try{await p.promises.truncate(u,0),m="r+"}catch(h){h.code!=="ENOENT"&&this.logService.trace(h)}m||(m="w")}else m="r";const b=await(0,L.promisify)(p.open)(u,m);return this.mapHandleToPos.set(b,0),(0,R.isFileOpenForWriteOptions)(l)&&this.writeHandles.set(b,c),b}catch(u){throw(0,R.isFileOpenForWriteOptions)(l)?await this.toFileSystemProviderWriteError(c,u):this.toFileSystemProviderError(u)}}async close(c){try{if(this.mapHandleToPos.delete(c),this.writeHandles.delete(c)&&this.canFlush)try{await(0,L.promisify)(p.fdatasync)(c)}catch(l){this.canFlush=!1,this.logService.error(l)}return await(0,L.promisify)(p.close)(c)}catch(l){throw this.toFileSystemProviderError(l)}}async read(c,l,u,m,b){const h=this.normalizePos(c,l);let k=null;try{const _=await(0,L.promisify)(p.read)(c,u,m,b,h);return typeof _=="number"?k=_:k=_.bytesRead,k}catch(_){throw this.toFileSystemProviderError(_)}finally{this.updatePos(c,h,k)}}normalizePos(c,l){return l===this.mapHandleToPos.get(c)?null:l}updatePos(c,l,u){const m=this.mapHandleToPos.get(c);typeof m=="number"&&(typeof l=="number"||(typeof u=="number"?this.mapHandleToPos.set(c,m+u):this.mapHandleToPos.delete(c)))}async write(c,l,u,m,b){return(0,v.retry)(()=>this.doWrite(c,l,u,m,b),100,3)}async doWrite(c,l,u,m,b){const h=this.normalizePos(c,l);let k=null;try{const _=await(0,L.promisify)(p.write)(c,u,m,b,h);return typeof _=="number"?k=_:k=_.bytesWritten,k}catch(_){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(c),_)}finally{this.updatePos(c,h,k)}}async mkdir(c){try{await p.promises.mkdir(this.toFilePath(c))}catch(l){throw this.toFileSystemProviderError(l)}}async delete(c,l){try{const u=this.toFilePath(c);await this.doDelete(u,l)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(c,l){l.recursive?await(0,S.rimraf)(c,S.RimRafMode.MOVE):await p.promises.unlink(c)}async rename(c,l,u){const m=this.toFilePath(c),b=this.toFilePath(l);if(m!==b)try{await this.validateTargetDeleted(c,l,"move",u.overwrite),await(0,S.move)(m,b)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(2,null,(0,y.basename)(m),(0,y.basename)((0,y.dirname)(b)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(c,l,u){const m=this.toFilePath(c),b=this.toFilePath(l);if(m!==b)try{await this.validateTargetDeleted(c,l,"copy",u.overwrite),await(0,S.copy)(m,b,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,d.localize)(3,null,(0,y.basename)(m),(0,y.basename)((0,y.dirname)(b)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(c,l,u,m){const b=this.toFilePath(c),h=this.toFilePath(l);let k=!1;if(!!(this.capabilities&1024)||(k=(0,f.isEqual)(b,h,!0)),k&&u==="copy")throw(0,R.createFileSystemProviderError)((0,d.localize)(4,null),R.FileSystemProviderErrorCode.FileExists);if(!k&&await(0,S.exists)(h)){if(!m)throw(0,R.createFileSystemProviderError)((0,d.localize)(5,null),R.FileSystemProviderErrorCode.FileExists);await this.delete(l,{recursive:!0,useTrash:!1})}}watch(c,l){return l.recursive?this.watchRecursive(c,l.excludes):this.watchNonRecursive(c)}watchRecursive(c,l){const u={path:this.toFilePath(c),excludes:l},m=(0,t.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,O.toDisposable)(()=>{m(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var c,l,u;if(this.recursiveWatcher instanceof D.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,O.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let m,b;((l=(c=this.options)===null||c===void 0?void 0:c.watcher)===null||l===void 0?void 0:l.usePolling)?(m=I.FileWatcher,b=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?A.isWindows?m=E.FileWatcher:m=I.FileWatcher:m=D.FileWatcher,this.recursiveWatcher=new m(this.recursiveFoldersToWatch,h=>this._onDidChangeFile.fire((0,w.toFileChanges)(h)),h=>{h.type==="error"&&this._onDidWatchErrorOccur.fire(h.message),this.logService[h.type](h.message)},this.logService.getLevel()===C.LogLevel.Trace,b),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)}))}}watchNonRecursive(c){const l=new g.FileWatcher(this.toFilePath(c),m=>this._onDidChangeFile.fire((0,w.toFileChanges)(m)),m=>{m.type==="error"&&this._onDidWatchErrorOccur.fire(m.message),this.logService[m.type](m.message)},this.logService.getLevel()===C.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{l.setVerboseLogging(this.logService.getLevel()===C.LogLevel.Trace)});return(0,O.combinedDisposable)(l,u)}toFilePath(c){return(0,y.normalize)(c.fsPath)}toFileSystemProviderError(c){if(c instanceof R.FileSystemProviderError)return c;let l;switch(c.code){case"ENOENT":l=R.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":l=R.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":l=R.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":l=R.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":l=R.FileSystemProviderErrorCode.NoPermissions;break;default:l=R.FileSystemProviderErrorCode.Unknown}return(0,R.createFileSystemProviderError)(c,l)}async toFileSystemProviderWriteError(c,l){let u=this.toFileSystemProviderError(l);if(c&&u.code===R.FileSystemProviderErrorCode.NoPermissions)try{const{stat:m}=await S.SymlinkSupport.stat(this.toFilePath(c));m.mode&128||(u=(0,R.createFileSystemProviderError)(l,R.FileSystemProviderErrorCode.FileWriteLocked))}catch(m){this.logService.trace(m)}return u}dispose(){super.dispose(),(0,O.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,O.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=r}),define(Z[28],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Z[161],ee([0,1,27,7,17,28,2,11,18,9]),function(G,e,p,L,O,R,U,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let n=class extends U.Disposable{constructor(v,C,d){super();this._environmentService=v,this._logService=C,this._productService=d,this._DataMaxAge=this._productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._environmentService.isBuilt&&this._manageCachedDataSoon()}_manageCachedDataSoon(){let v=setTimeout(async()=>{v=void 0,this._logService.info("Starting to clean up unused language packs.");try{const C=Object.create(null),d=JSON.parse(await p.promises.readFile(L.join(this._environmentService.userDataPath,"languagepacks.json"),"utf8"));for(let D of Object.keys(d)){const g=d[D];C[`${g.hash}.${D}`]=!0}const w=L.join(this._environmentService.userDataPath,"clp");if(!await O.exists(w))return;for(let D of await O.readdir(w)){if(C[D]){this._logService.info(`Skipping directory ${D}. Language pack still in use.`);continue}this._logService.info("Removing unused language pack:",D),await O.rimraf(L.join(w,D))}const E=Date.now();for(let D of Object.keys(C)){const g=L.join(w,D);for(let a of await O.readdir(g))if(a!=="tcf.json"){const s=L.join(g,a),t=await p.promises.stat(s);t.isDirectory()&&E-t.mtime.getTime()>this._DataMaxAge&&(this._logService.info("Removing language pack cache entry: ",L.join(D,a)),await O.rimraf(s))}}}catch(C){(0,A.onUnexpectedError)(C)}},40*1e3);this._register((0,U.toDisposable)(()=>{v!==void 0&&clearTimeout(v)}))}};n=de([Y(0,y.INativeEnvironmentService),Y(1,S.ILogService),Y(2,R.IProductService)],n),e.LanguagePackCachedDataCleaner=n}),define(Z[162],ee([0,1,27,7,11,2,17,28]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeCachedDataCleaner=void 0;let S=class{constructor(n,f){this.nodeCachedDataDir=n,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this._disposables=new R.DisposableStore,this._manageCachedDataSoon()}dispose(){this._disposables.dispose()}_manageCachedDataSoon(){if(!!this.nodeCachedDataDir){const n=(0,L.dirname)(this.nodeCachedDataDir),f=(0,L.basename)(this.nodeCachedDataDir);let v=setTimeout(()=>{v=void 0,(0,U.readdir)(n).then(C=>{const d=Date.now(),w=[];return C.forEach(I=>{if(I!==f){const E=(0,L.join)(n,I);w.push(p.promises.stat(E).then(D=>{if(D.isDirectory()&&d-D.mtime.getTime()>this._DataMaxAge)return(0,U.rimraf)(E)}))}}),Promise.all(w)}).then(void 0,O.onUnexpectedError)},30*1e3);this._disposables.add((0,R.toDisposable)(()=>{v&&(clearTimeout(v),v=void 0)}))}}};S=de([Y(1,A.IProductService)],S),e.NodeCachedDataCleaner=S}),define(Z[32],ee([0,1,15,86]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class O{constructor(){this.data=new Map}add(U,A){L.ok(p.isString(U)),L.ok(p.isObject(A)),L.ok(!this.data.has(U),"There is already an extension with this id"),this.data.set(U,A)}knows(U){return this.data.has(U)}as(U){return this.data.get(U)||null}}e.Registry=new O}),define(Z[79],ee([0,1,32,3]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function O(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this._onDidChangeSchema=new L.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(S,y){this.schemasById[O(S)]=y,this._onDidChangeSchema.fire(S)}notifySchemaChanged(S){this._onDidChangeSchema.fire(S)}getSchemaContributions(){return{schemas:this.schemasById}}}const U=new R;p.Registry.add(e.Extensions.JSONContribution,U)}),define(Z[38],ee([0,1,108,3,32,15,79]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var A;(function(I){I[I.APPLICATION=1]="APPLICATION",I[I.MACHINE=2]="MACHINE",I[I.WINDOW=3]="WINDOW",I[I.RESOURCE=4]="RESOURCE",I[I.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",I[I.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const S=O.Registry.as(U.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:p.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(E,D=!0){this.registerConfigurations([E],D)}registerConfigurations(E,D=!0){const g=[];E.forEach(a=>{g.push(...this.validateAndRegisterProperties(a,D,a.extensionInfo)),this.configurationContributors.push(a),this.registerJSONConfiguration(a)}),S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(E){const D=[],g=a=>{if(a.properties)for(const s in a.properties)D.push(s),delete this.configurationProperties[s],this.removeFromSchema(s,a.properties[s]);a.allOf&&a.allOf.forEach(s=>g(s))};for(const a of E){g(a);const s=this.configurationContributors.indexOf(a);s!==-1&&this.configurationContributors.splice(s,1)}S.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}registerDefaultConfigurations(E){const D=[],g=[];for(const a of E)for(const s in a)if(D.push(s),e.OVERRIDE_PROPERTY_PATTERN.test(s)){this.defaultValues[s]=Object.assign(Object.assign({},this.defaultValues[s]||{}),a[s]);const t={type:"object",default:this.defaultValues[s],description:p.localize(1,null,s),$ref:e.resourceLanguageSettingsSchemaId};g.push(f(s)),this.configurationProperties[s]=t,this.defaultLanguageConfigurationOverridesNode.properties[s]=t}else{this.defaultValues[s]=a[s];const t=this.configurationProperties[s];t&&(this.updatePropertyDefaultValue(s,t),this.updateSchema(s,t))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}deregisterDefaultConfigurations(E){const D=[];for(const g of E)for(const a in g)if(D.push(a),delete this.defaultValues[a],e.OVERRIDE_PROPERTY_PATTERN.test(a))delete this.configurationProperties[a],delete this.defaultLanguageConfigurationOverridesNode.properties[a];else{const s=this.configurationProperties[a];s&&(this.updatePropertyDefaultValue(a,s),this.updateSchema(a,s))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(D)}notifyConfigurationSchemaUpdated(...E){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(E){for(const D of E)this.overrideIdentifiers.add(D);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(E,D=!0,g,a=3){var s;a=R.isUndefinedOrNull(E.scope)?a:E.scope;let t=[],i=E.properties;if(i)for(let o in i){if(D&&d(o)){delete i[o];continue}const c=i[o];if(this.updatePropertyDefaultValue(o,c),e.OVERRIDE_PROPERTY_PATTERN.test(o)?c.scope=void 0:(c.scope=R.isUndefinedOrNull(c.scope)?a:c.scope,c.restricted=R.isUndefinedOrNull(c.restricted)?!!((s=g==null?void 0:g.restrictedConfigurations)===null||s===void 0?void 0:s.includes(o)):c.restricted),i[o].hasOwnProperty("included")&&!i[o].included){this.excludedConfigurationProperties[o]=i[o],delete i[o];continue}else this.configurationProperties[o]=i[o];!i[o].deprecationMessage&&i[o].markdownDeprecationMessage&&(i[o].deprecationMessage=i[o].markdownDeprecationMessage),t.push(o)}let r=E.allOf;if(r)for(let o of r)t.push(...this.validateAndRegisterProperties(o,D,g,a));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(E){const D=g=>{let a=g.properties;if(a)for(const t in a)this.updateSchema(t,a[t]);let s=g.allOf;s&&s.forEach(D)};D(E)}updateSchema(E,D){switch(e.allSettings.properties[E]=D,D.scope){case 1:e.applicationSettings.properties[E]=D;break;case 2:e.machineSettings.properties[E]=D;break;case 6:e.machineOverridableSettings.properties[E]=D;break;case 3:e.windowSettings.properties[E]=D;break;case 4:e.resourceSettings.properties[E]=D;break;case 5:e.resourceSettings.properties[E]=D,this.resourceLanguageSettingsSchema.properties[E]=D;break}}removeFromSchema(E,D){switch(delete e.allSettings.properties[E],D.scope){case 1:delete e.applicationSettings.properties[E];break;case 2:delete e.machineSettings.properties[E];break;case 6:delete e.machineOverridableSettings.properties[E];break;case 3:delete e.windowSettings.properties[E];break;case 4:case 5:delete e.resourceSettings.properties[E];break}}updateOverridePropertyPatternKey(){for(const E of this.overrideIdentifiers.values()){const D=`[${E}]`,g={type:"object",description:p.localize(2,null),errorMessage:p.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(D,g),e.allSettings.properties[D]=g,e.applicationSettings.properties[D]=g,e.machineSettings.properties[D]=g,e.machineOverridableSettings.properties[D]=g,e.windowSettings.properties[D]=g,e.resourceSettings.properties[D]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(E,D){let g=this.defaultValues[E];R.isUndefined(g)&&(g=D.default),R.isUndefined(g)&&(g=v(D.type)),D.default=g}}const n="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(n);function f(I){return I.substring(1,I.length-1)}e.overrideIdentifierFromKey=f;function v(I){switch(Array.isArray(I)?I[0]:I){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=v;const C=new y;O.Registry.add(e.Extensions.Configuration,C);function d(I){return I.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(I)?p.localize(5,null,I):C.getConfigurationProperties()[I]!==void 0?p.localize(6,null,I):null:p.localize(4,null)}e.validateProperty=d;function w(){const I=[],E=C.getConfigurationProperties();for(const D of Object.keys(E))I.push([D,E[D].scope]);return I.push(["launch",4]),I.push(["task",4]),I}e.getScopes=w}),define(Z[23],ee([0,1,26,15,5,32,4,38]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,U.createDecorator)("configurationService");function S(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof O.URI)}e.isConfigurationOverrides=S;var y;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function n(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=n;function f(i,r){const o=r?i?r.keys.filter(k=>i.keys.indexOf(k)===-1):[...r.keys]:[],c=i?r?i.keys.filter(k=>r.keys.indexOf(k)===-1):[...i.keys]:[],l=[];if(r&&i){for(const k of i.keys)if(r.keys.indexOf(k)!==-1){const _=E(i.contents,k),j=E(r.contents,k);p.equals(_,j)||l.push(k)}}const u=[],m=k=>{const _={};for(const j of k)for(const q of j.identifiers)_[s(q)]=j;return _},b=r?m(r.overrides):{},h=i?m(i.overrides):{};if(Object.keys(b).length)for(const k of o){const _=b[k];_&&u.push([(0,A.overrideIdentifierFromKey)(k),_.keys])}if(Object.keys(h).length)for(const k of c){const _=h[k];_&&u.push([(0,A.overrideIdentifierFromKey)(k),_.keys])}if(Object.keys(b).length&&Object.keys(h).length)for(const k of l){const _=h[k],j=b[k];if(_&&j){const q=f({contents:_.contents,keys:_.keys,overrides:[]},{contents:j.contents,keys:j.keys,overrides:[]});u.push([(0,A.overrideIdentifierFromKey)(k),[...q.added,...q.removed,...q.updated]])}}return{added:o,removed:c,updated:l,overrides:u}}e.compare=f;function v(i,r){const o=[];for(const c of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(c)){const l={};for(const u in i[c])l[u]=i[c][u];o.push({identifiers:[(0,A.overrideIdentifierFromKey)(c).trim()],keys:Object.keys(l),contents:C(l,r)})}return o}e.toOverrides=v;function C(i,r){const o=Object.create(null);for(let c in i)d(o,c,i[c],r);return o}e.toValuesTree=C;function d(i,r,o,c){const l=r.split("."),u=l.pop();let m=i;for(let b=0;b<l.length;b++){let h=l[b],k=m[h];switch(typeof k){case"undefined":k=m[h]=Object.create(null);break;case"object":break;default:c(`Ignoring ${r} as ${l.slice(0,b+1).join(".")} is ${JSON.stringify(k)}`);return}m=k}if(typeof m=="object"&&m!==null)try{m[u]=o}catch(b){c(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}else c(`Ignoring ${r} as ${l.join(".")} is ${JSON.stringify(m)}`)}e.addToValueTree=d;function w(i,r){const o=r.split(".");I(i,o)}e.removeFromValueTree=w;function I(i,r){const o=r.shift();if(r.length===0){delete i[o];return}if(Object.keys(i).indexOf(o)!==-1){const c=i[o];typeof c=="object"&&!Array.isArray(c)&&(I(c,r),Object.keys(c).length===0&&delete i[o])}}function E(i,r,o){function c(m,b){let h=m;for(const k of b){if(typeof h!="object"||h===null)return;h=h[k]}return h}const l=r.split("."),u=c(i,l);return typeof u=="undefined"?o:u}e.getConfigurationValue=E;function D(i,r,o){Object.keys(r).forEach(c=>{c!=="__proto__"&&(c in i?L.isObject(i[c])&&L.isObject(r[c])?D(i[c],r[c],o):o&&(i[c]=r[c]):i[c]=r[c])})}e.merge=D;function g(){const i=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=g;function a(){const i=Object.create(null),r=R.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let o in r){let c=r[o].default;d(i,o,c,l=>console.error(`Conflict in default settings: ${l}`))}return i}e.getDefaultValues=a;function s(i){return`[${i}]`}e.keyFromOverrideIdentifier=s;function t(i,r,o){const c=i.inspect(r),l=i.inspect(o);return typeof c.userValue!="undefined"||typeof c.workspaceValue!="undefined"||typeof c.workspaceFolderValue!="undefined"?c.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:c.defaultValue}e.getMigratedSettingValue=t}),define(Z[163],ee([0,1,33,39,19,15,26,5,38,23,32,2,3]),function(G,e,p,L,O,R,U,A,S,y,n,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class C{constructor(t={},i=[],r=[]){this._contents=t,this._keys=i,this._overrides=r,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?(0,y.getConfigurationValue)(this.contents,t):this.contents}getOverrideValue(t,i){const r=this.getContentsForOverrideIdentifer(i);return r?t?(0,y.getConfigurationValue)(r,t):r:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let r={};for(const o of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o],l=i[o];l&&(typeof c=="object"&&typeof l=="object"?(c=U.deepClone(c),this.mergeContents(c,l)):c=l),r[o]=c}return new C(r,this.keys,this.overrides)}merge(...t){const i=U.deepClone(this.contents),r=U.deepClone(this.overrides),o=[...this.keys];for(const c of t){this.mergeContents(i,c.contents);for(const l of c.overrides){const[u]=r.filter(m=>O.equals(m.identifiers,l.identifiers));u?this.mergeContents(u.contents,l.contents):r.push(U.deepClone(l))}for(const l of c.keys)o.indexOf(l)===-1&&o.push(l)}return new C(i,o,r)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const r of Object.keys(i)){if(r in t&&R.isObject(t[r])&&R.isObject(i[r])){this.mergeContents(t[r],i[r]);continue}t[r]=U.deepClone(i[r])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?U.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),(0,y.addToValueTree)(this.contents,t,i,r=>{throw new Error(r)})}removeValue(t){this.removeKey(t)&&(0,y.removeFromValueTree)(this.contents,t)}addKey(t){let i=this.keys.length;for(let r=0;r<i;r++)t.indexOf(this.keys[r])===0&&(i=r);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=C;class d extends C{constructor(){const t=(0,y.getDefaultValues)(),i=(0,y.getConfigurationKeys)(),r=[];for(const o of Object.keys(t))S.OVERRIDE_PROPERTY_PATTERN.test(o)&&r.push({identifiers:[(0,S.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(t[o]),contents:(0,y.toValuesTree)(t[o],c=>console.error(`Conflict in default settings file: ${c}`))});super(t,i,r)}}e.DefaultConfigurationModel=d;class w{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new C}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!R.isUndefinedOrNull(t)){const r=this.doParseContent(t);this.parseRaw(r,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:r,keys:o,overrides:c,restricted:l}=this.doParseRaw(t,i);this._configurationModel=new C(r,o,c),this._restrictedConfigurations=l||[]}doParseContent(t){let i={},r=null,o=[],c=[],l=[];function u(b){Array.isArray(o)?o.push(b):r&&(o[r]=b)}let m={onObjectBegin:()=>{let b={};u(b),c.push(o),o=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{let b=[];u(b),c.push(o),o=b,r=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:u,onError:(b,h,k)=>{l.push({error:b,offset:h,length:k})}};if(t)try{p.visit(t,m),i=o[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return i}doParseRaw(t,i){const r=n.Registry.as(S.Extensions.Configuration).getConfigurationProperties(),o=this.filter(t,r,!0,i);t=o.raw;const c=(0,y.toValuesTree)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),l=Object.keys(t),u=(0,y.toOverrides)(t,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:c,keys:l,overrides:u,restricted:o.restricted}}filter(t,i,r,o){if(!(o==null?void 0:o.scopes)&&!(o==null?void 0:o.skipRestricted))return{raw:t,restricted:[]};const c={},l=[];for(let u in t)if(S.OVERRIDE_PROPERTY_PATTERN.test(u)&&r){const m=this.filter(t[u],i,!1,o);c[u]=m.raw,l.push(...m.restricted)}else{const m=i[u],b=m?typeof m.scope!="undefined"?m.scope:3:void 0;(m==null?void 0:m.restricted)&&l.push(u),(b===void 0||o.scopes===void 0||o.scopes.includes(b))&&(o.skipRestricted&&(m==null?void 0:m.restricted)||(c[u]=t[u]))}return{raw:c,restricted:l}}}e.ConfigurationModelParser=w;class I extends f.Disposable{constructor(t,i,r,o){super();this.userSettingsResource=t,this.scopes=i,this.fileService=o,this._onDidChange=this._register(new v.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new w(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(v.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new C}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=I;class E{constructor(t,i,r=new C,o=new C,c=new L.ResourceMap,l=new C,u=new L.ResourceMap,m=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=r,this._workspaceConfiguration=o,this._folderConfigurations=c,this._memoryConfiguration=l,this._memoryConfigurationByResource=u,this._freeze=m,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new L.ResourceMap,this._userConfiguration=null}getValue(t,i,r){return this.getConsolidateConfigurationModel(i,r).getValue(t)}updateValue(t,i,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new C,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,i===void 0?o.removeValue(t):o.setValue(t,i),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,r){const o=this.getConsolidateConfigurationModel(i,r),c=this.getFolderConfigurationModelForResource(i.resource,r),l=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,u=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),m=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),b=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),h=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),k=r?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,_=c?i.overrideIdentifier?c.freeze().override(i.overrideIdentifier).getValue(t):c.freeze().getValue(t):void 0,j=i.overrideIdentifier?l.override(i.overrideIdentifier).getValue(t):l.getValue(t),q=o.getValue(t),K=O.distinct(O.flatten(o.overrides.map(M=>M.identifiers))).filter(M=>o.getOverrideValue(t,M)!==void 0);return{defaultValue:u,userValue:m,userLocalValue:b,userRemoteValue:h,workspaceValue:k,workspaceFolderValue:_,memoryValue:j,value:q,default:u!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:m!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:h!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:k!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:_!==void 0?{value:c==null?void 0:c.freeze().getValue(t),override:i.overrideIdentifier?c==null?void 0:c.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:j!==void 0?{value:l.getValue(t),override:i.overrideIdentifier?l.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const r=i.filter(o=>S.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const c=(0,S.overrideIdentifierFromKey)(o),l=this._defaultConfiguration.getKeysForOverrideIdentifier(c),u=t.getKeysForOverrideIdentifier(c),m=[...u.filter(b=>l.indexOf(b)===-1),...l.filter(b=>u.indexOf(b)===-1),...l.filter(b=>!U.equals(this._defaultConfiguration.override(c).getValue(b),t.override(c).getValue(b)))];return[c,m]});return this.updateDefaultConfiguration(t),{keys:i,overrides:r}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=(0,y.compare)(this.localUserConfiguration,t),l=[...i,...r,...o];return l.length&&this.updateLocalUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=(0,y.compare)(this.remoteUserConfiguration,t);let l=[...i,...r,...o];return l.length&&this.updateRemoteUserConfiguration(t),{keys:l,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:r,removed:o,overrides:c}=(0,y.compare)(this.workspaceConfiguration,t);let l=[...i,...r,...o];return l.length&&this.updateWorkspaceConfiguration(t),{keys:l,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const r=this.folderConfigurations.get(t),{added:o,updated:c,removed:l,overrides:u}=(0,y.compare)(r,i);let m=[...o,...c,...l];return(m.length||!r)&&this.updateFolderConfiguration(t,i),{keys:m,overrides:u}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:r,updated:o,removed:c,overrides:l}=(0,y.compare)(i,void 0);return{keys:[...r,...o,...c],overrides:l}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let r=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?r.override(t.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:t},i){let r=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const o=i.getFolder(t);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const c=this._memoryConfigurationByResource.get(t);c&&(r=r.merge(c))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(t);o?(i=r.merge(o),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=r}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const r=i.getFolder(t);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:r,overrides:o,keys:c}=this._folderConfigurations.get(i);return t.push([i,{contents:r,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(r=>t.add(r))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(r=>i.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),r=this.parseConfigurationModel(t.user),o=this.parseConfigurationModel(t.workspace),c=t.folders.reduce((l,u)=>(l.set(A.URI.revive(u[0]),this.parseConfigurationModel(u[1])),l),new L.ResourceMap);return new E(i,r,new C,o,c,new C,new L.ResourceMap,!1)}static parseConfigurationModel(t){return new C(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=E;function D(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const t=new Set,i=new Map;for(const o of s)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,l])=>{const u=(0,L.getOrSet)(i,c,new Set);l.forEach(m=>u.add(m))});const r=[];return i.forEach((o,c)=>r.push([c,[...o.values()]])),{keys:[...t.values()],overrides:r}}e.mergeChanges=D;class g{constructor(t,i,r,o){this.change=t,this.previous=i,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;t.keys.forEach(u=>c.add(u)),t.overrides.forEach(([,u])=>u.forEach(m=>c.add(m))),this.affectedKeys=[...c.values()];const l=new C;this.affectedKeys.forEach(u=>l.setValue(u,{})),this.affectedKeysTree=l.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=E.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var r;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const o=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(r=this.previous)===null||r===void 0?void 0:r.workspace):void 0,c=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!U.equals(o,c)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let r=(0,y.toValuesTree)({[i]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(t=t[o],!t)return!1;r=r[o]}return!0}}e.ConfigurationChangeEvent=g;class a extends g{constructor(t,i,r,o){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=r,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=a}),define(Z[164],ee([0,1,32,38,2,23,163,3,8,14]),function(G,e,p,L,O,R,U,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class n extends O.Disposable{constructor(v,C){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new A.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new U.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,C)),this.configuration=new U.Configuration(new U.DefaultConfigurationModel,new U.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new S.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(p.Registry.as(L.Extensions.Configuration).onDidUpdateConfiguration(d=>this.onDidDefaultConfigurationChange(d))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const v=await this.userConfiguration.loadConfiguration();this.configuration=new U.Configuration(new U.DefaultConfigurationModel,v)}getConfigurationData(){return this.configuration.toData()}getValue(v,C){const d=typeof v=="string"?v:void 0,w=(0,R.isConfigurationOverrides)(v)?v:(0,R.isConfigurationOverrides)(C)?C:{};return this.configuration.getValue(d,w,void 0)}updateValue(v,C,d,w){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const C=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(d,C,1)}onDidDefaultConfigurationChange(v){const C=this.configuration.toData(),d=this.configuration.compareAndUpdateDefaultConfiguration(new U.DefaultConfigurationModel,v);this.trigger(d,C,6)}trigger(v,C,d){const w=new U.ConfigurationChangeEvent(v,{data:C},this.configuration);w.source=d,w.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(w)}getTargetConfiguration(v){switch(v){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=n}),define(Z[165],ee([0,1,23,18,102]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let R=class{constructor(A,S){this.configurationService=A,this.logService=S}request(A,S){return this.logService.trace("RequestService#request",A.url),A.proxyAuthorization||(A.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization")),(0,O.request)(A,S)}async resolveProxy(A){}};R=de([Y(0,p.IConfigurationService),Y(1,L.ILogService)],R),e.RequestService=R}),define(Z[40],ee([0,1,119,4,38,32,25]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function A(d){return d.res.statusCode&&d.res.statusCode>=200&&d.res.statusCode<300||d.res.statusCode===1223}e.isSuccess=A;function S(d){return d.res.statusCode===204}async function y(d){if(!A(d))throw new Error("Server returned "+d.res.statusCode);return S(d)?null:(await(0,U.streamToBuffer)(d.stream)).toString()}e.asText=y;async function n(d){if(!A(d))throw new Error("Server returned "+d.res.statusCode);if(S(d))return null;const I=(await(0,U.streamToBuffer)(d.stream)).toString();try{return JSON.parse(I)}catch(E){throw E.message+=`:
`+I,E}}e.asJson=n;function f(d){C(d)}e.updateProxyConfigurationsScope=f;let v;function C(d){const w=R.Registry.as(O.Extensions.Configuration);v&&w.deregisterConfigurations([v]),v={id:"http",order:15,title:(0,p.localize)(0,null),type:"object",scope:d,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,p.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,p.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,p.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,p.localize)(4,null),(0,p.localize)(5,null),(0,p.localize)(6,null),(0,p.localize)(7,null)],default:"override",description:(0,p.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,p.localize)(9,null),restricted:!0}}},w.registerConfiguration(v)}C(2)}),define(Z[166],ee([0,1,40,30,10,16]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let U=class{constructor(S,y){this.requestService=S,this.fileService=y}async download(S,y,n=L.CancellationToken.None){if(S.scheme===R.Schemas.file||S.scheme===R.Schemas.vscodeRemote){await this.fileService.copy(S,y);return}const f={type:"GET",url:S.toString()},v=await this.requestService.request(f,n);if(v.res.statusCode===200)await this.fileService.writeFile(y,v.stream);else{const C=await(0,p.asText)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${C}`)}}};U=de([Y(0,p.IRequestService),Y(1,O.IFileService)],U),e.DownloadService=U}),define(Z[167],ee([0,1,28,10,19,63,40,30,18,14,131,2]),function(G,e,p,L,O,R,U,A,S,y,n,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let v=class extends f.Disposable{constructor(d,w,I,E){super();this.fileService=d,this.productService=w,this.requestService=I,this.logService=E,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&(0,R.forEach)(this.productService.configBasedExtensionTips,({value:D})=>this.allConfigBasedTips.set(D.configPath,D))}getConfigBasedTips(d){return this.getValidConfigBasedTips(d)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(d){const w=[];for(const[I,E]of this.allConfigBasedTips)try{const D=await this.fileService.readFile((0,y.joinPath)(d,I)),g=new Map;(0,R.forEach)(E.recommendations,({key:s,value:t})=>{if((0,O.isNonEmptyArray)(t.remotes))for(const i of t.remotes)g.set(i,{extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack});else w.push({extensionId:s,extensionName:t.name,configName:E.configName,important:!!t.important,isExtensionPack:!!t.isExtensionPack})});const a=(0,n.getDomainsOfRemotes)(D.value.toString(),[...g.keys()]);for(const s of a){const t=g.get(s);t&&w.push(t)}}catch(D){}return w}async fetchWorkspacesTips(){var d,w;if(!((d=this.productService.extensionsGallery)===null||d===void 0?void 0:d.recommendationsUrl))return[];try{const I=await this.requestService.request({type:"GET",url:(w=this.productService.extensionsGallery)===null||w===void 0?void 0:w.recommendationsUrl},A.CancellationToken.None);if(I.res.statusCode!==200)return[];const E=await(0,U.asJson)(I);return E?E.workspaceRecommendations||[]:[]}catch(I){return this.logService.error(I),[]}}};v=de([Y(0,L.IFileService),Y(1,p.IProductService),Y(2,U.IRequestService),Y(3,S.ILogService)],v),e.ExtensionTipsService=v}),define(Z[45],ee([0,1,31,25]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function O(R,U,A){let S=A&&A.get("storage.serviceMachineId",0)||null;if(S)return S;try{const n=(await U.readFile(R.serviceMachineIdResource)).value.toString();S=(0,p.isUUID)(n)?n:null}catch(y){S=null}if(!S){S=(0,p.generateUuid)();try{await U.writeFile(R.serviceMachineIdResource,L.VSBuffer.fromString(S))}catch(y){}}return A&&A.store("storage.serviceMachineId",S,0,1),S}e.getServiceMachineId=O}),define(Z[20],ee([0,1,4,3,2,15,69,8]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const S="__$__targetStorageMarker";e.IStorageService=(0,p.createDecorator)("storageService");var y;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var n;(function(w){w[w.GLOBAL=0]="GLOBAL",w[w.WORKSPACE=1]="WORKSPACE"})(n=e.StorageScope||(e.StorageScope={}));var f;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class v extends O.Disposable{constructor(I={flushInterval:v.DEFAULT_FLUSH_INTERVAL}){super();this.options=I,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new A.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new O.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,A.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,O.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(I,E){E===S?(I===0?this._globalKeyTargets=void 0:I===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:I})):this._onDidChangeValue.fire({scope:I,key:E,target:this.getKeyTargets(I)[E]})}emitWillSaveState(I){this._onWillSaveState.fire({reason:I})}get(I,E,D){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.get(I,D)}getBoolean(I,E,D){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.getBoolean(I,D)}getNumber(I,E,D){var g;return(g=this.getStorage(E))===null||g===void 0?void 0:g.getNumber(I,D)}store(I,E,D,g){if((0,R.isUndefinedOrNull)(E)){this.remove(I,D);return}this.withPausedEmitters(()=>{var a;this.updateKeyTarget(I,D,g),(a=this.getStorage(D))===null||a===void 0||a.set(I,E)})}remove(I,E){this.withPausedEmitters(()=>{var D;this.updateKeyTarget(I,E,void 0),(D=this.getStorage(E))===null||D===void 0||D.delete(I)})}withPausedEmitters(I){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{I()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(I,E){const D=[],g=this.getKeyTargets(I);for(const a of Object.keys(g))g[a]===E&&D.push(a);return D}updateKeyTarget(I,E,D){var g,a;const s=this.getKeyTargets(E);typeof D=="number"?s[I]!==D&&(s[I]=D,(g=this.getStorage(E))===null||g===void 0||g.set(S,JSON.stringify(s))):typeof s[I]=="number"&&(delete s[I],(a=this.getStorage(E))===null||a===void 0||a.set(S,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(I){return I===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(I){const E=this.get(S,I);if(E)try{return JSON.parse(E)}catch(D){}return Object.create(null)}isNew(I){return this.getBoolean(e.IS_NEW_KEY,I)===!0}async flush(){var I,E,D,g;this._onWillSaveState.fire({reason:y.NONE}),await A.Promises.settled([(E=(I=this.getStorage(0))===null||I===void 0?void 0:I.whenFlushed())!==null&&E!==void 0?E:Promise.resolve(),(g=(D=this.getStorage(1))===null||D===void 0?void 0:D.whenFlushed())!==null&&g!==void 0?g:Promise.resolve()])}async logStorage(){var I,E,D,g,a,s;const t=(E=(I=this.getStorage(0))===null||I===void 0?void 0:I.items)!==null&&E!==void 0?E:new Map,i=(g=(D=this.getStorage(1))===null||D===void 0?void 0:D.items)!==null&&g!==void 0?g:new Map;return d(t,i,(a=this.getLogDetails(0))!==null&&a!==void 0?a:"",(s=this.getLogDetails(1))!==null&&s!==void 0?s:"")}}e.AbstractStorageService=v,v.DEFAULT_FLUSH_INTERVAL=60*1e3;class C extends v{constructor(){super();this.globalStorage=new U.Storage(new U.InMemoryStorageDatabase),this.workspaceStorage=new U.Storage(new U.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(I=>this.emitDidChangeValue(1,I))),this._register(this.globalStorage.onDidChangeStorage(I=>this.emitDidChangeValue(0,I)))}getStorage(I){return I===0?this.globalStorage:this.workspaceStorage}getLogDetails(I){return I===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(I){}}e.InMemoryStorageService=C;async function d(w,I,E,D){const g=c=>{try{return JSON.parse(c)}catch(l){return c}},a=new Map,s=new Map;w.forEach((c,l)=>{a.set(l,c),s.set(l,g(c))});const t=new Map,i=new Map;I.forEach((c,l)=>{t.set(l,c),i.set(l,g(c))}),console.group(`Storage: Global (path: ${E})`);let r=[];a.forEach((c,l)=>{r.push({key:l,value:c})}),console.table(r),console.groupEnd(),console.log(s),console.group(`Storage: Workspace (path: ${D})`);let o=[];t.forEach((c,l)=>{o.push({key:l,value:c})}),console.table(o),console.groupEnd(),console.log(i)}e.logStorage=d}),define(Z[168],ee([0,1,3,2,29,34,20,15]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let S=class extends L.Disposable{constructor(f){super();this._onDidChangeEnablement=new p.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new y(f)),this._register(this.storageManger.onDidChange(v=>this._onDidChangeEnablement.fire({extensions:v,source:"storage"})))}async enableExtension(f,v){return this._removeFromDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:v}),!0):!1}async disableExtension(f,v){return this._addToDisabledExtensions(f)?(this._onDidChangeEnablement.fire({extensions:[f],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(f){let v=this.getDisabledExtensions();return v.every(C=>!(0,R.areSameExtensions)(C,f))?(v.push(f),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(f){let v=this.getDisabledExtensions();for(let C=0;C<v.length;C++){const d=v[C];if((0,R.areSameExtensions)(d,f))return v.splice(C,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(f){this._setExtensions(O.DISABLED_EXTENSIONS_STORAGE_PATH,f)}_getExtensions(f){return this.storageManger.get(f,0)}_setExtensions(f,v){this.storageManger.set(f,v,0)}};S=de([Y(0,U.IStorageService)],S),e.GlobalExtensionEnablementService=S;class y extends L.Disposable{constructor(f){super();this.storageService=f,this.storage=Object.create(null),this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._register(f.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(f,v){let C;return v===0?((0,A.isUndefinedOrNull)(this.storage[f])&&(this.storage[f]=this._get(f,v)),C=this.storage[f]):C=this._get(f,v),JSON.parse(C)}set(f,v,C){let d=JSON.stringify(v.map(({id:I,uuid:E})=>({id:I,uuid:E})));this._get(f,C)!==d&&(C===0&&(v.length?this.storage[f]=d:delete this.storage[f]),this._set(f,v.length?d:void 0,C))}onDidStorageChange(f){if(f.scope===0&&!(0,A.isUndefinedOrNull)(this.storage[f.key])&&this._get(f.key,f.scope)!==this.storage[f.key]){const C=this.get(f.key,f.scope);delete this.storage[f.key];const d=this.get(f.key,f.scope),w=C.filter(E=>!d.some(D=>(0,R.areSameExtensions)(E,D))),I=d.filter(E=>!C.some(D=>(0,R.areSameExtensions)(D,E)));(w.length||I.length)&&this._onDidChange.fire([...w,...I])}}_get(f,v){return this.storageService.get(f,v,"[]")}_set(f,v,C){v?this.storageService.store(f,v,C,1):this.storageService.remove(f,C)}}e.StorageManager=y}),define(Z[169],ee([0,1,3,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannelClient=void 0;class O extends L.Disposable{constructor(y,n){super();this.channel=y,this.workspace=n}async getItems(){const y={workspace:this.workspace},n=await this.channel.call("getItems",y);return new Map(n)}updateItems(y){const n={workspace:this.workspace};return y.insert&&(n.insert=Array.from(y.insert.entries())),y.delete&&(n.delete=Array.from(y.delete.values())),this.channel.call("updateItems",n)}}class R extends O{constructor(y){super(y,void 0);this._onDidChangeItemsExternal=this._register(new p.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeGlobalStorage")(y=>this.onDidChangeGlobalStorage(y)))}onDidChangeGlobalStorage(y){(Array.isArray(y.changed)||Array.isArray(y.deleted))&&this._onDidChangeItemsExternal.fire({changed:y.changed?new Map(y.changed):void 0,deleted:y.deleted?new Set(y.deleted):void 0})}async close(){this.dispose()}}class U extends O{constructor(y,n){super(y,n);this.onDidChangeItemsExternal=p.Event.None}async close(){const y={workspace:this.workspace};return this.channel.call("close",y)}}class A extends L.Disposable{constructor(y,n){super();this.channel=y,this.workspace=n,this._globalStorage=void 0,this._workspaceStorage=void 0}get globalStorage(){return this._globalStorage||(this._globalStorage=new R(this.channel)),this._globalStorage}get workspaceStorage(){return!this._workspaceStorage&&this.workspace&&(this._workspaceStorage=new U(this.channel,this.workspace)),this._workspaceStorage}}e.StorageDatabaseChannelClient=A}),define(Z[170],ee([0,1,2,20,69,8,159,169,14]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class y extends L.AbstractStorageService{constructor(f,v,C){super();this.mainProcessService=v,this.environmentService=C,this.workspaceStorage=void 0,this.workspaceStorageId=void 0,this.workspaceStorageDisposable=this._register(new p.MutableDisposable),this.globalStorage=this.createGlobalStorage(),this.workspaceStorage=this.createWorkspaceStorage(f)}createGlobalStorage(){const f=new A.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),void 0),v=new O.Storage(f.globalStorage);return this._register(v.onDidChangeStorage(C=>this.emitDidChangeValue(0,C))),v}createWorkspaceStorage(f){const v=new A.StorageDatabaseChannelClient(this.mainProcessService.getChannel("storage"),f);if(v.workspaceStorage){const C=new O.Storage(v.workspaceStorage);return this.workspaceStorageDisposable.value=C.onDidChangeStorage(d=>this.emitDidChangeValue(1,d)),this.workspaceStorageId=f==null?void 0:f.id,C}else{this.workspaceStorageDisposable.clear(),this.workspaceStorageId=void 0;return}}async doInitialize(){var f,v;(0,U.mark)("code/willInitStorage");try{await R.Promises.settled([this.globalStorage.init(),(v=(f=this.workspaceStorage)===null||f===void 0?void 0:f.init())!==null&&v!==void 0?v:Promise.resolve()])}finally{(0,U.mark)("code/didInitStorage")}}getStorage(f){return f===0?this.globalStorage:this.workspaceStorage}getLogDetails(f){return f===0?this.environmentService.globalStorageHome.fsPath:this.workspaceStorageId?`${(0,S.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}async close(){var f,v;this.stopFlushWhenIdle(),this.emitWillSaveState(L.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.globalStorage.close(),(v=(f=this.workspaceStorage)===null||f===void 0?void 0:f.close())!==null&&v!==void 0?v:Promise.resolve()])}async migrate(f){var v;const C=this.workspaceStorage,d=(v=C==null?void 0:C.items)!==null&&v!==void 0?v:new Map;C&&(await C.close(),C.dispose()),this.workspaceStorage=this.createWorkspaceStorage(f),await this.workspaceStorage.init();for(const[w,I]of d)this.workspaceStorage.set(w,I)}}e.NativeStorageService=y}),define(Z[171],ee([0,1,6,35,31,5]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function U(y){if(p.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function A(y,n,f,v,C,d,w,I,E,D){const g=Object.create(null);g["common.machineId"]=w,g.sessionID=(0,O.generateUuid)()+Date.now(),g.commitHash=C,g.version=d,g["common.platformVersion"]=(n||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,p.PlatformToString)(p.platform),g["common.nodePlatform"]=L.platform,g["common.nodeArch"]=v,g["common.product"]=D||"desktop";const a=S(I||[]);a&&(g["common.msftInternal"]=a);let s=0;const t=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>s++,enumerable:!0}}),p.isLinuxSnap&&(g["common.snap"]="true");const i=U(f);i&&(g["common.platformDetail"]=i);try{const r=await y.readFile(R.URI.file(E));g["common.source"]=r.value.toString().slice(0,30)}catch(r){}return g}e.resolveCommonProperties=A;function S(y){const n=L.env.USERDNSDOMAIN;if(!n)return!1;const f=n.toLowerCase();return y.some(v=>f===v)}e.verifyMicrosoftInternalDomain=S}),define(Z[24],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(Z[172],ee([0,1,36,93,71,27,7,33,97,28,6,5,24,53,16,10,17]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function E(t,i){const r=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],o=new Map,c=new Map,l=2e4;function u(h,k,_,j){const q=k.substring(h.length+1);return new Promise(async K=>{var M,$,z;let W;try{W=await(0,I.readdir)(k,{withFileTypes:!0})}catch(P){K();return}if(j.count>=l){j.count+=W.length,j.maxReached=!0,K();return}let H=W.length;if(H===0){K();return}let T=W;j.count+W.length>l&&(j.maxReached=!0,H=l-j.count,T=W.slice(0,H)),j.count+=W.length;for(const P of T)if(P.isDirectory()){if(_.includes(P.name)||await u(h,(0,U.join)(k,P.name),_,j),--H==0){K();return}}else{const F=P.name.lastIndexOf(".");if(F>=0){const N=P.name.substring(F+1);N&&o.set(N,((M=o.get(N))!==null&&M!==void 0?M:0)+1)}for(const N of r)(($=N.relativePathPattern)===null||$===void 0?void 0:$.test(q))!==!1&&N.filePattern.test(P.name)&&c.set(N.tag,((z=c.get(N.tag))!==null&&z!==void 0?z:0)+1);if(--H==0){K();return}}})}const m={count:0,maxReached:!1};await u(t,t,i,m);const b=await a(t);return{configFiles:D(c),fileTypes:D(o),fileCount:m.count,maxFilesReached:m.maxReached,launchConfigFiles:b}}e.collectWorkspaceStats=E;function D(t){return[...C.Iterable.map(t.entries(),([i,r])=>({name:i,count:r}))].sort((i,r)=>r.count-i.count)}function g(){const t={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(L.virtualMachineHint.value()*100)}%`},i=p.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=g;function a(t){let i=new Map,r=(0,U.join)(t,".vscode","launch.json");return new Promise((o,c)=>{(0,R.exists)(r,l=>{if(l)(0,R.readFile)(r,(u,m)=>{if(u)return o([]);const b=[],h=(0,A.parse)(m.toString(),b);if(b.length)return console.log(`Unable to parse ${r}`),o([]);if((0,A.getNodeType)(h)==="object"&&h.configurations)for(const k of h.configurations){const _=k.type;_&&(i.has(_)?i.set(_,i.get(_)+1):i.set(_,1))}return o(D(i))});else return o([])})})}e.collectLaunchConfigs=a;let s=class{constructor(i,r){this.telemetryService=i,this.productService=r}formatMachineInfo(i){const r=[];return r.push(`OS Version:       ${i.os}`),r.push(`CPUs:             ${i.cpus}`),r.push(`Memory (System):  ${i.memory}`),r.push(`VM:               ${i.vmHint}`),r.join(`
`)}formatEnvironment(i){const r=[];r.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),r.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const o=p.cpus();return o&&o.length>0&&r.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),r.push(`Memory (System):  ${(p.totalmem()/w.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/w.ByteSize.GB).toFixed(2)}GB free)`),n.isWindows||r.push(`Load (avg):       ${p.loadavg().map(c=>Math.round(c)).join(", ")}`),r.push(`VM:               ${Math.round(L.virtualMachineHint.value()*100)}%`),r.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${i.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(i,r){return Promise.all([(0,S.listProcesses)(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async o=>{let[c,l]=o,u=this.formatProcessList(i,c);return r.forEach(m=>{if((0,O.isRemoteDiagnosticError)(m))u+=`
${m.errorMessage}`,l+=`
${m.errorMessage}`;else if(u+=`

Remote: ${m.hostName}`,m.processes&&(u+=`
${this.formatProcessList(i,m.processes)}`),m.workspaceMetadata){l+=`
|  Remote: ${m.hostName}`;for(const b of Object.keys(m.workspaceMetadata)){const h=m.workspaceMetadata[b];let k=`${h.fileCount} files`;h.maxFilesReached&&(k=`more than ${k}`),l+=`|    Folder (${b}): ${k}`,l+=this.formatWorkspaceStats(h)}}}),{processInfo:u,workspaceInfo:l}})}async getSystemInfo(i,r){const{memory:o,vmHint:c,os:l,cpus:u}=g(),m={os:l,memory:o,cpus:u,vmHint:c,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:r};return n.isWindows||(m.load=`${p.loadavg().map(b=>Math.round(b)).join(", ")}`),n.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(i,r){const o=[];return(0,S.listProcesses)(i.mainPID).then(async c=>(o.push(""),o.push(this.formatEnvironment(i)),o.push(""),o.push(this.formatProcessList(i,c)),i.windows.some(l=>l.folderURIs&&l.folderURIs.length>0&&!l.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(i))),r.forEach(l=>{if((0,O.isRemoteDiagnosticError)(l))o.push(`
${l.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${l.hostName}`),o.push(this.formatMachineInfo(l.machineInfo)),l.processes&&o.push(this.formatProcessList(i,l.processes)),l.workspaceMetadata)for(const u of Object.keys(l.workspaceMetadata)){const m=l.workspaceMetadata[u];let b=`${m.fileCount} files`;m.maxFilesReached&&(b=`more than ${b}`),o.push(`Folder (${u}): ${b}`),o.push(this.formatWorkspaceStats(m))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(i){const r=[],o=60;let c=0;const l=(h,k)=>{const _=` ${h}(${k})`;c+_.length>o?(r.push(u),u="|                 ",c=u.length):c+=_.length,u+=_};let u="|      File types:";const m=10;let b=i.fileTypes.length>m?m:i.fileTypes.length;for(let h=0;h<b;h++){const k=i.fileTypes[h];l(k.name,k.count)}if(r.push(u),i.configFiles.length>=0&&(u="|      Conf files:",c=0,i.configFiles.forEach(h=>{l(h.name,h.count)}),r.push(u)),i.launchConfigFiles.length>0){let h="|      Launch Configs:";i.launchConfigFiles.forEach(k=>{h+=k.count>1?` ${k.name}(${k.count})`:` ${k.name}`}),r.push(h)}return r.join(`
`)}expandGPUFeatures(i){const r=Math.max(...Object.keys(i).map(o=>o.length));return Object.keys(i).map(o=>`${o}:  ${" ".repeat(r-o.length)}  ${i[o]}`).join(`
                  `)}formatWorkspaceMetadata(i){const r=[],o=[];return i.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(r.push(`|  Window (${c.title})`),c.folderURIs.forEach(l=>{const u=f.URI.revive(l);if(u.scheme===d.Schemas.file){const m=u.fsPath;o.push(E(m,["node_modules",".git"]).then(b=>{let h=`${b.fileCount} files`;b.maxFilesReached&&(h=`more than ${h}`),r.push(`|    Folder (${(0,U.basename)(m)}): ${h}`),r.push(this.formatWorkspaceStats(b))}).catch(b=>{r.push(`|      Error: Unable to collect workspace stats for folder ${m} (${b.toString()})`)}))}else r.push(`|    Folder (${u.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(c=>r.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(i,r){const o=new Map;i.windows.forEach(l=>o.set(l.pid,l.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),r&&this.formatProcessItem(i.mainPID,o,c,r,0),c.join(`
`)}formatProcessItem(i,r,o,c,l){const u=l===0;let m;u?m=c.pid===i?`${this.productService.applicationName} main`:"remote agent":(m=`${"  ".repeat(l)} ${c.name}`,c.name==="window"&&(m=`${m} (${r.get(c.pid)})`));const b=process.platform==="win32"?c.mem:p.totalmem()*(c.mem/100);o.push(`${c.load.toFixed(0).padStart(5," ")}	${(b/w.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(c.children)&&c.children.forEach(h=>this.formatProcessItem(i,r,o,h,l+1))}async reportWorkspaceStats(i){for(const{uri:r}of i.folders){const o=f.URI.revive(r);if(o.scheme===d.Schemas.file){const c=o.fsPath;try{const l=await E(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),l.fileTypes.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.launchConfigFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})}),l.configFiles.forEach(u=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:u.name,count:u.count})})}catch(l){}}}}};s=de([Y(0,v.ITelemetryService),Y(1,y.IProductService)],s),e.DiagnosticsService=s}),define(Z[173],ee([0,1,11,29,34,26,24,40,70,9,30,18,10,5,28,20,45,4,14]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var g;(function(T){T[T.None=0]="None",T[T.IncludeVersions=1]="IncludeVersions",T[T.IncludeFiles=2]="IncludeFiles",T[T.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",T[T.IncludeSharedAccounts=8]="IncludeSharedAccounts",T[T.IncludeVersionProperties=16]="IncludeVersionProperties",T[T.ExcludeNonValidated=32]="ExcludeNonValidated",T[T.IncludeInstallationTargets=64]="IncludeInstallationTargets",T[T.IncludeAssetUri=128]="IncludeAssetUri",T[T.IncludeStatistics=256]="IncludeStatistics",T[T.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",T[T.Unpublished=4096]="Unpublished"})(g||(g={}));function a(...T){return String(T.reduce((P,F)=>P|F,0))}var s;(function(T){T[T.Tag=1]="Tag",T[T.ExtensionId=4]="ExtensionId",T[T.Category=5]="Category",T[T.ExtensionName=7]="ExtensionName",T[T.Target=8]="Target",T[T.Featured=9]="Featured",T[T.SearchText=10]="SearchText",T[T.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},o={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:g.None,criteria:[],assetTypes:[]};class c{constructor(P=o){this.state=P}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(P,F=this.state.pageSize){return new c(Object.assign(Object.assign({},this.state),{pageNumber:P,pageSize:F}))}withFilter(P,...F){const N=[...this.state.criteria,...F.length?F.map(x=>({filterType:P,value:x})):[{filterType:P}]];return new c(Object.assign(Object.assign({},this.state),{criteria:N}))}withSortBy(P){return new c(Object.assign(Object.assign({},this.state),{sortBy:P}))}withSortOrder(P){return new c(Object.assign(Object.assign({},this.state),{sortOrder:P}))}withFlags(...P){return new c(Object.assign(Object.assign({},this.state),{flags:P.reduce((F,N)=>F|N,0)}))}withAssetTypes(...P){return new c(Object.assign(Object.assign({},this.state),{assetTypes:P}))}get raw(){const{criteria:P,pageNumber:F,pageSize:N,sortBy:x,sortOrder:V,flags:X,assetTypes:Q}=this.state;return{filters:[{criteria:P,pageNumber:F,pageSize:N,sortBy:x,sortOrder:V}],assetTypes:Q,flags:X}}get searchText(){const P=this.state.criteria.filter(F=>F.filterType===s.SearchText)[0];return P&&P.value?P.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(P=>String(P.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(T,P){const F=(T||[]).filter(N=>N.statisticName===P)[0];return F?F.value:0}function u(T){const P="Microsoft.VisualStudio.Code.Translation.";return T.files.filter(N=>N.assetType.indexOf(P)===0).reduce((N,x)=>{const V=k(T,x.assetType);return V&&N.push([x.assetType.substring(P.length),V]),N},[])}function m(T){if(T.properties){const P=T.properties.filter(x=>x.key===t.Repository),F=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),N=P.filter(x=>F.test(x.value))[0];return N?{uri:N.value,fallbackUri:N.value}:null}return k(T,t.Repository)}function b(T){return{uri:`${T.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${T.fallbackAssetUri}/${t.VSIX}`}}function h(T){const P=k(T,t.Icon);if(P)return P;const F=L.DefaultIconPath;return{uri:F,fallbackUri:F}}function k(T,P){return T.files.filter(N=>N.assetType===P)[0]?{uri:`${T.assetUri}/${P}`,fallbackUri:`${T.fallbackAssetUri}/${P}`}:null}function _(T,P){const F=T.properties?T.properties.filter(x=>x.key===P):[],N=F.length>0&&F[0].value;return N?N.split(",").map(x=>(0,O.adoptToGalleryExtensionId)(x)):[]}function j(T){const P=T.properties?T.properties.filter(F=>F.key===i.Engine):[];return P.length>0&&P[0].value||""}function q(T){const P=T.properties?T.properties.filter(N=>N.key===i.LocalizedLanguages):[],F=P.length>0&&P[0].value||"";return F?F.split(","):[]}function K(T){return T.indexOf("preview")!==-1}function M(T){const P=T.properties?T.properties.find(F=>F.key===i.WebExtension):void 0;return!!P&&P.value==="true"}function $(T){return T.files.some(P=>P.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?(0,D.joinPath)(C.URI.parse(T.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function z(T,P,F,N,x){const V={manifest:k(P,t.Manifest),readme:k(P,t.Details),changelog:k(P,t.Changelog),license:k(P,t.License),repository:m(P),download:b(P),icon:h(P),coreTranslations:u(P)};return{identifier:{id:(0,O.getGalleryExtensionId)(T.publisher.publisherName,T.extensionName),uuid:T.extensionId},name:T.extensionName,version:P.version,date:P.lastUpdated,displayName:T.displayName,publisherId:T.publisher.publisherId,publisher:T.publisher.publisherName,publisherDisplayName:T.publisher.displayName,description:T.shortDescription||"",installCount:l(T.statistics,"install"),rating:l(T.statistics,"averagerating"),ratingCount:l(T.statistics,"ratingcount"),assetUri:C.URI.parse(P.assetUri),webResource:$(P),assetTypes:P.files.map(({assetType:X})=>X),assets:V,properties:{dependencies:_(P,i.Dependency),extensionPack:_(P,i.ExtensionPack),engine:j(P),localizedLanguages:q(P),webExtension:M(P)},telemetryData:{index:(N.pageNumber-1)*N.pageSize+F,querySource:x},preview:K(T.flags)}}let W=class{constructor(P,F,N,x,V,X,Q){this.requestService=P,this.logService=F,this.environmentService=N,this.telemetryService=x,this.fileService=V,this.productService=X;const ie=X.extensionsGallery;this.extensionsGalleryUrl=ie&&ie.serviceUrl,this.extensionsControlUrl=ie&&ie.controlUrl,this.commonHeadersPromise=H(X.version,this.environmentService,this.fileService,Q)}api(P=""){return`${this.extensionsGalleryUrl}${P}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(P,F){const N=[];let{total:x,firstPage:V,getPage:X}=await this.query({names:P,pageSize:P.length},F);N.push(...V);for(let Q=1;N.length<x&&(V=await X(Q,F),V.length);Q++)N.push(...V);return N}async getCompatibleExtension(P,F){const N=await this.getCompatibleExtensionByEngine(P,F);return(N==null?void 0:N.properties.webExtension)?N.webResource?N:null:N}async getCompatibleExtensionByEngine(P,F){const N=(0,L.isIExtensionIdentifier)(P)?null:P;if(N&&N.properties.engine&&(0,S.isEngineValid)(N.properties.engine,this.productService.version,this.productService.date))return N;const{id:x,uuid:V}=N?N.identifier:P;let X=new c().withFlags(g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?X=X.withFilter(s.ExtensionId,V):X=X.withFilter(s.ExtensionName,x);const{galleryExtensions:Q}=await this.queryGallery(X,n.CancellationToken.None),[ie]=Q;if(!ie||!ie.versions.length)return null;if(F){const ce=ie.versions.filter(ue=>ue.version===F)[0];if(ce){const ue=z(ie,ce,0,X);if(ue.properties.engine&&(0,S.isEngineValid)(ue.properties.engine,this.productService.version,this.productService.date))return ue}return null}const ne=await this.getLastValidExtensionVersion(ie,ie.versions);return ne?z(ie,ne,0,X):null}async query(P,F){const N=n.CancellationToken.isCancellationToken(P)?{}:P,x=n.CancellationToken.isCancellationToken(P)?P:F;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let V=N.text||"";const X=(0,R.getOrDefault)(N,ge=>ge.pageSize,50);let Q=new c().withFlags(g.IncludeLatestVersionOnly,g.IncludeAssetUri,g.IncludeStatistics,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,X).withFilter(s.Target,"Microsoft.VisualStudio.Code");V?(V=V.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Ce)=>(Q=Q.withFilter(s.Category,Ce||pe),"")),V=V.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ge,pe,Ce)=>(Q=Q.withFilter(s.Tag,Ce||pe),"")),V=V.replace(/\bfeatured(\s+|\b|$)/g,()=>(Q=Q.withFilter(s.Featured),"")),V=V.trim(),V&&(V=V.length<200?V:V.substring(0,200),Q=Q.withFilter(s.SearchText,V)),Q=Q.withSortBy(0)):N.ids?Q=Q.withFilter(s.ExtensionId,...N.ids):N.names?Q=Q.withFilter(s.ExtensionName,...N.names):Q=Q.withSortBy(4),typeof N.sortBy=="number"&&(Q=Q.withSortBy(N.sortBy)),typeof N.sortOrder=="number"&&(Q=Q.withSortOrder(N.sortOrder));const{galleryExtensions:ie,total:ne}=await this.queryGallery(Q,x),ce=ie.map((ge,pe)=>z(ge,ge.versions[0],pe,Q,N.source)),ue=async(ge,pe)=>{if(pe.isCancellationRequested)throw(0,p.canceled)();const Ce=Q.withPage(ge+1),{galleryExtensions:ke}=await this.queryGallery(Ce,pe);return ke.map((Fe,Oe)=>z(Fe,Fe.versions[0],Oe,Ce,N.source))};return{firstPage:ce,total:ne,pageSize:Q.pageSize,getPage:ue}}async queryGallery(P,F){if(!this.isEnabled())throw new Error("No extension gallery service configured.");P=P.withFlags(P.flags,g.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,a(g.Unpublished));const N=await this.commonHeadersPromise,x=JSON.stringify(P.raw),V=Object.assign(Object.assign({},N),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(x.length)}),X=new Date().getTime();let Q,ie,ne=0;try{if(Q=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:x,headers:V},F),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:ne};const ce=await(0,A.asJson)(Q);if(ce){const ue=ce.results[0],ge=ue.extensions,pe=ue.resultMetadata&&ue.resultMetadata.filter(Ce=>Ce.metadataType==="ResultCount")[0];return ne=pe&&pe.metadataItems.filter(Ce=>Ce.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ne}}return{galleryExtensions:[],total:ne}}catch(ce){throw ie=ce,ce}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},P.telemetryData),{requestBodySize:String(x.length),duration:new Date().getTime()-X,success:!!Q&&(0,A.isSuccess)(Q),responseBodySize:Q==null?void 0:Q.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:ie?(0,p.isPromiseCanceledError)(ie)?"canceled":(0,p.getErrorMessage)(ie).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ne)}))}}async reportStatistic(P,F,N,x){if(!!this.isEnabled()){const V=await this.commonHeadersPromise,X=Object.assign(Object.assign({},V),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${P}/extensions/${F}/${N}/stats?statType=${x}`),headers:X},n.CancellationToken.None)}catch(Q){}}}async download(P,F,N){this.logService.trace("ExtensionGalleryService#download",P.identifier.id);const x=(0,O.getGalleryExtensionTelemetryData)(P),V=new Date().getTime(),X=ce=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},x),{duration:ce})),Q=N===1?"install":N===2?"update":"",ie=Q?{uri:`${P.assets.download.uri}&${Q}=true`,fallbackUri:`${P.assets.download.fallbackUri}?${Q}=true`}:P.assets.download,ne=await this.getAsset(ie);await this.fileService.writeFile(F,ne.stream),X(new Date().getTime()-V)}async getReadme(P,F){if(P.assets.readme){const N=await this.getAsset(P.assets.readme,{},F);return await(0,A.asText)(N)||""}return""}async getManifest(P,F){if(P.assets.manifest){const N=await this.getAsset(P.assets.manifest,{},F),x=await(0,A.asText)(N);return x?JSON.parse(x):null}return null}async getCoreTranslation(P,F){const N=P.assets.coreTranslations.filter(x=>x[0]===F.toUpperCase())[0];if(N){const x=await this.getAsset(N[1]),V=await(0,A.asText)(x);return V?JSON.parse(V):null}return null}async getChangelog(P,F){if(P.assets.changelog){const N=await this.getAsset(P.assets.changelog,{},F);return await(0,A.asText)(N)||""}return""}async getAllVersions(P,F){let N=new c().withFlags(g.IncludeVersions,g.IncludeFiles,g.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");P.identifier.uuid?N=N.withFilter(s.ExtensionId,P.identifier.uuid):N=N.withFilter(s.ExtensionName,P.identifier.id);const x=[],{galleryExtensions:V}=await this.queryGallery(N,n.CancellationToken.None);return V.length&&(F?await Promise.all(V[0].versions.map(async X=>{let Q;try{Q=await this.getEngine(X)}catch(ie){}Q&&(0,S.isEngineValid)(Q,this.productService.version,this.productService.date)&&x.push({version:X.version,date:X.lastUpdated})})):x.push(...V[0].versions.map(X=>({version:X.version,date:X.lastUpdated})))),x}async getAsset(P,F={},N=n.CancellationToken.None){const x=await this.commonHeadersPromise,V={type:"GET"},X=Object.assign(Object.assign({},x),F.headers||{});F=Object.assign(Object.assign(Object.assign({},F),V),{headers:X});const Q=P.uri,ie=P.fallbackUri,ne=Object.assign(Object.assign({},F),{url:Q});try{const ce=await this.requestService.request(ne,N);if(ce.res.statusCode===200)return ce;const ue=await(0,A.asText)(ce);throw new Error(`Expected 200, got back ${ce.res.statusCode} instead.

${ue}`)}catch(ce){if((0,p.isPromiseCanceledError)(ce))throw ce;const ue=(0,p.getErrorMessage)(ce);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:Q,message:ue});const ge=Object.assign(Object.assign({},F),{url:ie});return this.requestService.request(ge,N)}}async getLastValidExtensionVersion(P,F){const N=this.getLastValidExtensionVersionFromProperties(P,F);return N||this.getLastValidExtensionVersionRecursively(P,F)}getLastValidExtensionVersionFromProperties(P,F){for(const N of F){const x=j(N);if(!x)return null;if((0,S.isEngineValid)(x,this.productService.version,this.productService.date))return N}return null}async getEngine(P){const F=j(P);if(F)return F;const N=k(P,t.Manifest);if(!N)throw new Error("Manifest was not found");const x={"Accept-Encoding":"gzip"},V=await this.getAsset(N,{headers:x}),X=await(0,A.asJson)(V);if(X)return X.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(P,F){if(!F.length)return null;const N=F[0],x=await this.getEngine(N);return(0,S.isEngineValid)(x,this.productService.version,this.productService.date)?(N.properties=N.properties||[],N.properties.push({key:i.Engine,value:x}),N):this.getLastValidExtensionVersionRecursively(P,F.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const P=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(P.res.statusCode!==200)throw new Error("Could not get extensions report.");const F=await(0,A.asJson)(P),N=new Map;if(F)for(const x of F.malicious){const V=N.get(x)||{id:{id:x},malicious:!0,slow:!1};V.malicious=!0,N.set(x,V)}return[...N.values()]}};W=de([Y(0,A.IRequestService),Y(1,f.ILogService),Y(2,y.IEnvironmentService),Y(3,U.ITelemetryService),Y(4,v.IFileService),Y(5,d.IProductService),Y(6,(0,E.optional)(w.IStorageService))],W),e.ExtensionGalleryService=W;async function H(T,P,F,N){const x={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T}`},V=await(0,I.getServiceMachineId)(P,F,N);return x["X-Market-User-Id"]=V,x}e.resolveMarketplaceHeaders=H}),define(Z[174],ee([0,1,5,7,28,9,35,10,6,19,29,63,40,18,167,8,24,73,110,20,3,58]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const t="extensionTips/promptedExecutableTips",i="extensionTips/lastPromptedMediumImpExeTime";let r=class extends d.ExtensionTipsService{constructor(c,l,u,m,b,h,k,_,j,q){super(k,_,j,q);this.environmentService=c,this.telemetryService=l,this.extensionManagementService=u,this.storageService=m,this.nativeHostService=b,this.extensionRecommendationNotificationService=h,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,_.exeBasedExtensionTips&&(0,f.forEach)(_.exeBasedExtensionTips,({key:K,value:M})=>{const $=[],z=[],W=[];(0,f.forEach)(M.recommendations,({key:H,value:T})=>{T.important?M.important?$.push({extensionId:H,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):z.push({extensionId:H,extensionName:T.name,isExtensionPack:!!T.isExtensionPack}):W.push({extensionId:H,extensionName:T.name,isExtensionPack:!!T.isExtensionPack})}),$.length&&this.highImportanceExecutableTips.set(K,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:$}),z.length&&this.mediumImportanceExecutableTips.set(K,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:z}),W.length&&this.allOtherExecutableTips.set(K,{exeFriendlyName:M.friendlyName,windowsPath:M.windowsPath,recommendations:W})}),(0,w.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...c,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const c=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),u=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(c,u),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,u)}groupImportantTipsByExe(c,l){const u=new Map;c.forEach(_=>u.set(_.extensionId.toLowerCase(),_));const{installed:m,uninstalled:b}=this.groupByInstalled([...u.keys()],l);for(const _ of m){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:_,exeName:(0,L.basename)(j.windowsPath)})}for(const _ of b){const j=u.get(_);j&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:_,exeName:(0,L.basename)(j.windowsPath)})}const h=this.getPromptedExecutableTips(),k=new Map;for(const _ of b){const j=u.get(_);if(j&&(!h[j.exeName]||!h[j.exeName].includes(j.extensionId))){let q=k.get(j.exeName);q||(q=[],k.set(j.exeName,q)),q.push(j)}}return k}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size!==0){const[c,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(u=>{switch(u){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(c);break;case"incompatibleWindow":const m=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(m(()=>this.promptHighImportanceExeBasedTip()));break;case"toomany":const b=this._register((0,w.disposableTimeout)(()=>{b.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}})}}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size!==0){const c=this.getLastPromptedMediumExeTime(),l=Date.now()-c,u=7*24*60*60*1e3;if(l<u){const h=this._register((0,w.disposableTimeout)(()=>{h.dispose(),this.promptMediumImportanceExeBasedTip()},u-l));return}const[m,b]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(b).then(h=>{switch(h){case"reacted":this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(m),this.addToRecommendedExecutables(b[0].exeName,b);const k=this._register((0,w.disposableTimeout)(()=>{k.dispose(),this.promptMediumImportanceExeBasedTip()},u));break;case"ignored":this.mediumImportanceTipsByExe.delete(m),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":const _=a.Event.once(a.Event.latch(a.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(_(()=>this.promptMediumImportanceExeBasedTip()));break;case"toomany":const j=this._register((0,w.disposableTimeout)(()=>{j.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}})}}promptExeRecommendations(c){const l=c.map(({extensionId:m})=>m.toLowerCase()),u=(0,D.localize)(0,null,c[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(l,u,`@exe:"${c[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let c=this.storageService.getNumber(i,0);return c||(c=Date.now(),this.updateLastPromptedMediumExeTime(c)),c}updateLastPromptedMediumExeTime(c){this.storageService.store(i,c,0,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(t,0,"{}"))}addToRecommendedExecutables(c,l){const u=this.getPromptedExecutableTips();u[c]=l.map(({extensionId:m})=>m.toLowerCase()),this.storageService.store(t,JSON.stringify(u),0,0)}groupByInstalled(c,l){const u=[],m=[],b=l.reduce((h,k)=>(h.add(k.identifier.id.toLowerCase()),h),new Set);return c.forEach(h=>{b.has(h.toLowerCase())?u.push(h):m.push(h)}),{installed:u,uninstalled:m}}async getValidExecutableBasedExtensionTips(c){const l=[],u=new Map;for(const m of c.keys()){const b=c.get(m);if(!(!b||!(0,y.isNonEmptyArray)(b.recommendations))){const h=[];S.isWindows?b.windowsPath&&h.push(b.windowsPath.replace("%USERPROFILE%",U.env.USERPROFILE).replace("%ProgramFiles(x86)%",U.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",U.env.ProgramFiles).replace("%APPDATA%",U.env.APPDATA).replace("%WINDIR%",U.env.WINDIR)):(h.push((0,L.join)("/usr/local/bin",m)),h.push((0,L.join)("/usr/bin",m)),h.push((0,L.join)(this.environmentService.userHome.fsPath,m)));for(const k of h){let _=u.get(k);if(_===void 0&&(_=await this.fileService.exists(p.URI.file(k)),u.set(k,_)),_)for(const{extensionId:j,extensionName:q,isExtensionPack:K}of b.recommendations)l.push({extensionId:j,extensionName:q,isExtensionPack:K,exeName:m,exeFriendlyName:b.exeFriendlyName,windowsPath:b.windowsPath})}}}return l}};r=de([Y(0,R.INativeEnvironmentService),Y(1,I.ITelemetryService),Y(2,n.IExtensionManagementService),Y(3,g.IStorageService),Y(4,s.INativeHostService),Y(5,E.IExtensionRecommendationNotificationService),Y(6,A.IFileService),Y(7,O.IProductService),Y(8,v.IRequestService),Y(9,C.ILogService)],r),e.ExtensionTipsService=r}),define(Z[80],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(R){this.appender=R}listen(R,U){throw new Error(`Event not found: ${U}`)}call(R,U,{eventName:A,data:S}){return this.appender.log(A,S),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(R){this.channel=R}log(R,U){return this.channel.call("log",{eventName:R,data:U}).then(void 0,A=>`Failed to log telemetry: ${console.warn(A)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Z[81],ee([0,1,51,120,22,4,23,38,2,26,32]),function(G,e,p,L,O,R,U,A,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let f=class{constructor(d,w){this._configurationService=w,this._experimentProperties={},this._disposables=new S.DisposableStore,this._cleanupPatterns=[],this._appender=d.appender,this._commonProperties=d.commonProperties||Promise.resolve({}),this._piiPaths=d.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!d.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let I of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,O.escapeRegExpCharacters)(I),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(I=>{const E=/^[a-f0-9]+$/i.test(I["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!E})}))}setExperimentProperty(d,w){this._experimentProperties[d]=w}setEnabled(d){this._enabled=d}_updateUserOptIn(){var d;const w=(d=this._configurationService)===null||d===void 0?void 0:d.getValue(v);this._userOptIn=w?w.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const d=await this._commonProperties;let w=d.sessionID,I=d["common.instanceId"],E=d["common.machineId"],D=d["common.firstSessionDate"],g=d["common.msftInternal"];return{sessionId:w,instanceId:I,machineId:E,firstSessionDate:D,msftInternal:g}}dispose(){this._disposables.dispose()}publicLog(d,w,I){return this.isOptedIn?this._commonProperties.then(E=>{w=(0,y.mixin)(w,E),w=(0,y.mixin)(w,this._experimentProperties),w=(0,y.cloneAndChange)(w,D=>{if(typeof D=="string")return this._cleanupInfo(D,I)}),this._appender.log(d,w)},E=>{console.error(E)}):Promise.resolve(void 0)}publicLog2(d,w,I){return this.publicLog(d,w,I)}publicLogError(d,w){return this.sendErrorTelemetry?this.publicLog(d,w,!0):Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}_cleanupInfo(d,w){let I=d;if(w){const E=[];for(let s of this._cleanupPatterns)for(;;){const t=s.exec(d);if(!t)break;E.push([t.index,s.lastIndex])}const D=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,g=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(I="";;){const s=g.exec(d);if(!s)break;!D.test(s[0])&&E.every(([t,i])=>s.index<t||s.index>=i)&&(I+=d.substring(a,s.index)+"<REDACTED: user-file-path>",a=g.lastIndex)}a<d.length&&(I+=d.substr(a))}for(let E of this._cleanupPatterns)I=I.replace(E,"");return I}};f.IDLE_START_EVENT_NAME="UserIdleStart",f.IDLE_STOP_EVENT_NAME="UserIdleStop",f=de([Y(1,(0,R.optional)(U.IConfigurationService))],f),e.TelemetryService=f;const v="telemetry";n.Registry.as(A.Extensions.Configuration).registerConfiguration({id:v,order:110,type:"object",title:(0,L.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:p.default.privacyStatementUrl?(0,L.localize)(2,null,p.default.privacyStatementUrl):(0,L.localize)(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(Z[59],ee([0,1,23,26,15,8]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(d,w){return Promise.resolve(void 0)}publicLog2(d,w){return this.publicLog(d,w)}publicLogError(d,w){return Promise.resolve(void 0)}publicLogError2(d,w){return this.publicLogError(d,w)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class U{async publicLog(w,I,E){}async publicLogError(w,I,E){}}e.NullEndpointTelemetryService=U;function A(...d){return{log:(w,I)=>d.forEach(E=>E.log(w,I)),flush:()=>R.Promises.settled(d.map(w=>w.flush()))}}e.combinedAppender=A,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function S(d,w){return w.onDidChangeConfiguration(I=>{I.source!==6&&d.publicLog2("updateConfiguration",{configurationSource:(0,p.ConfigurationTargetToString)(I.source),configurationKeys:v(I.sourceConfig)})})}e.configurationTelemetry=S;function y(d){const w=Object.create(null),I=Object.create(null),E=Object.create(null);f(d,E);for(let D in E){D=D.length>150?D.substr(D.length-149):D;const g=E[D];typeof g=="number"?I[D]=g:typeof g=="boolean"?I[D]=g?1:0:typeof g=="string"?w[D]=g.substring(0,1023):typeof g!="undefined"&&g!==null&&(w[D]=g)}return{properties:w,measurements:I}}e.validateTelemetryData=y;function n(d){if(!d)return"none";let w="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(E=>{d.indexOf(`${E}+`)===0&&(w=E)}),w}e.cleanRemoteAuthority=n;function f(d,w,I=0,E){if(!!d)for(let D of Object.getOwnPropertyNames(d)){const g=d[D],a=E?E+D:D;Array.isArray(g)?w[a]=(0,L.safeStringify)(g):g instanceof Date?w[a]=g.toISOString():(0,O.isObject)(g)?I<2?f(g,w,I+1,a+"."):w[a]=(0,L.safeStringify)(g):w[a]=g}}function v(d){if(!d)return[];const w=[];return C(w,"",d),w}function C(d,w,I){I&&typeof I=="object"&&!Array.isArray(I)?Object.keys(I).forEach(E=>C(d,w?`${w}.${E}`:E,I[E])):d.push(w)}}),define(Z[175],ee([0,1,2,9,18,59]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let U=class extends p.Disposable{constructor(S,y){super();this.logger=this._register(S.createLogger(y.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("===========================================================")}flush(){return Promise.resolve(void 0)}log(S,y){this.logger.trace(`telemetry/${S}`,(0,R.validateTelemetryData)(y))}};U=de([Y(0,O.ILoggerService),Y(1,L.IEnvironmentService)],U),e.TelemetryLogAppender=U}),define(Z[176],ee([0,1,11,26,59]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function R(A){const S=await new Promise((n,f)=>{G(["applicationinsights"],n,f)});let y;return S.defaultClient?(y=new S.TelemetryClient(A),y.channel.setUseDiskRetryCaching(!0)):(S.setup(A).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=S.defaultClient),A.indexOf("AIF-")===0&&(y.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),y}class U{constructor(S,y,n){this._eventPrefix=S,this._defaultData=y,this._defaultData||(this._defaultData=Object.create(null)),typeof n=="function"?this._aiClient=n():this._aiClient=n,this._asyncAIClient=null}_withAIClient(S){if(!!this._aiClient){if(typeof this._aiClient!="string"){S(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=R(this._aiClient)),this._asyncAIClient.then(y=>{S(y)},y=>{(0,p.onUnexpectedError)(y),console.error(y)})}}log(S,y){!this._aiClient||(y=(0,L.mixin)(y,this._defaultData),y=(0,O.validateTelemetryData)(y),this._withAIClient(n=>n.trackEvent({name:this._eventPrefix+"/"+S,properties:y.properties,measurements:y.measurements})))}flush(){return this._aiClient?new Promise(S=>{this._withAIClient(y=>{y.flush({callback:()=>{this._aiClient=void 0,S(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=U}),define(Z[177],ee([0,1,49,80,16,81,23,24]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let S=class{constructor(n,f){this.configurationService=n,this.telemetryService=f,this.customTelemetryServices=new Map}async getCustomTelemetryService(n){if(!this.customTelemetryServices.has(n.id)){const{machineId:f,sessionId:v}=await this.telemetryService.getTelemetryInfo(),C=Object.create(null);C["common.vscodemachineid"]=f,C["common.vscodesessionid"]=v;const d=[n.id,JSON.stringify(C),n.aiKey],I=new p.Client(O.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:d,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),E=new L.TelemetryAppenderClient(I);this.customTelemetryServices.set(n.id,new R.TelemetryService({appender:E,sendErrorTelemetry:n.sendErrorTelemetry},this.configurationService))}return this.customTelemetryServices.get(n.id)}async publicLog(n,f,v){await(await this.getCustomTelemetryService(n)).publicLog(f,v)}async publicLogError(n,f,v){await(await this.getCustomTelemetryService(n)).publicLogError(f,v)}};S=de([Y(0,U.IConfigurationService),Y(1,A.ITelemetryService)],S),e.CustomEndpointTelemetryService=S}),define(Z[82],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=void 0;var L;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.TitleMode="terminal.integrated.titleMode",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.AllowWorkspaceConfiguration="terminal.integrated.allowWorkspaceConfiguration",f.InheritEnv="terminal.integrated.inheritEnv"})(L=e.TerminalSettingId||(e.TerminalSettingId={}));var O;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(O=e.WindowsShellType||(e.WindowsShellType={}));var R;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence"})(R=e.TitleEventSource||(e.TitleEventSource={}));var U;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Log="log",f.Heartbeat="heartbeat"})(U=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=(0,p.createDecorator)("localTerminalService"),e.IPtyService=(0,p.createDecorator)("ptyService");var A;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(A=e.HeartbeatConstants||(e.HeartbeatConstants={}));var S;(function(f){f[f.ReconnectionGraceTime=6e4]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=6e3]="ReconnectionShortGraceTime"})(S=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var y;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(y=e.FlowControlConstants||(e.FlowControlConstants={}));var n;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(n=e.ProfileSource||(e.ProfileSource={}))}),define(Z[178],ee([0,1,38,121,32,54]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const U={type:"object",required:["path"],properties:{path:{description:(0,L.localize)(0,null),type:["string","array"],items:{type:"string"}},args:{description:(0,L.localize)(1,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(2,null),type:"boolean"},icon:{description:(0,L.localize)(3,null),type:"string",enum:Array.from(R.iconRegistry.all,w=>w.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,w=>`$(${w.id})`)},env:{markdownDescription:(0,L.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}}},A=(0,L.localize)(5,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),S=(0,L.localize)(6,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),y=(0,L.localize)(7,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),n={id:"terminal",order:100,title:(0,L.localize)(8,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(9,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(10,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(11,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(12,null),type:["string","null"],default:null,markdownDeprecationMessage:A},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(13,null),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(14,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(15,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:A},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(16,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:S},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(17,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,L.localize)(18,null)}},{type:"string",markdownDescription:(0,L.localize)(19,null)}],default:[],markdownDeprecationMessage:y},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,L.localize)(20,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,L.localize)(21,null),enum:["PowerShell","Git Bash"]},args:{description:(0,L.localize)(22,null),type:"array",items:{type:"string"}},overrideName:{description:(0,L.localize)(23,null),type:"boolean"},icon:{description:(0,L.localize)(24,null),type:"string",enum:Array.from(R.iconRegistry.all,w=>w.id),markdownEnumDescriptions:Array.from(R.iconRegistry.all,w=>`$(${w.id})`)},env:{markdownDescription:(0,L.localize)(25,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}}},{type:"null"},U]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,L.localize)(26,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},U]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(27,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},U]}},["terminal.integrated.useWslProfiles"]:{description:(0,L.localize)(28,null),type:"boolean",default:!0},["terminal.integrated.allowWorkspaceConfiguration"]:{scope:1,description:(0,L.localize)(29,null),type:"boolean",default:!1},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,L.localize)(30,null),type:"boolean",default:!0}}};function f(){O.Registry.as(p.Extensions.Configuration).registerConfiguration(n),C()}e.registerTerminalPlatformConfiguration=f;let v;function C(w){const I=O.Registry.as(p.Extensions.Configuration);v&&I.deregisterConfigurations([v]);let E,D;if(w){const g=w.profiles.map(a=>({name:a.profileName,description:d(a)}));E=g.map(a=>a.name),D=g.map(a=>a.description)}v={id:"terminal",order:100,title:(0,L.localize)(31,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,L.localize)(32,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===3?E:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===3?D:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,description:(0,L.localize)(33,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===2?E:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===2?D:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,description:(0,L.localize)(34,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===1?E:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===1?D:void 0}}},I.registerConfiguration(v)}e.registerTerminalDefaultProfileConfiguration=C;function d(w){let I=`$(${w.icon||R.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?I+=`
- args: "${w.args}"`:I+=`
- args: [${w.args.length===0?"":w.args.join("','")}]`),w.overrideName!==void 0&&(I+=`
- overrideName: ${w.overrideName}`),w.env&&(I+=`
- env: ${JSON.stringify(w.env)}`),I}}),define(Z[179],ee([0,1,4]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,p.createDecorator)("localPtyService")}),define(Z[180],ee([0,1,36,7,35,17,15,26,6]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(p.release());let v=0;return f&&f.length===4&&(v=parseInt(f[3])),v}e.getWindowsBuildNumber=y;async function n(f,v,C,d=O.env,w=R.exists){if(L.isAbsolute(f))return await w(f)?f:void 0;if(v===void 0&&(v=O.cwd()),L.dirname(f)!=="."){const g=L.join(v,f);return await w(g)?g:void 0}const E=(0,A.getCaseInsensitive)(d,"PATH");if(C===void 0&&(0,U.isString)(E)&&(C=E.split(L.delimiter)),C===void 0||C.length===0){const g=L.join(v,f);return await w(g)?g:void 0}for(let g of C){let a;if(L.isAbsolute(g)?a=L.join(g,f):a=L.join(v,g,f),await w(a))return a;if(S.isWindows){let s=a+".com";if(await w(s)||(s=a+".exe",await w(s)))return s}}const D=L.join(v,f);return await w(D)?D:void 0}e.findExecutable=n}),define(Z[181],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Z[182],ee([0,1,4,2,32,3,181,54]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,p.createDecorator)("themeService");var S;(function(I){function E(D){return D&&typeof D=="object"&&typeof D.id=="string"}I.isThemeColor=E})(S=e.ThemeColor||(e.ThemeColor={}));function y(I){return{id:I}}e.themeColorFromId=y;var n;(function(I){function E(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||S.isThemeColor(i.color))}I.isThemeIcon=E;const D=new RegExp(`^\\$\\((${A.CSSIcon.iconNameExpression}(?:${A.CSSIcon.iconModifierExpression})?)\\)$`);function g(i){const r=D.exec(i);if(!!r){let[,o]=r;return{id:o}}}I.fromString=g;function a(i,r){let o=i.id;const c=o.lastIndexOf("~");return c!==-1&&(o=o.substring(0,c)),r&&(o=`${o}~${r}`),{id:o}}I.modify=a;function s(i,r){var o,c;return i.id===r.id&&((o=i.color)===null||o===void 0?void 0:o.id)===((c=r.color)===null||c===void 0?void 0:c.id)}I.isEqual=s;function t(i){return{id:i.id}}I.asThemeIcon=t,I.asClassNameArray=A.CSSIcon.asClassNameArray,I.asClassName=A.CSSIcon.asClassName,I.asCSSSelector=A.CSSIcon.asCSSSelector})(n=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=A.Codicon.file,e.FolderThemeIcon=A.Codicon.folder;function f(I){switch(I){case U.ColorScheme.DARK:return"vs-dark";case U.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=f,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new R.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,L.toDisposable)(()=>{const D=this.themingParticipants.indexOf(E);this.themingParticipants.splice(D,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let C=new v;O.Registry.add(e.Extensions.ThemingContribution,C);function d(I){return C.onColorThemeChange(I)}e.registerThemingParticipant=d;class w extends L.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(D=>this.onThemeChange(D)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,D){let g=this.theme.getColor(E);return g&&D&&(g=D(g,this.theme)),g?g.toString():null}}e.Themable=w});var et=this&&this.__asyncValues||function(G){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=G[Symbol.asyncIterator],p;return e?e.call(G):(G=typeof __values=="function"?__values(G):G[Symbol.iterator](),p={},L("next"),L("throw"),L("return"),p[Symbol.asyncIterator]=function(){return this},p);function L(R){p[R]=G[R]&&function(U){return new Promise(function(A,S){U=G[R](U),O(A,S,U.done,U.value)})}}function O(R,U,A,S){Promise.resolve(S).then(function(y){R({value:y,done:A})},U)}};define(Z[183],ee([0,1,27,7,96,180,43,17,54,6,182]),function(G,e,p,L,O,R,U,A,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let f;function v(s,t,i,r,o,c){return i=i||{existsFile:A.SymlinkSupport.existsFile,readFile:p.promises.readFile},y.isWindows?C(s,i,r,t("terminal.integrated.useWslProfiles")||!0,t("terminal.integrated.profiles.windows"),t("terminal.integrated.defaultProfile.windows"),o):D(i,r,s,t(y.isMacintosh?"terminal.integrated.profiles.osx":"terminal.integrated.profiles.linux"),t(y.isMacintosh?"terminal.integrated.defaultProfile.osx":"terminal.integrated.defaultProfile.linux"),c,o)}e.detectAvailableProfiles=v;async function C(s,t,i,r,o,c,l){const u=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${process.env.windir}\\${u?"Sysnative":"System32"}`;let b=!1;(0,R.getWindowsBuildNumber)()>=16299&&(b=!0),await w();const h=new Map;s&&(h.set("PowerShell",{source:"PowerShell",icon:S.Codicon.terminalPowershell,isAutoDetected:!0}),h.set("Windows PowerShell",{path:`${m}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:S.Codicon.terminalPowershell,isAutoDetected:!0}),h.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),h.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),h.set("Command Prompt",{path:`${m}\\cmd.exe`,icon:S.Codicon.terminalCmd,isAutoDetected:!0})),g(o,h);const k=await d(h.entries(),c,t,i,l);if(s||!s&&r)try{const _=await E(`${m}\\${b?"wsl":"bash"}.exe`,c);_&&k.push(..._)}catch(_){i==null||i.info("WSL is not installed, so could not detect WSL profiles")}return k}async function d(s,t,i,r,o){const c=[];for(const[l,u]of s)if(u!==null){let m,b,h;if("source"in u){const j=f==null?void 0:f.get(u.source);if(!j)continue;m=j.paths,b=u.args||j.args,u.icon?h=u.icon:j.icon&&(h=j.icon)}else m=Array.isArray(u.path)?u.path:[u.path],b=y.isWindows||Array.isArray(u.args)?u.args:void 0,h=u.icon||void 0;const k=await(o==null?void 0:o(m))||m.slice(),_=await a(l,t,k,i,b,u.env,u.overrideName,u.isAutoDetected,r);_?(_.isAutoDetected=u.isAutoDetected,_.icon=h,c.push(_)):r==null||r.trace("profile not validated",l,m)}return c}async function w(){f||(f=new Map,f.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),f.set("PowerShell",{profileName:"PowerShell",paths:await I(),icon:n.ThemeIcon.asThemeIcon(S.Codicon.terminalPowershell)}))}async function I(){var s,t;const i=[];try{for(var r=et((0,O.enumeratePowerShellInstallations)()),o;o=await r.next(),!o.done;){const c=o.value;i.push(c.exePath)}}catch(c){s={error:c}}finally{try{o&&!o.done&&(t=r.return)&&await t.call(r)}finally{if(s)throw s.error}}return i}async function E(s,t){const i=[],r=await new Promise((l,u)=>{U.exec("wsl.exe -l -q",{encoding:"utf16le"},(m,b)=>{if(m)return u("Problem occurred when getting wsl distros");l(b)})});if(!r)return[];const o=new RegExp(/[\r?\n]/),c=r.split(o).filter(l=>l.trim().length>0&&l!=="");for(const l of c)if(l!==""&&!l.startsWith("docker-desktop")){const u=`${l} (WSL)`,m={profileName:u,path:s,args:["-d",`${l}`],isDefault:u===t};l.includes("Ubuntu")?m.icon=n.ThemeIcon.asThemeIcon(S.Codicon.terminalUbuntu):l.includes("Debian")?m.icon=n.ThemeIcon.asThemeIcon(S.Codicon.terminalDebian):m.icon=n.ThemeIcon.asThemeIcon(S.Codicon.terminalLinux),i.push(m)}return i}async function D(s,t,i,r,o,c,l){const u=new Map;if(i){const m=await s.readFile("/etc/shells","utf8"),b=c||m.split(`
`).filter(k=>k.trim().indexOf("#")!==0&&k.trim().length>0),h=new Map;for(const k of b){let _=(0,L.basename)(k),j=h.get(_)||0;j++,j>1&&(_=`${_} (${j})`),h.set(_,j),u.set(_,{path:k,isAutoDetected:!0})}}return g(r,u),await d(u.entries(),o,s,t,l)}function g(s,t){if(!!s)for(const[i,r]of Object.entries(s))r===null||!("path"in r)&&!("source"in r)?t.delete(i):t.set(i,r)}async function a(s,t,i,r,o,c,l,u,m){if(i.length===0)return Promise.resolve(void 0);const b=i.shift();if(b==="")return a(s,t,i,r,o,c,l,u);const h={profileName:s,path:b,args:o,env:c,overrideName:l,isAutoDetected:u,isDefault:s===t};if((0,L.basename)(b)===b){const _=process.env.PATH?process.env.PATH.split(L.delimiter):void 0;return await(0,R.findExecutable)(b,void 0,_,void 0,r.existsFile)?h:a(s,t,i,r,o)}return await r.existsFile((0,L.normalize)(b))?h:a(s,t,i,r,o,c,l,u)}}),define(Z[184],ee([0,1,2,18,82,49,16,37,3,77,24,183,23,178]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var d;(function(D){D[D.MaxRestarts=5]="MaxRestarts"})(d||(d={}));let w=0,I=0,E=class extends p.Disposable{constructor(g,a,s){super();this._configurationService=g,this._logService=a,this._telemetryService=s,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new S.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new S.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new S.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new S.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new S.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new S.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new S.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new S.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new S.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new S.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new S.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new S.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new S.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new S.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,(0,C.registerTerminalPlatformConfiguration)(),this._register((0,p.toDisposable)(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const g=new R.Client(U.FileAccess.asFileUri("bootstrap-fork",G).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:w,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}});this._onPtyHostStart.fire(),A.ProxyChannel.toService(g.getChannel(O.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(g.onDidProcessExit(i=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(i.code),this._isDisposed||(this._restartCount<=d.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const s=g.getChannel(O.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(s,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(s,this._logService.getLevel())}));const t=A.ProxyChannel.toService(g.getChannel(O.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(i=>this._onProcessData.fire(i))),this._register(t.onProcessExit(i=>this._onProcessExit.fire(i))),this._register(t.onProcessReady(i=>this._onProcessReady.fire(i))),this._register(t.onProcessTitleChanged(i=>this._onProcessTitleChanged.fire(i))),this._register(t.onProcessShellTypeChanged(i=>this._onProcessShellTypeChanged.fire(i))),this._register(t.onProcessOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i))),this._register(t.onProcessResolvedShellLaunchConfig(i=>this._onProcessResolvedShellLaunchConfig.fire(i))),this._register(t.onProcessReplay(i=>this._onProcessReplay.fire(i))),this._register(t.onProcessOrphanQuestion(i=>this._onProcessOrphanQuestion.fire(i))),[g,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(g,a,s,t,i,r,o,c,l,u){const m=setTimeout(()=>this._handleUnresponsiveCreateProcess(),O.HeartbeatConstants.CreateProcessTimeout),b=await this._proxy.createProcess(g,a,s,t,i,r,o,c,l,u);return clearTimeout(m),w=Math.max(w,b),b}updateTitle(g,a,s){return this._proxy.updateTitle(g,a,s)}updateIcon(g,a,s){return this._proxy.updateIcon(g,a,s)}attachToProcess(g){return this._proxy.attachToProcess(g)}detachFromProcess(g){return this._proxy.detachFromProcess(g)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(g){return this._proxy.start(g)}shutdown(g,a){return this._proxy.shutdown(g,a)}input(g,a){return this._proxy.input(g,a)}processBinary(g,a){return this._proxy.processBinary(g,a)}resize(g,a,s){return this._proxy.resize(g,a,s)}acknowledgeDataEvent(g,a){return this._proxy.acknowledgeDataEvent(g,a)}getInitialCwd(g){return this._proxy.getInitialCwd(g)}getCwd(g){return this._proxy.getCwd(g)}getLatency(g){return this._proxy.getLatency(g)}orphanQuestionReply(g){return this._proxy.orphanQuestionReply(g)}getDefaultSystemShell(g){return this._proxy.getDefaultSystemShell(g)}async getProfiles(g=!1){return(0,f.detectAvailableProfiles)(g,this._buildSafeConfigProvider(),void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(g){return this._proxy.getWslPath(g)}setTerminalLayoutInfo(g){return this._proxy.setTerminalLayoutInfo(g)}async getTerminalLayoutInfo(g){return await this._proxy.getTerminalLayoutInfo(g)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier+O.HeartbeatConstants.BeatInterval*O.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${O.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(g){return new Promise(a=>{const s=++I;this._pendingResolveVariablesRequests.set(s,a),this._onPtyHostRequestResolveVariables.fire({id:s,originalText:g})})}async acceptPtyHostResolvedVariables(g,a){const s=this._pendingResolveVariablesRequests.get(g);s?(s(a),this._pendingResolveVariablesRequests.delete(g)):this._logService.warn(`Resolved variables received without matching request ${g}`)}_buildSafeConfigProvider(){return g=>{if(this._configurationService.getValue("terminal.integrated.allowWorkspaceConfiguration"))return this._configurationService.getValue(g);const s=this._configurationService.inspect(g);return(s==null?void 0:s.userValue)||(s==null?void 0:s.defaultValue)}}};E=de([Y(0,v.IConfigurationService),Y(1,L.ILogService),Y(2,n.ITelemetryService)],E),e.PtyHostService=E}),define(Z[52],ee([0,1,41]),function(G,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function L(U,A,S,y){const n=(0,p.setProperty)(U,A,S,y)[0];return n&&(U=U.substring(0,n.offset)+n.content+U.substring(n.offset+n.length)),U}e.edit=L;function O(U,A,S){let y=S;for(;y>=0;){if(U.charAt(y)===A.charAt(A.length-1)&&A.length===1)return y+1;if(y--,A.length===2&&y>=0&&U.charAt(y)===A.charAt(0))return y+2}return 0}e.getLineStartOffset=O;function R(U,A,S){let y=S;for(;y>=0;)if(U.charAt(y)===A.charAt(A.length-1)&&A.length===1||(y++,A.length===2&&y>=0&&U.charAt(y)===A.charAt(1)))return y;return U.length-1}e.getLineEndOffset=R}),define(Z[185],ee([0,1,26,57]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(f,v,C,d,w){var I,E;const D=[],g=[],a=[];if(!v){const j=f.filter(({identifier:q})=>w.every(K=>K.toLowerCase()!==q.id.toLowerCase()));return{added:D,removed:g,updated:a,remote:j.length>0?j:null}}f=f.map(y),v=v.map(y),C=C?C.map(y):null;const s=new Map,t=j=>{j.uuid&&s.set(j.id.toLowerCase(),j.uuid)};f.forEach(({identifier:j})=>t(j)),v.forEach(({identifier:j})=>t(j)),C&&C.forEach(({identifier:j})=>t(j));const i=j=>{const q=j.identifier.uuid||s.get(j.identifier.id.toLowerCase());return q?`uuid:${q}`:`id:${j.identifier.id.toLowerCase()}`},r=(j,q)=>(j.set(i(q),q),j),o=f.reduce(r,new Map),c=v.reduce(r,new Map),l=v.reduce((j,q)=>{const K=i(q);q=(0,p.deepClone)(q);const M=o.get(K);return M&&(M.installed&&(q.installed=!0),q.version||(q.version=M.version)),r(j,q)},new Map),u=C?C.reduce(r,new Map):null,m=d.reduce(r,new Map),b=w.reduce((j,q)=>{const K=s.get(q.toLowerCase());return j.add(K?`uuid:${K}`:`id:${q.toLowerCase()}`)},new Set),h=R(o,c,b);if(h.added.size>0||h.removed.size>0||h.updated.size>0){const j=R(u,o,b),q=R(u,c,b),K=(M,$)=>{const z=o.get(M);if(z){const W=c.get(M);return Object.assign(Object.assign({},$?W:z),{version:(W.version&&L.gt(W.version,z.version),z.version),state:U(z,W,u==null?void 0:u.get(M))})}};for(const M of q.removed.values()){const $=o.get(M);$&&g.push($.identifier)}for(const M of q.added.values())if(j.added.has(M)){if(h.updated.has(M)){const $=K(M,!0);$&&(a.push(n($,M)),l.set(M,$))}}else{const $=c.get(M);$.installed&&D.push(n($,M))}for(const M of q.updated.values()){const $=K(M,!0);$&&(a.push(n($,M)),l.set(M,$))}for(const M of j.added.values())q.added.has(M)||l.set(M,o.get(M));for(const M of j.updated.values())if(!q.removed.has(M)&&!q.updated.has(M)){const $=K(M,!1);$&&(((I=l.get(M))===null||I===void 0?void 0:I.installed)&&($.installed=!0),l.set(M,$))}for(const M of j.removed.values())!m.has(M)&&!q.updated.has(M)&&((E=u==null?void 0:u.get(M))===null||E===void 0?void 0:E.installed)&&l.delete(M)}const k=[],_=R(c,l,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(_.added.size>0||_.updated.size>0||_.removed.size>0)&&l.forEach((j,q)=>k.push(n(j,q))),{added:D,removed:g,updated:a,remote:k.length?k:null}}e.merge=O;function R(f,v,C,{checkInstalledProperty:d,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const I=f?[...f.keys()].filter(s=>!C.has(s)):[],E=[...v.keys()].filter(s=>!C.has(s)),D=E.filter(s=>I.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),g=I.filter(s=>E.indexOf(s)===-1).reduce((s,t)=>(s.add(t),s),new Set),a=new Set;for(const s of I)if(!g.has(s)){const t=f.get(s),i=v.get(s);(!i||t.disabled!==i.disabled||!S(t.state,i.state)||w&&t.version!==i.version||d&&t.installed!==i.installed)&&a.add(s)}return{added:D,removed:g,updated:a}}function U(f,v,C){const d=f.state,w=v.state,I=C==null?void 0:C.state;if(!v.version||d&&L.gt(f.version,v.version))return d;if(w&&L.gt(v.version,f.version)||!d)return w;if(!w)return d;const E=(0,p.deepClone)(d),D=I?A(I,w):{added:Object.keys(w).reduce((a,s)=>(a.add(s),a),new Set),removed:new Set,updated:new Set},g=I?A(I,d):{added:Object.keys(d).reduce((a,s)=>(a.add(s),a),new Set),removed:new Set,updated:new Set};for(const a of[...D.added.values(),...D.updated.values()])E[a]=w[a];for(const a of D.removed.values())g.updated.has(a)||delete E[a];return E}function A(f,v){const C=Object.keys(f),d=Object.keys(v),w=d.filter(D=>C.indexOf(D)===-1).reduce((D,g)=>(D.add(g),D),new Set),I=C.filter(D=>d.indexOf(D)===-1).reduce((D,g)=>(D.add(g),D),new Set),E=new Set;for(const D of C)if(!I.has(D)){const g=f[D],a=v[D];(0,p.equals)(g,a)||E.add(D)}return{added:w,removed:I,updated:E}}function S(f={},v={}){const{added:C,removed:d,updated:w}=A(f,v);return C.size===0&&d.size===0&&w.size===0}function y(f){return Object.assign(Object.assign({},f),{disabled:!!f.disabled,installed:!!f.installed})}function n(f,v){const C={identifier:{id:f.identifier.id,uuid:v.startsWith("uuid:")?v.substring("uuid:".length):void 0}};return f.version&&(C.version=f.version),f.disabled&&(C.disabled=!0),f.installed&&(C.installed=!0),f.state&&(C.state=f.state),C}}),define(Z[83],ee([0,1,19,3,2,34,4,28,20]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsStorageSyncService=e.IExtensionsStorageSyncService=void 0,e.IExtensionsStorageSyncService=(0,U.createDecorator)("IExtensionsStorageSyncService");const y=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let n=class Ze extends O.Disposable{constructor(v,C){super();this.storageService=v,this.productService=C,this._onDidChangeExtensionsStorage=this._register(new L.Emitter),this.onDidChangeExtensionsStorage=this._onDidChangeExtensionsStorage.event,this.extensionsWithKeysForSync=new Set,this.initialize(),this._register(this.storageService.onDidChangeValue(d=>this.onDidChangeStorageValue(d)))}static toKey(v){return`extensionKeys/${(0,R.adoptToGalleryExtensionId)(v.id)}@${v.version}`}static fromKey(v){const C=y.exec(v);if(C&&C[1])return{id:C[1],version:C[2]}}initialize(){const v=this.storageService.keys(0,1);for(const C of v){const d=Ze.fromKey(C);d&&this.extensionsWithKeysForSync.add(d.id.toLowerCase())}}onDidChangeStorageValue(v){if(v.scope===0){if(this.extensionsWithKeysForSync.has(v.key.toLowerCase())){this._onDidChangeExtensionsStorage.fire();return}const C=Ze.fromKey(v.key);if(C){this.extensionsWithKeysForSync.add(C.id.toLowerCase()),this._onDidChangeExtensionsStorage.fire();return}}}setKeysForSync(v,C){this.storageService.store(Ze.toKey(v),JSON.stringify(C),0,1)}getKeysForSync(v){var C;const d=(C=this.productService.extensionSyncedKeys)===null||C===void 0?void 0:C[v.id.toLowerCase()],w=this.storageService.get(Ze.toKey(v),0),I=w?JSON.parse(w):void 0;return I&&d?(0,p.distinct)([...I,...d]):I||d}};n=de([Y(0,S.IStorageService),Y(1,A.IProductService)],n),e.ExtensionsStorageSyncService=n}),define(Z[84],ee([0,1,19,23,4]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,O.createDecorator)("IIgnoredExtensionsManagementService");let R=class{constructor(A){this.configurationService=A}hasToNeverSyncExtension(A){return this.getConfiguredIgnoredExtensions().includes(A.toLowerCase())}hasToAlwaysSyncExtension(A){return this.getConfiguredIgnoredExtensions().includes(`-${A.toLowerCase()}`)}updateIgnoredExtensions(A,S){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return y=y.filter(n=>n!==A&&n!==`-${A}`),S&&y.push(A.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,1)}updateSynchronizedExtensions(A,S){let y=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(n=>n.toLowerCase());return y=y.filter(n=>n!==A&&n!==`-${A}`),S&&y.push(`-${A.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",y.length?y:void 0,1)}getIgnoredExtensions(A){const S=A.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),y=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),n=[],f=[];if(Array.isArray(y))for(const v of y)v.startsWith("-")?f.push(v.substring(1)):n.push(v);return(0,p.distinct)([...S,...n].filter(v=>f.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let A=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return A!==void 0||(A=this.configurationService.inspect("sync.ignoredExtensions").userValue,A!==void 0)?A:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(S=>S.toLowerCase())}};R=de([Y(0,L.IConfigurationService)],R),e.IgnoredExtensionsManagementService=R}),define(Z[186],ee([0,1,26,33,19,142,52]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function A(a){return(0,L.parse)(a)||[]}e.parseKeybindings=A;async function S(a,s,t,i,r){const o=A(a),c=A(s),l=t?A(t):null,u=[...o,...c,...l||[]].map(z=>z.key),m=await r.resolveUserBindings(u);let b=n(o,c,l,m);if(!b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:a,hasChanges:!1,hasConflicts:!1};if(!b.hasLocalForwarded&&b.hasRemoteForwarded)return{mergeContent:s,hasChanges:!0,hasConflicts:!1};if(b.hasLocalForwarded&&!b.hasRemoteForwarded)return{mergeContent:a,hasChanges:!0,hasConflicts:!1};const h=v(o),k=v(c),_=l?v(l):null,j=d(h,k,m),q=_?d(_,h,m):{added:[...h.keys()].reduce((z,W)=>(z.add(W),z),new Set),removed:new Set,updated:new Set},K=_?d(_,k,m):{added:[...k.keys()].reduce((z,W)=>(z.add(W),z),new Set),removed:new Set,updated:new Set},M=y(j,q,K);let $=a;for(const z of M.removed.values())M.conflicts.has(z)||($=D($,z,i));for(const z of M.added.values())if(!M.conflicts.has(z)){const W=k.get(z);if(W.some(H=>H.command!==`-${z}`&&b.conflicts.has(m[H.key]))){M.conflicts.add(z);continue}$=E($,W,i)}for(const z of M.updated.values())if(!M.conflicts.has(z)){const W=k.get(z);if(W.some(H=>H.command!==`-${z}`&&b.conflicts.has(m[H.key]))){M.conflicts.add(z);continue}$=g($,z,W,i)}return{mergeContent:$,hasChanges:!0,hasConflicts:M.conflicts.size>0}}e.merge=S;function y(a,s,t){const i=new Set,r=new Set,o=new Set,c=new Set;for(const l of s.removed.values())t.updated.has(l)&&c.add(l);for(const l of t.removed.values())c.has(l)||(s.updated.has(l)?c.add(l):r.add(l));for(const l of s.added.values())c.has(l)||t.added.has(l)&&a.updated.has(l)&&c.add(l);for(const l of t.added.values())c.has(l)||(s.added.has(l)?a.updated.has(l)&&c.add(l):i.add(l));for(const l of s.updated.values())c.has(l)||t.updated.has(l)&&a.updated.has(l)&&c.add(l);for(const l of t.updated.values())c.has(l)||(s.updated.has(l)?a.updated.has(l)&&c.add(l):o.add(l));return{added:i,removed:r,updated:o,conflicts:c}}function n(a,s,t,i){const r=new Set,o=f(a,i),c=f(s,i),l=t?f(t,i):null,u=C(o,c);if(u.added.size===0&&u.removed.size===0&&u.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const m=l?C(l,o):{added:[...o.keys()].reduce((q,K)=>(q.add(K),q),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:r,removed:r,updated:r,conflicts:r};const b=l?C(l,c):{added:[...c.keys()].reduce((q,K)=>(q.add(K),q),new Set),removed:new Set,updated:new Set};if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:r,removed:r,updated:r,conflicts:r};const{added:h,removed:k,updated:_,conflicts:j}=y(u,m,b);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:h,removed:k,updated:_,conflicts:j}}function f(a,s){const t=new Map;for(const i of a){const r=s[i.key];let o=t.get(r);o||(o=[],t.set(r,o)),o.push(i)}return t}function v(a){const s=new Map;for(const t of a){const i=t.command[0]==="-"?t.command.substring(1):t.command;let r=s.get(i);r||(r=[],s.set(i,r)),r.push(t)}return s}function C(a,s){const t=[...a.keys()],i=[...s.keys()],r=i.filter(l=>t.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),o=t.filter(l=>i.indexOf(l)===-1).reduce((l,u)=>(l.add(u),l),new Set),c=new Set;for(const l of t)if(!o.has(l)){const u=a.get(l).map(b=>Object.assign(Object.assign({},b),{key:l})),m=s.get(l).map(b=>Object.assign(Object.assign({},b),{key:l}));(0,O.equals)(u,m,(b,h)=>I(b,h))||c.add(l)}return{added:r,removed:o,updated:c}}function d(a,s,t){const i=[...a.keys()],r=[...s.keys()],o=r.filter(u=>i.indexOf(u)===-1).reduce((u,m)=>(u.add(m),u),new Set),c=i.filter(u=>r.indexOf(u)===-1).reduce((u,m)=>(u.add(m),u),new Set),l=new Set;for(const u of i)if(!c.has(u)){const m=a.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]})),b=s.get(u).map(h=>Object.assign(Object.assign({},h),{key:t[h.key]}));w(m,b)||l.add(u)}return{added:o,removed:c,updated:l}}function w(a,s){return!(!(0,O.equals)(a.filter(({command:t})=>t[0]!=="-"),s.filter(({command:t})=>t[0]!=="-"),(t,i)=>I(t,i))||!(0,O.equals)(a.filter(({command:t})=>t[0]==="-"),s.filter(({command:t})=>t[0]==="-"),(t,i)=>I(t,i)))}function I(a,s){if(a.command!==s.command||a.key!==s.key)return!1;const t=R.ContextKeyExpr.deserialize(a.when),i=R.ContextKeyExpr.deserialize(s.when);return!(t&&!i||!t&&i||t&&i&&!t.equals(i)||!p.equals(a.args,s.args))}function E(a,s,t){for(const i of s)a=U.edit(a,[-1],i,t);return a}function D(a,s,t){const i=A(a);for(let r=i.length-1;r>=0;r--)(i[r].command===s||i[r].command===`-${s}`)&&(a=U.edit(a,[r],void 0,t));return a}function g(a,s,t,i){const r=A(a),o=r.findIndex(c=>c.command===s||c.command===`-${s}`);for(let c=r.length-1;c>=0;c--)(r[c].command===s||r[c].command===`-${s}`)&&(a=U.edit(a,[c],void 0,i));for(let c=t.length-1;c>=0;c--)a=U.edit(a,[o],t[c],i);return a}}),define(Z[187],ee([0,1]),function(G,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function p(R,U,A){const S={},y={},n=new Set;if(!U)return{local:{added:S,updated:y,removed:[...n.values()]},remote:{added:R,updated:{},removed:[]},conflicts:[]};const f=L(R,U);if(f.added.size===0&&f.removed.size===0&&f.updated.size===0)return{local:{added:S,updated:y,removed:[...n.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=L(A,R),C=L(A,U),d={},w={},I=new Set,E=new Set;for(const D of v.removed.values())C.updated.has(D)?S[D]=U[D]:I.add(D);for(const D of C.removed.values())E.has(D)||(v.updated.has(D)?E.add(D):n.add(D));for(const D of v.updated.values())E.has(D)||(C.updated.has(D)?f.updated.has(D)&&E.add(D):w[D]=R[D]);for(const D of C.updated.values())E.has(D)||(v.updated.has(D)?f.updated.has(D)&&E.add(D):R[D]!==void 0&&(y[D]=U[D]));for(const D of v.added.values())E.has(D)||(C.added.has(D)?f.updated.has(D)&&E.add(D):d[D]=R[D]);for(const D of C.added.values())E.has(D)||(v.added.has(D)?f.updated.has(D)&&E.add(D):S[D]=U[D]);return{local:{added:S,removed:[...n.values()],updated:y},remote:{added:d,removed:[...I.values()],updated:w},conflicts:[...E.values()]}}e.merge=p;function L(R,U){const A=R?Object.keys(R):[],S=U?Object.keys(U):[],y=S.filter(v=>A.indexOf(v)===-1).reduce((v,C)=>(v.add(C),v),new Set),n=A.filter(v=>S.indexOf(v)===-1).reduce((v,C)=>(v.add(C),v),new Set),f=new Set;for(const v of A)if(!n.has(v)){const C=R[v],d=U[v];C!==d&&f.add(v)}return{added:y,removed:n,updated:f}}function O(R,U){const{added:A,removed:S,updated:y}=L(R,U);return A.size===0&&S.size===0&&y.size===0}e.areSame=O}),define(Z[21],ee([0,1,4,29,32,38,126,79,14,19,15]),function(G,e,p,L,O,R,U,A,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataAutoSyncEnablementService=e.IUserDataSyncService=e.IUserDataSyncResourceEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function f(){const c=O.Registry.as(R.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(l=>!!c[l].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=f;function v(){const c=O.Registry.as(R.Extensions.Configuration).getConfigurationProperties(),l=Object.keys(c).filter(b=>!!c[b].ignoreSync),u=Object.keys(c).filter(b=>c[b].scope===2||c[b].scope===6),m=f();return(0,y.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...l,...u,...m])}e.getDefaultIgnoredSettings=v;function C(){const c="vscode://schemas/ignoredSettings",l=O.Registry.as(R.Extensions.Configuration);l.registerConfiguration({id:"settingsSync",order:30,title:(0,U.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,U.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,U.localize)(2,null),items:[{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,U.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,U.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const u=O.Registry.as(A.Extensions.JSONContribution),m=()=>{const b=f(),h=v().filter(q=>q!==e.CONFIGURATION_SYNC_STORE_KEY),k=Object.keys(R.allSettings.properties).filter(q=>h.indexOf(q)===-1),_=h.filter(q=>b.indexOf(q)===-1),j={items:{type:"string",enum:[...k,..._.map(q=>`-${q}`)]}};u.registerSchema(c,j)};return l.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=C;function d(c){return c&&(0,n.isObject)(c)&&(0,n.isString)(c.id)&&(0,n.isArray)(c.scopes)}e.isAuthenticationProvider=d;var w;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Extensions="extensions",c.GlobalState="globalState"})(w=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","extensions","globalState"],e.IUserDataSyncStoreManagementService=(0,p.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,p.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,p.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function I(c){const l={};return l[e.HEADER_EXECUTION_ID]=c,l}e.createSyncHeaders=I;var E;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.NoRef="NoRef",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(E=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class D extends Error{constructor(l,u,m,b){super(l);this.code=u,this.resource=m,this.operationId=b,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=D;class g extends D{constructor(l,u,m,b){super(l,m,void 0,b);this.url=u}}e.UserDataSyncStoreError=g;class a extends D{constructor(l,u){super(l,u)}}e.UserDataAutoSyncError=a,function(c){function l(u){if(u instanceof c)return u;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(u.name);if(m&&m[1]){const b=m[2]==="unknown"?void 0:m[2],h=m[3]==="unknown"?void 0:m[3];return new c(u.message,m[1],b,h)}return new c(u.message,E.Unknown)}c.toUserDataSyncError=l}(D=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var t;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(t=e.Change||(e.Change={}));var i;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(i=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function r(c){return`sync.enable.${c}`}e.getEnablementKey=r,e.IUserDataSyncResourceEnablementService=(0,p.createDecorator)("IUserDataSyncResourceEnablementService"),e.IUserDataSyncService=(0,p.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncEnablementService=(0,p.createDecorator)("IUserDataAutoSyncEnablementService"),e.IUserDataAutoSyncService=(0,p.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,p.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,p.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,l){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:l.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(u=>(0,S.isEqualOrParent)(c,(0,S.joinPath)(l.userDataSyncHome,u,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(Z[46],ee([0,1,2,10,25,5,21,9,14,8,3,24,33,122,23,15,22,19,45,20,30]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function s(l){return!!(l&&l.version!==void 0&&typeof l.version=="number"&&l.content!==void 0&&typeof l.content=="string"&&(Object.keys(l).length===2||Object.keys(l).length===3&&l.machineId!==void 0&&typeof l.machineId=="string"))}e.isSyncData=s;function t(l,u,m){return m.joinPath(u.userDataSyncHome,l,`lastSync${l}.json`)}let i=class extends p.Disposable{constructor(u,m,b,h,k,_,j,q,K,M){super();this.resource=u,this.fileService=m,this.environmentService=b,this.userDataSyncStoreService=k,this.userDataSyncBackupStoreService=_,this.userDataSyncResourceEnablementService=j,this.telemetryService=q,this.logService=K,this.configurationService=M,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new n.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new n.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerScheduler=new y.RunOnceScheduler(()=>this.doTriggerLocalChange(),50),this._onDidChangeLocal=this._register(new n.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=this.fileService.hasCapability(b.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.syncFolder=this.extUri.joinPath(b.userDataSyncHome,u),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,U.PREVIEW_DIR_NAME),this.lastSyncResource=t(u,b,this.extUri),this.currentMachineIdPromise=(0,D.getServiceMachineId)(b,m,h)}get status(){return this._status}get conflicts(){return this._conflicts}isEnabled(){return this.userDataSyncResourceEnablementService.isResourceEnabled(this.resource)}async triggerLocalChange(){this.isEnabled()&&this.localChangeTriggerScheduler.schedule()}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const u=await this.syncPreviewPromise;this.syncPreviewPromise=null;const m=await this.performSync(u.remoteUserData,u.lastSyncUserData,!0);this.setStatus(m)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const u=await this.getLastSyncUserData();(u?(await this.doGenerateSyncResourcePreview(u,u,!0,a.CancellationToken.None)).resourcePreviews.some(({remoteChange:b})=>b!==0):!0)&&this._onDidChangeLocal.fire()}}setStatus(u){if(this._status!==u){const m=this._status;u==="hasConflicts"&&this.telemetryService.publicLog2("sync/conflictsDetected",{source:this.resource}),m==="hasConflicts"&&u==="idle"&&this.telemetryService.publicLog2("sync/conflictsResolved",{source:this.resource}),this._status=u,this._onDidChangStatus.fire(u)}}async sync(u,m={}){await this._sync(u,!0,m)}async preview(u,m={}){return this._sync(u,!1,m)}async apply(u,m={}){try{this.syncHeaders=Object.assign({},m);const b=await this.doApply(u);return this.setStatus(b),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(u,m,b){try{if(this.syncHeaders=Object.assign({},b),!this.isEnabled())return this.status!=="idle"&&await this.stop(),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is disabled.`),null;if(this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let h="idle";try{const k=await this.getLastSyncUserData(),_=await this.getLatestRemoteUserData(u,k);return h=await this.performSync(_,k,m),h==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):h==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(h)}}finally{this.syncHeaders={}}}async replace(u){const m=await this.resolveContent(u);if(!m)return!1;const b=this.parseSyncData(m);if(!b)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const h=await this.getLastSyncUserData(),k=await this.getLatestRemoteUserData(null,h),_=await this.generateSyncPreview({ref:k.ref,syncData:b},h,a.CancellationToken.None),j=[];for(const q of _){const K=await this.getAcceptResult(q,q.remoteResource,void 0,a.CancellationToken.None),{remoteChange:M}=await this.getAcceptResult(q,q.previewResource,q.remoteContent,a.CancellationToken.None);j.push([q,Object.assign(Object.assign({},K),{remoteChange:M!==0?M:2})])}await this.applyResult(k,h,j,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async getLatestRemoteUserData(u,m){if(m){const b=u&&u.latest?u.latest[this.resource]:void 0;if(m.ref===b||b===void 0&&m.syncData===null)return m}return this.getRemoteUserData(m)}async performSync(u,m,b){if(u.syncData&&u.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new U.UserDataSyncError((0,C.localize)(0,null,this.resource,this.version,u.syncData.version),U.UserDataSyncErrorCode.IncompatibleLocalContent,this.resource);try{return await this.doSync(u,m,b)}catch(h){if(h instanceof U.UserDataSyncError)switch(h.code){case U.UserDataSyncErrorCode.LocalPreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(u,m,b);case U.UserDataSyncErrorCode.Conflict:case U.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),u=await this.getRemoteUserData(null),m=await this.getLastSyncUserData(),this.performSync(u,m,b)}throw h}}async doSync(u,m,b){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,y.createCancelablePromise)(k=>this.doGenerateSyncResourcePreview(u,m,b,k)));const h=await this.syncPreviewPromise;return this.updateConflicts(h.resourcePreviews),h.resourcePreviews.some(({mergeState:k})=>k==="conflict")?"hasConflicts":b?await this.doApply(!1):"syncing"}catch(h){throw this.syncPreviewPromise=null,h}}async merge(u){return await this.updateSyncResourcePreview(u,async m=>{const b=await this.getMergeResult(m,a.CancellationToken.None);await this.fileService.writeFile(m.previewResource,O.VSBuffer.fromString((b==null?void 0:b.content)||""));const h=b&&!b.hasConflicts?await this.getAcceptResult(m,m.previewResource,void 0,a.CancellationToken.None):void 0;return m.acceptResult=h,m.mergeState=b.hasConflicts?"conflict":h?"accepted":"preview",m.localChange=h?h.localChange:b.localChange,m.remoteChange=h?h.remoteChange:b.remoteChange,m}),this.syncPreviewPromise}async accept(u,m){return await this.updateSyncResourcePreview(u,async b=>{const h=await this.getAcceptResult(b,u,m,a.CancellationToken.None);return b.acceptResult=h,b.mergeState="accepted",b.localChange=h.localChange,b.remoteChange=h.remoteChange,b}),this.syncPreviewPromise}async discard(u){return await this.updateSyncResourcePreview(u,async m=>{const b=await this.getMergeResult(m,a.CancellationToken.None);return await this.fileService.writeFile(m.previewResource,O.VSBuffer.fromString(b.content||"")),m.acceptResult=void 0,m.mergeState="preview",m.localChange=b.localChange,m.remoteChange=b.remoteChange,m}),this.syncPreviewPromise}async updateSyncResourcePreview(u,m){if(!!this.syncPreviewPromise){let b=await this.syncPreviewPromise;const h=b.resourcePreviews.findIndex(({localResource:k,remoteResource:_,previewResource:j})=>this.extUri.isEqual(k,u)||this.extUri.isEqual(_,u)||this.extUri.isEqual(j,u));h!==-1&&(this.syncPreviewPromise=(0,y.createCancelablePromise)(async k=>{const _=[...b.resourcePreviews];return _[h]=await m(_[h]),Object.assign(Object.assign({},b),{resourcePreviews:_})}),b=await this.syncPreviewPromise,this.updateConflicts(b.resourcePreviews),b.resourcePreviews.some(({mergeState:k})=>k==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}}async doApply(u){if(!this.syncPreviewPromise)return"idle";const m=await this.syncPreviewPromise;return m.resourcePreviews.some(({mergeState:b})=>b==="conflict")?"hasConflicts":m.resourcePreviews.some(({mergeState:b})=>b!=="accepted")?"syncing":(await this.applyResult(m.remoteUserData,m.lastSyncUserData,m.resourcePreviews.map(b=>[b,b.acceptResult]),u),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch(u){}}updateConflicts(u){const m=u.filter(({mergeState:b})=>b==="conflict");(0,E.equals)(this._conflicts,m,(b,h)=>this.extUri.isEqual(b.previewResource,h.previewResource))||(this._conflicts=m,this._onDidChangeConflicts.fire(m))}async hasPreviouslySynced(){return!!await this.getLastSyncUserData()}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:m,ref:b})=>({created:m,uri:this.toRemoteBackupResource(b)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:m,ref:b})=>({created:m,uri:this.toLocalBackupResource(b)}))}toRemoteBackupResource(u){return R.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${u}`})}toLocalBackupResource(u){return R.URI.from({scheme:U.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${u}`})}async getMachineId({uri:u}){const m=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(m))){const{content:b}=await this.getUserData(m);if(b){const h=this.parseSyncData(b);return h==null?void 0:h.machineId}}}async resolveContent(u){const m=this.extUri.basename(u);if(this.extUri.isEqual(u,this.toRemoteBackupResource(m))){const{content:b}=await this.getUserData(m);return b}return this.extUri.isEqual(u,this.toLocalBackupResource(m))?this.userDataSyncBackupStoreService.resolveContent(this.resource,m):null}async resolvePreviewContent(u){const m=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(m)for(const b of m.resourcePreviews){if(this.extUri.isEqual(b.acceptedResource,u))return b.acceptResult?b.acceptResult.content:null;if(this.extUri.isEqual(b.remoteResource,u))return b.remoteContent;if(this.extUri.isEqual(b.localResource,u))return b.localContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch(u){}}async doGenerateSyncResourcePreview(u,m,b,h){var k;const _=await this.currentMachineIdPromise,j=!!((k=u.syncData)===null||k===void 0?void 0:k.machineId)&&u.syncData.machineId===_,q=m===null&&j&&!this.hasSyncResourceStateVersionChanged?u:m,K=await this.generateSyncPreview(u,q,h),M=[];for(const $ of K){const z=$.previewResource.with({scheme:U.USER_DATA_SYNC_SCHEME,authority:"accepted"});if($.localChange===0&&$.remoteChange===0)M.push(Object.assign(Object.assign({},$),{acceptedResource:z,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"}));else{const W=b?await this.getMergeResult($,h):void 0;if(h.isCancellationRequested)break;await this.fileService.writeFile($.previewResource,O.VSBuffer.fromString((W==null?void 0:W.content)||""));const H=W&&!W.hasConflicts?await this.getAcceptResult($,$.previewResource,void 0,h):void 0;M.push(Object.assign(Object.assign({},$),{acceptResult:H,mergeState:(W==null?void 0:W.hasConflicts)?"conflict":H?"accepted":"preview",localChange:H?H.localChange:W?W.localChange:$.localChange,remoteChange:H?H.remoteChange:W?W.remoteChange:$.remoteChange}))}}return{remoteUserData:u,lastSyncUserData:m,resourcePreviews:M,isLastSyncFromCurrentMachine:j}}async getLastSyncUserData(){try{const u=await this.fileService.readFile(this.lastSyncResource),m=JSON.parse(u.value.toString()),b=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=m.version&&b&&m.version!==b,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${m.version} is not compatible with current sync state version ${b}.`),await this.resetLocal(),null;const h=m;if(h.content===null)return{ref:m.ref,syncData:null};const k=JSON.parse(h.content);if(s(k))return Object.assign(Object.assign({},m),{syncData:k,content:void 0})}catch(u){u instanceof L.FileOperationError&&u.fileOperationResult===1||this.logService.error(u)}return null}async updateLastSyncUserData(u,m={}){if(m.ref||m.content||m.version)throw new Error("Cannot have core properties as additional");const b=this.userDataSyncResourceEnablementService.getResourceSyncStateVersion(this.resource),h=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null,version:b},m);await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(h)))}async getRemoteUserData(u){const{ref:m,content:b}=await this.getUserData(u);let h=null;return b!==null&&(h=this.parseSyncData(b)),{ref:m,syncData:h}}parseSyncData(u){try{const m=JSON.parse(u);if(s(m))return m}catch(m){this.logService.error(m)}throw new U.UserDataSyncError((0,C.localize)(1,null),U.UserDataSyncErrorCode.IncompatibleRemoteContent,this.resource)}async getUserData(u){if((0,w.isString)(u)){const m=await this.userDataSyncStoreService.resolveContent(this.resource,u);return{ref:u,content:m}}else{const m=u?{ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,m,this.syncHeaders)}}async updateRemoteUserData(u,m){const b=await this.currentMachineIdPromise,h={version:this.version,machineId:b,content:u};return m=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(h),m,this.syncHeaders),{ref:m,syncData:h}}async backupLocal(u){const m={version:this.version,content:u};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(m))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}};i=de([Y(1,L.IFileService),Y(2,A.IEnvironmentService),Y(3,g.IStorageService),Y(4,U.IUserDataSyncStoreService),Y(5,U.IUserDataSyncBackupStoreService),Y(6,U.IUserDataSyncResourceEnablementService),Y(7,f.ITelemetryService),Y(8,U.IUserDataSyncLogService),Y(9,d.IConfigurationService)],i),e.AbstractSynchroniser=i;let r=class extends i{constructor(u,m,b,h,k,_,j,q,K,M,$){super(m,b,h,k,_,j,q,K,M,$);this.file=u,this._register(this.fileService.watch(this.extUri.dirname(u))),this._register(this.fileService.onDidFilesChange(z=>this.onFileChanges(z)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch(u){return null}}async updateLocalFileContent(u,m,b){try{m?await this.fileService.writeFile(this.file,O.VSBuffer.fromString(u),b?void 0:m):await this.fileService.createFile(this.file,O.VSBuffer.fromString(u),{overwrite:b})}catch(h){throw h instanceof L.FileOperationError&&h.fileOperationResult===1||h instanceof L.FileOperationError&&h.fileOperationResult===3?new U.UserDataSyncError(h.message,U.UserDataSyncErrorCode.LocalPreconditionFailed):h}}onFileChanges(u){!u.contains(this.file)||this.triggerLocalChange()}};r=de([Y(2,L.IFileService),Y(3,A.IEnvironmentService),Y(4,g.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,d.IConfigurationService)],r),e.AbstractFileSynchroniser=r;let o=class extends r{constructor(u,m,b,h,k,_,j,q,K,M,$,z){super(u,m,b,h,k,_,j,q,K,M,z);this.userDataSyncUtilService=$,this._formattingOptions=void 0}hasErrors(u){const m=[];return(0,v.parse)(u,m,{allowEmptyContent:!0,allowTrailingComma:!0}),m.length>0}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=de([Y(2,L.IFileService),Y(3,A.IEnvironmentService),Y(4,g.IStorageService),Y(5,U.IUserDataSyncStoreService),Y(6,U.IUserDataSyncBackupStoreService),Y(7,U.IUserDataSyncResourceEnablementService),Y(8,f.ITelemetryService),Y(9,U.IUserDataSyncLogService),Y(10,U.IUserDataSyncUtilService),Y(11,d.IConfigurationService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(u,m,b,h){this.resource=u,this.environmentService=m,this.logService=b,this.fileService=h,this.extUri=this.fileService.hasCapability(m.userDataSyncHome,1024)?S.extUri:S.extUriIgnorePathCase,this.lastSyncResource=t(this.resource,m,S.extUri)}async initialize({ref:u,content:m}){if(!m){this.logService.info("Remote content does not exist.",this.resource);return}const b=this.parseSyncData(m);if(!!b){if(await this.fileService.exists(this.lastSyncResource)){this.logService.info("Remote content does not exist.",this.resource);return}try{await this.doInitialize({ref:u,syncData:b})}catch(k){this.logService.error(k)}}}parseSyncData(u){try{const m=JSON.parse(u);if(s(m))return m}catch(m){this.logService.error(m)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(u,m={}){const b=Object.assign({ref:u.ref,content:u.syncData?JSON.stringify(u.syncData):null},m);await this.fileService.writeFile(this.lastSyncResource,O.VSBuffer.fromString(JSON.stringify(b)))}};c=de([Y(1,A.IEnvironmentService),Y(2,U.IUserDataSyncLogService),Y(3,L.IFileService)],c),e.AbstractInitializer=c}),define(Z[188],ee([0,1,21,3,9,29,34,10,23,185,46,24,5,47,41,22,20,84,11,83,8]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=e.storeExtensionStorageState=e.getExtensionStorageState=void 0;async function s(c,l){const u=JSON.parse(c.content);if(c.version===1||c.version===2){const m=(await l.getInstalled(0)).filter(b=>b.isBuiltin);for(const b of u)c.version===1&&(b.enabled===!1&&(b.disabled=!0),delete b.enabled),c.version===2&&m.every(h=>!(0,U.areSameExtensions)(h.identifier,b.identifier))&&(b.installed=!0)}return u}function t(c,l,u){const m=u.get((0,U.getExtensionId)(c,l),0)||"{}";return JSON.parse(m)}e.getExtensionStorageState=t;function i(c,l,u,m){m.store((0,U.getExtensionId)(c,l),JSON.stringify(u),0,1)}e.storeExtensionStorageState=i;let r=class ot extends n.AbstractSynchroniser{constructor(l,u,m,b,h,k,_,j,q,K,M,$,z,W){super("extensions",u,l,m,b,h,$,z,q,M);this.storageService=m,this.extensionManagementService=k,this.extensionEnablementService=_,this.ignoredExtensionsManagementService=j,this.extensionGalleryService=K,this.extensionsStorageSyncService=W,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.debounce(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtension,H=>!!H.gallery),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,H=>!H.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionsStorageSyncService.onDidChangeExtensionsStorage),()=>{},500)(()=>this.triggerLocalChange()))}isEnabled(){return super.isEnabled()&&this.extensionGalleryService.isEnabled()}async generateSyncPreview(l,u){const m=l.syncData?await s(l.syncData,this.extensionManagementService):null,b=(u==null?void 0:u.skippedExtensions)||[],h=(u==null?void 0:u.syncData)?await s(u.syncData,this.extensionManagementService):null,k=await this.extensionManagementService.getInstalled(),_=this.getLocalExtensions(k),j=this.ignoredExtensionsManagementService.getIgnoredExtensions(k);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{added:q,removed:K,updated:M,remote:$}=(0,y.merge)(_,m,h,b,j),z={added:q,removed:K,updated:M,remote:$,content:this.getPreviewContent(_,q,M,K),localChange:q.length>0||K.length>0||M.length>0?2:0,remoteChange:$!==null?2:0};return[{skippedExtensions:b,localResource:this.localResource,localContent:this.format(_),localExtensions:_,remoteResource:this.remoteResource,remoteContent:m?this.format(m):null,previewResource:this.previewResource,previewResult:z,localChange:z.localChange,remoteChange:z.remoteChange,acceptedResource:this.acceptedResource}]}getPreviewContent(l,u,m,b){const h=[...u,...m],k=new Set,_=j=>{k.add(j.id.toLowerCase()),j.uuid&&k.add(j.uuid)};h.forEach(({identifier:j})=>_(j)),b.forEach(_);for(const j of l)k.has(j.identifier.id.toLowerCase())||j.identifier.uuid&&k.has(j.identifier.uuid)||h.push(j);return this.format(h)}async getMergeResult(l,u){return Object.assign(Object.assign({},l.previewResult),{hasConflicts:!1})}async getAcceptResult(l,u,m,b){if(this.extUri.isEqual(u,this.localResource))return this.acceptLocal(l);if(this.extUri.isEqual(u,this.remoteResource))return this.acceptRemote(l);if(this.extUri.isEqual(u,this.previewResource))return l.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async acceptLocal(l){const u=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),b=(0,y.merge)(l.localExtensions,null,null,l.skippedExtensions,m),{added:h,removed:k,updated:_,remote:j}=b;return{content:l.localContent,added:h,removed:k,updated:_,remote:j,localChange:h.length>0||k.length>0||_.length>0?2:0,remoteChange:j!==null?2:0}}async acceptRemote(l){const u=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(u),b=l.remoteContent?JSON.parse(l.remoteContent):null;if(b!==null){const h=(0,y.merge)(l.localExtensions,b,l.localExtensions,[],m),{added:k,removed:_,updated:j,remote:q}=h;return{content:l.remoteContent,added:k,removed:_,updated:j,remote:q,localChange:k.length>0||_.length>0||j.length>0?2:0,remoteChange:q!==null?2:0}}else return{content:l.remoteContent,added:[],removed:[],updated:[],remote:null,localChange:0,remoteChange:0}}async applyResult(l,u,m,b){let{skippedExtensions:h,localExtensions:k}=m[0][0],{added:_,removed:j,updated:q,remote:K,localChange:M,remoteChange:$}=m[0][1];if(M===0&&$===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),M!==0&&(await this.backupLocal(JSON.stringify(k)),h=await this.updateLocalExtensions(_,j,q,h)),K){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const z=JSON.stringify(K);l=await this.updateRemoteUserData(z,b?null:l.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions`)}(u==null?void 0:u.ref)!==l.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(l,{skippedExtensions:h}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions`))}async getAssociatedResources({uri:l}){return[{resource:this.extUri.joinPath(l,"extensions.json"),comparableResource:ot.EXTENSIONS_DATA_URI}]}async resolveContent(l){if(this.extUri.isEqual(l,ot.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),b=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),h=this.getLocalExtensions(m).filter(k=>!b.some(_=>(0,U.areSameExtensions)({id:_},k.identifier)));return this.format(h)}if(this.extUri.isEqual(this.remoteResource,l)||this.extUri.isEqual(this.localResource,l)||this.extUri.isEqual(this.acceptedResource,l))return this.resolvePreviewContent(l);let u=await super.resolveContent(l);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(l)),u){const m=this.parseSyncData(u);if(m)switch(this.extUri.basename(l)){case"extensions.json":return this.format(this.parseExtensions(m))}}return null}format(l){l.sort((b,h)=>!b.identifier.uuid&&h.identifier.uuid?-1:b.identifier.uuid&&!h.identifier.uuid?1:(0,w.compare)(b.identifier.id,h.identifier.id));const u=JSON.stringify(l),m=(0,C.format)(u,void 0,{});return(0,d.applyEdits)(u,m)}async hasLocalData(){try{const l=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(l).some(m=>m.installed||m.disabled))return!0}catch(l){}return!1}async updateLocalExtensions(l,u,m,b){const h=[],k=[],_=await this.extensionManagementService.getInstalled();if(u.length){const q=_.filter(({identifier:K,isBuiltin:M})=>!M&&u.some($=>(0,U.areSameExtensions)(K,$)));await a.Promises.settled(q.map(async K=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,K.identifier.id),await this.extensionManagementService.uninstall(K,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,K.identifier.id),h.push(K.identifier)}))}(l.length||m.length)&&await a.Promises.settled([...l,...m].map(async q=>{const K=_.find($=>(0,U.areSameExtensions)($.identifier,q.identifier));if(K&&K.isBuiltin){q.state&&K.manifest.version===q.version&&this.updateExtensionState(q.state,K.manifest.publisher,K.manifest.name,K.manifest.version),q.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,q.identifier.id),await this.extensionEnablementService.disableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,q.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,q.identifier.id),await this.extensionEnablementService.enableExtension(q.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,q.identifier.id)),h.push(q.identifier);return}const M=await this.extensionGalleryService.getCompatibleExtension(q.identifier);if(q.state&&(K?K.manifest.version===q.version:!!M)){const $=K?K.manifest.publisher:M.publisher,z=K?K.manifest.name:M.name;this.updateExtensionState(q.state,$,z,K==null?void 0:K.manifest.version)}if(M)try{q.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,q.identifier.id,M.version),await this.extensionEnablementService.disableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,q.identifier.id,M.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,q.identifier.id,M.version),await this.extensionEnablementService.enableExtension(M.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,q.identifier.id,M.version)),K||(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,q.identifier.id,M.version),await this.extensionManagementService.installFromGallery(M,{isMachineScoped:!1,donotIncludePackAndDependencies:!0}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,q.identifier.id,M.version),h.push(M.identifier))}catch($){k.push(q),this.logService.error($),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,M.displayName||M.identifier.id)}else k.push(q)}));const j=[];for(const q of b)h.some(K=>(0,U.areSameExtensions)(K,q.identifier))||j.push(q);for(const q of k)j.some(K=>(0,U.areSameExtensions)(K.identifier,q.identifier))||j.push(q);return j}updateExtensionState(l,u,m,b){const h=t(u,m,this.storageService),k=b?this.extensionsStorageSyncService.getKeysForSync({id:(0,U.getGalleryExtensionId)(u,m),version:b}):void 0;k?k.forEach(_=>{h[_]=l[_]}):Object.keys(l).forEach(_=>h[_]=l[_]),i(u,m,h,this.storageService)}parseExtensions(l){return JSON.parse(l.content)}getLocalExtensions(l){const u=this.extensionEnablementService.getDisabledExtensions();return l.map(({identifier:m,isBuiltin:b,manifest:h})=>{const k={identifier:m,version:h.version};u.some(_=>(0,U.areSameExtensions)(_,m))&&(k.disabled=!0),b||(k.installed=!0);try{const _=this.extensionsStorageSyncService.getKeysForSync({id:m.id,version:h.version});if(_){const j=t(h.publisher,h.name,this.storageService);k.state=Object.keys(j).reduce((q,K)=>(_.includes(K)&&(q[K]=j[K]),q),{})}}catch(_){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,D.getErrorMessage)(_))}return k})}};r.EXTENSIONS_DATA_URI=v.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),r=de([Y(0,O.IEnvironmentService),Y(1,A.IFileService),Y(2,I.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,R.IExtensionManagementService),Y(6,R.IGlobalExtensionEnablementService),Y(7,E.IIgnoredExtensionsManagementService),Y(8,p.IUserDataSyncLogService),Y(9,R.IExtensionGalleryService),Y(10,S.IConfigurationService),Y(11,p.IUserDataSyncResourceEnablementService),Y(12,f.ITelemetryService),Y(13,g.IExtensionsStorageSyncService)],r),e.ExtensionsSynchroniser=r;let o=class extends n.AbstractInitializer{constructor(l,u,m,b,h){super("extensions",b,h,m);this.extensionManagementService=l,this.ignoredExtensionsManagementService=u}async parseExtensions(l){return l.syncData?await s(l.syncData,this.extensionManagementService):null}generatePreview(l,u){const m=[],b=[],h=[];for(const k of l)if(!this.ignoredExtensionsManagementService.hasToNeverSyncExtension(k.identifier.id)){const _=u.find(j=>(0,U.areSameExtensions)(j.identifier,k.identifier));_?(m.push(_),k.disabled&&h.push(k.identifier)):k.installed&&(b.push(k.identifier),k.disabled&&h.push(k.identifier))}return{installedExtensions:m,newExtensions:b,disabledExtensions:h,remoteExtensions:l}}};o=de([Y(0,R.IExtensionManagementService),Y(1,E.IIgnoredExtensionsManagementService),Y(2,A.IFileService),Y(3,O.IEnvironmentService),Y(4,p.IUserDataSyncLogService)],o),e.AbstractExtensionsInitializer=o}),define(Z[189],ee([0,1,26,21]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(A,S,y,n,f){if(!S)return{remote:Object.keys(A).length>0?A:null,local:{added:{},removed:[],updated:{}}};const v=R(A,S);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const C=y?R(y,S):{added:Object.keys(S).reduce((D,g)=>(D.add(g),D),new Set),removed:new Set,updated:new Set},d=y?R(y,A):{added:Object.keys(A).reduce((D,g)=>(D.add(g),D),new Set),removed:new Set,updated:new Set},w={added:{},removed:[],updated:{}},I=p.deepClone(S),E=!y;for(const D of d.added.values())D!==L.SYNC_SERVICE_URL_TYPE&&E&&C.added.has(D)||(I[D]=A[D]);for(const D of d.updated.values())I[D]=A[D];for(const D of d.removed.values())n.unregistered.includes(D)||delete I[D];for(const D of C.added.values()){const g=S[D];if(n.machine.includes(D)){f.info(`GlobalState: Skipped adding ${D} in local storage because it is declared as machine scoped.`);continue}if(!(y&&d.added.has(D))){const a=A[D];a&&a.value===g.value||D===L.SYNC_SERVICE_URL_TYPE&&E&&d.added.has(D)||(a?w.updated[D]=g:w.added[D]=g)}}for(const D of C.updated.values()){const g=S[D];if(n.machine.includes(D)){f.info(`GlobalState: Skipped updating ${D} in local storage because it is declared as machine scoped.`);continue}if(!(d.updated.has(D)||d.removed.has(D))){const a=A[D];a&&a.value===g.value||(w.updated[D]=g)}}for(const D of C.removed.values()){if(n.machine.includes(D)){f.trace(`GlobalState: Skipped removing ${D} in local storage because it is declared as machine scoped.`);continue}d.updated.has(D)||d.removed.has(D)||w.removed.push(D)}return{local:w,remote:U(I,S)?null:I}}e.merge=O;function R(A,S){const y=Object.keys(A),n=Object.keys(S),f=n.filter(d=>y.indexOf(d)===-1).reduce((d,w)=>(d.add(w),d),new Set),v=y.filter(d=>n.indexOf(d)===-1).reduce((d,w)=>(d.add(w),d),new Set),C=new Set;for(const d of y)if(!v.has(d)){const w=A[d],I=S[d];p.equals(w,I)||C.add(d)}return{added:f,removed:v,updated:C}}function U(A,S){const{added:y,removed:n,updated:f}=R(A,S);return y.size===0&&n.size===0&&f.size===0}}),define(Z[190],ee([0,1,21,25,3,9,10,52,189,33,46,24,23,5,47,41,20,6,45,31,18]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const s="globalState.argv.",t=["locale"];function i(u){const m=u.storage?Object.keys(u.storage).sort():[],b={};m.forEach(_=>b[_]=u.storage[_]),u.storage=b;const h=JSON.stringify(u),k=(0,d.format)(h,void 0,{});return(0,w.applyEdits)(h,k)}const r=1;let o=class ct extends n.AbstractSynchroniser{constructor(m,b,h,k,_,j,q,K,M){super("globalState",m,_,M,b,h,j,q,k,K);this.storageService=M,this.version=r,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(m.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(O.Event.any(O.Event.filter(m.onDidFilesChange,$=>$.contains(this.environmentService.argvResource)),O.Event.filter(M.onDidChangeValue,$=>$.scope===0&&$.target!==void 0?$.target===0:M.keys(0,0).includes($.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(m,b,h){const k=m.syncData?JSON.parse(m.syncData.content):null,_=b&&b.syncData?JSON.parse(b.syncData.content):null,j=await this.getLocalGlobalState();k?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const q=this.getStorageKeys(_),{local:K,remote:M}=(0,S.merge)(j.storage,k?k.storage:null,_?_.storage:null,q,this.logService),$={content:null,local:K,remote:M,localChange:Object.keys(K.added).length>0||Object.keys(K.updated).length>0||K.removed.length>0?2:0,remoteChange:M!==null?2:0};return[{localResource:this.localResource,localContent:i(j),localUserData:j,remoteResource:this.remoteResource,remoteContent:k?i(k):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:q}]}async getMergeResult(m,b){return Object.assign(Object.assign({},m.previewResult),{hasConflicts:!1})}async getAcceptResult(m,b,h,k){if(this.extUri.isEqual(b,this.localResource))return this.acceptLocal(m);if(this.extUri.isEqual(b,this.remoteResource))return this.acceptRemote(m);if(this.extUri.isEqual(b,this.previewResource))return m.previewResult;throw new Error(`Invalid Resource: ${b.toString()}`)}async acceptLocal(m){return{content:m.localContent,local:{added:{},removed:[],updated:{}},remote:m.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(m){if(m.remoteContent!==null){const b=JSON.parse(m.remoteContent),{local:h,remote:k}=(0,S.merge)(m.localUserData.storage,b.storage,null,m.storageKeys,this.logService);return{content:m.remoteContent,local:h,remote:k,localChange:Object.keys(h.added).length>0||Object.keys(h.updated).length>0||h.removed.length>0?2:0,remoteChange:k!==null?2:0}}else return{content:m.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(m,b,h,k){let{localUserData:_}=h[0][0],{local:j,remote:q,localChange:K,remoteChange:M}=h[0][1];if(K===0&&M===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),K!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(_)),await this.writeLocalGlobalState(j),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),M!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:q});m=await this.updateRemoteUserData($,k?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}(b==null?void 0:b.ref)!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:m}){return[{resource:this.extUri.joinPath(m,"globalState.json"),comparableResource:ct.GLOBAL_STATE_DATA_URI}]}async resolveContent(m){if(this.extUri.isEqual(m,ct.GLOBAL_STATE_DATA_URI)){const h=await this.getLocalGlobalState();return i(h)}if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let b=await super.resolveContent(m);if(b)return b;if(b=await super.resolveContent(this.extUri.dirname(m)),b){const h=this.parseSyncData(b);if(h)switch(this.extUri.basename(m)){case"globalState.json":return i(JSON.parse(h.content))}}return null}async hasLocalData(){var m;try{const{storage:b}=await this.getLocalGlobalState();if(Object.keys(b).length>1||((m=b[`${s}.locale`])===null||m===void 0?void 0:m.value)!=="en")return!0}catch(b){}return!1}async getLocalGlobalState(){const m={},b=await this.getLocalArgvContent(),h=(0,y.parse)(b);for(const k of t)h[k]!==void 0&&(m[`${s}${k}`]={version:1,value:h[k]});for(const k of this.storageService.keys(0,0)){const _=this.storageService.get(k,0);_&&(m[k]={version:1,value:_})}return{storage:m}}async getLocalArgvContent(){try{return(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(m){}return"{}"}async writeLocalGlobalState({added:m,removed:b,updated:h}){const k={},_={},j=(K,M)=>{for(const $ of K){if($.startsWith(s)){k[$.substring(s.length)]=M?M[$].value:void 0;continue}if(M){const z=M[$];z.value!==String(this.storageService.get($,0))&&(_[$]=z.value)}else this.storageService.get($,0)!==void 0&&(_[$]=void 0)}};if(j(Object.keys(m),m),j(Object.keys(h),h),j(b),Object.keys(k).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(k),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(_).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const K of Object.keys(_))this.storageService.store(K,_[K],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(_))}}async updateArgv(m){const b=await this.getLocalArgvContent();let h=b;for(const k of Object.keys(m))h=(0,A.edit)(h,[k],m[k],{});b!==h&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(h)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(m){const b=this.storageService.keys(0,0),h=this.storageService.keys(0,1),k=[...b,...h],_=(m==null?void 0:m.storage)?Object.keys(m.storage).filter(j=>!j.startsWith(s)&&!k.includes(j)&&this.storageService.get(j,0)!==void 0):[];if(!E.isWeb){const j=[...p.ALL_SYNC_RESOURCES.map(q=>(0,p.getEnablementKey)(q)),p.SYNC_SERVICE_URL_TYPE];_.push(...j),h.push(...j)}return{user:b,machine:h,unregistered:_}}};o.GLOBAL_STATE_DATA_URI=C.URI.from({scheme:p.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),o=de([Y(0,U.IFileService),Y(1,p.IUserDataSyncStoreService),Y(2,p.IUserDataSyncBackupStoreService),Y(3,p.IUserDataSyncLogService),Y(4,R.IEnvironmentService),Y(5,p.IUserDataSyncResourceEnablementService),Y(6,f.ITelemetryService),Y(7,v.IConfigurationService),Y(8,I.IStorageService)],o),e.GlobalStateSynchroniser=o;let c=class extends n.AbstractInitializer{constructor(m,b,h,k){super("globalState",h,k,b);this.storageService=m}async doInitialize(m){const b=m.syncData?JSON.parse(m.syncData.content):null;if(!b){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const h={},k={};for(const _ of Object.keys(b.storage))_.startsWith(s)?h[_.substring(s.length)]=b.storage[_].value:this.storageService.get(_,0)===void 0&&(k[_]=b.storage[_].value);if(Object.keys(h).length){let _="{}";try{_=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch(j){}for(const j of Object.keys(h))_=(0,A.edit)(_,[j],h[j],{});await this.fileService.writeFile(this.environmentService.argvResource,L.VSBuffer.fromString(_))}if(Object.keys(k).length)for(const _ of Object.keys(k))this.storageService.store(_,k[_],0,0)}};c=de([Y(0,I.IStorageService),Y(1,U.IFileService),Y(2,R.IEnvironmentService),Y(3,p.IUserDataSyncLogService)],c),e.GlobalStateInitializer=c;let l=class{constructor(m,b,h,k,_){this.userDataSyncStoreClient=m,this.storageService=b,this.environmentService=h,this.fileService=k,this.logService=_}getSyncStoreType(m){var b;const h=this.parseGlobalState(m);return(b=h==null?void 0:h.storage[p.SYNC_SERVICE_URL_TYPE])===null||b===void 0?void 0:b.value}async sync(m){const b=(0,p.createSyncHeaders)((0,g.generateUuid)());try{return await this.doSync(m,b)}catch(h){if(h instanceof p.UserDataSyncError)switch(h.code){case p.UserDataSyncErrorCode.PreconditionFailed:return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(m,b)}throw h}}async doSync(m,b){const h=await this.userDataSyncStoreClient.read("globalState",null,b),k=this.parseGlobalState(h)||{storage:{}};k.storage[p.SYNC_SERVICE_URL_TYPE]={value:m,version:r};const _=await(0,D.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),j={version:r,machineId:_,content:i(k)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(j),h.ref,b)}parseGlobalState({content:m}){if(!m)return null;const b=JSON.parse(m);if((0,n.isSyncData)(b))return b?JSON.parse(b.content):null;throw new Error("Invalid remote data")}};l=de([Y(1,I.IStorageService),Y(2,R.IEnvironmentService),Y(3,U.IFileService),Y(4,a.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(Z[191],ee([0,1,10,21,186,33,123,9,23,6,15,19,46,24,20,25,3]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function E(a,s){const t=JSON.parse(a);if(!s)return(0,n.isUndefined)(t.all)?null:t.all;switch(y.OS){case 2:return(0,n.isUndefined)(t.mac)?null:t.mac;case 3:return(0,n.isUndefined)(t.linux)?null:t.linux;case 1:return(0,n.isUndefined)(t.windows)?null:t.windows}}e.getKeybindingsContentFromSyncContent=E;let D=class extends v.AbstractJsonFileSynchroniser{constructor(s,t,i,r,o,c,l,u,m,b){super(l.keybindingsResource,"keybindings",c,l,u,s,t,o,b,i,m,r);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(I.Event.filter(r.onDidChangeConfiguration,h=>h.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(s,t,i){const r=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null,o=t?this.getKeybindingsContentFromLastSyncUserData(t):null,c=await this.getLocalFileContent(),l=await this.getFormattingOptions();let u=null,m=!1,b=!1,h=!1;if(r){let _=c?c.value.toString():"[]";if(_=_||"[]",this.hasErrors(_))throw new L.UserDataSyncError((0,U.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(!o||o!==_||o!==r){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const j=await(0,O.merge)(_,r,o,l,this.userDataSyncUtilService);j.hasChanges&&(u=j.mergeContent,h=j.hasConflicts,m=h||j.mergeContent!==_,b=h||j.mergeContent!==r)}}else c&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=c.value.toString(),b=!0);const k={content:u,localChange:m?c?2:1:0,remoteChange:b?2:0,hasConflicts:h};return[{fileContent:c,localResource:this.localResource,localContent:c?c.value.toString():null,localChange:k.localChange,remoteResource:this.remoteResource,remoteContent:r,remoteChange:k.remoteChange,previewResource:this.previewResource,previewResult:k,acceptedResource:this.acceptedResource}]}async getMergeResult(s,t){return s.previewResult}async getAcceptResult(s,t,i,r){if(this.extUri.isEqual(t,this.localResource))return{content:s.fileContent?s.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:s.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:s.previewResult.content,localChange:s.previewResult.localChange,remoteChange:s.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(s,t,i,r){var o;const{fileContent:c}=i[0][0];let{content:l,localChange:u,remoteChange:m}=i[0][1];if(u===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),l!==null&&(l=l.trim(),l=l||"[]",this.hasErrors(l)))throw new L.UserDataSyncError((0,U.localize)(1,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource);if(u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(l||"[]",c,r),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),m!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const b=this.toSyncContent(l||"[]",(o=s.syncData)===null||o===void 0?void 0:o.content);s=await this.updateRemoteUserData(b,r?null:s.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch(b){}(t==null?void 0:t.ref)!==s.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(s,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const s=await this.getLocalFileContent();if(s){const t=(0,R.parse)(s.value.toString());if((0,f.isNonEmptyArray)(t))return!0}}catch(s){if(s.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:s}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(s,"keybindings.json"),comparableResource:t}]}async resolveContent(s){if(this.extUri.isEqual(this.remoteResource,s)||this.extUri.isEqual(this.localResource,s)||this.extUri.isEqual(this.acceptedResource,s))return this.resolvePreviewContent(s);let t=await super.resolveContent(s);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(s)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(s)){case"keybindings.json":return this.getKeybindingsContentFromSyncContent(i.content)}}return null}getKeybindingsContentFromLastSyncUserData(s){return!s.syncData||s.platformSpecific!==void 0&&s.platformSpecific!==this.syncKeybindingsPerPlatform()?null:this.getKeybindingsContentFromSyncContent(s.syncData.content)}getKeybindingsContentFromSyncContent(s){try{return E(s,this.syncKeybindingsPerPlatform())}catch(t){return this.logService.error(t),null}}toSyncContent(s,t){let i={};try{i=JSON.parse(t||"{}")}catch(r){this.logService.error(r)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=s,y.OS){case 2:i.mac=s;break;case 3:i.linux=s;break;case 1:i.windows=s;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){let s=this.configurationService.inspect("settingsSync.keybindingsPerPlatform").userValue;return s!==void 0||(s=this.configurationService.inspect("sync.keybindingsPerPlatform").userValue,s!==void 0)?s:this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};D=de([Y(0,L.IUserDataSyncStoreService),Y(1,L.IUserDataSyncBackupStoreService),Y(2,L.IUserDataSyncLogService),Y(3,S.IConfigurationService),Y(4,L.IUserDataSyncResourceEnablementService),Y(5,p.IFileService),Y(6,A.IEnvironmentService),Y(7,d.IStorageService),Y(8,L.IUserDataSyncUtilService),Y(9,C.ITelemetryService)],D),e.KeybindingsSynchroniser=D;let g=class extends v.AbstractInitializer{constructor(s,t,i){super("keybindings",t,i,s)}async doInitialize(s){const t=s.syncData?this.getKeybindingsContentFromSyncContent(s.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.environmentService.keybindingsResource,w.VSBuffer.fromString(t)),await this.updateLastSyncUserData(s)}async isEmpty(){try{const s=await this.fileService.readFile(this.environmentService.settingsResource),t=(0,R.parse)(s.value.toString());return!(0,f.isNonEmptyArray)(t)}catch(s){return s.fileOperationResult===1}}getKeybindingsContentFromSyncContent(s){try{return E(s,!0)}catch(t){return this.logService.error(t),null}}};g=de([Y(0,p.IFileService),Y(1,A.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],g),e.KeybindingsInitializer=g}),define(Z[192],ee([0,1,26,33,41,47,52,21,19]),function(G,e,p,L,O,R,U,A,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.getIgnoredSettings=void 0;function y(l,u,m){let b=[];m?b=f(m):b=n(u);const h=[],k=[...(0,A.getDisallowedIgnoredSettings)()];if(Array.isArray(b))for(const _ of b)_.startsWith("-")?k.push(_.substring(1)):h.push(_);return(0,S.distinct)([...l,...h].filter(_=>k.indexOf(_)===-1))}e.getIgnoredSettings=y;function n(l){let u=l.inspect("settingsSync.ignoredSettings").userValue;return u!==void 0||(u=l.inspect("sync.ignoredSettings").userValue,u!==void 0)?u:l.getValue("settingsSync.ignoredSettings")||[]}function f(l){const u=(0,L.parse)(l);return u?u["settingsSync.ignoredSettings"]||u["sync.ignoredSettings"]||[]:[]}function v(l,u,m,b){if(m.length){const h=c(u),k=(0,L.parse)(u),_=(0,L.parse)(l),j=[];for(const q of m){const K=k[q],M=_[q];K===void 0?l=U.edit(l,[q],void 0,b):M!==void 0?l=U.edit(l,[q],K,b):j.push(s(q,h))}j.sort((q,K)=>q.startOffset-K.startOffset),j.forEach(q=>l=E(q.setting.key,u,l,b))}return l}e.updateIgnoredSettings=v;function C(l,u,m,b,h,k){const _=v(l,u,b,k),j=m!==_,q=m!==u;if(!j&&!q)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!q)return{conflictsSettings:[],localContent:null,remoteContent:_,hasConflicts:!1};if(q&&!j)return{conflictsSettings:[],localContent:v(u,l,b,k),remoteContent:null,hasConflicts:!1};if(m===null&&w(l)){const ne=d(l,u,b)?null:v(u,l,b,k);return{conflictsSettings:[],localContent:ne,remoteContent:null,hasConflicts:!1}}let K=l,M=u;const $=(0,L.parse)(l),z=(0,L.parse)(u),W=m?(0,L.parse)(m):null,H=b.reduce((ne,ce)=>(ne.add(ce),ne),new Set),T=I($,z,H),P=I(W,$,H),F=I(W,z,H),N=new Map,x=new Set,V=ne=>{x.add(ne);const ce=h.filter(({key:ue})=>ue===ne)[0];ce?(K=U.edit(K,[ne],ce.value,k),M=U.edit(M,[ne],ce.value,k)):N.set(ne,{key:ne,localValue:$[ne],remoteValue:z[ne]})};for(const ne of P.removed.values())F.updated.has(ne)?V(ne):M=U.edit(M,[ne],void 0,k);for(const ne of F.removed.values())x.has(ne)||(P.updated.has(ne)?V(ne):K=U.edit(K,[ne],void 0,k));for(const ne of P.updated.values())x.has(ne)||(F.updated.has(ne)?T.updated.has(ne)&&V(ne):M=U.edit(M,[ne],$[ne],k));for(const ne of F.updated.values())x.has(ne)||(P.updated.has(ne)?T.updated.has(ne)&&V(ne):K=U.edit(K,[ne],z[ne],k));for(const ne of P.added.values())x.has(ne)||(F.added.has(ne)?T.updated.has(ne)&&V(ne):M=E(ne,K,M,k));for(const ne of F.added.values())x.has(ne)||(P.added.has(ne)?T.updated.has(ne)&&V(ne):K=E(ne,M,K,k));const X=N.size>0||!d(K,M,b),Q=X||!d(K,l,[]),ie=X||!d(M,u,[]);return{localContent:Q?K:null,remoteContent:ie?M:null,conflictsSettings:[...N.values()],hasConflicts:X}}e.merge=C;function d(l,u,m){if(l===u)return!0;const b=(0,L.parse)(l),h=(0,L.parse)(u),k=m.reduce((q,K)=>(q.add(K),q),new Set),_=c(l).filter(q=>!(q.setting&&k.has(q.setting.key))),j=c(u).filter(q=>!(q.setting&&k.has(q.setting.key)));if(_.length!==j.length)return!1;for(let q=0;q<_.length;q++){const K=_[q],M=j[q];if(K.setting&&M.setting){if(K.setting.key!==M.setting.key||!p.equals(b[K.setting.key],h[K.setting.key]))return!1}else if(!K.setting&&!M.setting){if(K.value!==M.value)return!1}else return!1}return!0}e.areSame=d;function w(l){return l?c(l).length===0:!0}e.isEmpty=w;function I(l,u,m){const b=l?Object.keys(l).filter(q=>!m.has(q)):[],h=Object.keys(u).filter(q=>!m.has(q)),k=h.filter(q=>b.indexOf(q)===-1).reduce((q,K)=>(q.add(K),q),new Set),_=b.filter(q=>h.indexOf(q)===-1).reduce((q,K)=>(q.add(K),q),new Set),j=new Set;if(l){for(const q of b)if(!_.has(q)){const K=l[q],M=u[q];p.equals(K,M)||j.add(q)}}return{added:k,removed:_,updated:j}}function E(l,u,m,b){const h=(0,L.parse)(u),k=c(u),_=c(m),j=D(l,k,_);return g(m,l,h[l],j,_,b)}e.addSetting=E;function D(l,u,m){const b=u.findIndex(k=>{var _;return((_=k.setting)===null||_===void 0?void 0:_.key)===l}),h=u[b-1];if(h){if(h.setting){const _=s(h.setting.key,m);if(_)return{index:m.indexOf(_),insertAfter:!0}}else{const _=t(b,u);if(_){const j=s(_.setting.key,m);if(j){const q=i(m.indexOf(j),m),K=r(u,_,u[b]);if(q){const M=r(m,j,q),$=o(K,M);return $?{index:m.indexOf($),insertAfter:!0}:{index:m.indexOf(q),insertAfter:!1}}else{const M=r(m,j,m[m.length-1]),$=o(K,M);return $?{index:m.indexOf($),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const k=u[b+1];if(k)if(k.setting){const _=s(k.setting.key,m);if(_)return{index:m.indexOf(_),insertAfter:!1}}else{const _=i(b,u);if(_){const j=s(_.setting.key,m);if(j){const q=t(m.indexOf(j),m),K=r(u,u[b],_);if(q){const M=r(m,q,j),$=o(K.reverse(),M.reverse());return $?{index:m.indexOf($),insertAfter:!1}:{index:m.indexOf(q),insertAfter:!0}}else{const M=r(m,m[0],j),$=o(K.reverse(),M.reverse());return $?{index:m.indexOf($),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function g(l,u,m,b,h,k){let _;return b.index===-1?_=(0,O.setProperty)(l,[u],m,k):_=a(l,u,m,b,h,k).map(j=>(0,O.withFormatting)(l,j,k)[0]),(0,O.applyEdits)(l,_)}function a(l,u,m,b,h,k){var _;const j=`${JSON.stringify(u)}: ${JSON.stringify(m)}`,q=(0,R.getEOL)(k,l),K=h[b.index];if(b.insertAfter){const M=[];if(K.setting)M.push({offset:K.endOffset,length:0,content:","+j});else{const $=i(b.index,h),z=t(b.index,h),W=(_=z==null?void 0:z.setting)===null||_===void 0?void 0:_.commaOffset;z&&W===void 0&&M.push({offset:z.endOffset,length:0,content:","});const H=W!==void 0&&W>K.endOffset;M.push({offset:H?W+1:K.endOffset,length:0,content:$?q+j+",":q+j})}return M}else{if(K.setting)return[{offset:K.startOffset,length:0,content:j+","}];const M=(h[b.index-1]&&!h[b.index-1].setting?q:"")+j+(i(b.index,h)?",":"")+q;return[{offset:K.startOffset,length:0,content:M}]}}function s(l,u){return u.filter(m=>{var b;return((b=m.setting)===null||b===void 0?void 0:b.key)===l})[0]}function t(l,u){for(let m=l-1;m>=0;m--)if(u[m].setting)return u[m]}function i(l,u){for(let m=l+1;m<u.length;m++)if(u[m].setting)return u[m]}function r(l,u,m){const b=l.indexOf(u),h=l.indexOf(m);return l.filter((k,_)=>b<_&&_<h)}function o(l,u){if(l.length&&u.length){let m=0;for(;m<u.length&&m<l.length;m++)if(l[m].value!==u[m].value)return u[m-1];return u[m-1]}}function c(l){const u=[];let m=-1,b,h;const k={onObjectBegin:_=>{m++},onObjectProperty:(_,j,q)=>{m===0&&(b=j,h=_)},onObjectEnd:(_,j)=>{m--,m===0&&u.push({startOffset:b,endOffset:_+j,value:l.substring(b,_+j),setting:{key:h,commaOffset:void 0}})},onArrayBegin:(_,j)=>{m++},onArrayEnd:(_,j)=>{m--,m===0&&u.push({startOffset:b,endOffset:_+j,value:l.substring(b,_+j),setting:{key:h,commaOffset:void 0}})},onLiteralValue:(_,j,q)=>{m===0&&u.push({startOffset:b,endOffset:j+q,value:l.substring(b,j+q),setting:{key:h,commaOffset:void 0}})},onSeparator:(_,j,q)=>{if(m===0&&_===","){let K=u.length-1;for(;K>=0&&!u[K].setting;K--);const M=u[K];M&&u.splice(K,1,{startOffset:M.startOffset,endOffset:M.endOffset,value:M.value,setting:{key:M.setting.key,commaOffset:j}})}},onComment:(_,j)=>{m===0&&u.push({startOffset:_,endOffset:_+j,value:l.substring(_,_+j)})}};return(0,L.visit)(l,k),u}}),define(Z[193],ee([0,1,10,21,25,124,3,9,23,192,52,46,24,29,20,41]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function I(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function E(s){const t=JSON.parse(s);return I(t)?t:{settings:s}}e.parseSettingsSyncContent=E;let D=class extends f.AbstractJsonFileSynchroniser{constructor(t,i,r,o,c,l,u,m,b,h,k){super(i.settingsResource,"settings",t,i,r,o,c,b,h,l,u,m);this.extensionManagementService=k,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.localResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:L.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async generateSyncPreview(t,i,r){const o=await this.getLocalFileContent(),c=await this.getFormattingOptions(),l=this.getSettingsSyncContent(t),u=i?this.getSettingsSyncContent(i):null,m=await this.getIgnoredSettings();let b=null,h=!1,k=!1,_=!1;if(l){let q=o?o.value.toString().trim():"{}";q=q||"{}",this.validateContent(q),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const K=(0,y.merge)(q,l.settings,u?u.settings:null,m,[],c);b=K.localContent||K.remoteContent,h=K.localContent!==null,k=K.remoteContent!==null,_=K.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),b=o.value.toString(),k=!0);const j={content:b,localChange:h?2:0,remoteChange:k?2:0,hasConflicts:_};return[{fileContent:o,localResource:this.localResource,localContent:o?o.value.toString():null,localChange:j.localChange,remoteResource:this.remoteResource,remoteContent:l?l.settings:null,remoteChange:j.remoteChange,previewResource:this.previewResource,previewResult:j,acceptedResource:this.acceptedResource}]}async getMergeResult(t,i){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return Object.assign(Object.assign({},t.previewResult),{content:t.previewResult.content?(0,y.updateIgnoredSettings)(t.previewResult.content,"{}",o,r):null})}async getAcceptResult(t,i,r,o){const c=await this.getFormattingOptions(),l=await this.getIgnoredSettings();if(this.extUri.isEqual(i,this.localResource))return{content:t.fileContent?(0,y.updateIgnoredSettings)(t.fileContent.value.toString(),"{}",l,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(i,this.remoteResource))return{content:t.remoteContent!==null?(0,y.updateIgnoredSettings)(t.remoteContent,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(i,this.previewResource))return r===void 0?{content:t.previewResult.content,localChange:t.previewResult.localChange,remoteChange:t.previewResult.remoteChange}:{content:r!==null?(0,y.updateIgnoredSettings)(r,t.fileContent?t.fileContent.value.toString():"{}",l,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${i.toString()}`)}async applyResult(t,i,r,o){const{fileContent:c}=r[0][0];let{content:l,localChange:u,remoteChange:m}=r[0][1];if(u===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),l=l?l.trim():"{}",l=l||"{}",this.validateContent(l),u!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(l,c,o),await this.configurationService.reloadConfiguration(2),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const b=await this.getFormattingOptions(),h=this.getSettingsSyncContent(t),k=await this.getIgnoredSettings(l);l=(0,y.updateIgnoredSettings)(l,h?h.settings:"{}",k,b),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),t=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(l)),o?null:t.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch(b){}(i==null?void 0:i.ref)!==t.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(t),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const t=await this.getLocalFileContent();if(t){const i=await this.getFormattingOptions(),r=(0,n.edit)(t.value.toString(),[L.CONFIGURATION_SYNC_STORE_KEY],void 0,i);return!(0,y.isEmpty)(r)}}catch(t){if(t.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:t}){const i=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(t,"settings.json"),comparableResource:i}]}async resolveContent(t){if(this.extUri.isEqual(this.remoteResource,t)||this.extUri.isEqual(this.localResource,t)||this.extUri.isEqual(this.acceptedResource,t))return this.resolvePreviewContent(t);let i=await super.resolveContent(t);if(i)return i;if(i=await super.resolveContent(this.extUri.dirname(t)),i){const r=this.parseSyncData(i);if(r){const o=this.parseSettingsSyncContent(r.content);if(o)switch(this.extUri.basename(t)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(t){let i=await super.resolvePreviewContent(t);if(i){const r=await this.getFormattingOptions(),o=await this.getIgnoredSettings();i=(0,y.updateIgnoredSettings)(i,"{}",o,r)}return i}getSettingsSyncContent(t){return t.syncData?this.parseSettingsSyncContent(t.syncData.content):null}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}toSettingsSyncContent(t){return{settings:t}}async getIgnoredSettings(t){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const r=U.Event.any(U.Event.filter(this.extensionManagementService.onDidInstallExtension,o=>!!o.gallery),U.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{r.dispose(),this._defaultIgnoredSettings=void 0})}const i=await this._defaultIgnoredSettings;return(0,y.getIgnoredSettings)(i,this.configurationService,t)}validateContent(t){if(this.hasErrors(t))throw new L.UserDataSyncError((0,R.localize)(0,null),L.UserDataSyncErrorCode.LocalInvalidContent,this.resource)}async recoverSettings(){try{const t=await this.getLocalFileContent();if(!t)return;const i=JSON.parse(t.value.toString());if(!a(i))return;this.telemetryService.publicLog2("sync/settingsCorrupted");const r=this.parseSettingsSyncContent(i.content);if(!r||!r.settings)return;let o=r.settings;const c=await this.getFormattingOptions();for(const l in i)if(["version","content","machineId"].indexOf(l)===-1&&i[l]!==void 0){const u=(0,w.setProperty)(o,[l],i[l],c);u.length&&(o=(0,w.applyEdits)(o,u))}await this.fileService.writeFile(this.file,O.VSBuffer.fromString(o))}catch(t){}}};D=de([Y(0,p.IFileService),Y(1,A.IEnvironmentService),Y(2,d.IStorageService),Y(3,L.IUserDataSyncStoreService),Y(4,L.IUserDataSyncBackupStoreService),Y(5,L.IUserDataSyncLogService),Y(6,L.IUserDataSyncUtilService),Y(7,S.IConfigurationService),Y(8,L.IUserDataSyncResourceEnablementService),Y(9,v.ITelemetryService),Y(10,C.IExtensionManagementService)],D),e.SettingsSynchroniser=D;let g=class extends f.AbstractInitializer{constructor(t,i,r){super("settings",i,r,t)}async doInitialize(t){const i=t.syncData?this.parseSettingsSyncContent(t.syncData.content):null;if(!i){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.environmentService.settingsResource,O.VSBuffer.fromString(i.settings)),await this.updateLastSyncUserData(t)}async isEmpty(){try{const t=await this.fileService.readFile(this.environmentService.settingsResource);return(0,y.isEmpty)(t.value.toString().trim())}catch(t){return t.fileOperationResult===1}}parseSettingsSyncContent(t){try{return E(t)}catch(i){this.logService.error(i)}return null}};g=de([Y(0,p.IFileService),Y(1,A.IEnvironmentService),Y(2,L.IUserDataSyncLogService)],g),e.SettingsInitializer=g;function a(s){return!!(s&&s.version!==void 0&&typeof s.version=="number"&&s.content!==void 0&&typeof s.content=="string"&&s.machineId!==void 0&&typeof s.machineId=="string")}}),define(Z[194],ee([0,1,21,9,10,23,46,24,25,187,20,26,3]),function(G,e,p,L,O,R,U,A,S,y,n,f,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let C=class extends U.AbstractSynchroniser{constructor(I,E,D,g,a,s,t,i,r){super("snippets",E,I,D,g,a,i,r,s,t);this.version=1,this.snippetsFolder=I.snippetsHome,this._register(this.fileService.watch(I.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(v.Event.filter(this.fileService.onDidFilesChange,o=>o.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(I,E,D){const g=await this.getSnippetsFileContents(),a=this.toSnippetsContents(g),s=I.syncData?this.parseSnippets(I.syncData):null,t=E&&E.syncData?this.parseSnippets(E.syncData):null;s?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(a,s,t);return this.getResourcePreviews(i,g,s||{})}async getMergeResult(I,E){return I.previewResult}async getAcceptResult(I,E,D,g){if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:I.fileContent?I.fileContent.value.toString():null,localChange:0,remoteChange:I.fileContent?I.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:I.remoteContent,localChange:I.remoteContent!==null?I.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(E,this.syncPreviewFolder))return D===void 0?{content:I.previewResult.content,localChange:I.previewResult.localChange,remoteChange:I.previewResult.remoteChange}:{content:D,localChange:D===null?I.fileContent!==null?3:0:2,remoteChange:D===null?I.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${E.toString()}`)}async applyResult(I,E,D,g){const a=D.map(([s,t])=>Object.assign(Object.assign({},s),{acceptResult:t}));a.every(({localChange:s,remoteChange:t})=>s===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),a.some(({localChange:s})=>s!==0)&&(await this.updateLocalBackup(a),await this.updateLocalSnippets(a,g)),a.some(({remoteChange:s})=>s!==0)&&(I=await this.updateRemoteSnippets(a,I,g)),(E==null?void 0:E.ref)!==I.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(I),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:s}of a)try{await this.fileService.del(s)}catch(t){}}getResourcePreviews(I,E,D){const g=new Map;for(const a of Object.keys(I.local.added)){const s={content:I.local.added[a],hasConflicts:!1,localChange:1,remoteChange:0};g.set(a,{fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.local.updated)){const s={content:I.local.updated[a],hasConflicts:!1,localChange:2,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.remote.added)){const s={content:I.remote.added[a],hasConflicts:!1,localChange:0,remoteChange:1};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(I.remote.updated)){const s={content:I.remote.updated[a],hasConflicts:!1,localChange:0,remoteChange:2};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a],localContent:E[a].value.toString(),remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a],previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of I.conflicts){const s={content:E[a]?E[a].value.toString():null,hasConflicts:!0,localChange:E[a]?2:1,remoteChange:D[a]?2:1};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a]||null,localContent:E[a]?E[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const a of Object.keys(E))if(!g.has(a)){const s={content:E[a]?E[a].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0};g.set(a,{localResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:E[a]||null,localContent:E[a]?E[a].value.toString():null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:D[a]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,a),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,a).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...g.values()]}async getAssociatedResources({uri:I}){let E=await super.resolveContent(I);if(E){const D=this.parseSyncData(E);if(D){const g=this.parseSnippets(D),a=[];for(const s of Object.keys(g)){const t=this.extUri.joinPath(I,s),i=this.extUri.joinPath(this.snippetsFolder,s),r=await this.fileService.exists(i);a.push({resource:t,comparableResource:r?i:this.extUri.joinPath(this.syncPreviewFolder,s).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})})}return a}}return[]}async resolveContent(I){if(this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(I,this.syncPreviewFolder.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(I);let E=await super.resolveContent(I);if(E)return E;if(E=await super.resolveContent(this.extUri.dirname(I)),E){const D=this.parseSyncData(E);if(D)return this.parseSnippets(D)[this.extUri.basename(I)]||null}return null}async hasLocalData(){try{const I=await this.getSnippetsFileContents();if(Object.keys(I).length)return!0}catch(I){}return!1}async updateLocalBackup(I){const E={};for(const D of I)D.fileContent&&(E[this.extUri.basename(D.localResource)]=D.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(E)))}async updateLocalSnippets(I,E){for(const{fileContent:D,acceptResult:g,localResource:a,remoteResource:s,localChange:t}of I)if(t!==0){const i=s?this.extUri.basename(s):this.extUri.basename(a),r=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(r)),await this.fileService.del(r),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(r))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(r)),await this.fileService.createFile(r,S.VSBuffer.fromString(g.content),{overwrite:E}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(r))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(r)),await this.fileService.writeFile(r,S.VSBuffer.fromString(g.content),E?void 0:D),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(r)))}}async updateRemoteSnippets(I,E,D){const g=E.syncData?this.parseSnippets(E.syncData):{},a=(0,f.deepClone)(g);for(const{acceptResult:s,localResource:t,remoteResource:i,remoteChange:r}of I)if(r!==0){const o=t?this.extUri.basename(t):this.extUri.basename(i);r===3?delete a[o]:a[o]=s.content}return(0,y.areSame)(g,a)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),E=await this.updateRemoteUserData(JSON.stringify(a),D?null:E.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),E}parseSnippets(I){return JSON.parse(I.content)}toSnippetsContents(I){const E={};for(const D of Object.keys(I))E[D]=I[D].value.toString();return E}async getSnippetsFileContents(){const I={};let E;try{E=await this.fileService.resolve(this.snippetsFolder)}catch(D){if(D instanceof O.FileOperationError&&D.fileOperationResult===1)return I;throw D}for(const D of E.children||[]){const g=D.resource,a=this.extUri.extname(g);if(a===".json"||a===".code-snippets"){const s=this.extUri.relativePath(this.snippetsFolder,g),t=await this.fileService.readFile(g);I[s]=t}}return I}};C=de([Y(0,L.IEnvironmentService),Y(1,O.IFileService),Y(2,n.IStorageService),Y(3,p.IUserDataSyncStoreService),Y(4,p.IUserDataSyncBackupStoreService),Y(5,p.IUserDataSyncLogService),Y(6,R.IConfigurationService),Y(7,p.IUserDataSyncResourceEnablementService),Y(8,A.ITelemetryService)],C),e.SnippetsSynchroniser=C;let d=class extends U.AbstractInitializer{constructor(I,E,D){super("snippets",E,D,I)}async doInitialize(I){const E=I.syncData?JSON.parse(I.syncData.content):null;if(!E){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const g of Object.keys(E)){const a=E[g];if(a){const s=this.extUri.joinPath(this.environmentService.snippetsHome,g);await this.fileService.createFile(s,S.VSBuffer.fromString(a)),this.logService.info("Created snippet",this.extUri.basename(s))}}await this.updateLastSyncUserData(I)}async isEmpty(){var I;try{return!((I=(await this.fileService.resolve(this.environmentService.snippetsHome)).children)===null||I===void 0?void 0:I.length)}catch(E){return E.fileOperationResult===1}}};d=de([Y(0,O.IFileService),Y(1,L.IEnvironmentService),Y(2,p.IUserDataSyncLogService)],d),e.SnippetsInitializer=d}),define(Z[60],ee([0,1,4,3,2,21]),function(G,e,p,L,O,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,p.createDecorator)("IUserDataSyncAccountService");let U=class extends O.Disposable{constructor(S){super();this.userDataSyncStoreService=S,this._onDidChangeAccount=this._register(new L.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(S.onTokenFailed(()=>{this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(S.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(S){(S&&this._account?S.token!==this._account.token||S.authenticationProviderId!==this._account.authenticationProviderId:S!==this._account)&&(this._account=S,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(S))}};U=de([Y(0,R.IUserDataSyncStoreService)],U),e.UserDataSyncAccountService=U}),define(Z[195],ee([0,1,2,21,14,23,10,9,55,25,8]),function(G,e,p,L,O,R,U,A,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let f=class extends p.Disposable{constructor(C,d,w,I){super();this.environmentService=C,this.fileService=d,this.configurationService=w,this.logService=I,L.ALL_SYNC_RESOURCES.forEach(E=>this.cleanUpBackup(E))}async getAllRefs(C){const d=(0,O.joinPath)(this.environmentService.userDataSyncHome,C),w=await this.fileService.resolve(d);return w.children?w.children.filter(E=>E.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(E.name)).sort().reverse().map(E=>({ref:E.name,created:this.getCreationTime(E)})):[]}async resolveContent(C,d){if(!d){const w=await this.getAllRefs(C);w.length&&(d=w[w.length-1].ref)}if(d){const w=(0,O.joinPath)(this.environmentService.userDataSyncHome,C,d);return(await this.fileService.readFile(w)).value.toString()}return null}async backup(C,d){const w=(0,O.joinPath)(this.environmentService.userDataSyncHome,C),I=(0,O.joinPath)(w,`${(0,S.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(I,y.VSBuffer.fromString(d))}catch(E){this.logService.error(E)}try{this.cleanUpBackup(C)}catch(E){}}async cleanUpBackup(C){const d=(0,O.joinPath)(this.environmentService.userDataSyncHome,C);try{try{if(!await this.fileService.exists(d))return}catch(I){return}const w=await this.fileService.resolve(d);if(w.children){const I=w.children.filter(a=>a.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(a.name)).sort(),E=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let D=I.filter(a=>Date.now()-this.getCreationTime(a)>E);const g=I.length-D.length;g<10&&(D=D.slice(10-g)),await n.Promises.settled(D.map(async a=>{this.logService.info("Deleting from backup",a.resource.path),await this.fileService.del(a.resource)}))}}catch(w){this.logService.error(w)}}getCreationTime(C){return C.ctime||new Date(parseInt(C.name.substring(0,4)),parseInt(C.name.substring(4,6))-1,parseInt(C.name.substring(6,8)),parseInt(C.name.substring(9,11)),parseInt(C.name.substring(11,13)),parseInt(C.name.substring(13,15))).getTime()}};f=de([Y(0,A.IEnvironmentService),Y(1,U.IFileService),Y(2,R.IConfigurationService),Y(3,L.IUserDataSyncLogService)],f),e.UserDataSyncBackupStoreService=f}),define(Z[196],ee([0,1,5,2]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class O{constructor(v){this.service=v}listen(v,C){switch(C){case"onError":return this.service.onError}throw new Error(`Event not found: ${C}`)}call(v,C,d){switch(C){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=O;class R{constructor(v){this.service=v}listen(v,C){throw new Error(`Event not found: ${C}`)}call(v,C,d){switch(C){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(p.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=R;class U{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=U;class A{constructor(v){this.service=v}listen(v,C){switch(C){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${C}`)}async call(v,C,d){switch(C){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablement":return this.service.setEnablement(d[0],d[1])}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=A;class S{constructor(v){this.service=v}listen(v,C){switch(C){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${C}`)}call(v,C,d){switch(C){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=S;class y{constructor(v){this.service=v}listen(v,C){switch(C){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${C}`)}call(v,C,d){switch(C){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=y;class n extends L.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:p.URI.revive(v.url),type:v.type,defaultUrl:p.URI.revive(v.defaultUrl),insidersUrl:p.URI.revive(v.insidersUrl),stableUrl:p.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=n}),define(Z[197],ee([0,1,18,9]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=class extends p.AbstractLogger{constructor(U,A){super();this.logger=this._register(U.createLogger(A.userDataSyncLogResource,{name:"settingssync"}))}trace(U,...A){this.logger.trace(U,...A)}debug(U,...A){this.logger.debug(U,...A)}info(U,...A){this.logger.info(U,...A)}warn(U,...A){this.logger.warn(U,...A)}error(U,...A){this.logger.error(U,...A)}critical(U,...A){this.logger.critical(U,...A)}flush(){this.logger.flush()}};O=de([Y(0,p.ILoggerService),Y(1,L.IEnvironmentService)],O),e.UserDataSyncLogService=O}),define(Z[61],ee([0,1,4,2,45,9,10,20,21,127,28,6,22,3]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,p.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName";let w=class Ge extends L.Disposable{constructor(E,D,g,a,s,t){super();this.storageService=g,this.userDataSyncStoreService=a,this.logService=s,this.productService=t,this._onDidChange=this._register(new C.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,O.getServiceMachineId)(E,D,g)}async getMachines(E){const D=await this.currentMachineIdPromise;return(await this.readMachinesData(E)).machines.map(a=>Object.assign(Object.assign({},a),{isCurrent:a.id===D}))}async addCurrentMachine(E){const D=await this.currentMachineIdPromise,g=await this.readMachinesData(E);g.machines.some(({id:a})=>a===D)||(g.machines.push({id:D,name:this.computeCurrentMachineName(g.machines)}),await this.writeMachinesData(g))}async removeCurrentMachine(E){const D=await this.currentMachineIdPromise,g=await this.readMachinesData(E),a=g.machines.filter(({id:s})=>s!==D);a.length!==g.machines.length&&(g.machines=a,await this.writeMachinesData(g))}async renameMachine(E,D,g){const a=await this.currentMachineIdPromise,s=await this.readMachinesData(g),t=s.machines.find(({id:i})=>i===E);t&&(t.name=D,await this.writeMachinesData(s),s.machines.some(({id:i})=>i===a)&&this.storageService.store(d,D,0,1))}async setEnablement(E,D){const g=await this.readMachinesData(),a=g.machines.find(({id:s})=>s===E);a&&(a.disabled=D?void 0:!0,await this.writeMachinesData(g))}computeCurrentMachineName(E){const D=this.storageService.get(d,0);if(D)return D;const g=`${this.productService.nameLong} (${(0,f.PlatformToString)(f.isWeb?0:f.platform)})`,a=new RegExp(`${(0,v.escapeRegExpCharacters)(g)}\\s#(\\d+)`);let s=0;for(const t of E){const i=a.exec(t.name),r=i?parseInt(i[1]):0;s=r>s?r:s}return`${g} #${s+1}`}async readMachinesData(E){this.userData=await this.readUserData(E);const D=this.parse(this.userData);if(D.version!==Ge.VERSION)throw new Error((0,y.localize)(0,null,this.productService.nameLong));return D}async writeMachinesData(E){var D;const g=JSON.stringify(E),a=await this.userDataSyncStoreService.write(Ge.RESOURCE,g,((D=this.userData)===null||D===void 0?void 0:D.ref)||null);this.userData={ref:a,content:g},this._onDidChange.fire()}async readUserData(E){if(this.userData){const D=E&&E.latest?E.latest[Ge.RESOURCE]:void 0;if(this.userData.ref===D)return this.userData;if(D===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(Ge.RESOURCE,this.userData)}parse(E){if(E.content!==null)try{return JSON.parse(E.content)}catch(D){this.logService.error(D)}return{version:Ge.VERSION,machines:[]}}};w.VERSION=1,w.RESOURCE="machines",w=de([Y(0,R.IEnvironmentService),Y(1,U.IFileService),Y(2,A.IStorageService),Y(3,S.IUserDataSyncStoreService),Y(4,S.IUserDataSyncLogService),Y(5,n.IProductService)],w),e.UserDataSyncMachinesService=w}),define(Z[85],ee([0,1,8,3,2,21,60,24,11,20,9,61,125,55,5,14,6,28]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=e.UserDataAutoSyncEnablementService=void 0;const D="sync.enable",g="sync.disableMachineEventually",a="sync.sessionId",s="sync.storeUrl",t="sync.productQuality";let i=class extends O.Disposable{constructor(l,u,m){super();this.storageService=l,this.environmentService=u,this.userDataSyncStoreManagementService=m,this._onDidChangeEnablement=new L.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._register(l.onDidChangeValue(b=>this.onDidStorageChange(b)))}isEnabled(l){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(D,0,!!l)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(l){l&&!this.canToggleEnablement()||this.storageService.store(D,l,0,1)}onDidStorageChange(l){if(l.scope===0&&D===l.key){this._onDidChangeEnablement.fire(this.isEnabled());return}}};i=de([Y(0,y.IStorageService),Y(1,n.IEnvironmentService),Y(2,R.IUserDataSyncStoreManagementService)],i),e.UserDataAutoSyncEnablementService=i;let r=class extends O.Disposable{constructor(l,u,m,b,h,k,_,j,q,K,M){var $;super();this.userDataSyncStoreManagementService=u,this.userDataSyncStoreService=m,this.userDataSyncResourceEnablementService=b,this.userDataSyncService=h,this.logService=k,this.userDataSyncAccountService=_,this.telemetryService=j,this.userDataSyncMachinesService=q,this.storageService=K,this.autoSync=this._register(new O.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this._onError=this._register(new L.Emitter),this.onError=this._onError.event,this.sources=[],this.userDataAutoSyncEnablementService=M,this.syncTriggerDelayer=this._register(new p.Delayer(0)),this.lastSyncUrl=this.syncUrl,this.syncUrl=($=u.userDataSyncStore)===null||$===void 0?void 0:$.url,this.previousProductQuality=this.productQuality,this.productQuality=l.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(u.onDidChangeUserDataSyncStore(()=>{var z,W;(0,w.isEqual)(this.syncUrl,(z=u.userDataSyncStore)===null||z===void 0?void 0:z.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=(W=u.userDataSyncStore)===null||W===void 0?void 0:W.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataAutoSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(_.onDidChangeAccount(()=>this.updateAutoSync())),this._register(m.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(L.Event.debounce(h.onDidChangeLocal,(z,W)=>z?[...z,W]:[W],1e3)(z=>this.triggerSync(z,!1,!1))),this._register(L.Event.filter(this.userDataSyncResourceEnablementService.onDidChangeResourceEnablement,([,z])=>z)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const l=this.storageService.get(s,0);return l?d.URI.parse(l):void 0}set syncUrl(l){l?this.storageService.store(s,l.toString(),0,1):this.storageService.remove(s,0)}get productQuality(){return this.storageService.get(t,0)}set productQuality(l){l?this.storageService.store(t,l,0,1):this.storageService.remove(t,0)}updateAutoSync(){const{enabled:l,message:u}=this.isAutoSyncEnabled();l?this.autoSync.value===void 0&&(this.autoSync.value=new o(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(m=>this.onDidFinishSync(m))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(u&&this.logService.info(u),this.autoSync.clear()):u&&this.userDataAutoSyncEnablementService.isEnabled()&&this.logService.info(u))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataAutoSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,C.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(l,u,m){try{this.userDataSyncAccountService.account&&!m&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(a,0),l?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(b){if(u)this.logService.error(b),this.updateEnablement(!1);else throw b}}updateEnablement(l){this.userDataAutoSyncEnablementService.isEnabled()!==l&&(this.telemetryService.publicLog2(D,{enabled:l}),this.userDataAutoSyncEnablementService.setEnablement(l),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(l){if(!l){this.successiveFailures=0;return}const u=R.UserDataSyncError.toUserDataSyncError(l);u instanceof R.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:u.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),u.code===R.UserDataSyncErrorCode.SessionExpired?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):u.code===R.UserDataSyncErrorCode.TurnedOff?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):u.code===R.UserDataSyncErrorCode.LocalTooManyRequests||u.code===R.UserDataSyncErrorCode.TooManyRequests?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):u.code===R.UserDataSyncErrorCode.UpgradeRequired||u.code===R.UserDataSyncErrorCode.Gone?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):u.code===R.UserDataSyncErrorCode.IncompatibleLocalContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with newer version than of client. Requires client upgrade.`)):u.code===R.UserDataSyncErrorCode.IncompatibleRemoteContent?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${u.resource} content with older version than of client. Requires server reset.`)):u.code===R.UserDataSyncErrorCode.ServiceChanged||u.code===R.UserDataSyncErrorCode.DefaultServiceChanged?I.isWeb&&u.code===R.UserDataSyncErrorCode.DefaultServiceChanged&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(u),this.successiveFailures++),this._onError.fire(u)}async disableMachineEventually(){this.storageService.store(g,!0,0,1),await(0,p.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataAutoSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,0,!1)}stopDisableMachineEventually(){this.storageService.remove(g,0)}async triggerSync(l,u,m){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(u&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...l),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",m)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 1e3}};r=de([Y(0,E.IProductService),Y(1,R.IUserDataSyncStoreManagementService),Y(2,R.IUserDataSyncStoreService),Y(3,R.IUserDataSyncResourceEnablementService),Y(4,R.IUserDataSyncService),Y(5,R.IUserDataSyncLogService),Y(6,U.IUserDataSyncAccountService),Y(7,A.ITelemetryService),Y(8,f.IUserDataSyncMachinesService),Y(9,y.IStorageService),Y(10,R.IUserDataAutoSyncEnablementService)],r),e.UserDataAutoSyncService=r;class o extends O.Disposable{constructor(l,u,m,b,h,k,_,j){super();this.lastSyncUrl=l,this.interval=u,this.userDataSyncStoreManagementService=m,this.userDataSyncStoreService=b,this.userDataSyncService=h,this.userDataSyncMachinesService=k,this.logService=_,this.storageService=j,this.intervalHandler=this._register(new O.MutableDisposable),this._onDidStartSync=this._register(new L.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new L.Emitter),this.onDidFinishSync=this._onDidFinishSync.event}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,O.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask&&this.syncTask.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(o.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,p.disposableTimeout)(()=>this.sync(o.INTERVAL_SYNCING,!1),this.interval)}sync(l,u){const m=(0,p.createCancelablePromise)(async b=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,S.isPromiseCanceledError)(h))return}return this.doSync(l,u,b)});return this.syncPromise=m,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){var l;return this.lastSyncUrl!==void 0&&!(0,w.isEqual)(this.lastSyncUrl,(l=this.userDataSyncStoreManagementService.userDataSyncStore)===null||l===void 0?void 0:l.url)}async hasDefaultServiceChanged(){const l=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),u=this.userDataSyncStoreManagementService.userDataSyncStore;return!!u&&!!l&&(!(0,w.isEqual)(u.defaultUrl,l.defaultUrl)||!(0,w.isEqual)(u.insidersUrl,l.insidersUrl)||!(0,w.isEqual)(u.stableUrl,l.stableUrl))}async doSync(l,u,m){this.logService.info(`Auto Sync: Triggered by ${l}`),this._onDidStartSync.fire();let b;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(u),m.isCancellationRequested)return;let h=this.syncTask.manifest;if(h===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,v.localize)(0,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(1,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(2,null),R.UserDataSyncErrorCode.TurnedOff);const k=this.storageService.get(a,0);if(k&&h&&k!==h.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new R.UserDataAutoSyncError((0,v.localize)(3,null),R.UserDataSyncErrorCode.DefaultServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(4,null),R.UserDataSyncErrorCode.ServiceChanged):new R.UserDataAutoSyncError((0,v.localize)(5,null),R.UserDataSyncErrorCode.SessionExpired);const _=await this.userDataSyncMachinesService.getMachines(h||void 0);if(m.isCancellationRequested)return;const j=_.find(q=>q.isCurrent);if(j==null?void 0:j.disabled)throw new R.UserDataAutoSyncError((0,v.localize)(6,null),R.UserDataSyncErrorCode.TurnedOff);if(await this.syncTask.run(),h===null&&(h=await this.userDataSyncStoreService.manifest()),h&&h.session!==k&&this.storageService.store(a,h.session,0,1),m.isCancellationRequested)return;j||await this.userDataSyncMachinesService.addCurrentMachine(h||void 0)}catch(h){this.logService.error(h),b=h}this._onDidFinishSync.fire(b)}register(l){return super._register(l)}}o.INTERVAL_SYNCING="Interval"}),define(Z[198],ee([0,1,21,2,3,20,24,6]),function(G,e,p,L,O,R,U,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceEnablementService=void 0;let S=class extends L.Disposable{constructor(n,f){super();this.storageService=n,this.telemetryService=f,this._onDidChangeResourceEnablement=new O.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(n.onDidChangeValue(v=>this.onDidStorageChange(v)))}isResourceEnabled(n){return this.storageService.getBoolean((0,p.getEnablementKey)(n),0,!0)}setResourceEnablement(n,f){if(this.isResourceEnabled(n)!==f){const v=(0,p.getEnablementKey)(n);this.telemetryService.publicLog2(v,{enabled:f}),this.storeResourceEnablement(v,f)}}getResourceSyncStateVersion(n){}storeResourceEnablement(n,f){this.storageService.store(n,f,0,A.isWeb?0:1)}onDidStorageChange(n){if(n.scope===0){const f=p.ALL_SYNC_RESOURCES.filter(v=>(0,p.getEnablementKey)(v)===n.key)[0];if(f){this._onDidChangeResourceEnablement.fire([f,this.isResourceEnabled(f)]);return}}}};S=de([Y(0,R.IStorageService),Y(1,U.ITelemetryService)],S),e.UserDataSyncResourceEnablementService=S}),define(Z[199],ee([0,1,21,2,4,3,188,191,190,44,24,19,20,193,14,194,31,8,11]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const g="sync.lastSyncTime";let a=class extends L.Disposable{constructor(r,o,c,l,u,m){super();this.userDataSyncStoreService=r,this.userDataSyncStoreManagementService=o,this.instantiationService=c,this.logService=l,this.telemetryService=u,this.storageService=m,this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new R.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new R.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.recoveredSettings=!1,this.settingsSynchroniser=this._register(this.instantiationService.createInstance(C.SettingsSynchroniser)),this.keybindingsSynchroniser=this._register(this.instantiationService.createInstance(A.KeybindingsSynchroniser)),this.snippetsSynchroniser=this._register(this.instantiationService.createInstance(w.SnippetsSynchroniser)),this.globalStateSynchroniser=this._register(this.instantiationService.createInstance(S.GlobalStateSynchroniser)),this.extensionsSynchroniser=this._register(this.instantiationService.createInstance(U.ExtensionsSynchroniser)),this.synchronisers=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.globalStateSynchroniser,this.extensionsSynchroniser],this.updateStatus(),this.userDataSyncStoreManagementService.userDataSyncStore&&(this._register(R.Event.any(...this.synchronisers.map(b=>R.Event.map(b.onDidChangeStatus,()=>{})))(()=>this.updateStatus())),this._register(R.Event.any(...this.synchronisers.map(b=>R.Event.map(b.onDidChangeConflicts,()=>{})))(()=>this.updateConflicts()))),this._lastSyncTime=this.storageService.getNumber(g,0,void 0),this.onDidChangeLocal=R.Event.any(...this.synchronisers.map(b=>R.Event.map(b.onDidChangeLocal,()=>b.resource)))}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(r){await this.checkEnablement();const o=(0,I.generateUuid)();let c;try{const b=(0,p.createSyncHeaders)(o);r&&(b["Cache-Control"]="no-cache"),c=await this.userDataSyncStoreService.manifest(b)}catch(b){const h=p.UserDataSyncError.toUserDataSyncError(b);throw this.reportUserDataSyncError(h,o),h}let l=!1;const u=this;let m;return{manifest:c,run(){if(l)throw new Error("Can run a task only once");return m=(0,E.createCancelablePromise)(b=>u.sync(c,o,b)),m.finally(()=>m=void 0)},async stop(){if(m&&m.cancel(),u.status!=="idle")return u.stop()}}}async createManualSyncTask(){await this.checkEnablement();const r=(0,I.generateUuid)(),o=(0,p.createSyncHeaders)(r);let c;try{c=await this.userDataSyncStoreService.manifest(o)}catch(l){const u=p.UserDataSyncError.toUserDataSyncError(l);throw this.reportUserDataSyncError(u,r),u}return new s(r,c,o,this.synchronisers,this.logService)}async sync(r,o,c){if(this.recoveredSettings||(await this.settingsSynchroniser.recoverSettings(),this.recoveredSettings=!0),!c.isCancellationRequested){const l=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const u=(0,p.createSyncHeaders)(o);for(const m of this.synchronisers){if(c.isCancellationRequested)return;try{await m.sync(r,u)}catch(b){if(b instanceof p.UserDataSyncError)switch(b.code){case p.UserDataSyncErrorCode.TooLarge:throw new p.UserDataSyncError(b.message,b.code,m.resource);case p.UserDataSyncErrorCode.TooManyRequests:case p.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter:case p.UserDataSyncErrorCode.LocalTooManyRequests:case p.UserDataSyncErrorCode.Gone:case p.UserDataSyncErrorCode.UpgradeRequired:case p.UserDataSyncErrorCode.IncompatibleRemoteContent:case p.UserDataSyncErrorCode.IncompatibleLocalContent:throw b}const h=p.UserDataSyncError.toUserDataSyncError(b);this.reportUserDataSyncError(h,o),this.logService.error(b),this.logService.error(`${m.resource}: ${(0,y.toErrorMessage)(b)}`),this._syncErrors.push([m.resource,h])}}this.logService.info(`Sync done. Took ${new Date().getTime()-l}ms`),this.updateLastSyncTime()}catch(u){const m=p.UserDataSyncError.toUserDataSyncError(u);throw this.reportUserDataSyncError(m,o),m}finally{this.updateStatus(),this._onSyncErrors.fire(this._syncErrors)}}}async stop(){if(this.status!=="idle")for(const r of this.synchronisers)try{r.status!=="idle"&&await r.stop()}catch(o){this.logService.error(o)}}async replace(r){await this.checkEnablement();for(const o of this.synchronisers)if(await o.replace(r))return}async accept(r,o,c,l){await this.checkEnablement();const u=this.getSynchroniser(r);await u.accept(o,c),l&&await u.apply(!1,(0,p.createSyncHeaders)((0,I.generateUuid)()))}async resolveContent(r){for(const o of this.synchronisers){const c=await o.resolveContent(r);if(c)return c}return null}getRemoteSyncResourceHandles(r){return this.getSynchroniser(r).getRemoteSyncResourceHandles()}getLocalSyncResourceHandles(r){return this.getSynchroniser(r).getLocalSyncResourceHandles()}getAssociatedResources(r,o){return this.getSynchroniser(r).getAssociatedResources(o)}getMachineId(r,o){return this.getSynchroniser(r).getMachineId(o)}async hasLocalData(){const r=[this.settingsSynchroniser,this.keybindingsSynchroniser,this.snippetsSynchroniser,this.extensionsSynchroniser];for(const o of r)if(await o.hasLocalData())return!0;return!1}async reset(){await this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){await this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(r){this.logService.error(r)}this._onDidResetRemote.fire()}async resetLocal(){await this.checkEnablement(),this.storageService.remove(g,0);for(const r of this.synchronisers)try{await r.resetLocal()}catch(o){this.logService.error(`${r.resource}: ${(0,y.toErrorMessage)(o)}`),this.logService.error(o)}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async hasPreviouslySynced(){for(const r of this.synchronisers)if(await r.hasPreviouslySynced())return!0;return!1}setStatus(r){const o=this._status;this._status!==r&&(this._status=r,this._onDidChangeStatus.fire(r),o==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(){this.updateConflicts();const r=this.computeStatus();this.setStatus(r)}updateConflicts(){const r=this.computeConflicts();(0,f.equals)(this._conflicts,r,([o,c],[l,u])=>o===o&&(0,f.equals)(c,u,(m,b)=>(0,d.isEqual)(m.previewResource,b.previewResource)))||(this._conflicts=this.computeConflicts(),this._onDidChangeConflicts.fire(r))}computeStatus(){return this.userDataSyncStoreManagementService.userDataSyncStore?this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(g,this._lastSyncTime,0,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(r,o){this.telemetryService.publicLog2("sync/error",{code:r.code,url:r instanceof p.UserDataSyncStoreError?r.url:void 0,resource:r.resource,executionId:o,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}computeConflicts(){return this.synchronisers.filter(r=>r.status==="hasConflicts").map(r=>[r.resource,r.conflicts.map(t)])}getSynchroniser(r){return this.synchronisers.find(o=>o.resource===r)}async checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};a=de([Y(0,p.IUserDataSyncStoreService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,O.IInstantiationService),Y(3,p.IUserDataSyncLogService),Y(4,n.ITelemetryService),Y(5,v.IStorageService)],a),e.UserDataSyncService=a;class s extends L.Disposable{constructor(r,o,c,l,u){super();this.id=r,this.manifest=o,this.syncHeaders=c,this.synchronisers=l,this.logService=u,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new R.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(r=>r.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(r=>r.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,E.createCancelablePromise)(r=>this.getPreviews(r))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(r){throw this.logService.error(r),r}}async accept(r,o){try{return await this.performAction(r,c=>c.accept(r,o))}catch(c){throw this.logService.error(c),c}}async merge(r){try{return r?await this.performAction(r,o=>o.merge(r)):await this.mergeAll()}catch(o){throw this.logService.error(o),o}}async discard(r){try{return await this.performAction(r,o=>o.discard(r))}catch(o){throw this.logService.error(o),o}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const r=[];for(const[,o]of this.previews)for(const c of o.resourcePreviews)c.mergeState==="conflict"&&r.push(c.previewResource);for(const o of r)await this.discard(o);return this.previews}catch(r){throw this.logService.error(r),r}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const r=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(m=>m.resource===o);for(const m of c.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&await l.merge(m.previewResource);const u=await l.apply(!1,this.syncHeaders);u&&r.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}catch(r){throw this.logService.error(r),r}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===r);for(const l of o.resourcePreviews)await c.accept(l.remoteResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[r,o]of this.previews){this.synchronizingResources.push([r,o.resourcePreviews.map(l=>l.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const c=this.synchronisers.find(l=>l.resource===r);for(const l of o.resourcePreviews)await c.accept(l.localResource);await c.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(l=>l[0]===r),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(r){throw this.logService.error(r),r}}async stop(){for(const r of this.synchronisers)try{await r.stop()}catch(o){(0,D.isPromiseCanceledError)(o)||this.logService.error(o)}this.reset()}async performAction(r,o){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const c=this.previews.findIndex(([,j])=>j.resourcePreviews.some(({localResource:q,previewResource:K,remoteResource:M})=>(0,d.isEqual)(r,q)||(0,d.isEqual)(r,K)||(0,d.isEqual)(r,M)));if(c===-1)return this.previews;const[l,u]=this.previews[c],m=u.resourcePreviews.find(({localResource:j,remoteResource:q,previewResource:K})=>(0,d.isEqual)(j,r)||(0,d.isEqual)(q,r)||(0,d.isEqual)(K,r));if(!m)return this.previews;let b=this.synchronizingResources.find(j=>j[0]===l);b||(b=[l,[]],this.synchronizingResources.push(b)),b[1].some(j=>(0,d.isEqual)(j,m.localResource))||(b[1].push(m.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const h=this.synchronisers.find(j=>j.resource===this.previews[c][0]),k=await o(h);k?this.previews.splice(c,1,this.toSyncResourcePreview(h.resource,k)):this.previews.splice(c,1);const _=this.synchronizingResources.findIndex(j=>j[0]===l);return this.synchronizingResources[_][1].splice(b[1].findIndex(j=>(0,d.isEqual)(j,m.localResource)),1),b[1].length||(this.synchronizingResources.splice(_,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const r=[];for(const[o,c]of this.previews){this.synchronizingResources.push([o,c.resourcePreviews.map(m=>m.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const l=this.synchronisers.find(m=>m.resource===o);let u=c;for(const m of c.resourcePreviews)(m.localChange!==0||m.remoteChange!==0)&&m.mergeState==="preview"&&(u=await l.merge(m.previewResource));u&&r.push(this.toSyncResourcePreview(l.resource,u)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(m=>m[0]===o),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=r,this.previews}async getPreviews(r){const o=[];for(const c of this.synchronisers){if(r.isCancellationRequested)return[];const l=await c.preview(this.manifest,this.syncHeaders);l&&o.push(this.toSyncResourcePreview(c.resource,l))}return o}toSyncResourcePreview(r,o){return[r,{isLastSyncFromCurrentMachine:o.isLastSyncFromCurrentMachine,resourcePreviews:o.resourcePreviews.map(t)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}function t(i){return{localResource:i.localResource,previewResource:i.previewResource,remoteResource:i.remoteResource,acceptedResource:i.acceptedResource,localChange:i.localChange,remoteChange:i.remoteChange,mergeState:i.mergeState}}}),define(Z[200],ee([0,1,3,21,5,2,15]),function(G,e,p,L,O,R,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(f,v){this.service=f,this.logService=v,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new p.Emitter}listen(f,v){switch(v){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${v}`)}async call(f,v,C){try{return await this._call(f,v,C)}catch(d){throw this.logService.error(d),d}}async _call(f,v,C){switch(v){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(O.URI.revive(C[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(C[0],O.URI.revive(C[1]),C[2],C[3]);case"resolveContent":return this.service.resolveContent(O.URI.revive(C[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(C[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(C[0]);case"getAssociatedResources":return this.service.getAssociatedResources(C[0],{created:C[1].created,uri:O.URI.revive(C[1].uri)});case"getMachineId":return this.service.getMachineId(C[0],{created:C[1].created,uri:O.URI.revive(C[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(v.startsWith("manualSync/")){const d=v.substring("manualSync/".length),w=C[0],I=this.getManualSyncTask(w);switch(C=C.slice(1),d){case"preview":return I.preview();case"accept":return I.accept(O.URI.revive(C[0]),C[1]);case"merge":return I.merge(O.URI.revive(C[0]));case"discard":return I.discard(O.URI.revive(C[0]));case"discardConflicts":return I.discardConflicts();case"apply":return I.apply();case"pull":return I.pull();case"push":return I.push();case"stop":return I.stop();case"_getStatus":return I.status;case"dispose":return this.disposeManualSyncTask(I)}}throw new Error("Invalid call")}getManualSyncTask(f){const v=this.manualSyncTasks.get(this.createKey(f));if(!v)throw new Error(`Manual sync taks not found: ${f}`);return v.manualSyncTask}async createManualSyncTask(){const f=new R.DisposableStore,v=f.add(await this.service.createManualSyncTask());return f.add(v.onSynchronizeResources(C=>this.onManualSynchronizeResources.fire({manualSyncTaskId:v.id,data:C}))),this.manualSyncTasks.set(this.createKey(v.id),{manualSyncTask:v,disposables:f}),{id:v.id,manifest:v.manifest,status:v.status}}disposeManualSyncTask(f){var v;f.dispose();const C=this.createKey(f.id);(v=this.manualSyncTasks.get(C))===null||v===void 0||v.disposables.dispose(),this.manualSyncTasks.delete(C)}createKey(f){return`manualSyncTask-${f}`}}e.UserDataSyncChannel=A;class S extends R.Disposable{constructor(f){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new p.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new p.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new p.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new p.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(v,C,d){return f.call(v,C,d).then(null,w=>{throw L.UserDataSyncError.toUserDataSyncError(w)})},listen(v,C){return f.listen(v,C)}},this.channel.call("_getInitialData").then(([v,C,d])=>{this.updateStatus(v),this.updateConflicts(C),d&&this.updateLastSyncTime(d),this._register(this.channel.listen("onDidChangeStatus")(w=>this.updateStatus(w))),this._register(this.channel.listen("onDidChangeLastSyncTime")(w=>this.updateLastSyncTime(w)))}),this._register(this.channel.listen("onDidChangeConflicts")(v=>this.updateConflicts(v))),this._register(this.channel.listen("onSyncErrors")(v=>this._onSyncErrors.fire(v.map(([C,d])=>[C,L.UserDataSyncError.toUserDataSyncError(d)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:f,manifest:v,status:C}=await this.channel.call("createManualSyncTask"),d=this,w=new y(f,v,C,{async call(I,E,D){return d.channel.call(`manualSync/${I}`,[f,...(0,U.isArray)(E)?E:[E]],D)},listen(I,E){return p.Event.map(p.Event.filter(d.channel.listen(`manualSync/${I}`,E),D=>!w.isDiposed()&&D.manualSyncTaskId===f),D=>D.data)}});return w}replace(f){return this.channel.call("replace",[f])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(f,v,C,d){return this.channel.call("accept",[f,v,C,d])}resolveContent(f){return this.channel.call("resolveContent",[f])}async getLocalSyncResourceHandles(f){return(await this.channel.call("getLocalSyncResourceHandles",[f])).map(({created:C,uri:d})=>({created:C,uri:O.URI.revive(d)}))}async getRemoteSyncResourceHandles(f){return(await this.channel.call("getRemoteSyncResourceHandles",[f])).map(({created:C,uri:d})=>({created:C,uri:O.URI.revive(d)}))}async getAssociatedResources(f,v){return(await this.channel.call("getAssociatedResources",[f,v])).map(({resource:d,comparableResource:w})=>({resource:O.URI.revive(d),comparableResource:O.URI.revive(w)}))}async getMachineId(f,v){return this.channel.call("getMachineId",[f,v])}async updateStatus(f){this._status=f,this._onDidChangeStatus.fire(f)}async updateConflicts(f){this._conflicts=f.map(([v,C])=>[v,C.map(d=>Object.assign(Object.assign({},d),{localResource:O.URI.revive(d.localResource),remoteResource:O.URI.revive(d.remoteResource),previewResource:O.URI.revive(d.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(f){this._lastSyncTime!==f&&(this._lastSyncTime=f,this._onDidChangeLastSyncTime.fire(f))}}e.UserDataSyncChannelClient=S;class y extends R.Disposable{constructor(f,v,C,d){super();this.id=f,this.manifest=v,this._disposed=!1,this._status=C;const w=this;this.channel={async call(I,E,D){try{const g=await d.call(I,E,D);return w.isDiposed()||(w._status=await d.call("_getStatus")),g}catch(g){throw L.UserDataSyncError.toUserDataSyncError(g)}},listen(I,E){return d.listen(I,E)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const f=await this.channel.call("preview");return this.deserializePreviews(f)}async accept(f,v){const C=await this.channel.call("accept",[f,v]);return this.deserializePreviews(C)}async merge(f){const v=await this.channel.call("merge",[f]);return this.deserializePreviews(v)}async discard(f){const v=await this.channel.call("discard",[f]);return this.deserializePreviews(v)}async discardConflicts(){const f=await this.channel.call("discardConflicts");return this.deserializePreviews(f)}async apply(){const f=await this.channel.call("apply");return this.deserializePreviews(f)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(f){return f.map(([v,C])=>[v,{isLastSyncFromCurrentMachine:C.isLastSyncFromCurrentMachine,resourcePreviews:C.resourcePreviews.map(d=>Object.assign(Object.assign({},d),{localResource:O.URI.revive(d.localResource),remoteResource:O.URI.revive(d.remoteResource),previewResource:O.URI.revive(d.previewResource),acceptedResource:O.URI.revive(d.acceptedResource)}))}])}}}),define(Z[201],ee([0,1,2,21,40,14,30,23,28,45,9,10,20,31,6,3,8,15,5,11]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const a="sync.previous.store",s="sync.donot-make-requests-until",t="sync.user-session-id",i="sync.machine-session-id",r=100,o=1e3*60*5;let c=class extends p.Disposable{constructor(k,_,j){super();this.productService=k,this.configurationService=_,this.storageService=j,this._onDidChangeUserDataSyncStore=this._register(new w.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(w.Event.filter(j.onDidChangeValue,q=>{var K;return q.key===L.SYNC_SERVICE_URL_TYPE&&q.scope===0&&this.userDataSyncStoreType!==((K=this.userDataSyncStore)===null||K===void 0?void 0:K.type)})(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(L.SYNC_SERVICE_URL_TYPE,0)}set userDataSyncStoreType(k){this.storageService.store(L.SYNC_SERVICE_URL_TYPE,k,0,d.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[L.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(L.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(k,_){k=d.isWeb&&(k==null?void 0:k.web)?Object.assign(Object.assign({},k),k.web):k;const j=Object.assign(Object.assign({},k||{}),_||{});if(j&&(0,E.isString)(j.url)&&(0,E.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(q=>(0,E.isArray)(j.authenticationProviders[q].scopes))){const q=j,K=!!q.canSwitch&&!(_==null?void 0:_.url),M=q.url===q.insidersUrl?"insiders":"stable",$=(K?this.userDataSyncStoreType:void 0)||M,z=(_==null?void 0:_.url)||($==="insiders"?q.insidersUrl:$==="stable"?q.stableUrl:q.url);return{url:D.URI.parse(z),type:$,defaultType:M,defaultUrl:D.URI.parse(q.url),stableUrl:D.URI.parse(q.stableUrl),insidersUrl:D.URI.parse(q.insidersUrl),canSwitch:K,authenticationProviders:Object.keys(q.authenticationProviders).reduce((W,H)=>(W.push({id:H,scopes:q.authenticationProviders[H].scopes}),W),[])}}}};c=de([Y(0,S.IProductService),Y(1,A.IConfigurationService),Y(2,v.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let l=class extends c{constructor(k,_,j){super(k,_,j);const q=this.storageService.get(a,0);q&&(this.previousConfigurationSyncStore=JSON.parse(q));const K=this.productService[L.CONFIGURATION_SYNC_STORE_KEY];K?this.storageService.store(a,JSON.stringify(K),0,1):this.storageService.remove(a,0)}async switch(k){k!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=k,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};l=de([Y(0,S.IProductService),Y(1,A.IConfigurationService),Y(2,v.IStorageService)],l),e.UserDataSyncStoreManagementService=l;let u=class extends p.Disposable{constructor(k,_,j,q,K,M,$){super();this.requestService=j,this.logService=q,this.storageService=$,this._onTokenFailed=this._register(new w.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new w.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new w.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(k),this.commonHeadersPromise=(0,y.getServiceMachineId)(K,M,$).then(z=>{const W={"X-Client-Name":`${_.applicationName}${d.isWeb?"-web":""}`,"X-Client-Version":_.version,"X-Machine-Id":z};return _.commit&&(W["X-Client-Commit"]=_.commit),W}),this.session=new b(r,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,p.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(k,_){this.authToken={token:k,type:_}}updateUserDataSyncStoreUrl(k){this.userDataSyncStoreUrl=k?(0,R.joinPath)(k,"v1"):void 0}initDonotMakeRequestsUntil(){const k=this.storageService.getNumber(s,0);k&&Date.now()<k&&this.setDonotMakeRequestsUntil(new Date(k))}setDonotMakeRequestsUntil(k){var _;((_=this._donotMakeRequestsUntil)===null||_===void 0?void 0:_.getTime())!==(k==null?void 0:k.getTime())&&(this._donotMakeRequestsUntil=k,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),0,1),this.resetDonotMakeRequestsUntilPromise=(0,I.createCancelablePromise)(j=>(0,I.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),j).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,j=>null)):this.storageService.remove(s,0),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",k),j={},q=await this.request(_.toString(),{type:"GET",headers:j},[],U.CancellationToken.None);return(await(0,O.asJson)(q)||[]).map(({url:M,created:$})=>({ref:(0,R.relativePath)(_,_.with({path:M})),created:$*1e3}))}async resolveContent(k,_){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const j=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",k,_).toString(),q={};q["Cache-Control"]="no-cache";const K=await this.request(j,{type:"GET",headers:q},[],U.CancellationToken.None);return await(0,O.asText)(K)}async delete(k){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",k).toString(),j={};await this.request(_,{type:"DELETE",headers:j},[],U.CancellationToken.None)}async read(k,_,j={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const q=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",k,"latest").toString();j=Object.assign({},j),j["Cache-Control"]="no-cache",_&&(j["If-None-Match"]=_.ref);const K=await this.request(q,{type:"GET",headers:j},[304],U.CancellationToken.None);if(K.res.statusCode===304)return _;const M=K.res.headers.etag;if(!M)throw new L.UserDataSyncStoreError("Server did not return the ref",q,L.UserDataSyncErrorCode.NoRef,K.res.headers[L.HEADER_OPERATION_ID]);const $=await(0,O.asText)(K);return{ref:M,content:$}}async write(k,_,j,q={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const K=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource",k).toString();q=Object.assign({},q),q["Content-Type"]="text/plain",j&&(q["If-Match"]=j);const M=await this.request(K,{type:"POST",data:_,headers:q},[],U.CancellationToken.None),$=M.res.headers.etag;if(!$)throw new L.UserDataSyncStoreError("Server did not return the ref",K,L.UserDataSyncErrorCode.NoRef,M.res.headers[L.HEADER_OPERATION_ID]);return $}async manifest(k={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const _=(0,R.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();k=Object.assign({},k),k["Content-Type"]="application/json";const j=await this.request(_,{type:"GET",headers:k},[],U.CancellationToken.None),q=await(0,O.asJson)(j),K=this.storageService.get(t,0);return K&&q&&K!==q.session&&this.clearSession(),q===null&&K&&this.clearSession(),q&&this.storageService.store(t,q.session,0,1),q}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const k=(0,R.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),_={"Content-Type":"text/plain"};await this.request(k,{type:"DELETE",headers:_},[],U.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(t,0),this.storageService.remove(i,0)}async request(k,_,j,q){if(!this.authToken)throw new L.UserDataSyncStoreError("No Auth Token Available",k,L.UserDataSyncErrorCode.Unauthorized,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of too many requests (429).`,k,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,void 0);this.setDonotMakeRequestsUntil(void 0);const K=await this.commonHeadersPromise;_.headers=Object.assign(Object.assign(Object.assign({},_.headers||{}),K),{"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`}),this.addSessionHeaders(_.headers),this.logService.trace("Sending request to server",{url:k,type:_.type,headers:Object.assign(Object.assign({},_.headers),{authorization:void 0})});let M;try{M=await this.session.request(k,_,q)}catch(H){if(!(H instanceof L.UserDataSyncStoreError)){const T=(0,g.isPromiseCanceledError)(H)?L.UserDataSyncErrorCode.RequestCanceled:(0,g.getErrorMessage)(H).startsWith("XHR timeout")?L.UserDataSyncErrorCode.RequestTimeout:L.UserDataSyncErrorCode.RequestFailed;H=new L.UserDataSyncStoreError(`Connection refused for the request '${k}'.`,k,T,void 0)}throw this.logService.info("Request failed",k),H}const $=M.res.headers[L.HEADER_OPERATION_ID],z={url:k,status:M.res.statusCode,"execution-id":_.headers[L.HEADER_EXECUTION_ID],"operation-id":$},W=(0,O.isSuccess)(M)||M.res.statusCode&&j.indexOf(M.res.statusCode)!==-1;if(W?this.logService.trace("Request succeeded",z):this.logService.info("Request failed",z),M.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new L.UserDataSyncStoreError(`Request '${k}' failed because of Unauthorized (401).`,k,L.UserDataSyncErrorCode.Unauthorized,$);if(this._onTokenSucceed.fire(),M.res.statusCode===409)throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,k,L.UserDataSyncErrorCode.Conflict,$);if(M.res.statusCode===410)throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because the requested resource is not longer available (410).`,k,L.UserDataSyncErrorCode.Gone,$);if(M.res.statusCode===412)throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,k,L.UserDataSyncErrorCode.PreconditionFailed,$);if(M.res.statusCode===413)throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of too large payload (413).`,k,L.UserDataSyncErrorCode.TooLarge,$);if(M.res.statusCode===426)throw new L.UserDataSyncStoreError(`${_.type} request '${k}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,k,L.UserDataSyncErrorCode.UpgradeRequired,$);if(M.res.statusCode===429){const H=M.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of too many requests (429).`,k,L.UserDataSyncErrorCode.TooManyRequestsAndRetryAfter,$)):new L.UserDataSyncStoreError(`${_.type} request '${k}' failed because of too many requests (429).`,k,L.UserDataSyncErrorCode.TooManyRequests,$)}if(!W)throw new L.UserDataSyncStoreError("Server returned "+M.res.statusCode,k,L.UserDataSyncErrorCode.Unknown,$);return M}addSessionHeaders(k){let _=this.storageService.get(i,0);_===void 0&&(_=(0,C.generateUuid)(),this.storageService.store(i,_,0,1)),k["X-Machine-Session-Id"]=_;const j=this.storageService.get(t,0);j!==void 0&&(k["X-User-Session-Id"]=j)}};u=de([Y(1,S.IProductService),Y(2,O.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,f.IFileService),Y(6,v.IStorageService)],u),e.UserDataSyncStoreClient=u;let m=class extends u{constructor(k,_,j,q,K,M,$){var z;super((z=k.userDataSyncStore)===null||z===void 0?void 0:z.url,_,j,q,K,M,$);this._register(k.onDidChangeUserDataSyncStore(()=>{var W;return this.updateUserDataSyncStoreUrl((W=k.userDataSyncStore)===null||W===void 0?void 0:W.url)}))}};m=de([Y(0,L.IUserDataSyncStoreManagementService),Y(1,S.IProductService),Y(2,O.IRequestService),Y(3,L.IUserDataSyncLogService),Y(4,n.IEnvironmentService),Y(5,f.IFileService),Y(6,v.IStorageService)],m),e.UserDataSyncStoreService=m;class b{constructor(k,_,j,q){this.limit=k,this.interval=_,this.requestService=j,this.logService=q,this.requests=[],this.startTime=void 0}request(k,_,j){if(this.isExpired()&&this.reset(),_.url=k,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new L.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,k,L.UserDataSyncErrorCode.LocalTooManyRequests,void 0);return this.startTime=this.startTime||new Date,this.requests.push(k),this.requestService.request(_,j)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=b}),define(Z[202],ee([0,1,21,3,58,85,60,24,20,61,28]),function(G,e,p,L,O,R,U,A,S,y,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let f=class extends R.UserDataAutoSyncService{constructor(C,d,w,I,E,D,g,a,s,t,i,r){super(C,d,w,I,E,g,a,s,t,i,r);this._register(L.Event.debounce(L.Event.any(L.Event.map(D.onDidFocusWindow,()=>"windowFocus"),L.Event.map(D.onDidOpenWindow,()=>"windowOpen")),(o,c)=>o?[...o,c]:[c],1e3)(o=>this.triggerSync(o,!0,!1)))}};f=de([Y(0,n.IProductService),Y(1,p.IUserDataSyncStoreManagementService),Y(2,p.IUserDataSyncStoreService),Y(3,p.IUserDataSyncResourceEnablementService),Y(4,p.IUserDataSyncService),Y(5,O.INativeHostService),Y(6,p.IUserDataSyncLogService),Y(7,U.IUserDataSyncAccountService),Y(8,A.ITelemetryService),Y(9,y.IUserDataSyncMachinesService),Y(10,S.IStorageService),Y(11,p.IUserDataAutoSyncEnablementService)],f),e.UserDataAutoSyncService=f}),define(Z[203],ee([0,1,3,2,8]),function(G,e,p,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends L.Disposable{constructor({onDidOpenWindow:A,onDidFocusWindow:S,getActiveWindowId:y}){super();this.disposables=this._register(new L.DisposableStore),p.Event.latch(p.Event.any(A,S))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,O.createCancelablePromise)(()=>y()),(async()=>{try{const f=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:f}catch(f){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(A){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=A}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(Z[62],ee([0,1,107,7,27,8,17,209,210,15]),function(G,e,p,L,O,R,U,A,S,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class n extends Error{constructor(t,i){let r=i.message;switch(t){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r);this.type=t,this.cause=i}}e.ExtractError=n;function f(s){const t=s.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,r)=>i+r,t&61440)}function v(s){if(s instanceof n)return s;let t;return/end of central directory record signature not found/.test(s.message)&&(t="CorruptZip"),new n(t,s)}function C(s,t,i,r,o,c){const l=L.dirname(t),u=L.join(r,l);if(!u.startsWith(r))return Promise.reject(new Error(p.localize(0,null,t)));const m=L.join(r,t);let b;return c.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(O.promises.mkdir(u,{recursive:!0})).then(()=>new Promise((h,k)=>{if(!c.isCancellationRequested)try{b=(0,O.createWriteStream)(m,{mode:i}),b.once("close",()=>h()),b.once("error",k),s.once("error",k),s.pipe(b)}catch(_){k(_)}}))}function d(s,t,i,r){let o=(0,R.createCancelablePromise)(()=>Promise.resolve()),c=0;return r.onCancellationRequested(()=>{o.cancel(),s.close()}),new Promise((l,u)=>{const m=new R.Sequencer,b=h=>{h.isCancellationRequested||(c++,s.readEntry())};s.once("error",u),s.once("close",()=>o.then(()=>{r.isCancellationRequested||s.entryCount===c?l():u(new n("Incomplete",new Error(p.localize(1,null,c,s.entryCount))))},u)),s.readEntry(),s.on("entry",h=>{if(!r.isCancellationRequested){if(!i.sourcePathRegex.test(h.fileName)){b(r);return}const k=h.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(k)){const q=L.join(t,k);o=(0,R.createCancelablePromise)(K=>O.promises.mkdir(q,{recursive:!0}).then(()=>b(K)).then(void 0,u));return}const _=I(s,h),j=f(h);o=(0,R.createCancelablePromise)(q=>m.queue(()=>_.then(K=>C(K,k,j,t,i,q).then(()=>b(q)))).then(null,u))}})})}function w(s,t=!1){return new Promise((i,r)=>{(0,A.open)(s,t?{lazyEntries:!0}:void 0,(o,c)=>{o?r(v(o)):i((0,y.assertIsDefined)(c))})})}function I(s,t){return new Promise((i,r)=>{s.openReadStream(t,(o,c)=>{o?r(v(o)):i((0,y.assertIsDefined)(c))})})}function E(s,t){return new Promise((i,r)=>{const o=new S.ZipFile;t.forEach(l=>{l.contents?o.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&o.addFile(l.localPath,l.path)}),o.end();const c=(0,O.createWriteStream)(s);o.outputStream.pipe(c),o.outputStream.once("error",r),c.once("error",r),c.once("finish",()=>i(s))})}e.zip=E;function D(s,t,i={},r){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let c=w(s,!0);return i.overwrite&&(c=c.then(l=>(0,U.rimraf)(t).then(()=>l))),c.then(l=>d(l,t,{sourcePathRegex:o},r))}e.extract=D;function g(s,t){return w(s).then(i=>new Promise((r,o)=>{i.on("entry",c=>{c.fileName===t&&I(i,c).then(l=>r(l),l=>o(l))}),i.once("close",()=>o(new Error(p.localize(2,null,t))))}))}function a(s,t){return g(s,t).then(i=>new Promise((r,o)=>{const c=[];i.once("error",o),i.on("data",l=>c.push(l)),i.on("end",()=>r(Buffer.concat(c)))}))}e.buffer=a}),define(Z[204],ee([0,1,62,112]),function(G,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function O(R){return(0,p.buffer)(R,"extension/package.json").then(U=>{try{return JSON.parse(U.toString("utf8"))}catch(A){throw new Error((0,L.localize)(0,null))}})}e.getManifest=O}),define(Z[205],ee([0,1,27,57,2,17,7,18,29,34,8,5,9,133,113,28,62,6,19,16,10,14,31,11]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a,s,t,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const r="scanningSystem",o="scanningUser",c="extracting",l="deleting",u="renaming";let m=class extends O.Disposable{constructor(h,k,_,j,q){super();this.beforeRemovingExtension=h,this.fileService=k,this.logService=_,this.environmentService=j,this.productService=q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=j.builtinExtensionsPath,this.extensionsPath=j.extensionsPath,this.uninstalledPath=U.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new n.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(h){const k=[];(h===null||h===0)&&k.push(this.scanSystemExtensions().then(null,_=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(_).message,r)))),(h===null||h===1)&&k.push(this.scanUserExtensions(!0).then(null,_=>Promise.reject(new S.ExtensionManagementError(this.joinErrors(_).message,o))));try{const _=await Promise.all(k);return(0,D.flatten)(_)}catch(_){throw this.joinErrors(_)}}async scanUserExtensions(h){this.logService.trace("Started scanning user extensions");let[k,_]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return _=_.filter(j=>!k[new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).key()]),h&&(_=(0,y.groupByExtension)(_,q=>q.identifier).map(q=>q.sort((K,M)=>L.rcompare(K.manifest.version,M.manifest.version))[0])),this.logService.trace("Scanned user extensions:",_.length),_}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(h,k,_){const j=h.key(),q=U.join(this.extensionsPath,`.${(0,t.generateUuid)()}`),K=U.join(this.extensionsPath,j);try{await R.rimraf(K)}catch($){try{await R.rimraf(K)}catch(z){}throw new S.ExtensionManagementError((0,d.localize)(0,null,K,h.id),l)}await this.extractAtLocation(h,k,q,_);let M=await this.scanExtension(f.URI.file(q),1);if(!M)throw new Error((0,d.localize)(1,null,q));await this.storeMetadata(M,{installedTimestamp:Date.now()});try{await this.rename(h,q,K,Date.now()+2*60*1e3),this.logService.info("Renamed to",K)}catch($){try{await R.rimraf(q)}catch(z){}if($.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",h.id);else throw this.logService.info(`Rename failed because of ${(0,i.getErrorMessage)($)}. Deleted from extracted location`,q),$}try{M=await this.scanExtension(f.URI.file(K),1)}catch($){}if(M)return M;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(h,k){return this.setMetadata(h,k),await this.storeMetadata(h,Object.assign(Object.assign({},k),{installedTimestamp:h.installedTimestamp})),h}async storeMetadata(h,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const _=U.join(h.location.fsPath,"package.json"),j=await p.promises.readFile(_,"utf8"),{manifest:q}=await this.parseManifest(j);return q.__metadata=k,await R.writeFile(_,JSON.stringify(q,null,"	")),h}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...h){const k=h.map(_=>new y.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version));await this.withUninstalledExtensions(_=>{k.forEach(j=>_[j.key()]=!0)})}async setInstalled(h){await this.withUninstalledExtensions(j=>delete j[h.key()]);const _=(await this.scanExtensions(1)).find(j=>new y.ExtensionIdentifierWithVersion(j.identifier,j.manifest.version).equals(h))||null;return _?(await this.storeMetadata(_,{installedTimestamp:Date.now()}),this.scanExtension(_.location,1)):null}async withUninstalledExtensions(h){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await p.promises.readFile(this.uninstalledPath,"utf8")}catch(j){if(j.code!=="ENOENT")throw j}let _={};if(k)try{_=JSON.parse(k)}catch(j){}return h&&(h(_),Object.keys(_).length?await R.writeFile(this.uninstalledPath,JSON.stringify(_)):await R.rimraf(this.uninstalledPath)),_})}async removeExtension(h,k){this.logService.trace(`Deleting ${k} extension from disk`,h.identifier.id,h.location.fsPath),await R.rimraf(h.location.fsPath),this.logService.info("Deleted from disk",h.identifier.id,h.location.fsPath)}async removeUninstalledExtension(h){await this.removeExtension(h,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new y.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version).key()])}async extractAtLocation(h,k,_,j){this.logService.trace(`Started extracting the extension from ${k} to ${_}`);try{await R.rimraf(_)}catch(q){throw new S.ExtensionManagementError(this.joinErrors(q).message,l)}try{await(0,I.extract)(k,_,{sourcePath:"extension",overwrite:!0},j),this.logService.info(`Extracted extension to ${_}:`,h.id)}catch(q){try{await R.rimraf(_)}catch(K){}throw new S.ExtensionManagementError(q.message,q instanceof I.ExtractError&&q.type?q.type:c)}}async rename(h,k,_,j){try{await p.promises.rename(k,_)}catch(q){if(E.isWindows&&q&&q.code==="EPERM"&&Date.now()<j)return this.logService.info(`Failed renaming ${k} to ${_} with 'EPERM' error. Trying again...`,h.id),this.rename(h,k,_,j);throw new S.ExtensionManagementError(q.message||(0,d.localize)(3,null,k,_),q.code||u)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const h=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return h;const k=this.scanDevSystemExtensions(),[_,j]=await Promise.all([h,k]);return[..._,...j]}async scanExtensionsInDir(h,k){const _=new n.Limiter(10),j=await this.fileService.resolve(f.URI.file(h));return j.children?(await Promise.all(j.children.filter(K=>K.isDirectory).map(K=>_.queue(async()=>k===1&&(0,s.basename)(K.resource).indexOf(".")===0?null:this.scanExtension(K.resource,k))))).filter(K=>K&&K.identifier):[]}async scanExtension(h,k){var _,j;try{const q=await this.fileService.resolve(h);if(q.children){const{manifest:K,metadata:M}=await this.readManifest(h.fsPath),$=(_=q.children.find(({name:T})=>/^readme(\.txt|\.md|)$/i.test(T)))===null||_===void 0?void 0:_.resource,z=(j=q.children.find(({name:T})=>/^changelog(\.txt|\.md|)$/i.test(T)))===null||j===void 0?void 0:j.resource,W={id:(0,y.getGalleryExtensionId)(K.publisher,K.name)},H={type:k,identifier:W,manifest:K,location:h,readmeUrl:$,changelogUrl:z,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return M&&(this.setMetadata(H,M),H.installedTimestamp=M.installedTimestamp),H}}catch(q){k!==0&&this.logService.trace(q)}return null}async scanDefaultSystemExtensions(){const h=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",h.length),h}async scanDevSystemExtensions(){const h=this.getDevSystemExtensionsList();if(h.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(_=>h.some(j=>(0,y.areSameExtensions)(_.identifier,{id:j})))}else return[]}setMetadata(h,k){h.publisherDisplayName=k.publisherDisplayName||null,h.publisherId=k.publisherId||null,h.identifier.uuid=k.id,h.isMachineScoped=!!k.isMachineScoped,h.isBuiltin=h.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const h=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),_=new Set;for(const K of k)h[new y.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version).key()]||_.add(K.identifier.id.toLowerCase());const j=(0,y.groupByExtension)(k,K=>K.identifier);await n.Promises.settled(j.map(async K=>{const M=K.sort(($,z)=>L.rcompare($.manifest.version,z.manifest.version))[0];_.has(M.identifier.id.toLowerCase())||await this.beforeRemovingExtension(M)}));const q=k.filter(K=>h[new y.ExtensionIdentifierWithVersion(K.identifier,K.manifest.version).key()]);await n.Promises.settled(q.map(K=>this.removeUninstalledExtension(K)))}async removeOutdatedExtensions(){const h=await this.scanAllUserExtensions(),k=[],_=(0,y.groupByExtension)(h,j=>j.identifier);k.push(...(0,D.flatten)(_.map(j=>j.sort((q,K)=>L.rcompare(q.manifest.version,K.manifest.version)).slice(1)))),await n.Promises.settled(k.map(j=>this.removeExtension(j,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(h=>h.name)}joinErrors(h){const k=Array.isArray(h)?h:[h];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((_,j)=>new Error(`${_.message}${_.message?",":""}${j instanceof Error?j.message:j}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=U.normalize(U.join(g.FileAccess.asFileUri("",G).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(h){const k=[p.promises.readFile(U.join(h,"package.json"),"utf8").then(K=>this.parseManifest(K)),p.promises.readFile(U.join(h,"package.nls.json"),"utf8").then(void 0,K=>K.code!=="ENOENT"?Promise.reject(K):"{}").then(K=>JSON.parse(K))],[{manifest:_,metadata:j},q]=await Promise.all(k);return{manifest:(0,C.localizeManifest)(_,q),metadata:j}}parseManifest(h){return new Promise((k,_)=>{try{const j=JSON.parse(h),q=j.__metadata||null;k({manifest:j,metadata:q})}catch(j){_(new Error((0,d.localize)(4,null)))}})}};m=de([Y(1,a.IFileService),Y(2,A.ILogService),Y(3,v.INativeEnvironmentService),Y(4,w.IProductService)],m),e.ExtensionsScanner=m}),define(Z[206],ee([0,1,27,111,7,17,2,19,62,29,34,9,8,3,57,5,51,6,18,146,44,24,70,14,31,72,4,16,30,204,154,205,155,156,10]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a,s,t,i,r,o,c,l,u,m,b,h,k,_,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const q="unsetUninstalled",K="downloading",M="validating",$="local",z="unknown";let W=class extends U.Disposable{constructor(T,P,F,N,x,V,X){super();this.environmentService=T,this.galleryService=P,this.logService=F,this.downloadService=N,this.telemetryService=x,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new C.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new C.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new C.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new C.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const Q=this._register(V.createInstance(k.ExtensionsLifecycle));this.extensionsScanner=this._register(V.createInstance(h.ExtensionsScanner,ne=>Q.postUninstall(ne))),this.manifestCache=this._register(new g.ExtensionsManifestCache(T,this)),this.extensionsDownloader=this._register(V.createInstance(b.ExtensionsDownloader));const ie=this._register(new _.ExtensionsWatcher(this,X,T,F));this._register(ie.onDidChangeExtensionsByAnotherSource(({added:ne,removed:ce})=>{ne.forEach(ue=>this._onDidInstallExtension.fire({identifier:ue.identifier,operation:0,local:ue})),ce.forEach(ue=>this._onDidUninstallExtension.fire({identifier:ue}))})),this._register((0,U.toDisposable)(()=>{this.installingExtensions.forEach(ne=>ne.cancel()),this.uninstallingExtensions.forEach(ne=>ne.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const P=await this.collectFiles(T),F=await(0,S.zip)((0,i.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)()).fsPath,P);return w.URI.file(F)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const P=await this.downloadVsix(T),F=O.resolve(P.fsPath);return(0,m.getManifest)(F)}async collectFiles(T){const P=async N=>{let x=await R.readdir(N);x=x.map(Q=>O.join(N,Q));const V=await Promise.all(x.map(Q=>p.promises.stat(Q)));let X=Promise.resolve([]);return V.forEach((Q,ie)=>{const ne=x[ie];Q.isFile()&&(X=X.then(ce=>[...ce,ne])),Q.isDirectory()&&(X=X.then(ce=>P(ne).then(ue=>[...ce,...ue])))}),X};return(await P(T.location.fsPath)).map(N=>({path:`extension/${O.relative(T.location.fsPath,N)}`,localPath:N}))}async install(T,P={}){return this.logService.trace("ExtensionManagementService#install",T.toString()),(0,v.createCancelablePromise)(async F=>{const N=await this.downloadVsix(T),x=O.resolve(N.fsPath),V=await(0,m.getManifest)(x),X={id:(0,n.getGalleryExtensionId)(V.publisher,V.name)};let Q=1;if(V.engines&&V.engines.vscode&&!(0,t.isEngineValid)(V.engines.vscode,I.default.version,I.default.date))throw new Error(L.localize(0,null,X.id,I.default.version));const ie=new n.ExtensionIdentifierWithVersion(X,V.version),ce=(await this.getInstalled(1)).find(ge=>(0,n.areSameExtensions)(X,ge.identifier));if(ce)if(P.isMachineScoped=P.isMachineScoped||ce.isMachineScoped,P.isBuiltin=P.isBuiltin||ce.isBuiltin,Q=2,ie.equals(new n.ExtensionIdentifierWithVersion(ce.identifier,ce.manifest.version)))try{await this.extensionsScanner.removeExtension(ce,"existing")}catch(ge){throw new Error(L.localize(1,null,V.displayName||V.name))}else d.gt(ce.manifest.version,V.version)&&await this.uninstallExtension(ce);else{const ge=await this.unsetUninstalledAndGetLocal(ie);if(ge)try{await this.extensionsScanner.removeExtension(ge,"existing")}catch(pe){throw new Error(L.localize(2,null,V.displayName||V.name))}}this.logService.info("Installing the extension:",X.id),this._onInstallExtension.fire({identifier:X,zipPath:x});let ue;try{ue=await this.getGalleryMetadata((0,n.getGalleryExtensionId)(V.publisher,V.name))}catch(ge){}try{const ge=await this.installFromZipPath(ie,x,Object.assign(Object.assign({},ue||{}),P),P,Q,F);return this.logService.info("Successfully installed the extension:",X.id),ge}catch(ge){throw this.logService.error("Failed to install the extension:",X.id,ge.message),ge}})}async downloadVsix(T){if(T.scheme===l.Schemas.file)return T;if(!this.downloadService)throw new Error("Download service is not available");const P=(0,i.joinPath)(this.environmentService.tmpDir,(0,r.generateUuid)());return await this.downloadService.download(T,P),P}async installFromZipPath(T,P,F,N,x,V){try{const X=await this.installExtension({zipPath:P,identifierWithVersion:T,metadata:F},V);try{await this.installDependenciesAndPackExtensions(X,void 0,N)}catch(Q){(0,A.isNonEmptyArray)(X.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",X.identifier.id,Q.message),(0,A.isNonEmptyArray)(X.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",X.identifier.id,Q.message)}return this._onDidInstallExtension.fire({identifier:T,zipPath:P,local:X,operation:x}),X}catch(X){throw this._onDidInstallExtension.fire({identifier:T,zipPath:P,operation:x,error:X}),X}}async canInstall(T){return!0}async installFromGallery(T,P={}){if(!this.galleryService.isEnabled())throw new Error(L.localize(3,null));try{T=await this.checkAndGetCompatibleVersion(T)}catch(x){const V=x&&x.code?x.code:z;throw this.logService.error("Failed to install extension:",T.identifier.id,x?x.message:V),this.reportTelemetry(this.getTelemetryEvent(1),(0,n.getGalleryExtensionTelemetryData)(T),void 0,x),x instanceof Error&&(x.name=V),x}const F=new n.ExtensionIdentifierWithVersion(T.identifier,T.version).key();let N=this.installingExtensions.get(F);return N||(N=(0,v.createCancelablePromise)(x=>this.doInstallFromGallery(T,P,x)),this.installingExtensions.set(F,N),N.finally(()=>this.installingExtensions.delete(F))),N}async doInstallFromGallery(T,P,F){const N=new Date().getTime();let x=1;this.logService.info("Installing extension:",T.identifier.id),this._onInstallExtension.fire({identifier:T.identifier,gallery:T});try{const X=(await this.getInstalled(1)).find(ne=>(0,n.areSameExtensions)(ne.identifier,T.identifier));X&&(x=2);const Q=await this.downloadInstallableExtension(T,x);Q.metadata.isMachineScoped=P.isMachineScoped||(X==null?void 0:X.isMachineScoped),Q.metadata.isBuiltin=P.isBuiltin||(X==null?void 0:X.isBuiltin);const ie=await this.installExtension(Q,F);try{await this.extensionsDownloader.delete(w.URI.file(Q.zipPath))}catch(ne){}if(!P.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(ie,X,P)}catch(ne){try{await this.uninstall(ie)}catch(ce){}throw ne}return X&&d.neq(X.manifest.version,T.version)&&await this.extensionsScanner.setUninstalled(X),this.logService.info("Extensions installed successfully:",T.identifier.id),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,local:ie,operation:x}),this.reportTelemetry(this.getTelemetryEvent(x),(0,n.getGalleryExtensionTelemetryData)(T),new Date().getTime()-N,void 0),ie}catch(V){const X=V&&V.code?V.code:z;throw this.logService.error("Failed to install extension:",T.identifier.id,V?V.message:X),this._onDidInstallExtension.fire({identifier:T.identifier,gallery:T,operation:x,error:X}),this.reportTelemetry(this.getTelemetryEvent(x),(0,n.getGalleryExtensionTelemetryData)(T),new Date().getTime()-N,V),V instanceof Error&&(V.name=X),V}}async checkAndGetCompatibleVersion(T){if(await this.isMalicious(T))throw new y.ExtensionManagementError(L.localize(4,null),y.INSTALL_ERROR_MALICIOUS);const P=await this.galleryService.getCompatibleExtension(T);if(!P)throw new y.ExtensionManagementError(L.localize(5,null,T.identifier.id,I.default.version),y.INSTALL_ERROR_INCOMPATIBLE);return P}async reinstallFromGallery(T){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",T.identifier.id),!this.galleryService.isEnabled())throw new Error(L.localize(6,null));const P=await this.findGalleryExtension(T);if(!P)throw new Error(L.localize(7,null));await this.extensionsScanner.setUninstalled(T);try{await this.extensionsScanner.removeUninstalledExtension(T)}catch(F){throw new Error(L.localize(8,null,(0,a.toErrorMessage)(F)))}await this.installFromGallery(P)}getTelemetryEvent(T){return T===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(T){const P=await this.getExtensionsReport();return(0,n.getMaliciousExtensionsSet)(P).has(T.identifier.id)}async downloadInstallableExtension(T,P){const F={id:T.identifier.uuid,publisherId:T.publisherId,publisherDisplayName:T.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",T.identifier.id),N=(await this.extensionsDownloader.downloadExtension(T,P)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,N)}catch(x){throw new y.ExtensionManagementError(this.joinErrors(x).message,K)}try{const x=await(0,m.getManifest)(N);return{zipPath:N,identifierWithVersion:new n.ExtensionIdentifierWithVersion(T.identifier,x.version),metadata:F}}catch(x){throw new y.ExtensionManagementError(this.joinErrors(x).message,M)}}async installExtension(T,P){try{const F=await this.unsetUninstalledAndGetLocal(T.identifierWithVersion);if(F)return T.metadata?this.extensionsScanner.saveMetadataForLocalExtension(F,T.metadata):F}catch(F){throw E.isMacintosh?new y.ExtensionManagementError(L.localize(9,null),q):new y.ExtensionManagementError(L.localize(10,null),q)}return this.extractAndInstall(T,P)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const F=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),F}async extractAndInstall({zipPath:T,identifierWithVersion:P,metadata:F},N){let x=await this.extensionsScanner.extractUserExtension(P,T,N);return this.logService.info("Installation completed.",P.id),F&&(x=await this.extensionsScanner.saveMetadataForLocalExtension(x,F)),x}async installDependenciesAndPackExtensions(T,P,F){if(!!this.galleryService.isEnabled()){const N=T.manifest.extensionDependencies||[];if(T.manifest.extensionPack)for(const x of T.manifest.extensionPack)P&&P.manifest.extensionPack&&P.manifest.extensionPack.some(V=>(0,n.areSameExtensions)({id:V},{id:x}))||N.every(V=>!(0,n.areSameExtensions)({id:V},{id:x}))&&N.push(x);if(N.length){const x=await this.getInstalled(),V=N.filter(X=>x.every(({identifier:Q})=>!(0,n.areSameExtensions)(Q,{id:X})));if(V.length){const Q=(await this.galleryService.query({names:V,pageSize:N.length},u.CancellationToken.None)).firstPage;try{await v.Promises.settled(Q.map(ie=>this.installFromGallery(ie,F)))}catch(ie){try{await this.rollback(Q)}catch(ne){}throw ie}}}}}async rollback(T){const F=(await this.getInstalled(1)).filter(N=>T.some(x=>new n.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new n.ExtensionIdentifierWithVersion(x.identifier,x.version))));await v.Promises.settled(F.map(N=>this.uninstall(N)))}async uninstall(T,P={}){this.logService.trace("ExtensionManagementService#uninstall",T.identifier.id);const F=await this.getInstalled(1),N=F.find(x=>(0,n.areSameExtensions)(x.identifier,T.identifier));if(!N)throw new Error(L.localize(11,null,T.manifest.displayName||T.manifest.name));try{await this.checkForDependenciesAndUninstall(N,F,P)}catch(x){throw this.joinErrors(x)}}async updateMetadata(T,P){return this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),P)),this.manifestCache.invalidate(),T}async updateExtensionScope(T,P){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.saveMetadataForLocalExtension(T,Object.assign(Object.assign({},T.manifest.__metadata||{}),{isMachineScoped:P})),this.manifestCache.invalidate(),T}async getGalleryMetadata(T){const P=await this.findGalleryExtensionByName(T);return P?{id:P.identifier.uuid,publisherDisplayName:P.publisherDisplayName,publisherId:P.publisherId}:void 0}async findGalleryExtension(T){if(T.identifier.uuid){const P=await this.findGalleryExtensionById(T.identifier.uuid);return P||this.findGalleryExtensionByName(T.identifier.id)}return this.findGalleryExtensionByName(T.identifier.id)}async findGalleryExtensionById(T){return(await this.galleryService.query({ids:[T],pageSize:1},u.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(T){return(await this.galleryService.query({names:[T],pageSize:1},u.CancellationToken.None)).firstPage[0]}joinErrors(T){const P=Array.isArray(T)?T:[T];return P.length===1?P[0]instanceof Error?P[0]:new Error(P[0]):P.reduce((F,N)=>new Error(`${F.message}${F.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(T,P,F){try{await this.preUninstallExtension(T);const N=F.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(T,P);await this.uninstallExtensions(T,N,P,F)}catch(N){throw await this.postUninstallExtension(T,new y.ExtensionManagementError(N instanceof Error?N.message:N,$)),N}await this.postUninstallExtension(T)}async uninstallExtensions(T,P,F,N){const x=[T,...P];if(!N.donotCheckDependents)for(const V of x)this.checkForDependents(V,x,F,T);await v.Promises.settled([this.uninstallExtension(T),...P.map(V=>this.doUninstall(V))])}checkForDependents(T,P,F,N){const x=this.getDependents(T,F);if(x.length){const V=x.filter(X=>P.indexOf(X)===-1);if(V.length)throw new Error(this.getDependentsErrorMessage(T,V,N))}}getDependentsErrorMessage(T,P,F){return F===T?P.length===1?L.localize(12,null,F.manifest.displayName||F.manifest.name,P[0].manifest.displayName||P[0].manifest.name):P.length===2?L.localize(13,null,F.manifest.displayName||F.manifest.name,P[0].manifest.displayName||P[0].manifest.name,P[1].manifest.displayName||P[1].manifest.name):L.localize(14,null,F.manifest.displayName||F.manifest.name,P[0].manifest.displayName||P[0].manifest.name,P[1].manifest.displayName||P[1].manifest.name):P.length===1?L.localize(15,null,F.manifest.displayName||F.manifest.name,T.manifest.displayName||T.manifest.name,P[0].manifest.displayName||P[0].manifest.name):P.length===2?L.localize(16,null,F.manifest.displayName||F.manifest.name,T.manifest.displayName||T.manifest.name,P[0].manifest.displayName||P[0].manifest.name,P[1].manifest.displayName||P[1].manifest.name):L.localize(17,null,F.manifest.displayName||F.manifest.name,T.manifest.displayName||T.manifest.name,P[0].manifest.displayName||P[0].manifest.name,P[1].manifest.displayName||P[1].manifest.name)}getAllPackExtensionsToUninstall(T,P,F=[]){if(F.indexOf(T)!==-1)return[];F.push(T);const N=T.manifest.extensionPack?T.manifest.extensionPack:[];if(N.length){const x=P.filter(X=>!X.isBuiltin&&N.some(Q=>(0,n.areSameExtensions)({id:Q},X.identifier))),V=[];for(const X of x)V.push(...this.getAllPackExtensionsToUninstall(X,P,F));return[...x,...V]}return[]}getDependents(T,P){return P.filter(F=>F.manifest.extensionDependencies&&F.manifest.extensionDependencies.some(N=>(0,n.areSameExtensions)({id:N},T.identifier)))}async doUninstall(T){try{await this.preUninstallExtension(T),await this.uninstallExtension(T)}catch(P){throw await this.postUninstallExtension(T,new y.ExtensionManagementError(P instanceof Error?P.message:P,$)),P}await this.postUninstallExtension(T)}async preUninstallExtension(T){if(!await R.exists(T.location.fsPath))throw new Error(L.localize(18,null));this.logService.info("Uninstalling extension:",T.identifier.id),this._onUninstallExtension.fire(T.identifier)}async uninstallExtension(T){let P=this.uninstallingExtensions.get(T.identifier.id);return P||(P=(0,v.createCancelablePromise)(async()=>{const F=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...F.filter(N=>(0,n.areSameExtensions)(N.identifier,T.identifier)))}),this.uninstallingExtensions.set(T.identifier.id,P),P.finally(()=>this.uninstallingExtensions.delete(T.identifier.id))),P}async postUninstallExtension(T,P){if(P)this.logService.error("Failed to uninstall extension:",T.identifier.id,P.message);else if(this.logService.info("Successfully uninstalled extension:",T.identifier.id),T.identifier.uuid)try{await this.galleryService.reportStatistic(T.manifest.publisher,T.manifest.name,T.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",(0,n.getLocalExtensionTelemetryData)(T),void 0,P);const F=P?P instanceof y.ExtensionManagementError?P.code:z:void 0;this._onDidUninstallExtension.fire({identifier:T.identifier,error:F})}getInstalled(T=null){return this.extensionsScanner.scanExtensions(T)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(T){return(await this.filterUninstalled(T)).length===1}async filterUninstalled(...T){const P=[],F=await this.extensionsScanner.getUninstalledExtensions();for(const N of T)F[N.key()]&&P.push(N.key());return P}getExtensionsReport(){const T=new Date().getTime();return(!this.reportedExtensions||T-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=T),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const T=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${T.length} reported extensions from service`),T}catch(T){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(T,P,F,N){const x=N?N instanceof y.ExtensionManagementError?N.code:z:void 0;this.telemetryService.publicLogError(T,Object.assign(Object.assign({},P),{success:!N,duration:F,errorcode:x}))}};W=de([Y(0,f.INativeEnvironmentService),Y(1,y.IExtensionGalleryService),Y(2,D.ILogService),Y(3,(0,c.optional)(o.IDownloadService)),Y(4,s.ITelemetryService),Y(5,c.IInstantiationService),Y(6,j.IFileService)],W),e.ExtensionManagementService=W}),define(Z[211],ee([0,1,27,36,212,101,51,100,37,76,50,150,9,130,132,29,206,173,23,164,40,165,24,59,171,80,81,176,18,77,157,56,2,166,72,162,161,144,143,152,151,172,71,158,10,160,16,28,21,199,201,196,58,197,202,170,20,168,198,60,195,174,61,73,134,203,175,85,84,83,4,153,145,11,44,82,184,179,200,141,147,177,5,14]),function(G,e,p,L,O,R,U,A,S,y,n,f,v,C,d,w,I,E,D,g,a,s,t,i,r,o,c,l,u,m,b,h,k,_,j,q,K,M,$,z,W,H,T,P,F,N,x,V,X,Q,ie,ne,ce,ue,ge,pe,Ce,ke,Fe,Oe,Ae,je,Ie,Te,Ke,Ye,$e,qe,J,re,se,ve,Se,Pe,be,Ue,De,B,te,ae,oe,he,me,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class ye extends k.Disposable{constructor(le){super();this.configuration=le,this.server=this._register(new A.Server),(0,O.gracefulify)(p),this.registerListeners()}registerListeners(){const le=()=>this.dispose();process.once("exit",le),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",le)}async open(){const le=await this.initServices();(0,X.registerConfiguration)(),le.invokeFunction(Re=>{const _e=Re.get(u.ILogService);_e.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Re),this.registerErrorHandler(_e)}),this._register((0,k.combinedDisposable)(le.createInstance(q.NodeCachedDataCleaner,this.configuration.nodeCachedDataDir),le.createInstance(K.LanguagePackCachedDataCleaner),le.createInstance(M.StorageDataCleaner,this.configuration.backupWorkspacesPath),le.createInstance($.LogsDataCleaner),le.createInstance(ve.LocalizationsUpdater),le.createInstance(Se.DeprecatedExtensionsCleaner)))}async initServices(){const le=new y.ServiceCollection,Re=Object.assign({_serviceBrand:void 0},U.default);le.set(V.IProductService,Re);const _e=new S.StaticRouter(xe=>xe==="main"),Me=new W.MessagePortMainProcessService(this.server,_e);le.set(z.IMainProcessService,Me);const Ne=new C.NativeEnvironmentService(this.configuration.args,Re);le.set(v.INativeEnvironmentService,Ne);const tt=new m.LogLevelChannelClient(this.server.getChannel("logLevel",_e)),Je=new m.LoggerChannelClient(this.configuration.logLevel,tt.onDidChangeLogLevel,Me.getChannel("logger"));le.set(u.ILoggerService,Je);const it=this._register(new u.MultiplexLogService([this._register(new u.ConsoleLogger(this.configuration.logLevel)),this._register(Je.createLogger((0,fe.joinPath)(me.URI.file(Ne.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),We=this._register(new m.FollowerLogService(tt,it));le.set(u.ILogService,We);const Ve=this._register(new P.FileService(We));le.set(F.IFileService,Ve);const rt=this._register(new N.DiskFileSystemProvider(We));Ve.registerProvider(x.Schemas.file,rt);const Be=this._register(new g.ConfigurationService(Ne.settingsResource,Ve));le.set(D.IConfigurationService,Be),await Be.initialize();const Xe=new pe.NativeStorageService(void 0,Me,Ne);le.set(Ce.IStorageService,Xe),await Xe.initialize(),this._register((0,k.toDisposable)(()=>Xe.flush())),le.set(a.IRequestService,new n.SyncDescriptor(s.RequestService)),le.set(ae.IChecksumService,new n.SyncDescriptor(oe.ChecksumService));const nt=S.ProxyChannel.toService(Me.getChannel("nativeHost"),{context:this.configuration.windowId});le.set(ce.INativeHostService,nt),le.set(j.IDownloadService,new n.SyncDescriptor(_.DownloadService));const st=this._register(new Ye.ActiveWindowManager(nt)),dt=new S.StaticRouter(xe=>st.getActiveClientId().then(at=>xe===at));le.set(Te.IExtensionRecommendationNotificationService,new Ke.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",dt)));let Qe,He;if(!Ne.isExtensionDevelopment&&!Ne.disableTelemetry&&Re.enableTelemetry){He=new $e.TelemetryLogAppender(Je,Ne);const{appRoot:xe,extensionsPath:at,isBuilt:mt,installSourcePath:vt}=Ne;if(Re.aiConfig&&Re.aiConfig.asimovKey&&mt){const ut=new l.AppInsightsAppender("monacoworkbench",null,Re.aiConfig.asimovKey);this._register((0,k.toDisposable)(()=>ut.flush())),He=(0,i.combinedAppender)(ut,He)}Qe=new c.TelemetryService({appender:He,commonProperties:(0,r.resolveCommonProperties)(Ve,(0,L.release)(),(0,L.hostname)(),process.arch,Re.commit,Re.version,this.configuration.machineId,Re.msftInternalDomains,vt),sendErrorTelemetry:!0,piiPaths:[xe,at]},Be)}else Qe=i.NullTelemetryService,He=i.NullAppender;this.server.registerChannel("telemetryAppender",new o.TelemetryAppenderChannel(He)),le.set(t.ITelemetryService,Qe);const gt=new he.CustomEndpointTelemetryService(Be,Qe);return le.set(t.ICustomEndpointTelemetryService,gt),le.set(w.IExtensionManagementService,new n.SyncDescriptor(I.ExtensionManagementService)),le.set(w.IExtensionGalleryService,new n.SyncDescriptor(E.ExtensionGalleryService)),le.set(w.IExtensionTipsService,new n.SyncDescriptor(je.ExtensionTipsService)),le.set(h.ILocalizationsService,new n.SyncDescriptor(b.LocalizationsService)),le.set(T.IDiagnosticsService,new n.SyncDescriptor(H.DiagnosticsService)),le.set(Oe.IUserDataSyncAccountService,new n.SyncDescriptor(Oe.UserDataSyncAccountService)),le.set(X.IUserDataSyncLogService,new n.SyncDescriptor(ue.UserDataSyncLogService)),le.set(X.IUserDataSyncUtilService,new ne.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",xe=>xe.ctx!=="main"))),le.set(w.IGlobalExtensionEnablementService,new n.SyncDescriptor(ke.GlobalExtensionEnablementService)),le.set(J.IIgnoredExtensionsManagementService,new n.SyncDescriptor(J.IgnoredExtensionsManagementService)),le.set(re.IExtensionsStorageSyncService,new n.SyncDescriptor(re.ExtensionsStorageSyncService)),le.set(X.IUserDataSyncStoreManagementService,new n.SyncDescriptor(ie.UserDataSyncStoreManagementService)),le.set(X.IUserDataSyncStoreService,new n.SyncDescriptor(ie.UserDataSyncStoreService)),le.set(Ie.IUserDataSyncMachinesService,new n.SyncDescriptor(Ie.UserDataSyncMachinesService)),le.set(X.IUserDataSyncBackupStoreService,new n.SyncDescriptor(Ae.UserDataSyncBackupStoreService)),le.set(X.IUserDataAutoSyncEnablementService,new n.SyncDescriptor(qe.UserDataAutoSyncEnablementService)),le.set(X.IUserDataSyncResourceEnablementService,new n.SyncDescriptor(Fe.UserDataSyncResourceEnablementService)),le.set(X.IUserDataSyncService,new n.SyncDescriptor(Q.UserDataSyncService)),le.set(B.ILocalPtyService,this._register(new De.PtyHostService(Be,We,Qe))),new f.InstantiationService(le)}initChannels(le){const Re=new d.ExtensionManagementChannel(le.get(w.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Re);const _e=S.ProxyChannel.fromService(le.get(h.ILocalizationsService));this.server.registerChannel("localizations",_e);const Me=S.ProxyChannel.fromService(le.get(T.IDiagnosticsService));this.server.registerChannel("diagnostics",Me);const Ne=new d.ExtensionTipsChannel(le.get(w.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Ne);const tt=S.ProxyChannel.fromService(le.get(ae.IChecksumService));this.server.registerChannel("checksum",tt);const Je=new ne.UserDataSyncMachinesServiceChannel(le.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Je);const it=S.ProxyChannel.fromService(le.get(t.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",it);const We=new ne.UserDataSyncAccountServiceChannel(le.get(Oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",We);const Ve=new ne.UserDataSyncStoreManagementServiceChannel(le.get(X.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ve);const rt=new te.UserDataSyncChannel(le.get(X.IUserDataSyncService),le.get(u.ILogService));this.server.registerChannel("userDataSync",rt);const Be=this._register(le.get(se.IInstantiationService).createInstance(ge.UserDataAutoSyncService)),Xe=new ne.UserDataAutoSyncChannel(Be);this.server.registerChannel("userDataAutoSync",Xe);const nt=le.get(B.ILocalPtyService),st=S.ProxyChannel.fromService(nt);this.server.registerChannel(Ue.TerminalIpcChannels.LocalPty,st)}registerErrorHandler(le){window.addEventListener("unhandledrejection",Re=>{(0,Pe.onUnexpectedError)(Re.reason),Re.preventDefault()}),(0,Pe.setUnexpectedErrorHandler)(Re=>{const _e=(0,be.toErrorMessage)(Re,!0);!_e||le.error(`[uncaught exception in sharedProcess]: ${_e}`)})}}async function we(Ee){const le=new ye(Ee);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await le.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/4fd4e10e99eff9eb77408b71c7f58b7ed7458ee5/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
